(*** Solution for the exercise no 1.2, ICP, of May, 12 ***)
(***         Numerical Stability in Recursions         ***)
(***             Matthias Jamin, 10.5.2003             ***)

(* Call the three cases with pTable, precTable and pinvTable *)

Print[ "Call 'pTable' (exact result), 'precTable' (recursion relation),"];
Print[ "or 'pinvTable' (inverse recursion relation)."];


(* Exact expression for the integrals p_n *)

p[n_] := Integrate[ x^n Exp[x], {x,0,1}];

(* Exact table p_n with n = 1, .. , 20 *)

pTable := pTable = Table[ p[n], {n,20}];

(* Care has to be taken when this is evaluated numerically. *)
(* Compare N[ pTable] and N[ pTable, 40] which is correct ! *)

NpTable = N[ pTable];   N40pTable = N[ pTable, 40];


(* Recursion relation for p_n *)

prec[1] = 1.;

prec[n_] := prec[n] = E - n prec[n-1];

(* Table for p_n with n = 1, .. , 20 from the recursion relation *)

precTable := precTable = Table[ prec[n], {n,20}];


(* Inverse recursion relation for p_n *)

pinv[30] = 1.;

pinv[n_] := pinv[n] = ( E - pinv[n+1] )/(n+1);

(* Table for p_n with n = 1, .. , 20 from the inverse recursion *)

pinvTable := pinvTable = Table[ pinv[n], {n,20}];


(* End *)
