(*** Solution for the exercise no 6.1, ICP, of June 16 ***)
(***                Romberg Integration                ***)
(***             Matthias Jamin, 16.6.2003             ***)

(* Define the two functions to be integrated *)

f1[x_] := 2 Sqrt[ 1 - x^2];
f2[x_] := 2 Sin[x]^2;


(* Extended trapezoidal rule *)

Trapez[ f_, a_, b_, n_] := Module[ { h=(b-a)/n},
        h ( (f[a]+f[b])/2 + Sum[ f[a+i h], {i,n-1}] )];


(* Romberg integration *)

Romberg[f_,a_,b_,m_,0] := Trapez[f,a,b,2^m];

Romberg[f_,a_,b_,m_,k_] := Module[ { n=2^m},
        (4^k Romberg[f,a,b,m,k-1]-Romberg[f,a,b,m-1,k-1])/(4^k-1)];


(* Ratio of successive Romberg steps to judge the convergence *)

Ratio[f_,a_,b_,m_] := (Romberg[f,a,b,m,0]-Romberg[f,a,b,m-1,0])/
                      (Romberg[f,a,b,m+1,0]-Romberg[f,a,b,m,0]);


(* Print the results *)

(* Result for integration of 2 Sqrt[1-x^2] *)

PrintRombergf1 := Do[ Print[];
                  Do[ Print[ Pi - Romberg[f1,-1.,1.,m,k]], {m,k,10}], {k,0,3}];

(* Corresponding Romberg ratio *)

PrintRombergf1R := Do[ Print[ Ratio[f1,-1.,1.,m]], {m,5}];

(* Result for integration of 2 Sin[x]^2 *)

PrintRombergf2 := Do[ Print[];
                  Do[ Print[ Pi - Romberg[f2,0.,Pi,m,k]], {m,k,5}], {k,0,3}];

