(*** Solution for the exercise no 6.2, ICP, of June 16 ***)
(***                Romberg Integration                ***)
(***             Matthias Jamin, 16.6.2003             ***)

(* Define the function to be integrated after *)
(* performing the substitution t = (1/z-1)^2. *)

f[0] = 0;
f[z_] := 2 Exp[ -(1/z-1)^2]/z^2;


(* Extended trapezoidal rule *)

Trapez[ f_, a_, b_, n_] := Module[ { h=(b-a)/n},
        h ( (f[a]+f[b])/2 + Sum[ f[a+i h], {i,n-1}] )];


(* Romberg integration *)

Romberg[f_,a_,b_,m_,0] := Trapez[f,a,b,2^m];

Romberg[f_,a_,b_,m_,k_] := Module[ { n=2^m},
        (4^k Romberg[f,a,b,m,k-1]-Romberg[f,a,b,m-1,k-1])/(4^k-1)];


(* Result for integration of 2 Exp[ -(1-z)^2/z^2]/z^2 *)

PrintRombergf := Do[ Print[];
                 Do[ Print[ (Sqrt[Pi] - Romberg[f,0,1.,m,k])/Sqrt[Pi]],
                     {m,k,10}], {k,0,3}];


