(*** Solution for the exercise no 6.3, ICP, of June 16 ***)
(***                Romberg Integration                ***)
(***             Matthias Jamin, 16.6.2003             ***)

(* Define the function to be integrated *)

f[x_] := 1/Sqrt[1-z^2 Sin[x]^2];


(* Extended trapezoidal rule *)

Trapez[ f_, a_, b_, n_] := Module[ { h=(b-a)/n},
        h ( (f[a]+f[b])/2 + Sum[ f[a+i h], {i,n-1}] )];


(* Romberg integration *)

Romberg[f_,a_,b_,m_,0] := Trapez[f,a,b,2^m];

Romberg[f_,a_,b_,m_,k_] := Module[ { n=2^m},
        (4^k Romberg[f,a,b,m,k-1]-Romberg[f,a,b,m-1,k-1])/(4^k-1)];


(* Result for the integration and function plot *)

PrintRombergf := Do[ z = Sin[theta0/2];
   Print[ (EllipticK[z^2]-Romberg[f,0.,Pi/2,8,1])/EllipticK[z^2] // N],
          {theta0,0,Pi,Pi/18}];

PlotEllipticK := Plot[ EllipticK[Sin[t0/2]^2], {t0,0,Pi}];

