(*** Solution for the exercise no 7.2, ICP, of June 27 ***)
(***            Gauss-Laguerre Integration             ***)
(***             Matthias Jamin, 26.6.2003             ***)

(* Parameter alpha of the Laguerre polynomial *)

al = - 1/2;

(* Abrevation for the Laguerre polynomial and its derivative *)

L[N_,x_] := LaguerreL[N,al,x];

Lp[N_,x_] := D[ L[N,z], z] /. z->x;


(* Calculate the roots with the Mathematical root finding *)
(* algorithm. The last parameter specifies the number of  *)
(* digits to be used, which is required in order to get   *)
(* sensible results. Play with this parameter!            *)

roots[N_] := roots[N] = NRoots[ L[N,x] == 0, x, 30]
xi[N_] := xi[N] = 1. Table[ roots[N][[i,2]], {i,N}];


(* Calculate the weights corresponding to the Gauss-Laguerre   *)
(* algorithm. Use the trick of the Numerical Recipes algorithm *)
(* of employing Exp[ LogGamma[]] to avoid large numbers.       *)

wi[N_] := wi[N] = Table[ - Exp[ LogGamma[N+al]-LogGamma[N]]/
                         (N L[N-1,xi[N][[i]]] Lp[N,xi[N][[i]]]), {i,N}];


(* Calculate the desired integral for different number of Gauss points *)

Do[ Int[k] = (wi[2^k] /. List->Plus); sqrtpi = Sqrt[ Pi] // N;
    Print[ k, "    ", Int[k], "    ", Int[k]-sqrtpi], {k,1,6}];

