C----------------------------------------------------------------------
      !
C     ! Implementation of the Newton-Raphson algorithm
      !
      Double Precision Function rtnewt(funcd,x1,x2,xacc)
      Implicit Double Precision (A-z)
      Integer j, JMAX
      External funcd
      Parameter (JMAX=20)
      !
C     ! Initial guess for the root
      !
      rtnewt = 0.5D0*(x1+x2)
      !
C     ! Iteration loop up to JMAX iterations
      !
      Do 10 j=1,JMAX
         Call funcd(rtnewt,f,df)
         dx=f/df
         rtnewt = rtnewt-dx
         If ((x1-rtnewt)*(rtnewt-x2).lt.0.) Pause
     .'rtnewt jumped out of brackets'
         If (dabs(dx).lt.xacc) Return
   10 Continue
      !
      Pause 'rtnewt exceeded maximum iterations'
      !
      End
C----------------------------------------------------------------------
