(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 3.0,
MathReader 3.0, or any compatible application. The data for the notebook 
starts with the line of stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    268364,       8963]*)
(*NotebookOutlinePosition[    269001,       8986]*)
(*  CellTagsIndexPosition[    268957,       8982]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
    \(\(ParametricPlot[\ {\ 2\ Sin[t]/t\ Cos[t], \ 2\ Sin[t]/t\ Sin[t]}, 
      \ {t, 0, 4  Pi}, PlotRange -> {0, 2}]; \)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.454427 0.991141 0 0.309017 [
[.05797 -0.0125 -12 -9 ]
[.05797 -0.0125 12 0 ]
[.2562 -0.0125 -12 -9 ]
[.2562 -0.0125 12 0 ]
[.65266 -0.0125 -9 -9 ]
[.65266 -0.0125 9 0 ]
[.85088 -0.0125 -9 -9 ]
[.85088 -0.0125 9 0 ]
[.44193 .07725 -24 -4.5 ]
[.44193 .07725 0 4.5 ]
[.44193 .15451 -18 -4.5 ]
[.44193 .15451 0 4.5 ]
[.44193 .23176 -24 -4.5 ]
[.44193 .23176 0 4.5 ]
[.44193 .30902 -6 -4.5 ]
[.44193 .30902 0 4.5 ]
[.44193 .38627 -24 -4.5 ]
[.44193 .38627 0 4.5 ]
[.44193 .46353 -18 -4.5 ]
[.44193 .46353 0 4.5 ]
[.44193 .54078 -24 -4.5 ]
[.44193 .54078 0 4.5 ]
[.44193 .61803 -6 -4.5 ]
[.44193 .61803 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.05797 0 m
.05797 .00625 L
s
[(-0.4)] .05797 -0.0125 0 1 Mshowa
.2562 0 m
.2562 .00625 L
s
[(-0.2)] .2562 -0.0125 0 1 Mshowa
.65266 0 m
.65266 .00625 L
s
[(0.2)] .65266 -0.0125 0 1 Mshowa
.85088 0 m
.85088 .00625 L
s
[(0.4)] .85088 -0.0125 0 1 Mshowa
.125 Mabswid
.10753 0 m
.10753 .00375 L
s
.15709 0 m
.15709 .00375 L
s
.20664 0 m
.20664 .00375 L
s
.30576 0 m
.30576 .00375 L
s
.35531 0 m
.35531 .00375 L
s
.40487 0 m
.40487 .00375 L
s
.50398 0 m
.50398 .00375 L
s
.55354 0 m
.55354 .00375 L
s
.6031 0 m
.6031 .00375 L
s
.70221 0 m
.70221 .00375 L
s
.75177 0 m
.75177 .00375 L
s
.80133 0 m
.80133 .00375 L
s
.00841 0 m
.00841 .00375 L
s
.90044 0 m
.90044 .00375 L
s
.95 0 m
.95 .00375 L
s
.99956 0 m
.99956 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.45443 .07725 m
.46068 .07725 L
s
[(0.25)] .44193 .07725 1 0 Mshowa
.45443 .15451 m
.46068 .15451 L
s
[(0.5)] .44193 .15451 1 0 Mshowa
.45443 .23176 m
.46068 .23176 L
s
[(0.75)] .44193 .23176 1 0 Mshowa
.45443 .30902 m
.46068 .30902 L
s
[(1)] .44193 .30902 1 0 Mshowa
.45443 .38627 m
.46068 .38627 L
s
[(1.25)] .44193 .38627 1 0 Mshowa
.45443 .46353 m
.46068 .46353 L
s
[(1.5)] .44193 .46353 1 0 Mshowa
.45443 .54078 m
.46068 .54078 L
s
[(1.75)] .44193 .54078 1 0 Mshowa
.45443 .61803 m
.46068 .61803 L
s
[(2)] .44193 .61803 1 0 Mshowa
.125 Mabswid
.45443 .01545 m
.45818 .01545 L
s
.45443 .0309 m
.45818 .0309 L
s
.45443 .04635 m
.45818 .04635 L
s
.45443 .0618 m
.45818 .0618 L
s
.45443 .09271 m
.45818 .09271 L
s
.45443 .10816 m
.45818 .10816 L
s
.45443 .12361 m
.45818 .12361 L
s
.45443 .13906 m
.45818 .13906 L
s
.45443 .16996 m
.45818 .16996 L
s
.45443 .18541 m
.45818 .18541 L
s
.45443 .20086 m
.45818 .20086 L
s
.45443 .21631 m
.45818 .21631 L
s
.45443 .24721 m
.45818 .24721 L
s
.45443 .26266 m
.45818 .26266 L
s
.45443 .27812 m
.45818 .27812 L
s
.45443 .29357 m
.45818 .29357 L
s
.45443 .32447 m
.45818 .32447 L
s
.45443 .33992 m
.45818 .33992 L
s
.45443 .35537 m
.45818 .35537 L
s
.45443 .37082 m
.45818 .37082 L
s
.45443 .40172 m
.45818 .40172 L
s
.45443 .41717 m
.45818 .41717 L
s
.45443 .43262 m
.45818 .43262 L
s
.45443 .44807 m
.45818 .44807 L
s
.45443 .47898 m
.45818 .47898 L
s
.45443 .49443 m
.45818 .49443 L
s
.45443 .50988 m
.45818 .50988 L
s
.45443 .52533 m
.45818 .52533 L
s
.45443 .55623 m
.45818 .55623 L
s
.45443 .57168 m
.45818 .57168 L
s
.45443 .58713 m
.45818 .58713 L
s
.45443 .60258 m
.45818 .60258 L
s
.25 Mabswid
.45443 0 m
.45443 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
1 .44718 m
.99122 .44703 L
.96435 .4464 L
.93649 .44553 L
.91051 .44455 L
.86463 .44236 L
.81595 .4394 L
.70743 .43033 L
.59935 .41755 L
.51286 .40425 L
.42509 .38741 L
.34388 .36816 L
.2751 .34827 L
.16819 .30761 L
.12116 .28344 L
.08611 .26063 L
.05679 .23534 L
.04559 .22259 L
.036 .20864 L
.03006 .19688 L
.02758 .19028 L
.02585 .1842 L
.02468 .17839 L
.02405 .17317 L
.02381 .1672 L
.02406 .16163 L
.02468 .15657 L
.02574 .1513 L
.02697 .14683 L
.02865 .14199 L
.03365 .13137 L
.03981 .12174 L
.04874 .11084 L
.05884 .10091 L
.08177 .08334 L
.11171 .06609 L
.14952 .04946 L
.18334 .03773 L
.22235 .02685 L
.26743 .01706 L
.31106 .00992 L
.33539 .00682 L
.35804 .00447 L
.38159 .00256 L
.39476 .00172 L
.4071 .00109 L
.41764 .00066 L
.42316 .00048 L
.42896 .00032 L
.43918 .00011 L
Mistroke
.4485 2e-05 L
.45914 1e-05 L
.46898 .00011 L
.47964 .00032 L
.48556 .00049 L
.49092 .00067 L
.50883 .00152 L
.5188 .00214 L
.528 .00282 L
.54748 .00461 L
.5646 .00659 L
.5935 .01097 L
.62152 .01672 L
.64627 .02349 L
.66885 .03179 L
.67838 .03627 L
.68716 .04122 L
.69351 .04559 L
.69923 .05048 L
.70347 .05525 L
.70527 .05788 L
.70663 .06034 L
.70761 .06265 L
.70827 .06476 L
.70874 .06719 L
.7089 .06949 L
.70887 .07079 L
.70877 .07196 L
.70857 .07331 L
.7083 .07457 L
.7076 .07682 L
.70656 .07923 L
.70506 .08187 L
.70309 .08462 L
.69858 .08945 L
.6937 .0935 L
.6875 .0977 L
.67391 .10483 L
.65409 .11245 L
.63299 .11847 L
.61048 .12332 L
.59735 .12557 L
.58459 .12741 L
.56124 .12999 L
.54849 .13102 L
.53456 .13184 L
.52721 .13216 L
.52034 .13239 L
.51638 .13249 L
.51278 .13256 L
Mistroke
.50863 .13262 L
.5047 .13266 L
.50087 .13267 L
.49682 .13266 L
.48956 .13258 L
.48552 .13251 L
.48176 .13242 L
.47321 .13214 L
.466 .13182 L
.45918 .13145 L
.44652 .13058 L
.4331 .1294 L
.41878 .12781 L
.39151 .12381 L
.36768 .11907 L
.34809 .11409 L
.32912 .10803 L
.31125 .10069 L
.29595 .09232 L
.28593 .08479 L
.28154 .08041 L
.27829 .07628 L
.27697 .0742 L
.2758 .07198 L
.27498 .07007 L
.27428 .06801 L
.27398 .06685 L
.27376 .0658 L
.27348 .06373 L
.27341 .06258 L
.2734 .06132 L
.27346 .06014 L
.27358 .05904 L
.27397 .05693 L
.27452 .05496 L
.27517 .0532 L
.27604 .0513 L
.27861 .04711 L
.28171 .04333 L
.28879 .03693 L
.29883 .03031 L
.31164 .02393 L
.3255 .01856 L
.34235 .01341 L
.36244 .0087 L
.3827 .00516 L
.3927 .00379 L
.40223 .00269 L
.41154 .00181 L
.42014 .00116 L
Mistroke
.42971 .0006 L
.43474 .00038 L
.44003 .0002 L
.44483 9e-05 L
.44994 2e-05 L
.45475 0 L
.4591 2e-05 L
.46419 9e-05 L
.46704 .00016 L
.46966 .00023 L
.47445 .0004 L
.47947 .00063 L
.48947 .00125 L
.49874 .00203 L
.51537 .00395 L
.53198 .00667 L
.54828 .01031 L
.56074 .014 L
.57205 .01836 L
.58074 .02282 L
.58687 .02708 L
.58955 .02952 L
.59188 .03224 L
.59281 .03362 L
.59362 .03511 L
.59422 .03651 L
.59461 .0378 L
.59487 .03908 L
.59498 .04026 L
.59498 .04155 L
.59481 .04292 L
.59454 .0441 L
.59419 .04521 L
.59368 .04641 L
.59299 .0477 L
.59112 .05034 L
.58841 .05316 L
.58484 .05601 L
.58089 .05857 L
.57233 .06289 L
.56127 .06705 L
.54794 .0708 L
.53425 .07369 L
.51797 .07617 L
.50937 .07714 L
.49969 .07797 L
.49526 .07827 L
.49104 .0785 L
.48717 .07868 L
.48305 .07883 L
Mistroke
.48092 .07889 L
.47856 .07894 L
.4744 .079 L
.47206 .07901 L
.46953 .07901 L
.46715 .079 L
.46496 .07897 L
.46103 .0789 L
.45738 .0788 L
.45339 .07865 L
.44914 .07845 L
.44053 .0779 L
.43283 .07724 L
.41766 .07547 L
.40249 .07297 L
.39048 .07037 L
.37843 .06706 L
.36706 .06303 L
.35684 .05826 L
.3527 .05581 L
.34927 .05341 L
.3442 .04876 L
.34222 .0462 L
.34144 .04493 L
.34085 .04376 L
.34041 .04272 L
.34002 .04156 L
.33975 .04041 L
.33957 .03918 L
.33952 .03849 L
.33951 .03784 L
.33958 .03662 L
.33979 .03531 L
.33997 .03458 L
.34017 .0339 L
.34117 .03154 L
.34185 .03036 L
.34272 .02907 L
.34671 .02476 L
.34962 .02242 L
.35269 .02035 L
.35985 .01645 L
.36751 .01319 L
.37723 .0099 L
.3888 .00686 L
.4004 .00451 L
.41197 .00273 L
.41873 .00191 L
.426 .0012 L
.43228 .00073 L
Mistroke
.43923 .00034 L
.44314 .00019 L
.44671 9e-05 L
.44868 5e-05 L
.45083 2e-05 L
.45286 0 L
.45473 0 L
.45662 1e-05 L
.45839 2e-05 L
.46169 8e-05 L
.46523 .00017 L
.46902 .00032 L
.47541 .00067 L
.48212 .00117 L
.4883 .00178 L
.49377 .00243 L
.50644 .00443 L
.5173 .0068 L
.5272 .00968 L
.535 .01267 L
.54193 .01626 L
.54474 .01816 L
.54729 .02032 L
.54898 .02216 L
.54971 .02315 L
.55035 .0242 L
.55085 .02522 L
.55119 .02615 L
.55144 .02708 L
.55157 .02796 L
.55162 .02882 L
.55157 .02973 L
.55146 .0305 L
.55125 .03135 L
.55094 .03225 L
.5505 .03322 L
.54942 .03495 L
.54774 .0369 L
.5454 .03898 L
.53983 .04256 L
.53287 .04576 L
.52521 .04842 L
.51683 .05068 L
.50687 .05272 L
.49675 .05424 L
.48699 .05529 L
.48123 .05573 L
.4758 .05603 L
.47266 .05615 L
.46979 .05624 L
Mistroke
.4682 .05627 L
.46647 .0563 L
.46333 .05632 L
.4603 .05631 L
.45857 .0563 L
.45696 .05627 L
.45527 .05623 L
.45372 .05619 L
.45024 .05606 L
.44731 .05592 L
.44413 .05573 L
.43839 .0553 L
.43256 .05473 L
.42642 .05399 L
.41577 .0523 L
.40618 .05026 L
.39815 .04807 L
.39042 .04539 L
.38324 .04215 L
.38019 .04041 L
.37735 .03848 L
.37528 .03679 L
.3734 .03488 L
.37203 .03305 L
.37144 .03205 L
.37099 .03109 L
.37066 .03021 L
.37044 .02939 L
.37029 .0285 L
.37022 .02755 L
.37023 .02705 L
.37026 .02659 L
.37032 .02607 L
.37041 .02557 L
.37063 .02469 L
.37097 .02375 L
.37146 .02271 L
.37212 .02162 L
.37362 .01969 L
.37526 .01807 L
.37736 .01637 L
.382 .01344 L
.38885 .01024 L
.39624 .00762 L
.40216 .00595 L
.40894 .00437 L
.41513 .00319 L
.4221 .00212 L
.42652 .00157 L
.43064 .00113 L
Mistroke
.43454 .00079 L
.43886 .00048 L
.44277 .00027 L
.44643 .00013 L
.44846 7e-05 L
.4503 3e-05 L
.45242 1e-05 L
.45443 0 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000900001Ha000`40n007h00Ooooooooo@_oo003o
oooooom2ool00?oooooood;oo`00oooooooo@_oo003ooooooom2ool00?oooooood;oo`00<Ooo1000
2Ooo0P002Ooo1P00BOoo10002Ooo0P001ooo2000Z_oo10002Ooo0P001ooo2000BOoo10002Ooo0P00
2Ooo1P00Fooo000`ool20003ool00`00ooooo`06ool3000;ool00`00ooooo`18ool20003ool00`00
ooooo`06ool30006ool20005ool00`00ooooo`2Wool20003ool00`00ooooo`06ool30006ool20005
ool00`00ooooo`16ool20003ool00`00ooooo`06ool3000;ool00`00ooooo`1Kool0033oo`03003o
oooo00;oo`8000Ooo`<000_oo`03003ooooo04Soo`03003ooooo00;oo`8000Ooo`<000Soo`03003o
oooo00;oo`03003ooooo0:Ooo`03003ooooo00;oo`8000Ooo`<000Soo`03003ooooo00;oo`03003o
oooo04Koo`03003ooooo00;oo`8000Ooo`<000_oo`03003ooooo05_oo`00;ooo00<00?ooool01?oo
00<00?ooool03_oo2000Aooo00<00?ooool01?oo00<00?ooool04Ooo00<00?ooool0Z_oo00<00?oo
ool01?oo00<00?ooool04Ooo00<00?ooool0BOoo00<00?ooool01?oo00<00?ooool03_oo2000Fooo
000_ool00`00ooooo`04ool00`00ooooo`0>ool00`00ooooo`02ool00`00ooooo`17ool00`00oooo
o`04ool00`00ooooo`0Bool00`00ooooo`2Yool00`00ooooo`04ool00`00ooooo`0Bool00`00oooo
o`18ool00`00ooooo`04ool00`00ooooo`0>ool00`00ooooo`02ool00`00ooooo`1Kool002ooo`03
003ooooo00Coo`03003ooooo00ooo`05003oooooool00019ool00`00ooooo`04ool00`00ooooo`0C
ool00`00ooooo`2Xool00`00ooooo`04ool00`00ooooo`0Cool00`00ooooo`17ool00`00ooooo`04
ool00`00ooooo`0?ool01@00oooooooo0000GOoo000Uool40006ool00`00ooooo`04ool00`00oooo
o`0?ool01@00oooooooo0000?ooo10001_oo00<00?ooool01?oo00<00?ooool05?oo00<00?ooool0
Yooo00<00?ooool01?oo00<00?ooool05?oo00<00?ooool0A_oo00<00?ooool01?oo00<00?ooool0
3ooo00D00?ooooooo`0005goo`00;ooo00<00?ooool01?oo00<00?ooool04?oo00@00?ooool004Wo
o`03003ooooo00Coo`03003ooooo01Coo`800:Soo`03003ooooo00Coo`03003ooooo01Coo`8004Oo
o`03003ooooo00Coo`03003ooooo013oo`04003ooooo001Mool002ooo`03003ooooo00Coo`03003o
oooo013oo`04003ooooo0019ool00`00ooooo`04ool00`00ooooo`0Eool00`00ooooo`2Vool00`00
ooooo`04ool00`00ooooo`0Eool00`00ooooo`15ool00`00ooooo`04ool00`00ooooo`0@ool01000
ooooo`00GOoo000_ool20005ool00`00ooooo`0Aool00`00ool00019ool20005ool00`00ooooo`0E
ool00`00ooooo`2Vool20005ool00`00ooooo`0Eool00`00ooooo`15ool20005ool00`00ooooo`0A
ool00`00ool0001Mool0033oo`03003ooooo00;oo`03003ooooo01;oo`03003oo`0004[oo`03003o
oooo00;oo`03003ooooo00ooo`03003ooooo00Coo`03003ooooo0:Ooo`03003ooooo00;oo`03003o
oooo00ooo`03003ooooo00Coo`03003ooooo04Koo`03003ooooo00;oo`03003ooooo01;oo`03003o
o`0005goo`00<?oo0P000ooo00<00?ooool04ooo0P00B_oo0P000ooo00<00?ooool03ooo0P000ooo
0P00Z_oo0P000ooo00<00?ooool03ooo0P000ooo0P00BOoo0P000ooo00<00?ooool04ooo0P00GOoo
000aool4000Fool2001;ool4000Dool4002/ool4000Dool4001;ool4000Fool2001Mool00?oooooo
od;oo`00oooooooo@_oo003ooooooom2ool00?oooooood;oo`00oooooooo@_oo000Koooo003o000;
000Lool001ooo`03003ooooo01Ooo`03003ooooo01Ooo`03003ooooo01Ooo`03003ooooo01Koo`03
003ooooo01Ooo`03003ooooo01Ooo`03003ooooo01Ooo`03003ooooo00Coob@000Soo`03003ooooo
00[ooaP000ooo`03003ooooo01Ooo`03003ooooo01Koo`03003ooooo01Ooo`03003ooooo01Ooo`03
003ooooo01Ooo`03003ooooo01Koo`03003ooooo01Ooo`03003ooooo01Ooo`03003ooooo01Ooo`03
003ooooo01[oo`007ooo00<00?ooool05ooo00<00?ooool05ooo00<00?ooool05ooo00<00?ooool0
5_oo00<00?ooool05ooo00<00?ooool05ooo00<00?ooool05Ooo2P002Ooo40004_oo00<00?ooool0
5Ooo2`000_oo20001ooo00<00?ooool05ooo00<00?ooool05_oo00<00?ooool05ooo00<00?ooool0
5ooo00<00?ooool05ooo00<00?ooool05_oo00<00?ooool05ooo00<00?ooool05ooo00<00?ooool0
5ooo00<00?ooool06_oo000iool00`00ooooo`1Tool00`00ooooo`0Yool7000=ool50002ool30000
0ooo00000002000Hool00`00ooooo`0Jool30003ool40005ool:000aool00`00ooooo`1Tool00`00
ooooo`1Xool00<?oo`X000goo`H000;oo`T001coo`03003ooooo01goo`@000?oo`L000Soo`P00?_o
o`00^ooo2@004Ooo1@001?oo1@000_oo0`007ooo00<00?ooool08Ooo10001Ooo1P002ooo2000looo
002eool6000Eool50007ool20005ool2000Rool00`00ooooo`0Tool30009ool4000?ool6003]ool0
0:ooo`H001Ooo`@000Woo`<000Koo`03003ooooo02;oo`03003ooooo02Koo`<000_oo`8001?oo`D0
0>Soo`00ZOoo1P006_oo0`002ooo0`001_oo0P009Ooo0`00:?oo0`002ooo0P005Ooo1@00i?oo002T
ool5000Mool3000<ool30007ool00`00ooooo`0Uool00`00ooooo`0Zool2000<ool2000Hool5003O
ool00:3oo`@001ooo`<000goo`<000Ooo`8002Soo`03003ooooo02coo`8000coo`8001_oo`@00=_o
o`00Vooo1@008Ooo0P003ooo0P002Ooo00<00?ooool09ooo00<00?ooool0;Ooo0P003Ooo0P007Ooo
1000eooo002Fool5000Tool2000?ool2000:ool00`00ooooo`0Xool00`00ooooo`0^ool2000>ool2
000Oool4003Cool009;oo`@002Koo`<0013oo`8000_oo`03003ooooo02Soo`03003ooooo02ooo`03
003ooooo00koo`80027oo`800=7oo`00S_oo1000:?oo0P004_oo00<00?ooool02ooo00<00?ooool0
:?oo00<00?ooool0<?oo00<00?ooool03ooo0P008Ooo0`00c_oo002:ool4000Zool2000Cool00`00
ooooo`0<ool00`00ooooo`0Xool00`00ooooo`0`ool00`00ooooo`0@ool2000Rool3003<ool008Oo
o`<002coo`8001Goo`03003ooooo00coo`03003ooooo02Soo`<0033oo`03003ooooo017oo`8002Co
o`800<[oo`00Pooo1000;Ooo0P005_oo00<00?ooool03Ooo00<00?ooool0:?oo00<00?ooool0;ooo
00<00?ooool04ooo00<00?ooool09?oo0`00aooo0020ool3000_ool2000Hool00`00ooooo`0>ool0
0`00ooooo`0Wool00`00ooooo`0_ool00`00ooooo`0Cool2000Xool20035ool007coo`@0037oo`03
003ooooo01Soo`03003ooooo00ooo`03003ooooo02Koo`03003ooooo02koo`03003ooooo01Goo`03
003ooooo02Soo`800<?oo`00NOoo0`00=?oo00<00?ooool06Ooo00<00?ooool04?oo0P009_oo00<0
0?ooool0;Ooo00<00?ooool05_oo00<00?ooool0:_oo0P00`Ooo001fool3000fool00`00ooooo`0J
ool00`00ooooo`0Aool2000Uool00`00ooooo`0[ool2000Iool00`00ooooo`0[ool20030ool007?o
o`<003Soo`03003ooooo01_oo`03003ooooo01?oo`8002?oo`03003ooooo02Woo`8001_oo`03003o
oooo02goo`800;koo`00L?oo1000>Ooo00<00?ooool07?oo0P005Ooo0`008Ooo00<00?ooool09ooo
0`007?oo00<00?ooool0;_oo0`00_?oo001^ool3000kool2000Oool00`00ooooo`0Eool4000Nool3
000Tool4000Nool00`00ooooo`0`ool2002kool006_oo`<003koo`03003ooooo01ooo`03003ooooo
01Ooo`D001[oo`03003ooooo023oo`D0023oo`03003ooooo03?oo`800;Woo`00J?oo0`00@?oo0P00
8_oo00<00?ooool06_oo1@005_oo00<00?ooool07Ooo10008ooo00<00?ooool0=_oo00<00?ooool0
]_oo001Vool20013ool00`00ooooo`0Rool00`00ooooo`0Nool6000@ool00`00ooooo`0Kool2000V
ool2000iool00`00ooooo`2eool006?oo`<004Coo`03003ooooo02Coo`03003ooooo02;oo`D000co
o`03003ooooo017oo`X002Ooo`8003[oo`03003ooooo0;Goo`00HOoo0P00Aooo00<00?ooool09Ooo
0P009ooo8000<?oo0P00??oo00<00?ooool0]?oo001Nool30018ool00`00ooooo`0Xool2000aool0
0`00ooooo`10ool00`00ooooo`0mool00`00ooooo`2cool005coo`8004_oo`03003ooooo02[oo`80
02ooo`03003ooooo03koo`80043oo`03003ooooo0;?oo`00FOoo0`00COoo00<00?ooool0;?oo0P00
;Ooo0`00??oo0`00@Ooo00<00?ooool0/ooo001Gool2001@ool00`00ooooo`0^ool2000[ool00`00
ooooo`0jool30014ool00`00ooooo`2bool005Goo`8005;oo`03003ooooo033oo`<002Soo`03003o
oooo03Ooo`<004Ooo`03003ooooo0;;oo`00Dooo0P00E?oo0P00=?oo0`009Ooo00<00?ooool0=?oo
0`00Booo00<00?ooool0/Ooo001Aool2001Gool00`00ooooo`0eool3000Rool00`00ooooo`0`ool4
001>ool00`00ooooo`2aool0053oo`03003ooooo05Ooo`03003ooooo02Soo`@000Woo`800003ool0
000000<00003ool0000000H000Goo`D000[oo`03003ooooo02_oo`D005;oo`03003ooooo0;7oo`00
C_oo0P00F_oo00<00?ooool09ooo0P000ooo00<00?ooool01_oo0`001?oo200000?oo`00ool00ooo
00<00?ooool00ooo00<00?ooool01ooo00<00?ooool09Ooo1P00E_oo0P00/ooo001<ool2001Mool0
0`00ooooo`0Vool00`00ooooo`02ool20007ool30008ool00`00ooooo`090005ool00`00ooooo`06
ool00`00ooooo`0Qool4001Lool00`00ooooo`2bool004_oo`03003ooooo05koo`03003ooooo02Co
o`03003ooooo00Coo`03003ooooo017oo`03003ooooo00Ooo`L000Soo`D001Koo`T0063oo`03003o
oooo0;;oo`00BOoo0P00HOoo0P009Ooo00<00?ooool01?oo00<00?ooool04_oo00<00?ooool03?oo
9000J?oo00<00?ooool0/ooo0017ool2001Tool00`00ooooo`0Sool00`00ooooo`04ool00`00oooo
o`0Cool00`00ooooo`0;ool00`00ooooo`06ool00`00ooooo`20ool00`00ooooo`2cool004Koo`03
003ooooo06Goo`8002?oo`03003ooooo00Coo`03003ooooo01Coo`03003ooooo00Coo`03003ooooo
00;oo`03003ooooo00Ooo`03003ooooo083oo`03003ooooo0;?oo`00AOoo00<00?ooool0J?oo00<0
0?ooool08?oo00<00?ooool01?oo00<00?ooool05?oo0P001Ooo1@002_oo00<00?ooool0Oooo00<0
0?ooool0]?oo0013ool2001/ool2000Pool00`00ooooo`04ool00`00ooooo`0Eool00`00ooooo`03
ool00`00ooooo`0<ool00`00ooooo`1nool00`00ooooo`2eool004;oo`8006koo`8001ooo`8000Go
o`03003ooooo01Goo`03003ooooo00?oo`03003ooooo00coo`03003ooooo07goo`03003ooooo0;Ko
o`00@Ooo00<00?ooool0Kooo0P007ooo00<00?ooool00_oo00<00?ooool03ooo00<00?ooool01?oo
00<00?ooool00ooo00<00?ooool03?oo00<00?ooool0O?oo00<00?ooool0]ooo0010ool00`00oooo
o`1bool2000Mool20003ool00`00ooooo`0?ool20003ool20006ool00`00ooooo`0<ool3001kool0
0`00ooooo`2hool003ooo`03003ooooo07Coo`<001coo`@001Coo`@000Ooo`H000Woo`03003ooooo
07[oo`03003ooooo0;Woo`00?Ooo0P00NOoo0`00C?oo00<00?ooool0N?oo0P00_?oo000lool2001l
ool3001:ool00`00ooooo`1fool2002nool003_oo`03003ooooo07koo`<004Soo`03003ooooo07Co
o`<00;ooo`00>_oo00<00?ooool0P_oo0P00A_oo00<00?ooool0L_oo0`00`Ooo000iool00`00oooo
o`25ool20014ool00`00ooooo`1`ool30033ool003Ooo`8008[oo`8004;oo`03003ooooo06koo`<0
0<Goo`00=_oo0P00SOoo0`00?ooo0`00K?oo0P00b?oo000eool00`00ooooo`2@ool4000kool00`00
ooooo`1Yool3003:ool003Coo`03003ooooo09Coo`@003Soo`03003ooooo06Ooo`800<goo`00<ooo
00<00?ooool0VOoo0`00=Ooo00<00?ooool0I?oo0`00cooo000bool2002Nool4000aool00`00oooo
o`1Pool4003Bool0037oo`800:;oo`@002koo`03003ooooo05coo`@00=Koo`00<Ooo00<00?ooool0
YOoo1000:_oo00<00?ooool0Eooo1@00f_oo000`ool00`00ooooo`2Zool4000Vool00`00ooooo`1A
ool7003Nool002ooo`03003ooooo0:ooo`@002;oo`<004_oo`L00>Coo`00;ooo00<00?ooool0/ooo
1P007?oo00<00?ooool0AOoo1`00j_oo000^ool00`00ooooo`2jool7000Eool00`00ooooo`0nool7
003aool002koo`03003ooooo0<7oo`h000Ooo`03003ooooo03Soo`L00?Ooo`00;Ooo00<00?ooool0
d?oo3000:Ooo3P00oOoo000/ool2003Iool00`00ooooo`02oolY003oool<ool002coo`03003ooooo
0=Soo`03003ooooo0?ooocOoo`00:ooo0P00f_oo00<00?ooool0oooo=ooo000[ool00`00ooooo`3I
ool3003ooolgool002[oo`800=_oo`03003ooooo0?ooocOoo`00:_oo00<00?ooool0f_oo00<00?oo
ool0oooo=ooo000Yool2003Lool00`00ooooo`3ooolgool002Woo`03003ooooo0=_oo`03003ooooo
0?ooocOoo`00:Ooo00<00?ooool0]Ooo10002Ooo0P002?oo1@002_oo00<00?ooool0oooo=ooo000X
ool00`00ooooo`2eool20003ool00`00ooooo`06ool30006ool00`00ooooo`03ool00`00ooooo`07
ool00`00ooooo`3ooolgool002Soo`03003ooooo0;Goo`03003ooooo00;oo`8000Ooo`<000goo`03
003ooooo00Koo`03003ooooo0?ooocOoo`00:?oo00<00?ooool0]?oo00<00?ooool01?oo00<00?oo
ool05Ooo00<00?ooool01_oo1@00oooo=Ooo000Xool00`00ooooo`2dool00`00ooooo`04ool00`00
ooooo`0Eool00`00ooooo`06ool00`00ooooo`3ooolgool002Soo`03003ooooo0;Coo`03003ooooo
00Coo`03003ooooo01Goo`03003ooooo00Koo`03003ooooo0?ooocOoo`00:?oo00<00?ooool0]?oo
00<00?ooool01?oo00<00?ooool03ooo00<00?ooool00_oo00<00?ooool01ooo00<00?ooool0oooo
=ooo000Xool00`00ooooo`2dool00`00ooooo`04ool00`00ooooo`0?ool5000:ool00`00ooooo`3o
oolgool002Soo`03003ooooo0;Coo`03003ooooo00Coo`03003ooooo00ooo`03003ooooo00coo`03
003ooooo0?ooocOoo`009ooo00<00?ooool0]Ooo0P001Ooo00<00?ooool03ooo00<00?ooool03?oo
00<00?ooool0oooo=ooo000Wool00`00ooooo`2fool00`00ooooo`02ool00`00ooooo`0@ool00`00
ooooo`0<ool00`00ooooo`3ooolgool002Ooo`03003ooooo0;Koo`8000?oo`03003ooooo013oo`03
003ooooo00coo`03003ooooo0?ooocOoo`00:?oo00<00?ooool0]_oo10004ooo1P002Ooo0`00oooo
=ooo000Xool00`00ooooo`3Lool00`00ooooo`3ooolgool002Soo`03003ooooo0=coo`03003ooooo
0?ooocOoo`00:?oo00<00?ooool0g?oo00<00?ooool0oooo=ooo000Xool00`00ooooo`3Lool00`00
ooooo`3ooolgool002Soo`03003ooooo0=coo`03003ooooo0?ooocOoo`00:?oo00<00?ooool0g?oo
00<00?ooool0oooo=ooo000Xool00`00ooooo`3Lool00`00ooooo`3ooolgool002Soo`03003ooooo
0=coo`<00?ooocOoo`00:Ooo00<00?ooool0fooo00<00?ooool0oooo=ooo000Yool00`00ooooo`3K
ool00`00ooooo`3ooolgool002Woo`800=coo`03003ooooo0?ooocOoo`00:_oo00<00?ooool0f_oo
00<00?ooool0oooo=ooo000Zool2003Kool00`00ooooo`3ooolgool002_oo`03003ooooo0=Woo`03
003ooooo0?ooocOoo`00:ooo0P00f_oo00<00?ooool0oooo=ooo000/ool00`00ooooo`3Hool3003o
oolgool002coo`800=Woo`03003ooooo0?ooocOoo`00;Ooo00<00?ooool0eooo00<00?ooool0oooo
=ooo000]ool2003Hool00`00ooooo`3ooolgool002koo`03003ooooo0=Koo`03003ooooo0?ooocOo
o`00;ooo00<00?ooool0eOoo00<00?ooool0oooo=ooo000_ool2003Fool00`00ooooo`3ooolgool0
033oo`03003ooooo0=Coo`03003ooooo0?ooocOoo`00<Ooo00<00?ooool0dooo0`00oooo=ooo000a
ool2003Dool00`00ooooo`3ooolgool003;oo`03003ooooo0=;oo`03003ooooo0?ooocOoo`00<ooo
00<00?ooool0dOoo00<00?ooool0oooo=ooo000dool00`00ooooo`2Nool40009ool2000:ool00`00
ooooo`07ool5000:ool00`00ooooo`3ooolgool003Goo`03003ooooo09coo`8000?oo`03003ooooo
00Koo`<000Woo`8000Ooo`03003ooooo00?oo`03003ooooo00Ooo`03003ooooo0?ooocOoo`00=_oo
00<00?ooool0Vooo00<00?ooool00_oo0P001ooo0`002_oo00<00?ooool03?oo00<00?ooool01_oo
00<00?ooool0oooo=ooo000gool00`00ooooo`2Iool00`00ooooo`04ool00`00ooooo`0Bool00`00
ooooo`0<ool00`00ooooo`06ool00`00ooooo`3ooolgool003Soo`03003ooooo09Soo`03003ooooo
00Coo`03003ooooo01;oo`8000goo`03003ooooo00Koo`D00?ooocGoo`00>Ooo00<00?ooool0Uooo
00<00?ooool01?oo00<00?ooool04ooo00<00?ooool02ooo00<00?ooool01_oo00<00?ooool0oooo
=ooo000jool00`00ooooo`2Fool00`00ooooo`04ool00`00ooooo`0Cool00`00ooooo`05ool00`00
ooooo`02ool00`00ooooo`07ool00`00ooooo`3ooolgool003_oo`03003ooooo09Goo`03003ooooo
00Coo`03003ooooo01?oo`8000Koo`D000[oo`03003ooooo0?ooocOoo`00??oo00<00?ooool0U?oo
00<00?ooool01?oo00<00?ooool05?oo00<00?ooool01?oo00<00?ooool03?oo00<00?ooool0oooo
=ooo000mool2002Dool20005ool00`00ooooo`0Dool00`00ooooo`04ool00`00ooooo`0<ool00`00
ooooo`3ooolgool003koo`8009Coo`03003ooooo00;oo`03003ooooo00ooo`03003ooooo00?oo`80
00Goo`03003ooooo00coo`03003ooooo0?ooocOoo`00?ooo0P00Tooo0P000ooo00<00?ooool03ooo
00<00?ooool01?oo00<00?ooool00ooo00<00?ooool03?oo00<00?ooool0oooo=ooo0010ool2002C
ool4000Bool80005ool60009ool3003ooolgool0047oo`800<Coo`03003ooooo0?ooocOoo`00@_oo
0P00`ooo00<00?ooool0oooo=ooo0013ool20032ool00`00ooooo`3ooolgool004Goo`03003ooooo
0;ooo`03003ooooo0?ooocOoo`00A_oo00<00?ooool0__oo00<00?ooool0oooo=ooo0017ool00`00
ooooo`2mool00`00ooooo`3ooolgool004Soo`03003ooooo0;coo`03003ooooo0?ooocOoo`00BOoo
0P00_?oo0`00oooo=ooo001;ool00`00ooooo`2iool00`00ooooo`3ooolgool004coo`800;Woo`03
003ooooo0?ooocOoo`00C_oo00<00?ooool0]_oo00<00?ooool0oooo=ooo001?ool2002fool00`00
ooooo`3ooolgool0057oo`03003ooooo0;?oo`03003ooooo0?ooocOoo`00D_oo0P00/ooo00<00?oo
ool0oooo=ooo001Dool00`00ooooo`2`ool00`00ooooo`3ooolgool005Goo`800;3oo`<00?ooocOo
o`00Eooo00<00?ooool0[Ooo00<00?ooool0oooo=ooo001Hool2002]ool00`00ooooo`3ooolgool0
05[oo`800:_oo`03003ooooo0?ooocOoo`00Fooo0`00ZOoo00<00?ooool0oooo=ooo001Mool3002W
ool00`00ooooo`3ooolgool005ooo`<00:Goo`03003ooooo0?ooocOoo`00HOoo0`00Xooo00<00?oo
ool0oooo=ooo001Sool3002Qool3003ooolgool006Goo`<009ooo`03003ooooo0?ooocOoo`00Iooo
0`00WOoo00<00?ooool0oooo=ooo001Yool3002Kool00`00ooooo`3ooolgool006_oo`<008Woo`P0
00Soo`03003ooooo0?ooocOoo`00KOoo0`00Rooo00<00?ooool02Ooo00<00?ooool0oooo=ooo001_
ool30029ool00`00ooooo`09ool00`00ooooo`3ooolgool0077oo`<008Ooo`03003ooooo00Woo`03
003ooooo0?ooocOoo`00M?oo0`00Q?oo00<00?ooool02Ooo1@00oooo=Ooo001fool30022ool00`00
ooooo`09ool00`00ooooo`3ooolgool007Woo`<007ooo`03003ooooo00Woo`03003ooooo0?ooocOo
o`00O?oo0`00O?oo00<00?ooool02Ooo00<00?ooool0oooo=ooo001nool3001jool00`00ooooo`09
ool00`00ooooo`3ooolgool0087oo`<007Ooo`03003ooooo00Woo`03003ooooo0?ooocOoo`00Q?oo
0`00L?oo00D00?ooooooo`0000_oo`03003ooooo0?ooocOoo`00Q_oo0`00Kooo10002ooo00<00?oo
ool0oooo=ooo0029ool3001^ool2000;ool3003ooolgool008coo`<007Soo`03003ooooo0?ooocOo
o`00S_oo0`00M_oo00<00?ooool0oooo=ooo002Aool3001cool00`00ooooo`3ooolgool009Coo`<0
073oo`03003ooooo0?ooocOoo`00U_oo0`00K_oo00<00?ooool0oooo=ooo002Iool3001[ool00`00
ooooo`3ooolgool009coo`<006Soo`03003ooooo0?ooocOoo`00W_oo0`00I_oo0`00oooo=ooo002Q
ool3001Sool00`00ooooo`3ooolgool00:Coo`<0063oo`03003ooooo0?ooocOoo`00Y_oo0`00G_oo
00<00?ooool0oooo=ooo002Yool3001Kool00`00ooooo`3ooolgool00:coo`<005Soo`03003ooooo
0?ooocOoo`00[ooo1000E?oo00<00?ooool0oooo=ooo002cool3001Aool00`00ooooo`3ooolgool0
0;Koo`<004koo`<00?ooocOoo`00^Ooo1000B_oo00<00?ooool0oooo=ooo002lool40017ool00`00
ooooo`3ooolgool00<3oo`<004Coo`03003ooooo0?ooocOoo`00`ooo0`00@Ooo00<00?ooool0oooo
=ooo0036ool4000mool00`00ooooo`3ooolgool00<[oo`<003[oo`03003ooooo0?ooocOoo`00cOoo
1000=_oo00<00?ooool0oooo=ooo003Aool4000bool3003ooolgool00=Goo`@002koo`03003ooooo
0?ooocOoo`00fOoo1000:_oo00<00?ooool0oooo=ooo003Mool4000Vool00`00ooooo`3ooolgool0
0=?oo`P000Koo`D000Goo`P000Goo`D000[oo`03003ooooo0?ooocOoo`00eooo00<00?ooool02?oo
0`0000?oo`0000000P0000?oo`0000001Ooo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool0
1ooo00<00?ooool0oooo=ooo003Gool00`00ooooo`08ool30005ool40004ool00`00ooooo`09ool0
0`00ooooo`06ool00`00ooooo`3ooolgool00=Ooo`03003ooooo01Coo`@000coo`03003ooooo00Ko
o`03003ooooo0?ooocOoo`00eooo00<00?ooool05Ooo00<00?ooool010002?oo00<00?ooool01_oo
1@00oooo=Ooo003Gool00`00ooooo`0Fool00`00ooooo`03ool50003ool00`00ooooo`06ool00`00
ooooo`3ooolgool00=Ooo`03003ooooo01Ooo`03003ooooo00Coo`03003ooooo00H000Koo`03003o
oooo0?ooocOoo`00eooo00<00?ooool05ooo0P001Ooo1@001?oo1`00oooo>Ooo003Gool00`00oooo
o`0Hool00`00ooooo`03ool00`00ooooo`0<ool6003oooldool00=Ooo`03003ooooo01Soo`03003o
oooo00?oo`03003ooooo00coo`03003ooooo00?oo`D00?ooobooo`00dooo00D00?ooooooo`0001?o
o`03003ooooo00Coo`03003ooooo00?oo`03003ooooo00coo`03003ooooo00Soo`H00?ooobWoo`00
e?oo10004ooo0P000ooo0P001_oo00<00?ooool03?oo00<00?ooool03_oo1P00oooo8ooo003Fool2
000Eool40007ool60009ool3000Dool6003ooolMool00?ooo`Soo`03003ooooo01[oo`H00?oooaOo
o`00oooo2?oo00<00?ooool08?oo1P00oooo4Ooo003oool8ool00`00ooooo`0Vool7003oool:ool0
0?ooo`Soo`03003ooooo02goo`H00?ooo`Coo`00oooo2?oo00<00?ooool0<ooo1P00oOoo003oool8
ool00`00ooooo`0iool7003fool00?ooo`Soo`03003ooooo043oo`H00?3oo`00oooo2?oo0`00A_oo
2000j?oo003oool8ool00`00ooooo`1=ool9003Pool00?ooo`Soo`03003ooooo05Goo`T00=Soo`00
oooo2?oo00<00?ooool0GOoo2@00d?oo003oool8ool00`00ooooo`1Uool90038ool00?ooo`Soo`03
003ooooo06goo`T00<3oo`00oooo2?oo00<00?ooool0MOoo2@00^?oo003oool8ool00`00ooooo`1m
ool:002_ool00?ooo`Soo`<008Ooo`/00:Coo`00oooo2?oo00<00?ooool0T_oo3000V?oo003oool8
ool00`00ooooo`2Mool<002=ool00?ooo`Soo`03003ooooo0:Woo`/008;oo`00oooo2?oo00<00?oo
ool0]?oo4`00Kooo003oool8ool00`00ooooo`36oolI001Gool00?ooo`Soo`03003ooooo0=oooa<0
04Coo`00oooo2?oo00<00?ooool0lOoo7@00:?oo003oool8ool3003oool>ool=000Lool00?ooo`So
o`03003ooooo0?ooocOoo`00oooo2?oo00<00?ooool0oooo=ooo003oool8ool00`00ooooo`3ooolg
ool00=ooo`P000Ooo`8000Soo`D000[oo`03003ooooo0?ooocOoo`00hooo00<00?ooool02?oo0`00
1_oo00<00?ooool00ooo00<00?ooool01ooo00<00?ooool0oooo=ooo003Sool00`00ooooo`08ool3
000=ool00`00ooooo`06ool00`00ooooo`3ooolgool00>?oo`03003ooooo01Soo`03003ooooo00Ko
o`03003ooooo0?ooocOoo`00hooo00<00?ooool06?oo00<00?ooool01_oo1@00oooo=Ooo003Sool0
0`00ooooo`0Hool00`00ooooo`06ool00`00ooooo`3ooolgool00>?oo`03003ooooo01;oo`03003o
oooo00;oo`03003ooooo00Ooo`03003ooooo0?ooocOoo`00hooo00<00?ooool04_oo1@002_oo00<0
0?ooool0oooo=ooo003Sool00`00ooooo`0Bool00`00ooooo`0<ool00`00ooooo`3ooolgool00>?o
o`03003ooooo01;oo`03003ooooo00coo`03003ooooo0?ooocOoo`00gooo00D00?ooooooo`0001Co
o`03003ooooo00coo`03003ooooo0?ooocOoo`00h?oo10005?oo00<00?ooool03?oo00<00?ooool0
oooo=ooo003Rool2000Dool60009ool3003ooolgool00?ooo`Soo`03003ooooo0?ooocOoo`00oooo
2?oo00<00?ooool0oooo=ooo003oool8ool00`00ooooo`3ooolgool00?ooo`Soo`03003ooooo0?oo
ocOoo`00oooo2?oo00<00?ooool0oooo=ooo003oool8ool00`00ooooo`3ooolgool00?ooo`Soo`03
003ooooo0?ooocOoo`00oooo2?oo0`00oooo=ooo003oool8ool00`00ooooo`3ooolgool00?ooo`So
o`03003ooooo0?ooocOoo`00oooo2?oo00<00?ooool0oooo=ooo003oool8ool00`00ooooo`3ooolg
ool00?ooo`Soo`03003ooooo0?ooocOoo`00oooo2?oo00<00?ooool0oooo=ooo003oool8ool00`00
ooooo`3ooolgool00?ooo`Soo`<00?ooocOoo`00oooo2?oo00<00?ooool0oooo=ooo003oool8ool0
0`00ooooo`3ooolgool00?ooo`Soo`03003ooooo0?ooocOoo`00oooo2?oo00<00?ooool0oooo=ooo
003oool8ool00`00ooooo`3ooolgool00?ooo`Soo`03003ooooo0?ooocOoo`00oooo2?oo00<00?oo
ool0oooo=ooo003oool8ool3003ooolgool00?ooo`Soo`03003ooooo0?ooocOoo`00oooo2?oo00<0
0?ooool0oooo=ooo003oool8ool00`00ooooo`3ooolgool00?ooo`Soo`03003ooooo0?ooocOoo`00
dooo20001ooo0P002_oo00<00?ooool01ooo1@002_oo00<00?ooool0oooo=ooo003Gool00`00oooo
o`08ool30009ool20007ool00`00ooooo`03ool00`00ooooo`07ool00`00ooooo`3ooolgool00=Oo
o`03003ooooo00Soo`<000[oo`03003ooooo00coo`03003ooooo00Koo`03003ooooo0?ooocOoo`00
eooo00<00?ooool05Ooo00<00?ooool03?oo00<00?ooool01_oo1@00oooo=Ooo003Gool00`00oooo
o`0Eool2000=ool00`00ooooo`06ool00`00ooooo`3ooolgool00=Ooo`03003ooooo01Koo`03003o
oooo00_oo`03003ooooo00Koo`03003ooooo0?ooocOoo`00eooo00<00?ooool05_oo00<00?ooool0
1Ooo00<00?ooool00_oo00<00?ooool01ooo00<00?ooool0oooo=ooo003Gool00`00ooooo`0Fool2
0006ool5000:ool00`00ooooo`3ooolgool00=Ooo`03003ooooo01Ooo`03003ooooo00Coo`03003o
oooo00coo`03003ooooo0?ooocOoo`00eooo00<00?ooool05ooo00<00?ooool01?oo00<00?ooool0
3?oo00<00?ooool0oooo=ooo003Cool01@00oooooooo00004ooo00<00?ooool00ooo0P001Ooo00<0
0?ooool03?oo00<00?ooool0oooo=ooo003Dool4000Cool00`00ooooo`04ool00`00ooooo`03ool0
0`00ooooo`0<ool3003ooolgool00=Koo`8001?oo`P000Goo`H000Woo`03003ooooo0?ooocOoo`00
oooo2?oo00<00?ooool0oooo=ooo003oool8ool00`00ooooo`3ooolgool00?ooo`Soo`03003ooooo
0?ooocOoo`00oooo2?oo00<00?ooool0oooo=ooo003oool8ool00`00ooooo`3ooolgool00?ooo`So
o`03003ooooo0?ooocOoo`00oooo2?oo0`00oooo=ooo003oool8ool00`00ooooo`3ooolgool00?oo
o`Soo`03003ooooo0?ooocOoo`00oooo2?oo00<00?ooool0oooo=ooo003oool8ool00`00ooooo`3o
oolgool00?ooo`Soo`03003ooooo0?ooocOoo`00oooo2?oo00<00?ooool0oooo=ooo003oool8ool0
0`00ooooo`3ooolgool00?ooo`Soo`<00?ooocOoo`00oooo2?oo00<00?ooool0oooo=ooo003oool8
ool00`00ooooo`3ooolgool00?ooo`Soo`03003ooooo0?ooocOoo`00oooo2?oo00<00?ooool0oooo
=ooo003oool8ool00`00ooooo`3ooolgool00?ooo`Soo`03003ooooo0?ooocOoo`00oooo2?oo00<0
0?ooool0oooo=ooo003oool8ool3003ooolgool00?ooo`Soo`03003ooooo0?ooocOoo`00oooo2?oo
00<00?ooool0oooo=ooo003oool8ool00`00ooooo`3ooolgool00?ooo`Soo`03003ooooo0?ooocOo
o`00mooo20002?oo00<00?ooool0oooo=ooo003gool20005ool00`00ooooo`06ool00`00ooooo`3o
oolgool00?Woo`03003ooooo00;oo`03003ooooo00Koo`03003ooooo0?ooocOoo`00n_oo00<00?oo
ool02_oo1@00oooo=Ooo003kool00`00ooooo`3ooom3ool00?coo`03003ooooo0?oood;oo`00oOoo
00<00?ooool0oooo@Ooo003mool2003ooom2ool00?koo`03003ooooo0?oood3oo`00o_oo00<00?oo
ool0oooo@?oo003gool00`00ooooo`04ool00`00ooooo`3ooom0ool00?Ooo`8000?oo`800?oood?o
o`00nOoo1000ooooA?oo0000\
\>"],
  ImageRangeCache->{{{0, 575}, {354.875, 0}} -> {-0.511853, -0.15248, 
  0.00388058, 0.0124466}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(ParametricPlot[
      \ {\ 4  Cos[t] + 2  Cos[2  t], \ 4  Sin[t] - 2  Sin[2  t]}, 
      \ {t, 0, 2  Pi}]; \)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.341269 0.10582 0.309019 0.0566389 [
[.12963 .29652 -6 -9 ]
[.12963 .29652 6 0 ]
[.55291 .29652 -3 -9 ]
[.55291 .29652 3 0 ]
[.76455 .29652 -3 -9 ]
[.76455 .29652 3 0 ]
[.97619 .29652 -3 -9 ]
[.97619 .29652 3 0 ]
[.32877 .08246 -12 -4.5 ]
[.32877 .08246 0 4.5 ]
[.32877 .19574 -12 -4.5 ]
[.32877 .19574 0 4.5 ]
[.32877 .4223 -6 -4.5 ]
[.32877 .4223 0 4.5 ]
[.32877 .53557 -6 -4.5 ]
[.32877 .53557 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.12963 .30902 m
.12963 .31527 L
s
[(-2)] .12963 .29652 0 1 Mshowa
.55291 .30902 m
.55291 .31527 L
s
[(2)] .55291 .29652 0 1 Mshowa
.76455 .30902 m
.76455 .31527 L
s
[(4)] .76455 .29652 0 1 Mshowa
.97619 .30902 m
.97619 .31527 L
s
[(6)] .97619 .29652 0 1 Mshowa
.125 Mabswid
.18254 .30902 m
.18254 .31277 L
s
.23545 .30902 m
.23545 .31277 L
s
.28836 .30902 m
.28836 .31277 L
s
.39418 .30902 m
.39418 .31277 L
s
.44709 .30902 m
.44709 .31277 L
s
.5 .30902 m
.5 .31277 L
s
.60582 .30902 m
.60582 .31277 L
s
.65873 .30902 m
.65873 .31277 L
s
.71164 .30902 m
.71164 .31277 L
s
.81746 .30902 m
.81746 .31277 L
s
.87037 .30902 m
.87037 .31277 L
s
.92328 .30902 m
.92328 .31277 L
s
.07672 .30902 m
.07672 .31277 L
s
.02381 .30902 m
.02381 .31277 L
s
.25 Mabswid
0 .30902 m
1 .30902 L
s
.34127 .08246 m
.34752 .08246 L
s
[(-4)] .32877 .08246 1 0 Mshowa
.34127 .19574 m
.34752 .19574 L
s
[(-2)] .32877 .19574 1 0 Mshowa
.34127 .4223 m
.34752 .4223 L
s
[(2)] .32877 .4223 1 0 Mshowa
.34127 .53557 m
.34752 .53557 L
s
[(4)] .32877 .53557 1 0 Mshowa
.125 Mabswid
.34127 .11078 m
.34502 .11078 L
s
.34127 .1391 m
.34502 .1391 L
s
.34127 .16742 m
.34502 .16742 L
s
.34127 .22406 m
.34502 .22406 L
s
.34127 .25238 m
.34502 .25238 L
s
.34127 .2807 m
.34502 .2807 L
s
.34127 .33734 m
.34502 .33734 L
s
.34127 .36566 m
.34502 .36566 L
s
.34127 .39398 m
.34502 .39398 L
s
.34127 .45062 m
.34502 .45062 L
s
.34127 .47894 m
.34502 .47894 L
s
.34127 .50725 m
.34502 .50725 L
s
.34127 .05414 m
.34502 .05414 L
s
.34127 .02582 m
.34502 .02582 L
s
.34127 .56389 m
.34502 .56389 L
s
.34127 .59221 m
.34502 .59221 L
s
.25 Mabswid
.34127 0 m
.34127 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.97619 .30902 m
.97615 .30902 L
.97605 .30902 L
.97586 .30902 L
.97559 .30902 L
.97494 .30903 L
.97397 .30904 L
.97257 .30907 L
.97072 .30911 L
.96645 .30923 L
.96079 .30945 L
.95434 .30975 L
.93561 .31086 L
.91094 .3128 L
.88377 .31543 L
.80827 .32498 L
.72944 .33796 L
.63374 .35747 L
.43554 .41072 L
.26005 .47431 L
.11944 .54109 L
.04337 .58807 L
.02814 .59964 L
.02445 .60275 L
.02405 .60311 L
.02385 .60329 L
.02381 .60332 L
.02381 .60332 L
.02385 .60328 L
.02393 .60321 L
.0259 .60126 L
.0304 .59643 L
.04561 .57769 L
.06443 .54959 L
.08294 .51547 L
.10155 .47118 L
.11004 .44524 L
.11759 .4163 L
.12292 .38935 L
.12527 .3739 L
.12697 .35969 L
.12819 .3463 L
.12872 .3387 L
.1291 .33169 L
.12935 .32553 L
.12945 .32203 L
.12953 .31876 L
.12959 .3153 L
.12962 .31215 L
.12963 .30851 L
Mistroke
.12961 .30505 L
.12957 .30131 L
.12953 .29921 L
.12949 .29728 L
.12939 .29373 L
.12926 .28998 L
.12896 .28349 L
.12853 .27639 L
.12722 .26072 L
.12555 .24624 L
.1215 .22062 L
.11577 .19404 L
.10822 .16679 L
.09865 .13899 L
.07886 .09436 L
.05865 .05921 L
.03975 .03271 L
.02761 .01856 L
.02478 .01566 L
.02402 .01492 L
.02384 .01474 L
.02381 .01472 L
.02382 .01472 L
.02387 .01477 L
.02398 .01487 L
.02428 .01514 L
.02534 .01607 L
.0299 .01982 L
.05038 .0349 L
.13312 .08432 L
.26548 .14597 L
.44808 .21122 L
.63771 .26146 L
.73525 .28113 L
.81763 .29441 L
.88527 .30277 L
.93269 .30697 L
.95089 .30811 L
.96362 .3087 L
.96894 .30888 L
.97256 .30897 L
.97396 .309 L
.9751 .30901 L
.97553 .30901 L
.97572 .30902 L
.97587 .30902 L
.97598 .30902 L
.97607 .30902 L
.97617 .30902 L
.97619 .30902 L
Mistroke
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000900001Ha000`40n007h00Oa?oo00<00?ooool0
ooooN_oo0034ool00`00ooooo`3ooomjool00<Coo`03003ooooo0?ooog[oo`00a?oo00<00?ooool0
ooooN_oo0034ool00`00ooooo`3ooomjool00<Coo`03003ooooo0?ooog[oo`00a?oo00<00?ooool0
ooooN_oo0034ool00`00ooooo`3ooomjool000koo`03003ooooo0;?oo`03003ooooo0?ooog[oo`00
3_oo0P00]?oo00<00?ooool0ooooN_oo000?ool2002cool00`00ooooo`3ooomjool0017oo`03003o
oooo0;3oo`03003ooooo0?ooog[oo`004_oo0P00/?oo00<00?ooool0ooooN_oo000Bool3002_ool0
0`00ooooo`3ooomjool001?oo`<00:koo`<00?ooog[oo`005?oo1000[?oo00<00?ooool0ooooN_oo
000Eool01000ool00000Zooo00<00?ooool0ooooN_oo000Fool01000ooooo`00Z_oo00<00?ooool0
ooooN_oo000Gool00`00ooooo`02002Xool00`00ooooo`3ooomjool001Soo`03003ooooo00800:Oo
o`03003ooooo0?ooog[oo`006?oo00<00?ooool00_oo00<00?ooool0Y?oo00<00?ooool0ooooN_oo
000Iool00`00ooooo`02ool2002Tool00`00ooooo`3ooomjool001[oo`03003ooooo00?oo`800:;o
o`03003ooooo0?ooog[oo`006_oo0P001_oo0P00X?oo00<00?ooool0ooooN_oo000Kool00`00oooo
o`05ool2002Oool00`00ooooo`3ooomjool001coo`03003ooooo00Koo`8009goo`03003ooooo0?oo
og[oo`007?oo0P002Ooo0P00Vooo00<00?ooool0ooooN_oo000Mool00`00ooooo`08ool2002Jool0
0`00ooooo`3ooomjool001koo`03003ooooo00Woo`8009Soo`03003ooooo0?ooog[oo`007_oo0P00
3?oo0P00U_oo00<00?ooool0ooooN_oo000Oool00`00ooooo`0;ool2002Eool00`00ooooo`3ooomj
ool0023oo`03003ooooo00coo`8009?oo`<00?ooog[oo`008Ooo00<00?ooool03Ooo0P00TOoo00<0
0?ooool0ooooN_oo000Qool00`00ooooo`0>ool2002@ool00`00ooooo`3ooomjool002;oo`03003o
oooo00ooo`8008koo`03003ooooo0?ooog[oo`008_oo0P004_oo0P00S?oo00<00?ooool0ooooN_oo
000Sool00`00ooooo`0Aool2002;ool00`00ooooo`3ooomjool002Coo`03003ooooo01;oo`8008Wo
o`03003ooooo0?ooog[oo`009?oo00<00?ooool05?oo0P00Qooo00<00?ooool0ooooN_oo000Uool0
0`00ooooo`0Dool20026ool00`00ooooo`3ooomjool002Goo`03003ooooo01Koo`8008Coo`03003o
oooo0?ooog[oo`009_oo00<00?ooool05ooo0P00P_oo00<00?ooool0ooooN_oo000Vool00`00oooo
o`0Hool20021ool00`00ooooo`3ooomjool002Ooo`03003ooooo01Woo`80073oo`H000Woo`03003o
oooo0?ooog[oo`009ooo0P007?oo0P00LOoo00<00?ooool02Ooo00<00?ooool0ooooN_oo000Xool0
0`00ooooo`0Kool2001`ool00`00ooooo`09ool00`00ooooo`3ooomjool002Woo`03003ooooo01co
o`8006Woo`P000Woo`03003ooooo0?ooog[oo`00:Ooo00<00?ooool07_oo0P00Iooo00<00?ooool0
0_oo00<00?ooool02Ooo1000ooooNOoo000Zool00`00ooooo`0Oool2001Vool01@00oooooooo0000
2ooo00<00?ooool0ooooN_oo000Zool00`00ooooo`0Pool3001Iool40007ool01@00oooooooo0000
2ooo00<00?ooool0ooooN_oo000[ool00`00ooooo`0Rool2001Sool01000ooooo`002ooo00<00?oo
ool0ooooN_oo000[ool00`00ooooo`0Tool2001Qool01000ooooo`002ooo00<00?ooool0ooooN_oo
000/ool00`00ooooo`0Uool2001Pool00`00ool0000;ool00`00ooooo`3ooomjool002coo`8002So
o`<005goo`03003oo`0000_oo`03003ooooo0?ooog[oo`00;Ooo00<00?ooool0:?oo0`00G?oo0P00
2ooo00<00?ooool0ooooN_oo000]ool2000/ool2001Jool2000;ool00`00ooooo`3ooomjool002ko
o`03003ooooo02coo`8006Goo`03003ooooo0?ooog[oo`00;_oo00<00?ooool0;_oo0P00Hooo00<0
0?ooool0ooooN_oo000_ool00`00ooooo`0_ool2001Qool00`00ooooo`3ooomjool002ooo`03003o
oooo037oo`<005koo`03003ooooo0?ooog[oo`00<?oo00<00?ooool0<_oo0`00G?oo00<00?ooool0
ooooN_oo000`ool00`00ooooo`0eool2001Jool00`00ooooo`3ooomjool0037oo`03003ooooo03Ko
o`8005Soo`03003ooooo0?ooog[oo`00<Ooo00<00?ooool0>?oo0P00E_oo0`00ooooN_oo000bool0
0`00ooooo`0iool2001Dool00`00ooooo`3ooomjool003;oo`03003ooooo03_oo`<0057oo`03003o
oooo0?ooog[oo`00<ooo00<00?ooool0??oo0`00Cooo00<00?ooool0ooooN_oo000cool00`00oooo
o`0oool2001=ool00`00ooooo`3ooomjool003Coo`03003ooooo043oo`8004_oo`03003ooooo0?oo
og[oo`00=?oo00<00?ooool0@_oo0P00BOoo00<00?ooool0ooooN_oo000eool00`00ooooo`13ool2
0017ool00`00ooooo`3ooomjool003Goo`03003ooooo04Goo`<004Coo`03003ooooo0?ooog[oo`00
=_oo00<00?ooool0A_oo0`00@_oo00<00?ooool0ooooN_oo000fool00`00ooooo`19ool20010ool0
0`00ooooo`3ooomjool003Ooo`03003ooooo04[oo`8003koo`03003ooooo0?ooog[oo`00=ooo00<0
0?ooool0C?oo0P00??oo00<00?ooool0ooooN_oo000hool00`00ooooo`1=ool2000jool00`00oooo
o`3ooomjool003Soo`03003ooooo04ooo`<003Ooo`03003ooooo0?ooog[oo`00>?oo0P00D_oo0`00
=Ooo00<00?ooool0ooooN_oo000iool00`00ooooo`1Cool2000cool3003ooomjool003Woo`03003o
oooo05Goo`80037oo`03003ooooo0?ooog[oo`00>_oo00<00?ooool0E_oo0P00;ooo00<00?ooool0
ooooN_oo000jool00`00ooooo`1Hool3000/ool00`00ooooo`3ooomjool003[oo`03003ooooo05[o
o`<002[oo`03003ooooo0?ooog[oo`00>ooo00<00?ooool0G?oo0`009ooo00<00?ooool0ooooN_oo
000kool00`00ooooo`1Oool2000Uool00`00ooooo`3ooomjool003_oo`03003ooooo067oo`<002;o
o`03003ooooo0?ooog[oo`00>ooo0P00IOoo0`007ooo00<00?ooool0ooooN_oo000lool00`00oooo
o`1Vool3000Lool00`00ooooo`3ooomjool003coo`03003ooooo06Woo`<001Woo`03003ooooo0?oo
og[oo`00??oo00<00?ooool0Jooo0`005ooo00<00?ooool0ooooN_oo000mool00`00ooooo`1]ool3
000Dool00`00ooooo`3ooomjool003goo`03003ooooo073oo`<0017oo`03003ooooo0?ooog[oo`00
?Ooo00<00?ooool0Looo0`003_oo00<00?ooool0ooooN_oo000nool00`00ooooo`1dool3000<ool0
0`00ooooo`3ooomjool003koo`03003ooooo07Ooo`<000Woo`03003ooooo0?ooog[oo`00?_oo00<0
0?ooool0N_oo0`001_oo0`00ooooN_oo000nool2001nool30003ool00`00ooooo`3ooomjool003oo
o`03003ooooo07koo`<00003ool00?oo0?ooog_oo`00?ooo00<00?ooool0POoo0`00ooooNooo000o
ool00`00ooooo`22ool00`00ool00002003ooomhool003ooo`8008?oo`03003ooooo00;oo`<00?oo
ogGoo`00@?oo00<00?ooool0POoo00<00?ooool01Ooo0P00ooooLooo0010ool00`00ooooo`21ool0
0`00ooooo`07ool3003ooom`ool0043oo`03003ooooo087oo`03003ooooo00[oo`<00?ooofgoo`00
@?oo0P00P_oo00<00?ooool03Ooo0`00ooooJ_oo0011ool00`00ooooo`20ool00`00ooooo`0@ool3
003ooomWool0047oo`03003ooooo083oo`03003ooooo01;oo`<00?ooofGoo`00@Ooo00<00?ooool0
Kooo20002Ooo00<00?ooool05Ooo0`00ooooH_oo0011ool2001`ool20005ool00`00ooooo`07ool0
0`00ooooo`0Hool3003ooomOool004;oo`03003ooooo073oo`03003ooooo00;oo`03003ooooo00Oo
o`03003ooooo01_oo`<00?oooecoo`00@_oo00<00?ooool0LOoo00<00?ooool02ooo00<00?ooool0
7Ooo0`00ooooF_oo0012ool00`00ooooo`1bool00`00ooooo`0:ool4000Oool3003ooomGool004?o
o`03003ooooo07;oo`03003ooooo00Woo`03003ooooo02?oo`<00?oooeCoo`00@ooo00<00?ooool0
Hooo10003?oo00<00?ooool02?oo00<00?ooool09_oo0`00ooooDOoo0013ool00`00ooooo`1cool2
0009ool00`00ooooo`0Xool3003ooom?ool004?oo`03003ooooo07Coo`03003ooooo00Ooo`03003o
oooo02_oo`<00?ooodcoo`00A?oo00<00?ooool0Looo00<00?ooool01ooo00<00?ooool0;_oo0`00
ooooBOoo0014ool00`00ooooo`1/ool00`00ooooo`04ool00`00ooooo`07ool00`00ooooo`0aool3
003ooom6ool004Coo`03003ooooo06coo`8000?oo`8000[oo`03003ooooo03Coo`800?ooodCoo`00
A?oo00<00?ooool0K_oo10002ooo00<00?ooool0=_oo0`00oooo@Ooo0015ool00`00ooooo`1lool0
0`00ooooo`0iool3003ooolnool004Goo`03003ooooo07coo`03003ooooo03coo`@00?oooc[oo`00
AOoo00<00?ooool0O?oo00<00?ooool0@?oo1000oooo=_oo0015ool00`00ooooo`1lool00`00oooo
o`14ool4003ooolbool004Koo`03003ooooo07_oo`03003ooooo04Soo`<00?ooobooo`00A_oo00<0
0?ooool0Nooo00<00?ooool0Booo1000oooo:ooo0016ool00`00ooooo`1kool00`00ooooo`1?ool4
003ooolWool004Koo`03003ooooo07_oo`<005?oo`@00?ooob?oo`00A_oo00<00?ooool0Nooo00<0
0?ooool0Eooo1000oooo7ooo0017ool00`00ooooo`1jool00`00ooooo`1Jool4003ooolLool004Oo
o`03003ooooo07[oo`03003ooooo05koo`@00?oooaSoo`00Aooo00<00?ooool0N_oo00<00?ooool0
H_oo1000oooo5?oo0017ool00`00ooooo`1jool00`00ooooo`1Vool4003oool@ool004Ooo`03003o
oooo07[oo`03003ooooo06Woo`@00?ooo`goo`00Aooo00<00?ooool0N_oo00<00?ooool0KOoo1000
oooo2Ooo0017ool00`00ooooo`1jool00`00ooooo`1aool4003oool5ool004Ooo`03003ooooo07[o
o`03003ooooo07Goo`@00?ooo`7oo`00B?oo00<00?ooool0NOoo00<00?ooool0N?oo1000oOoo0018
ool00`00ooooo`1iool00`00ooooo`1lool4003iool004Soo`03003ooooo07Woo`03003ooooo083o
o`@00?Goo`00B?oo00<00?ooool0NOoo00<00?ooool0Q?oo1000lOoo0018ool00`00ooooo`1iool0
0`00ooooo`27ool4003^ool004Soo`03003ooooo07Woo`03003ooooo08_oo`@00>[oo`00B?oo00<0
0?ooool0NOoo00<00?ooool0Sooo1000i_oo0018ool2001jool3002Cool4003Rool004Woo`03003o
oooo07Soo`03003ooooo09Ooo`<00=ooo`00BOoo00<00?ooool0N?oo00<00?ooool0V_oo1000fooo
0019ool00`00ooooo`1hool00`00ooooo`2Nool4003Gool004Woo`03003ooooo07Soo`03003ooooo
0:;oo`@00=?oo`00BOoo00<00?ooool0N?oo00<00?ooool0Y_oo1000cooo0019ool00`00ooooo`1h
ool00`00ooooo`2Zool5003:ool004Woo`03003ooooo07Soo`03003ooooo0:ooo`D00<Goo`00BOoo
00<00?ooool0N?oo00<00?ooool0]?oo1@00`?oo001:ool00`00ooooo`1gool00`00ooooo`2iool5
002kool004[oo`03003ooooo07Ooo`03003ooooo0;koo`H00;Goo`00B_oo00<00?ooool0Mooo00<0
0?ooool0`ooo1P00/?oo001:ool00`00ooooo`1gool00`00ooooo`39ool5002[ool004[oo`03003o
o`0000L0073oo`03003ooooo07;oo`P005Coo`D001_oo`H007?oo`@000koo`00B_oo00@00?oo0000
00Goo`03003ooooo06koo`03003ooooo07;oo`8000Goo`03003ooooo05Ooo`D001Woo`03003ooooo
07;oo`8000?oo`03003ooooo00_oo`00B_oo00D00?ooooooo`0000Coo`03003ooooo06koo`03003o
oooo07Coo`03003ooooo00;oo`03003ooooo05coo`D001Coo`03003ooooo07;oo`03003ooooo00?o
o`03003ooooo00[oo`00B_oo00<00?ooool00_oo00<00?ooool0L_oo0`00MOoo00<00?ooool0IOoo
1@002_oo2000LOoo00<00?ooool01?oo00<00?ooool02_oo001:ool00`00ooooo`03ool00`00oooo
o`1aool00`00ooooo`1fool00`00ooooo`1Yool60004ool00`00ooooo`02ool00`00ooooo`1aool0
0`00ooooo`04ool00`00ooooo`0:ool004[oo`03003ooooo00Coo`03003ooooo073oo`03003ooooo
07Ooo`03003ooooo06koo`H000?oo`03003ooooo077oo`8000Coo`8000coo`00@_oo10001?oo00<0
0?ooool01Ooo00<00?ooool0Kooo00<00?ooool0N?oo00<00?ooool0L_oo1`00LOoo00<00?oo0000
0ooo00<00?ooool02ooo001:ool00`00ooooo`05ool2001`ool00`00ooooo`1hool2001dool01000
ooooo`000_oo1P00Jooo00<00?ooool00`003_oo001:ool00`00ooooo`06ool00`00ooooo`1^ool0
0`00ooooo`1iool00`00ooooo`1bool01000ooooo`002?oo1P00IOoo00<00?ooool04Ooo001:ool0
0`00ooooo`06ool00`00ooooo`1^ool00`00ooooo`1iool00`00ooooo`1cool00`00ool0000>ool6
001Pool00`00ooooo`0@ool004[oo`03003oo`0000Koo`03003ooooo06koo`03003ooooo07;oo`03
003ooooo00Coo`03003ooooo07?oo`03003oo`0001Coo`H005[oo`80017oo`00B_oo00@00?oo0000
00?oo`80077oo`03003ooooo07;oo`8000?oo`8007Ooo`8001[oo`L005Coo`80013oo`00B_oo00@0
0?ooooooo`@007;oo`03003ooooo07Coo`@007Soo`80027oo`X004coo`@000coo`00B_oo00<00?oo
ool0Mooo00<00?ooool0oooo7_oo2P00D_oo001:ool00`00ooooo`1gool00`00ooooo`3ooolXool:
0018ool004[oo`03003ooooo07Ooo`03003ooooo0?oooc;oo`T003ooo`00B_oo00<00?ooool0Mooo
00<00?ooool0oooo>ooo2@00=_oo001:ool00`00ooooo`1gool00`00ooooo`3ooom4ool9000]ool0
04[oo`03003ooooo07Ooo`03003ooooo0?ooodgoo`X002?oo`00o`00o`00@@000Ooo000>ool00`00
ooooo`0Kool00`00ooooo`0Kool00`00ooooo`0Lool00`00ooooo`0Kool00`00ooooo`0Kool00`00
ooooo`0Lool00`00ooooo`0Kool00`00ooooo`0Lool00`00ooooo`0Kool00`00ooooo`0Kool00`00
ooooo`0Lool00`00ooooo`0Kool00`00ooooo`0Lool00`00ooooo`0Kool00`00ooooo`0Kool00`00
ooooo`0Lool00`00ooooo`0Kool=000Aool00`00ooooo`0=ool000koo`03003ooooo01_oo`03003o
oooo01_oo`03003ooooo01coo`03003ooooo01_oo`03003ooooo01_oo`03003ooooo01coo`03003o
oooo01_oo`03003ooooo01coo`03003ooooo01_oo`03003ooooo01_oo`03003ooooo01coo`03003o
oooo01_oo`03003ooooo01coo`03003ooooo01_oo`03003ooooo01_oo`03003ooooo01coo`03003o
oooo013oo``001goo`03003ooooo00goo`00B_oo00<00?ooool0Mooo00<00?ooool0M_oo00<00?oo
ool0Mooo00<00?ooool0AOoo2@00:?oo00<00?ooool03Ooo001:ool00`00ooooo`1gool00`00oooo
o`1fool00`00ooooo`1gool00`00ooooo`0mool9000`ool00`00ooooo`0=ool004[oo`03003ooooo
07Ooo`03003ooooo0?ooobWoo`P004Woo`00B_oo00<00?ooool0Mooo00<00?ooool0oooo8?oo2@00
DOoo001:ool00`00ooooo`1gool00`00ooooo`3ooolGool9001Jool004[oo`03003ooooo07Ooo`03
003ooooo0?ooo`ooo`P006?oo`00B_oo00<00?ooool0Mooo00<00?ooool0oooo2?oo1`00Jooo001:
ool00`00ooooo`1gool00`00ooooo`3oool2ool6001bool004[oo`03003ooooo07Ooo`03003ooooo
0?_oo`H007Soo`00B_oo00<00?ooool0Mooo00<00?ooool0m_oo1@00O_oo001:ool00`00ooooo`1g
ool00`00ooooo`3`ool60023ool004[oo`03003ooooo07Ooo`03003ooooo0>_oo`D008Woo`00B_oo
00<00?ooool0Mooo00<00?ooool0iOoo1P00S_oo001:ool00`00ooooo`1gool3003Oool6002Dool0
04[oo`03003ooooo07Ooo`03003ooooo0=[oo`D009[oo`00B_oo00<00?ooool0Mooo00<00?ooool0
eOoo1@00Wooo001:ool00`00ooooo`1gool00`00ooooo`3@ool5002Tool004[oo`03003ooooo07Oo
o`03003ooooo0<_oo`D00:Woo`00B_oo00<00?ooool0Mooo00<00?ooool0a_oo1@00[_oo001:ool0
0`00ooooo`1gool00`00ooooo`31ool5002cool004[oo`03003ooooo07Ooo`03003ooooo0;coo`D0
0;Soo`00B_oo00<00?ooool0Mooo00<00?ooool0]ooo1@00_Ooo0019ool2001iool00`00ooooo`2b
ool50032ool004Woo`03003ooooo07Soo`03003ooooo0:goo`D00<Ooo`00BOoo00<00?ooool0N?oo
00<00?ooool0Z?oo1@00c?oo0019ool00`00ooooo`1hool00`00ooooo`2Tool4003Aool004Woo`03
003ooooo07Soo`03003ooooo0:3oo`@00=Goo`00BOoo00<00?ooool0N?oo00<00?ooool0W?oo1000
fOoo0019ool00`00ooooo`1hool00`00ooooo`2Hool4003Mool004Woo`03003ooooo07Soo`03003o
oooo09Coo`@00>7oo`00B?oo0P00N_oo0`00TOoo0`00iOoo0018ool00`00ooooo`1iool00`00oooo
o`2=ool4003Xool004Soo`03003ooooo07Woo`03003ooooo08Woo`@00>coo`00B?oo00<00?ooool0
NOoo00<00?ooool0QOoo1000l?oo0018ool00`00ooooo`1iool00`00ooooo`21ool4003dool004So
o`03003ooooo07Woo`03003ooooo07koo`<00?Soo`00B?oo00<00?ooool0NOoo00<00?ooool0N_oo
1000nooo0017ool00`00ooooo`1jool00`00ooooo`1fool4003oool004Ooo`03003ooooo07[oo`03
003ooooo07;oo`@00?ooo`Coo`00Aooo00<00?ooool0N_oo00<00?ooool0K_oo1000oooo2?oo0017
ool00`00ooooo`1jool00`00ooooo`1[ool3003oool<ool004Koo`03003ooooo07_oo`03003ooooo
06Ooo`@00?ooo`ooo`00A_oo00<00?ooool0Nooo00<00?ooool0Hooo1000oooo4ooo0016ool00`00
ooooo`1kool00`00ooooo`1Oool4003ooolGool004Koo`03003ooooo07_oo`03003ooooo05_oo`@0
0?oooa_oo`00A_oo00<00?ooool0Nooo00<00?ooool0F?oo0`00oooo7ooo0015ool00`00ooooo`1l
ool3001Dool4003ooolRool004Goo`03003ooooo07coo`03003ooooo053oo`@00?ooobKoo`00AOoo
00<00?ooool0O?oo00<00?ooool0C?oo1000oooo:_oo0015ool00`00ooooo`1lool00`00ooooo`18
ool4003oool^ool004Goo`03003ooooo07coo`03003ooooo04Goo`<00?oooc;oo`00A?oo0P00O_oo
00<00?ooool0@Ooo1000oooo=Ooo0014ool00`00ooooo`1mool00`00ooooo`0mool4003oooliool0
04Coo`03003ooooo07goo`03003ooooo03Woo`@00?ooocgoo`00A?oo00<00?ooool0OOoo00<00?oo
ool0=Ooo1000oooo@Ooo0014ool00`00ooooo`1mool00`00ooooo`0bool3003ooom5ool004Coo`03
003ooooo07goo`03003ooooo02ooo`<00?ooodSoo`00@ooo00<00?ooool0O_oo00<00?ooool0;Ooo
0P00ooooBooo0013ool00`00ooooo`1]ool80009ool00`00ooooo`0Zool3003ooom=ool004?oo`03
003ooooo06goo`8000Goo`03003ooooo00Ooo`03003ooooo02Ooo`<00?oooe3oo`00@ooo00<00?oo
ool0Kooo00<00?ooool00_oo00<00?ooool01ooo00<00?ooool09?oo0`00ooooDooo0012ool2001b
ool00`00ooooo`0;ool00`00ooooo`0Rool3003ooomEool004;oo`03003ooooo07;oo`03003ooooo
00[oo`@001koo`<00?oooeSoo`00@_oo00<00?ooool0Looo00<00?ooool02Ooo00<00?ooool07?oo
0`00ooooFooo0012ool00`00ooooo`1dool00`00ooooo`08ool00`00ooooo`0Iool3003ooomNool0
047oo`8007Koo`8000Woo`03003ooooo01Ooo`<00?ooof3oo`00@Ooo00<00?ooool0M_oo00<00?oo
ool01ooo00<00?ooool05?oo0`00ooooHooo0011ool00`00ooooo`1fool00`00ooooo`07ool00`00
ooooo`0Aool3003ooomVool0047oo`03003ooooo06ooo`03003ooooo00Coo`03003ooooo00Ooo`03
003ooooo00ooo`800?ooofWoo`00@?oo0P00LOoo0P000ooo0P002_oo00<00?ooool03?oo0`00oooo
Jooo0010ool00`00ooooo`1bool4000;ool00`00ooooo`09ool3003ooom^ool0043oo`03003ooooo
087oo`03003ooooo00Koo`<00?ooog7oo`00@?oo00<00?ooool0POoo00<00?ooool01?oo0`00oooo
Looo000oool20023ool01000oooooooo0`00ooooM_oo000oool00`00ooooo`22ool4003ooomiool0
03ooo`03003ooooo083oo`<00?ooogcoo`00?ooo00<00?ooool0O_oo0`0000?oo`00ool0ooooNooo
000nool00`00ooooo`1lool30004ool00`00ooooo`3ooomjool003koo`03003ooooo07Woo`<000Oo
o`<00?ooog[oo`00?_oo00<00?ooool0Mooo0P002_oo00<00?ooool0ooooN_oo000mool00`00oooo
o`1eool3000<ool00`00ooooo`3ooomjool003goo`03003ooooo07;oo`<000ooo`03003ooooo0?oo
og[oo`00?Ooo00<00?ooool0Kooo0`004_oo00<00?ooool0ooooN_oo000lool00`00ooooo`1^ool3
000Dool00`00ooooo`3ooomjool003coo`03003ooooo06_oo`<001Ooo`03003ooooo0?ooog[oo`00
??oo00<00?ooool0J?oo0`006_oo00<00?ooool0ooooN_oo000kool00`00ooooo`1Vool3000Mool0
0`00ooooo`3ooomjool003_oo`03003ooooo06Coo`<001ooo`03003ooooo0?ooog[oo`00>ooo00<0
0?ooool0HOoo0`008_oo00<00?ooool0ooooN_oo000jool00`00ooooo`1Oool3000Uool00`00oooo
o`3ooomjool003[oo`03003ooooo05goo`8002Soo`03003ooooo0?ooog[oo`00>_oo00<00?ooool0
F_oo0`00:_oo00<00?ooool0ooooN_oo000iool00`00ooooo`1Hool3000]ool00`00ooooo`3ooomj
ool003Woo`03003ooooo05Koo`<002ooo`03003ooooo0?ooog[oo`00>?oo00<00?ooool0EOoo0P00
<_oo00<00?ooool0ooooN_oo000hool00`00ooooo`1Cool2000dool3003ooomjool003Soo`03003o
oooo057oo`8003Koo`03003ooooo0?ooog[oo`00=ooo00<00?ooool0D?oo0P00>?oo00<00?ooool0
ooooN_oo000gool00`00ooooo`1>ool2000jool00`00ooooo`3ooomjool003Ooo`03003ooooo04_o
o`<003coo`03003ooooo0?ooog[oo`00=_oo00<00?ooool0B_oo0`00?_oo00<00?ooool0ooooN_oo
000fool00`00ooooo`18ool20011ool00`00ooooo`3ooomjool003Goo`03003ooooo04Ooo`8004?o
o`03003ooooo0?ooog[oo`00=Ooo00<00?ooool0AOoo0P00AOoo00<00?ooool0ooooN_oo000eool0
0`00ooooo`13ool20017ool00`00ooooo`3ooomjool003Coo`03003ooooo04;oo`8004Woo`03003o
oooo0?ooog[oo`00=?oo00<00?ooool0?ooo0`00Booo00<00?ooool0ooooN_oo000cool00`00oooo
o`0nool3001=ool00`00ooooo`3ooomjool003?oo`03003ooooo03coo`<004ooo`03003ooooo0?oo
og[oo`00<ooo00<00?ooool0>_oo0P00D_oo00<00?ooool0ooooN_oo000bool00`00ooooo`0iool2
001Dool00`00ooooo`3ooomjool003;oo`03003ooooo03Ooo`8005Koo`<00?ooog[oo`00<_oo00<0
0?ooool0=Ooo0P00F?oo00<00?ooool0ooooN_oo000aool00`00ooooo`0dool2001Jool00`00oooo
o`3ooomjool0037oo`03003ooooo037oo`<005coo`03003ooooo0?ooog[oo`00<?oo00<00?ooool0
<?oo0`00G_oo00<00?ooool0ooooN_oo000`ool00`00ooooo`0^ool3001Pool00`00ooooo`3ooomj
ool002ooo`03003ooooo02goo`8006?oo`03003ooooo0?ooog[oo`00;ooo00<00?ooool0:ooo0P00
IOoo00<00?ooool0ooooN_oo000^ool00`00ooooo`0Zool2001Wool00`00ooooo`3ooomjool002ko
o`03003ooooo02Soo`8006Woo`03003ooooo0?ooog[oo`00;Ooo00<00?ooool09ooo0P00Jooo00<0
0?ooool0ooooN_oo000/ool2000Vool3001]ool00`00ooooo`3ooomjool002coo`03003ooooo02?o
o`<0063oo`H000Woo`03003ooooo0?ooog[oo`00:ooo00<00?ooool08_oo0P00I_oo00<00?ooool0
2Ooo00<00?ooool0ooooN_oo000[ool00`00ooooo`0Pool2001Xool00`00ooooo`09ool00`00oooo
o`3ooomjool002[oo`03003ooooo01ooo`8006Goo`P000Woo`03003ooooo0?ooog[oo`00:_oo00<0
0?ooool07Ooo0P00Iooo00<00?ooool00_oo00<00?ooool02Ooo1000ooooNOoo000Yool00`00oooo
o`0Lool2001Zool01@00oooooooo00002ooo00<00?ooool0ooooN_oo000Xool2000Kool3001/ool0
1@00oooooooo00002ooo00<00?ooool0ooooN_oo000Xool00`00ooooo`0Iool2001_ool01000oooo
o`002ooo00<00?ooool0ooooN_oo000Wool00`00ooooo`0Hool2001aool01000ooooo`002ooo00<0
0?ooool0ooooN_oo000Wool00`00ooooo`0Fool2001dool00`00ool0000;ool00`00ooooo`3ooomj
ool002Koo`03003ooooo01Koo`8007Goo`03003oo`0000_oo`03003ooooo0?ooog[oo`009_oo00<0
0?ooool05?oo0P00N?oo0P002ooo00<00?ooool0ooooN_oo000Uool00`00ooooo`0Dool00`00oooo
o`1hool2000;ool00`00ooooo`3ooomjool002Coo`03003ooooo01?oo`8008Soo`03003ooooo0?oo
og[oo`009?oo00<00?ooool04Ooo0P00R_oo00<00?ooool0ooooN_oo000Sool00`00ooooo`0Aool2
002;ool00`00ooooo`3ooomjool002;oo`03003ooooo013oo`8008goo`03003ooooo0?ooog[oo`00
8Ooo0P004Ooo0P00S_oo00<00?ooool0ooooN_oo000Qool00`00ooooo`0>ool2002@ool00`00oooo
o`3ooomjool0023oo`03003ooooo00goo`8009;oo`03003ooooo0?ooog[oo`007ooo0P003_oo0P00
Tooo0`00ooooN_oo000Oool00`00ooooo`0;ool2002Eool00`00ooooo`3ooomjool001koo`03003o
oooo00_oo`8009Koo`03003ooooo0?ooog[oo`007Ooo0P002ooo0P00V?oo00<00?ooool0ooooN_oo
000Mool00`00ooooo`08ool2002Jool00`00ooooo`3ooomjool001coo`03003ooooo00Soo`8009_o
o`03003ooooo0?ooog[oo`006ooo00<00?ooool01ooo0P00WOoo00<00?ooool0ooooN_oo000Kool0
0`00ooooo`06ool2002Nool00`00ooooo`3ooomjool001[oo`03003ooooo00Goo`800:3oo`03003o
oooo0?ooog[oo`006Ooo00<00?ooool01Ooo00<00?ooool0X?oo00<00?ooool0ooooN_oo000Hool2
0005ool2002Sool00`00ooooo`3ooomjool001Ooo`8000Coo`800:Goo`03003ooooo0?ooog[oo`00
5ooo00<00?ooool00_oo0P00Y_oo00<00?ooool0ooooN_oo000Fool01000oooooooo0P00Z?oo00<0
0?ooool0ooooN_oo000Eool01@00oooooooo0000Z_oo00<00?ooool0ooooN_oo000Dool00`00oooo
o`02002[ool00`00ooooo`3ooomjool001?oo`800003ool000000:coo`03003ooooo0?ooog[oo`00
4_oo0P0000?oo`00ool0[Ooo0`00ooooN_oo000Bool00`00ool0002_ool00`00ooooo`3ooomjool0
017oo`<00;3oo`03003ooooo0?ooog[oo`004?oo0`00/Ooo00<00?ooool0ooooN_oo000@ool00`00
ooooo`2aool00`00ooooo`3ooomjool000ooo`03003ooooo0;;oo`03003ooooo0?ooog[oo`003_oo
00<00?ooool0/ooo00<00?ooool0ooooN_oo0034ool00`00ooooo`3ooomjool00<Coo`03003ooooo
0?ooog[oo`00a?oo00<00?ooool0ooooN_oo0034ool00`00ooooo`3ooomjool00<Coo`03003ooooo
0?ooog[oo`00a?oo00<00?ooool0ooooN_oo0034ool00`00ooooo`3ooomjool00<Coo`03003ooooo
0?ooog[oo`00\
\>"],
  ImageRangeCache->{{{0, 575}, {354.875, 0}} -> {-3.23155, -5.45595, 
  0.0329152, 0.0614964}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(ParametricPlot[
      \ {\ 3  Sqrt[Abs[Cos[2  t]]]\ Cos[t], \ 
        3  Sqrt[Abs[Cos[2  t]]]\ Sin[t]}, {t, 0, 2  Pi}]; \)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.499994 0.158732 0.309017 0.098101 [
[.0238 .29652 -6 -9 ]
[.0238 .29652 6 0 ]
[.18253 .29652 -6 -9 ]
[.18253 .29652 6 0 ]
[.34126 .29652 -6 -9 ]
[.34126 .29652 6 0 ]
[.65873 .29652 -3 -9 ]
[.65873 .29652 3 0 ]
[.81746 .29652 -3 -9 ]
[.81746 .29652 3 0 ]
[.97619 .29652 -3 -9 ]
[.97619 .29652 3 0 ]
[.48749 .01471 -12 -4.5 ]
[.48749 .01471 0 4.5 ]
[.48749 .11281 -12 -4.5 ]
[.48749 .11281 0 4.5 ]
[.48749 .21092 -12 -4.5 ]
[.48749 .21092 0 4.5 ]
[.48749 .40712 -6 -4.5 ]
[.48749 .40712 0 4.5 ]
[.48749 .50522 -6 -4.5 ]
[.48749 .50522 0 4.5 ]
[.48749 .60332 -6 -4.5 ]
[.48749 .60332 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.0238 .30902 m
.0238 .31527 L
s
[(-3)] .0238 .29652 0 1 Mshowa
.18253 .30902 m
.18253 .31527 L
s
[(-2)] .18253 .29652 0 1 Mshowa
.34126 .30902 m
.34126 .31527 L
s
[(-1)] .34126 .29652 0 1 Mshowa
.65873 .30902 m
.65873 .31527 L
s
[(1)] .65873 .29652 0 1 Mshowa
.81746 .30902 m
.81746 .31527 L
s
[(2)] .81746 .29652 0 1 Mshowa
.97619 .30902 m
.97619 .31527 L
s
[(3)] .97619 .29652 0 1 Mshowa
.125 Mabswid
.05554 .30902 m
.05554 .31277 L
s
.08729 .30902 m
.08729 .31277 L
s
.11904 .30902 m
.11904 .31277 L
s
.15078 .30902 m
.15078 .31277 L
s
.21428 .30902 m
.21428 .31277 L
s
.24602 .30902 m
.24602 .31277 L
s
.27777 .30902 m
.27777 .31277 L
s
.30952 .30902 m
.30952 .31277 L
s
.37301 .30902 m
.37301 .31277 L
s
.40475 .30902 m
.40475 .31277 L
s
.4365 .30902 m
.4365 .31277 L
s
.46825 .30902 m
.46825 .31277 L
s
.53174 .30902 m
.53174 .31277 L
s
.56349 .30902 m
.56349 .31277 L
s
.59523 .30902 m
.59523 .31277 L
s
.62698 .30902 m
.62698 .31277 L
s
.69047 .30902 m
.69047 .31277 L
s
.72222 .30902 m
.72222 .31277 L
s
.75397 .30902 m
.75397 .31277 L
s
.78571 .30902 m
.78571 .31277 L
s
.8492 .30902 m
.8492 .31277 L
s
.88095 .30902 m
.88095 .31277 L
s
.9127 .30902 m
.9127 .31277 L
s
.94444 .30902 m
.94444 .31277 L
s
.25 Mabswid
0 .30902 m
1 .30902 L
s
.49999 .01471 m
.50624 .01471 L
s
[(-3)] .48749 .01471 1 0 Mshowa
.49999 .11281 m
.50624 .11281 L
s
[(-2)] .48749 .11281 1 0 Mshowa
.49999 .21092 m
.50624 .21092 L
s
[(-1)] .48749 .21092 1 0 Mshowa
.49999 .40712 m
.50624 .40712 L
s
[(1)] .48749 .40712 1 0 Mshowa
.49999 .50522 m
.50624 .50522 L
s
[(2)] .48749 .50522 1 0 Mshowa
.49999 .60332 m
.50624 .60332 L
s
[(3)] .48749 .60332 1 0 Mshowa
.125 Mabswid
.49999 .03433 m
.50374 .03433 L
s
.49999 .05395 m
.50374 .05395 L
s
.49999 .07357 m
.50374 .07357 L
s
.49999 .09319 m
.50374 .09319 L
s
.49999 .13243 m
.50374 .13243 L
s
.49999 .15206 m
.50374 .15206 L
s
.49999 .17168 m
.50374 .17168 L
s
.49999 .1913 m
.50374 .1913 L
s
.49999 .23054 m
.50374 .23054 L
s
.49999 .25016 m
.50374 .25016 L
s
.49999 .26978 m
.50374 .26978 L
s
.49999 .2894 m
.50374 .2894 L
s
.49999 .32864 m
.50374 .32864 L
s
.49999 .34826 m
.50374 .34826 L
s
.49999 .36788 m
.50374 .36788 L
s
.49999 .3875 m
.50374 .3875 L
s
.49999 .42674 m
.50374 .42674 L
s
.49999 .44636 m
.50374 .44636 L
s
.49999 .46598 m
.50374 .46598 L
s
.49999 .4856 m
.50374 .4856 L
s
.49999 .52484 m
.50374 .52484 L
s
.49999 .54446 m
.50374 .54446 L
s
.49999 .56408 m
.50374 .56408 L
s
.49999 .5837 m
.50374 .5837 L
s
.25 Mabswid
.49999 0 m
.49999 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.97619 .30902 m
.97615 .3113 L
.97603 .31337 L
.97581 .31577 L
.97552 .31803 L
.97479 .32204 L
.97369 .32637 L
.97211 .33111 L
.97003 .33609 L
.96524 .34488 L
.95886 .35368 L
.9516 .36163 L
.93051 .37834 L
.91703 .38614 L
.90271 .39283 L
.88845 .39823 L
.87197 .4032 L
.86205 .40562 L
.8527 .40755 L
.84286 .40924 L
.8335 .41054 L
.82218 .41174 L
.81607 .41222 L
.81291 .41243 L
.80949 .41262 L
.80646 .41276 L
.80367 .41287 L
.79816 .41301 L
.79504 .41305 L
.79161 .41307 L
.78835 .41305 L
.78531 .41301 L
.77996 .41288 L
.77425 .41266 L
.76931 .4124 L
.76383 .41203 L
.75133 .4109 L
.73936 .40944 L
.71668 .40568 L
.69089 .39983 L
.65739 .38973 L
.6212 .37568 L
.58088 .35634 L
.55055 .33958 L
.53929 .33298 L
.52146 .32223 L
.53821 .33294 L
.57173 .35552 L
.59094 .36987 L
.61713 .39244 L
Mistroke
.63608 .41263 L
.6501 .43186 L
.65521 .44065 L
.65912 .44863 L
.6622 .45616 L
.66443 .46289 L
.66606 .46915 L
.66729 .47558 L
.66774 .47886 L
.66804 .48189 L
.66826 .48516 L
.66835 .48861 L
.66831 .49196 L
.66823 .49384 L
.66812 .49559 L
.66778 .49908 L
.66753 .50101 L
.66726 .50277 L
.66604 .50887 L
.66428 .51509 L
.66185 .52167 L
.65914 .52757 L
.65146 .54022 L
.64307 .5505 L
.63429 .55909 L
.62356 .56765 L
.61106 .57574 L
.59901 .58213 L
.58493 .5882 L
.57133 .5929 L
.55846 .59644 L
.54282 .59969 L
.53405 .60104 L
.52566 .60203 L
.52189 .60238 L
.51787 .6027 L
.51438 .60292 L
.51062 .6031 L
.50659 .60323 L
.50281 .6033 L
.50061 .60332 L
.4983 .60331 L
.49417 .60325 L
.4903 .60314 L
.48813 .60305 L
.48612 .60294 L
.47854 .60242 L
.47168 .60175 L
.46446 .60083 L
.44968 .59827 L
Mistroke
.43382 .59442 L
.42072 .59029 L
.40721 .58498 L
.38471 .5732 L
.37278 .56494 L
.36279 .55644 L
.35316 .54621 L
.3446 .5343 L
.34132 .5285 L
.33827 .52199 L
.33602 .51605 L
.33413 .50957 L
.33285 .50354 L
.33232 .50003 L
.33196 .49672 L
.33175 .49362 L
.33165 .49076 L
.33165 .48742 L
.33178 .48422 L
.33202 .481 L
.33243 .47748 L
.33294 .47412 L
.33353 .47099 L
.33536 .46359 L
.33801 .45557 L
.34529 .4397 L
.35731 .42101 L
.37206 .40338 L
.39438 .38196 L
.42396 .35862 L
.44973 .3408 L
.47077 .32722 L
.47318 .32548 L
.44896 .33986 L
.43147 .34971 L
.40328 .36437 L
.36488 .38146 L
.33019 .3938 L
.29658 .40288 L
.28246 .40584 L
.26798 .40836 L
.25587 .41006 L
.24318 .41144 L
.23653 .412 L
.23052 .41241 L
.22486 .4127 L
.21896 .41292 L
.21374 .41303 L
.20894 .41307 L
.20374 .41304 L
Mistroke
.19824 .41293 L
.19298 .41274 L
.19002 .4126 L
.18726 .41244 L
.17598 .41158 L
.16653 .41055 L
.15666 .40917 L
.13539 .40503 L
.1174 .40014 L
.10197 .39473 L
.0866 .38798 L
.06271 .37372 L
.05208 .36512 L
.04357 .35656 L
.03713 .34844 L
.03169 .3396 L
.02942 .3349 L
.02736 .32969 L
.02589 .32491 L
.02487 .32042 L
.02442 .31769 L
.02424 .31634 L
.0241 .3151 L
.02391 .31277 L
.02381 .31023 L
.02381 .30771 L
.02386 .30627 L
.02394 .30492 L
.02405 .30351 L
.02418 .30221 L
.02458 .29929 L
.02503 .29683 L
.02554 .29451 L
.02675 .29018 L
.0284 .28555 L
.0306 .28058 L
.03564 .27179 L
.04149 .26391 L
.05926 .24691 L
.07044 .23907 L
.08443 .23114 L
.09903 .22448 L
.11425 .2189 L
.129 .21458 L
.14624 .21069 L
.15657 .20888 L
.16625 .20752 L
.17175 .20688 L
.1778 .20629 L
.18312 .20587 L
Mistroke
.18905 .20549 L
.19466 .20523 L
.19997 .20506 L
.20565 .20498 L
.20888 .20497 L
.21184 .20498 L
.21719 .20507 L
.22308 .20526 L
.22873 .20553 L
.23402 .20585 L
.24566 .20683 L
.25661 .20806 L
.28242 .21218 L
.30667 .21758 L
.33416 .22549 L
.40673 .25537 L
.43709 .27143 L
.45821 .28358 L
.48511 .2998 L
.45579 .28121 L
.43895 .26998 L
.41481 .25262 L
.38736 .22982 L
.3674 .2095 L
.35218 .18973 L
.34705 .18147 L
.34244 .17279 L
.33882 .16456 L
.33618 .15717 L
.33426 .1503 L
.33349 .14686 L
.33282 .14319 L
.33235 .13995 L
.33202 .13702 L
.3318 .13424 L
.33167 .13135 L
.33163 .12821 L
.3317 .12533 L
.33189 .1222 L
.33221 .11891 L
.33265 .1157 L
.33328 .11222 L
.33497 .10535 L
.33702 .0992 L
.33934 .09361 L
.34591 .08166 L
.35487 .06982 L
.36488 .05967 L
.37568 .05093 L
.3874 .04319 L
Mistroke
.39884 .03695 L
.42496 .02631 L
.44027 .0219 L
.44746 .02023 L
.45516 .0187 L
.46187 .01758 L
.46929 .01657 L
.47609 .01583 L
.48246 .01531 L
.48634 .01508 L
.49002 .01491 L
.49333 .0148 L
.49693 .01473 L
.50084 .01472 L
.50499 .01476 L
.50854 .01486 L
.51244 .01502 L
.51626 .01523 L
.5198 .01548 L
.5278 .01623 L
.53554 .0172 L
.54373 .01851 L
.55833 .02156 L
.57123 .0251 L
.58575 .03015 L
.60067 .03672 L
.61373 .04388 L
.62502 .05145 L
.64385 .06839 L
.65198 .07856 L
.65909 .09037 L
.66196 .09663 L
.66452 .1037 L
.66549 .10702 L
.66637 .11062 L
.66706 .11405 L
.66756 .11725 L
.66797 .12069 L
.66812 .12252 L
.66824 .12446 L
.66835 .12777 L
.66835 .12967 L
.66831 .13146 L
.66814 .13483 L
.66787 .13794 L
.66742 .14158 L
.66684 .14508 L
.66526 .15214 L
.66322 .15895 L
.65636 .17517 L
Mistroke
.6462 .1921 L
.63034 .21202 L
.61069 .23158 L
.57899 .25725 L
.55444 .27445 L
.53567 .28671 L
.51824 .29777 L
.54284 .28296 L
.55886 .2737 L
.58387 .26013 L
.62747 .23969 L
.66042 .22727 L
.6919 .21794 L
.70843 .21404 L
.72345 .2111 L
.73599 .20907 L
.74922 .20737 L
.75492 .20677 L
.76089 .20623 L
.76641 .20582 L
.77141 .20552 L
.77709 .20525 L
.78314 .20506 L
.78839 .20498 L
.79385 .20497 L
.79672 .205 L
.79976 .20506 L
.80518 .20522 L
.80846 .20536 L
.81153 .20552 L
.8172 .20589 L
.82696 .20675 L
.83583 .20779 L
.85511 .21095 L
.87265 .21502 L
.89009 .22037 L
.90493 .22615 L
.91782 .2323 L
.92931 .23892 L
.93868 .24535 L
.95504 .25995 L
.96207 .2685 L
.96742 .27682 L
.97125 .28472 L
.97382 .29211 L
.97479 .29601 L
.97523 .29826 L
.97556 .30031 L
.97584 .30248 L
.97604 .30481 L
Mistroke
.97616 .30697 L
.97619 .30902 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000900001Ha000`40n007h00Ooooo8?oo00<00?oo
ool0oooo7ooo003ooolPool00`00ooooo`3ooolOool00?ooob3oo`03003ooooo0?oooaooo`00oooo
8?oo00<00?ooool0oooo7ooo003ooolPool00`00ooooo`3ooolOool00?ooo`ooo`H000_oo`03003o
oooo0?oooaooo`00oooo3ooo00<00?ooool00ooo00<00?ooool02?oo00<00?ooool0oooo7ooo003o
oolFool00`00ooooo`07ool00`00ooooo`3ooolOool00?oooaKoo`03003ooooo00Ooo`03003ooooo
0?oooaooo`00oooo4?oo8`00oooo3ooo003oool8ool90004ool00`00ooooo`08ool00`00ooooo`0?
ool5003oool;ool00?ooo`Coo`D000Woo`@000[oo`03003ooooo01Coo`D00?ooo`Koo`00oooo1@00
3ooo00<00?ooool02Ooo00<00?ooool06?oo1@00oooo0_oo003kool5000Dool00`00ooooo`08ool0
0`00ooooo`0Lool5003mool00?Ooo`@001Woo`03003ooooo00Soo`03003ooooo023oo`D00?Woo`00
looo10007Ooo00<00?ooool02?oo00<00?ooool09?oo1@00mOoo003aool2000Kool20003ool00`00
ooooo`09ool00`00ooooo`0Xool5003aool00>koo`<001ooo`<000coo`03003ooooo02coo`@00>ko
o`00k?oo0P00<Ooo00<00?ooool0<?oo0P00k?oo003Yool3000cool00`00ooooo`0bool2003Zool0
0>Ooo`8003Koo`<003Coo`800>Soo`00iOoo0P00>?oo00<00?ooool0=_oo0`00iOoo003Sool2000j
ool00`00ooooo`0hool2003Tool00>;oo`03003ooooo03[oo`03003ooooo03[oo`800>;oo`00h?oo
0P00?Ooo00<00?ooool0??oo0P00h?oo003Nool2000oool00`00ooooo`0mool2003Oool00=goo`80
043oo`03003ooooo03ooo`800=goo`00fooo0P00@_oo00<00?ooool0@?oo0P00g?oo003Iool20014
ool00`00ooooo`12ool2003Jool00=Soo`8004Goo`03003ooooo04?oo`800=Woo`00eooo00<00?oo
ool0AOoo00<00?ooool0AOoo00<00?ooool0e_oo003Eool20018ool30016ool00`00ooooo`3Eool0
0=Coo`8004Woo`03003ooooo04Ooo`03003ooooo0=Coo`00dooo00<00?ooool0BOoo00<00?ooool0
B?oo0P00e?oo003Bool00`00ooooo`1:ool00`00ooooo`19ool2003Cool00=7oo`03003ooooo04_o
o`03003ooooo04[oo`800=;oo`00d?oo00<00?ooool0C?oo00<00?ooool0Booo0P00dOoo003?ool0
0`00ooooo`1=ool00`00ooooo`1=ool00`00ooooo`3>ool00<koo`03003ooooo04koo`03003ooooo
04koo`03003ooooo0<goo`00cOoo00<00?ooool0Cooo00<00?ooool0Cooo00<00?ooool0c?oo003<
ool00`00ooooo`1@ool00`00ooooo`1@ool00`00ooooo`3;ool00<_oo`03003ooooo057oo`03003o
oooo057oo`03003ooooo0<[oo`00b_oo0P00Dooo0`00DOoo0P00booo003:ool00`00ooooo`1Bool0
0`00ooooo`1Bool00`00ooooo`39ool00<Woo`03003ooooo05?oo`03003ooooo05?oo`03003ooooo
0<Soo`00b?oo0P00EOoo00<00?ooool0E?oo00<00?ooool0aooo0038ool00`00ooooo`1Dool00`00
ooooo`1Dool20038ool00<Ooo`03003ooooo05Goo`03003ooooo05Goo`03003ooooo0<Koo`00a_oo
0P00Eooo00<00?ooool0E_oo00<00?ooool0aOoo0036ool00`00ooooo`1Fool00`00ooooo`1Fool0
0`00ooooo`35ool00<Goo`03003ooooo05Ooo`03003ooooo05Ooo`03003ooooo0<Coo`00aOoo00<0
0?ooool0Eooo00<00?ooool0Eooo0P00aOoo0034ool00`00ooooo`1Hool00`00ooooo`1Hool00`00
ooooo`33ool00<?oo`8005[oo`03003ooooo05Soo`800<Coo`00`ooo00<00?ooool0FOoo0`00FOoo
00<00?ooool0`_oo0033ool00`00ooooo`1Iool00`00ooooo`1Iool20033ool00<;oo`03003ooooo
05[oo`03003ooooo05[oo`03003ooooo0<7oo`00`_oo00<00?ooool0F_oo00<00?ooool0F_oo00<0
0?ooool0`Ooo0032ool00`00ooooo`1Jool00`00ooooo`1Jool20032ool00<7oo`03003ooooo05_o
o`03003ooooo05_oo`03003ooooo0<3oo`00`Ooo00<00?ooool0Fooo00<00?ooool0Fooo00<00?oo
ool0`?oo0031ool00`00ooooo`1:ool80009ool00`00ooooo`1Lool00`00ooooo`2oool00<3oo`80
04coo`8000Goo`03003ooooo00Ooo`03003ooooo05coo`03003ooooo0;ooo`00`?oo00<00?ooool0
COoo00<00?ooool00_oo00<00?ooool01ooo00<00?ooool0G?oo00<00?ooool0_ooo0030ool00`00
ooooo`1>ool00`00ooooo`0;ool00`00ooooo`1Lool00`00ooooo`2oool00;ooo`80057oo`03003o
oooo00[oo`D005_oo`03003ooooo0;koo`00_ooo00<00?ooool0DOoo00<00?ooool02Ooo00<00?oo
ool0GOoo00<00?ooool0__oo002oool00`00ooooo`12ool4000<ool00`00ooooo`08ool00`00oooo
o`1Mool00`00ooooo`2nool00;ooo`03003ooooo05;oo`8000Woo`03003ooooo05goo`03003ooooo
0;koo`00_ooo00<00?ooool0Dooo00<00?ooool01ooo00<00?ooool0GOoo00<00?ooool0__oo002o
ool00`00ooooo`1Cool00`00ooooo`07ool00`00ooooo`1Mool00`00ooooo`2nool00;ooo`03003o
oooo04coo`03003ooooo00Coo`03003ooooo00Ooo`03003ooooo05goo`03003ooooo0;koo`00_ooo
00<00?ooool0C?oo0P000ooo0P002_oo00<00?ooool0GOoo00<00?ooool0__oo002oool00`00oooo
o`1>ool4000;ool00`00ooooo`1Mool00`00ooooo`2nool00;ooo`03003ooooo05goo`03003ooooo
05goo`03003ooooo0;koo`00_ooo00<00?ooool0GOoo00<00?ooool0GOoo00<00?ooool0__oo002o
ool00`00ooooo`1Mool3001Mool00`00ooooo`2nool00;ooo`03003ooooo05goo`03003ooooo05go
o`03003ooooo0;koo`00_ooo00<00?ooool0GOoo00<00?ooool0GOoo00<00?ooool0__oo002oool0
0`00ooooo`1Mool00`00ooooo`1Mool00`00ooooo`2nool00;ooo`03003ooooo05goo`03003ooooo
05goo`03003ooooo0;koo`00_ooo00<00?ooool0GOoo00<00?ooool0GOoo00<00?ooool0__oo002o
ool00`00ooooo`1Mool00`00ooooo`1Lool20030ool00;ooo`8005koo`03003ooooo05coo`03003o
oooo0;ooo`00`?oo00<00?ooool0G?oo00<00?ooool0G?oo00<00?ooool0_ooo0030ool00`00oooo
o`1Lool00`00ooooo`1Lool00`00ooooo`2oool00<3oo`03003ooooo05coo`03003ooooo05coo`03
003ooooo0;ooo`00`?oo00<00?ooool0G?oo0`00G?oo00<00?ooool0_ooo0030ool2001Mool00`00
ooooo`1Kool20031ool00<7oo`03003ooooo05_oo`03003ooooo05_oo`03003ooooo0<3oo`00`Ooo
00<00?ooool0Fooo00<00?ooool0F_oo0P00`_oo0031ool2001Lool00`00ooooo`1Jool00`00oooo
o`31ool00<;oo`03003ooooo05[oo`03003ooooo05[oo`03003ooooo0<7oo`00`_oo0P00Fooo00<0
0?ooool0FOoo00<00?ooool0`_oo0033ool00`00ooooo`1Iool00`00ooooo`1Iool00`00ooooo`32
ool00<?oo`03003ooooo05Woo`03003ooooo05Soo`03003ooooo0<?oo`00a?oo00<00?ooool0F?oo
00<00?ooool0F?oo00<00?ooool0`ooo0034ool00`00ooooo`1Hool00`00ooooo`1Gool00`00oooo
o`34ool00<Goo`03003ooooo05Ooo`<005Ooo`03003ooooo0<Coo`00aOoo00<00?ooool0Eooo00<0
0?ooool0E_oo00<00?ooool0aOoo0035ool00`00ooooo`1Gool00`00ooooo`1Fool00`00ooooo`35
ool00<Koo`03003ooooo05Koo`03003ooooo05Goo`800<Ooo`00a_oo00<00?ooool0E_oo00<00?oo
ool0EOoo00<00?ooool0a_oo0037ool00`00ooooo`1Eool00`00ooooo`1Dool20038ool00<Ooo`03
003ooooo05Goo`03003ooooo05Coo`03003ooooo0<Ooo`00b?oo00<00?ooool0E?oo00<00?ooool0
Dooo0P00bOoo0038ool00`00ooooo`1Dool00`00ooooo`1Cool00`00ooooo`38ool00<Woo`03003o
oooo05?oo`03003ooooo05;oo`800<[oo`00bOoo00<00?ooool0Dooo00<00?ooool0D_oo00<00?oo
ool0bOoo003:ool00`00ooooo`1Bool00`00ooooo`1Aool2003;ool00<_oo`03003ooooo057oo`<0
057oo`03003ooooo0<[oo`00booo0P00D_oo00<00?ooool0D?oo00<00?ooool0booo003<ool2001A
ool00`00ooooo`1?ool2003=ool00<goo`03003ooooo04ooo`03003ooooo04ooo`03003ooooo0<co
o`00c_oo00<00?ooool0C_oo00<00?ooool0C_oo00<00?ooool0cOoo003?ool00`00ooooo`1=ool0
0`00ooooo`1=ool00`00ooooo`3>ool00=3oo`03003ooooo04coo`03003ooooo04coo`800=3oo`00
d?oo0P00??oo20002Ooo00<00?ooool0C?oo00<00?ooool0cooo001UoolV0016ool2000oool00`00
ooooo`0:ool00`00ooooo`1;ool00`00ooooo`13oolU001Xool005goo`T002Coo`d003_oo`03003o
oooo03goo`03003ooooo00[oo`03003ooooo04[oo`03003ooooo03_oo`T002Goo`X005koo`00F?oo
1P00>Ooo1@00=ooo00<00?ooool0??oo00<00?ooool02_oo00<00?ooool0BOoo0P00=_oo2000=ooo
1P00F?oo001Cool50013ool5000dool00`00ooooo`0kool00`00ooooo`0:ool50017ool00`00oooo
o`0_ool60015ool5001Cool004koo`D004goo`D0033oo`03003ooooo03[oo`03003ooooo00[oo`03
003ooooo04Soo`03003ooooo02coo`@0053oo`D004koo`00BOoo1@00Eooo1@00;?oo00<00?ooool0
:ooo10002_oo00<00?ooool02_oo00<00?ooool0Aooo00<00?ooool0:?oo1@00FOoo1000B_oo0015
ool4001Pool5000Yool00`00ooooo`0hool00`00ooooo`0:ool00`00ooooo`16ool00`00ooooo`0U
ool4001Rool40016ool0047oo`@006Woo`D002Goo`03003ooooo03Ooo`03003ooooo00[oo`03003o
oooo04Coo`8002Coo`@006Woo`@004?oo`00?ooo0`00L?oo1@008_oo00<00?ooool0=_oo00<00?oo
ool02_oo00<00?ooool0@ooo0P008Ooo1000LOoo0`00@?oo000mool3001fool5000Oool00`00oooo
o`0aool01@00oooooooo00003?oo00<00?ooool0@_oo0P007_oo1000N?oo0P00?_oo000kool3001l
ool5000Lool00`00ooooo`0aool4000<ool00`00ooooo`11ool2000Lool4001mool2000lool003Wo
o`<008;oo`@001[oo`03003ooooo03;oo`8000coo`03003ooooo043oo`8001Woo`@008?oo`8003[o
o`00=_oo0`00ROoo0P006Ooo00<00?ooool0?ooo00<00?ooool0?ooo0P005ooo0`00ROoo0`00=ooo
000cool3002>ool3000Gool00`00ooooo`0nool00`00ooooo`0nool00`00ooooo`0Dool3002?ool2
000eool0037oo`8009Coo`8001Koo`03003ooooo03goo`<003goo`03003ooooo01?oo`<009?oo`80
03?oo`00;ooo0P00V?oo0`005?oo00<00?ooool0??oo00<00?ooool0??oo00<00?ooool04Ooo0`00
V?oo0`00<?oo000]ool2002Mool2000Cool2000lool00`00ooooo`0jool2000Aool3002Mool2000_
ool002coo`800:3oo`<0017oo`8003_oo`03003ooooo03Woo`8000ooo`<00:;oo`8002goo`00:_oo
0P00Y?oo0`004?oo0P00>_oo00<00?ooool0>?oo00<00?ooool03Ooo0`00Y_oo0P00:ooo000Yool0
0`00ooooo`2Wool3000?ool00`00ooooo`0gool00`00ooooo`0gool00`00ooooo`0;ool3002Zool2
000Zool002Soo`03003ooooo0:[oo`<000koo`03003ooooo03Koo`03003ooooo03Goo`8000coo`<0
0:koo`8002Soo`009_oo0P00/?oo0`003?oo00<00?ooool0=Ooo00<00?ooool0=?oo0P002ooo0P00
/_oo0P009ooo000Uool2002cool3000;ool00`00ooooo`0dool00`00ooooo`0cool00`00ooooo`09
ool2002eool2000Vool002Coo`03003ooooo0;Koo`8000[oo`8003Coo`03003ooooo037oo`8000[o
o`800;Woo`03003ooooo02?oo`008ooo00<00?ooool0^Ooo0`002?oo0P00<ooo00<00?ooool0<?oo
0P002Ooo0P00_?oo00<00?ooool08_oo000Rool00`00ooooo`2mool20007ool2000bool3000_ool0
0`00ooooo`07ool2002oool2000Rool0027oo`03003ooooo0<3oo`<000Koo`03003ooooo02ooo`03
003ooooo02koo`03003ooooo00Koo`800<;oo`80027oo`007ooo0P00a_oo0P001Ooo00<00?ooool0
;_oo00<00?ooool0;?oo0P001ooo0P00aOoo0P008?oo000Nool20039ool20004ool2000^ool00`00
ooooo`0[ool20006ool20038ool2000Oool001goo`800<coo`8000?oo`8002goo`03003ooooo02[o
o`03003ooooo00Coo`800<_oo`8001koo`007?oo0P00cooo0P000ooo0P00:ooo00<00?ooool0:?oo
0P001?oo0`00cooo00<00?ooool06ooo000Kool00`00ooooo`3Aool20002ool2000Zool00`00oooo
o`0Wool20003ool3003Bool00`00ooooo`0Jool001[oo`03003ooooo0=?oo`8000?oo`03003ooooo
02Ooo`03003ooooo02Goo`8000Coo`800=Goo`03003ooooo01Woo`006Ooo00<00?ooool0e_oo0P00
0_oo0P009ooo00<00?ooool09?oo0P000ooo0P00eooo0P006_oo000Hool00`00ooooo`3Iool20000
0ooo0000000Vool00`00ooooo`0Sool01000oooooooo0P00f_oo0P006Ooo000Gool2003Lool20002
ool2000Tool00`00ooooo`0Qool20002ool3003Lool00`00ooooo`0Gool001Koo`800=ooo`800003
ool0000002?oo`03003ooooo023oo`8000;oo`800=ooo`03003ooooo01Koo`005_oo00<00?ooool0
h?oo0P0000?oo`00ool08Ooo0`007_oo0P000_oo0P00h_oo00<00?ooool05Ooo000Eool00`00oooo
o`3Sool01000ool000008?oo00<00?ooool07Ooo0P0000?oo`000000i?oo0P005_oo000Dool00`00
ooooo`3Uool200000ooo0000000Nool00`00ooooo`0Lool00`00ool00002003Vool2000Eool0013o
o`H005Goo`P005?oo`P0033oo`800003ool00?oo01coo`03003ooooo01[oo`800003ool0000003Go
o`P005?oo`P0057oo`03003oo`0000D000koo`004?oo00@00?ooool000;oo`03003ooooo05;oo`80
00Goo`03003ooooo05Goo`03003ooooo03?oo`@001_oo`03003ooooo01Soo`800003ool0000003_o
o`03003ooooo05Coo`8000Goo`03003ooooo053oo`8000Goo`03003ooooo00_oo`004ooo00D00?oo
ooooo`0005Goo`03003ooooo00;oo`03003ooooo05Goo`03003ooooo03Coo`800003ool0000001Wo
o`03003ooooo01Ooo`@003goo`03003ooooo05Koo`03003ooooo00;oo`03003ooooo053oo`8000Ko
o`03003ooooo00[oo`004_oo00<00?ooool00_oo00<00?ooool0E?oo00<00?ooool0FOoo00<00?oo
ool0=_oo0P0000?oo`00ool05ooo00<00?ooool05Ooo1000?ooo00<00?ooool0Eooo00<00?ooool0
EOoo00<00?ooool01?oo00<00?ooool02_oo000Bool00`00ooooo`02ool00`00ooooo`1Eool00`00
ooooo`1Hool00`00ooooo`0hool4000Fool00`00ooooo`0Dool40010ool00`00ooooo`1Hool00`00
ooooo`1Dool20005ool00`00ooooo`0:ool0017oo`03003ooooo00;oo`03003ooooo05Ooo`03003o
oooo05Ooo`03003ooooo03[oo`03003oo`0001Goo`03003ooooo01;oo`@004;oo`03003ooooo05Wo
o`03003ooooo05Coo`03003ooooo00;oo`03003ooooo00_oo`001_oo10001ooo00<00?oo00000`00
B_oo10003?oo00<00?ooool0B?oo10002_oo00<00?ooool0>ooo10004ooo00<00?ooool04Ooo0`00
A?oo00<00?ooool0F_oo00<00?ooool0Dooo00<00?oo00000`003Ooo000@ool20003ool00`00oooo
o`1Iool2001Gool00`00ooooo`0mool3000Bool00`00ooooo`0?ool30016ool00`00ooooo`1Jool2
001Dool20002ool00`00ooooo`0<ool0013oo`03003ooooo00?oo`03003ooooo05Woo`03003ooooo
05Goo`03003ooooo03ooo`<0013oo`<000koo`<004Ooo`03003ooooo05_oo`03003ooooo05?oo`05
003oooooool0000=ool0013oo`03003ooooo00?oo`03003ooooo05Woo`03003ooooo05Goo`03003o
oooo043oo`<000ooo`03003ooooo00coo`<004Woo`03003ooooo05_oo`03003ooooo05?oo`05003o
ooooool0000=ool000ooo`03003ooooo00Coo`03003ooooo05;oo`03003ooooo00Coo`03003ooooo
057oo`05003oooooool00014ool3000=ool00`00ooooo`0;ool20017ool01@00oooooooo0000E_oo
00<00?ooool01?oo00<00?ooool0Dooo00D00?ooooooo`0000goo`003ooo0`000ooo00<00?ooool0
Dooo0P000ooo0P00EOoo1000A_oo0P003?oo00<00?ooool02Ooo0`00BOoo1000E_oo0P000ooo0P00
E?oo0P0000Coo`00ool000koo`003ooo00<00?ooool00`00F?oo1000F?oo0P00Aooo0P002ooo00<0
0?ooool02?oo0P00COoo0P00F?oo1000Eooo0`003ooo000?ool00`00ooooo`3oool3ool20009ool0
0`00ooooo`07ool00`00ooooo`3oool4ool00`00ooooo`0>ool000ooo`03003ooooo0?ooo`Goo`03
003ooooo00Koo`03003ooooo0?ooo`koo`03003ooooo00koo`003ooo00<00?ooool0oooo3_oo00<0
0?ooool0oooo3_oo00<00?ooool03_oo000?ool00`00ooooo`3oool>ool00`00ooooo`3oool>ool0
0`00ooooo`0>ool000koo`800?oooa3oo`03003ooooo0?ooo`koo`03003ooooo00koo`003_oo00<0
0?ooool0oooo3ooo00<00?ooool0oooo3ooo00<00?ooool03Ooo00000ooo0000003o003o000m0002
ool000koo`03003ooooo013oo`03003ooooo00ooo`03003ooooo00ooo`03003ooooo00ooo`03003o
oooo00ooo`03003ooooo00ooo`03003ooooo013oo`03003ooooo00ooo`03003ooooo00ooo`03003o
oooo00ooo`03003ooooo00ooo`03003ooooo00ooo`03003ooooo013oo`03003ooooo00ooo`03003o
oooo00ooo`03003ooooo00ooo`03003ooooo00ooo`03003ooooo013oo`03003ooooo00ooo`03003o
oooo00ooo`03003ooooo00ooo`03003ooooo00ooo`03003ooooo00ooo`03003ooooo013oo`03003o
oooo00ooo`03003ooooo00ooo`03003ooooo00ooo`03003ooooo00ooo`03003ooooo00ooo`03003o
oooo013oo`03003ooooo00goo`003_oo0P004Ooo00<00?ooool03ooo00<00?ooool03ooo00<00?oo
ool03ooo00<00?ooool03ooo00<00?ooool03ooo00<00?ooool04?oo00<00?ooool03ooo00<00?oo
ool03ooo00<00?ooool03ooo00<00?ooool03ooo00<00?ooool03ooo00<00?ooool04?oo00<00?oo
ool03ooo00<00?ooool03ooo00<00?ooool03ooo00<00?ooool03ooo00<00?ooool04?oo00<00?oo
ool03ooo00<00?ooool03ooo00<00?ooool03ooo00<00?ooool03ooo00<00?ooool03ooo00<00?oo
ool04?oo00<00?ooool03ooo00<00?ooool03ooo00<00?ooool03ooo00<00?ooool03ooo00<00?oo
ool03ooo00<00?ooool03ooo0P003ooo000>ool2001Iool00`00ooooo`1Hool00`00ooooo`1Hool0
0`00ooooo`1Hool00`00ooooo`1Hool00`00ooooo`1Gool2000?ool000koo`8005Woo`03003ooooo
05Soo`03003ooooo05Soo`03003ooooo05Soo`03003ooooo05Soo`03003ooooo05Ooo`8000ooo`00
3ooo00<00?ooool0oooo3_oo00<00?ooool0oooo3_oo00<00?ooool03_oo000?ool00`00ooooo`3o
ool>ool00`00ooooo`3oool>ool00`00ooooo`0>ool000ooo`03003ooooo0?ooo`koo`03003ooooo
0?ooo`koo`03003ooooo00koo`003ooo0P00oooo3ooo00<00?ooool02Ooo00<00?ooool0oooo0_oo
00<00?ooool03_oo000@ool00`00ooooo`3lool2000>ool00`00ooooo`0:ool2003oool1ool2000@
ool0013oo`03003ooooo0?_oo`8000ooo`03003ooooo00coo`800?koo`03003ooooo00ooo`004Ooo
00<00?ooool0n?oo0P004Ooo0`003_oo00<00?ooool0nooo00<00?ooool03ooo000Aool00`00oooo
o`3gool2000Bool00`00ooooo`0?ool2003jool00`00ooooo`0@ool0017oo`03003ooooo0?Goo`80
01Coo`03003ooooo017oo`800?Soo`03003ooooo013oo`004_oo00<00?ooool0looo0P005Ooo00<0
0?ooool04ooo0P00m_oo00<00?ooool04?oo000Bool00`00ooooo`3aool2000Gool00`00ooooo`0D
ool2003dool00`00ooooo`0Aool001;oo`03003ooooo0?3oo`8001Soo`03003ooooo01Koo`800?;o
o`03003ooooo017oo`004ooo00<00?ooool0kOoo0P006_oo00<00?ooool05ooo0`00kooo00<00?oo
ool04_oo000Cool00`00ooooo`3[ool2000Lool00`00ooooo`0Hool4003]ool00`00ooooo`0Bool0
01Coo`03003ooooo0>Soo`<001goo`03003ooooo01[oo`<00>_oo`03003ooooo01?oo`005?oo00<0
0?ooool0i_oo0`007ooo00<00?ooool06ooo1000jOoo00<00?ooool04ooo000Eool00`00ooooo`3S
ool4000Pool00`00ooooo`0Mool4003Vool00`00ooooo`0Dool001Goo`03003ooooo0>7oo`@002;o
o`03003ooooo01koo`800003ool000000>?oo`03003ooooo01Goo`005_oo00<00?ooool0g_oo1@00
8ooo0`008?oo0P0000?oo`000000hOoo00<00?ooool05Ooo000Gool00`00ooooo`3Lool200000ooo
003oo`0Tool00`00ooooo`0Qool20002ool2003Nool00`00ooooo`0Fool001Soo`03003ooooo0=Wo
o`800003ool0000002Koo`03003ooooo02?oo`04003oooooool2003Lool00`00ooooo`0Fool001Wo
o`03003ooooo0=Koo`8000;oo`03003ooooo02Koo`03003ooooo02Coo`8000?oo`800=Woo`03003o
oooo01Ooo`006_oo00<00?ooool0dooo0P000_oo0P00:Ooo00<00?ooool09_oo00@00?ooooooo`<0
0=Goo`8001[oo`006ooo00<00?ooool0dOoo0P000_oo00<00?ooool0:Ooo00<00?ooool09ooo0P00
0ooo0`00d_oo0P006ooo000Lool00`00ooooo`3>ool20003ool00`00ooooo`0Zool00`00ooooo`0X
ool20005ool2003?ool2000Lool001goo`03003ooooo0<_oo`8000?oo`8002goo`03003ooooo02[o
o`03003ooooo00Coo`800<coo`03003ooooo01coo`007_oo00<00?ooool0b?oo0P001?oo0P00;_oo
00<00?ooool0:ooo0P001_oo0P00bOoo00<00?ooool07Ooo000Oool00`00ooooo`35ool30004ool2
000_ool00`00ooooo`0]ool00`00ooooo`05ool20035ool2000Pool0023oo`03003ooooo0<;oo`<0
00Goo`80033oo`03003ooooo02koo`8000Ooo`800<;oo`80027oo`008Ooo0P00`?oo0P001ooo00<0
0?ooool0<?oo0`00;ooo0P002?oo0P00_ooo00<00?ooool08Ooo000Rool2002mool20008ool00`00
ooooo`0aool00`00ooooo`0aool00`00ooooo`07ool2002lool00`00ooooo`0Rool002Coo`03003o
oooo0;Ooo`<000Woo`03003ooooo03;oo`03003ooooo03;oo`03003ooooo00Soo`800;Woo`03003o
oooo02?oo`009Ooo00<00?ooool0]?oo0`002Ooo0P00=Ooo00<00?ooool0<ooo0P002_oo0`00]?oo
0P009_oo000Vool2002bool3000:ool2000fool00`00ooooo`0dool2000;ool3002aool2000Wool0
02Soo`800:koo`8000coo`8003Ooo`03003ooooo03Goo`8000goo`<00:goo`03003ooooo02Ooo`00
:Ooo0P00Zooo0P003Ooo0P00>?oo00<00?ooool0=ooo00<00?ooool03?oo0`00ZOoo0P00:_oo000[
ool2002Vool3000>ool00`00ooooo`0hool00`00ooooo`0hool00`00ooooo`0>ool3002Uool2000[
ool002goo`800:;oo`<000ooo`03003ooooo03Woo`03003ooooo03Woo`03003ooooo013oo`800:7o
o`8002goo`00;_oo0P00W_oo0`004Ooo00<00?ooool0>_oo00<00?ooool0>_oo00<00?ooool04Ooo
0`00W?oo0P00;ooo000`ool2002Iool3000Cool00`00ooooo`0kool00`00ooooo`0kool2000Dool3
002Gool3000`ool003;oo`8009Coo`<001Goo`03003ooooo03coo`<003coo`8001Goo`<009?oo`80
03?oo`00=?oo0P00T?oo0`005Ooo0P00?ooo00<00?ooool0?Ooo0P005ooo0`00S_oo0P00=Ooo000f
ool2002;ool3000Gool20010ool00`00ooooo`0oool00`00ooooo`0Gool30029ool2000gool003So
o`8008Koo`<001Woo`80047oo`03003ooooo043oo`03003ooooo01Woo`<008?oo`<003Woo`00>_oo
0`00P?oo0`006ooo0P00@_oo00<00?ooool0@Ooo00<00?ooool06ooo1000O?oo0`00??oo000mool3
001iool4000Mool20013ool00`00ooooo`12ool00`00ooooo`0Nool3001gool3000nool0043oo`<0
07;oo`@0023oo`03003ooooo04?oo`03003ooooo04?oo`03003ooooo023oo`<0077oo`<0047oo`00
@ooo0`00Jooo10008ooo00<00?ooool0A?oo00<00?ooool0A?oo00<00?ooool08_oo1000J_oo0`00
A?oo0016ool4001Sool4000Vool00`00ooooo`0dool80009ool00`00ooooo`15ool00`00ooooo`0U
ool5001Rool30017ool004Woo`@005[oo`H002Woo`03003ooooo03Woo`03003ooooo00[oo`03003o
oooo04Koo`03003ooooo02Woo`D005Soo`D004[oo`00COoo1@00Cooo1`00;Ooo00<00?ooool0>_oo
00<00?ooool02_oo00<00?ooool0Aooo00<00?ooool0;Ooo1@00C_oo1P00C_oo001Bool60015ool4
000cool00`00ooooo`0kool00`00ooooo`0:ool50016ool00`00ooooo`0aool40014ool6001Dool0
05Soo`H003Woo`H003Koo`03003ooooo03coo`03003ooooo00[oo`03003ooooo04Woo`03003ooooo
03Coo`@003_oo`H005Woo`00G_oo1P00;?oo1`00>ooo0P00?_oo00<00?ooool02_oo00<00?ooool0
B_oo00<00?ooool0=ooo3@00:?oo1P00Gooo001Sool>000?ool@0011ool2000oool00`00ooooo`0:
ool00`00ooooo`1;ool00`00ooooo`13ool;000>ool?001Uool0077ooa0004ooo`80043oo`03003o
oooo00[oo`03003ooooo04coo`03003ooooo04goo`h007Coo`00d?oo00<00?ooool0?ooo00<00?oo
ool02_oo00<00?ooool0C?oo0P00d?oo003?ool00`00ooooo`10ool00`00ooooo`0:ool00`00oooo
o`1=ool00`00ooooo`3>ool00<koo`03003ooooo03goo`05003oooooool0000<ool00`00ooooo`1>
ool00`00ooooo`3=ool00<goo`03003ooooo03ooo`@000coo`03003ooooo04ooo`03003ooooo0<co
o`00c?oo00<00?ooool0@_oo0P003?oo00<00?ooool0Cooo00<00?ooool0c?oo003<ool00`00oooo
o`1@ool00`00ooooo`1@ool00`00ooooo`3;ool00<_oo`03003ooooo057oo`<0057oo`03003ooooo
0<[oo`00b_oo0P00Dooo00<00?ooool0DOoo0P00booo003:ool00`00ooooo`1Bool00`00ooooo`1B
ool00`00ooooo`39ool00<Woo`03003ooooo05?oo`03003ooooo05?oo`03003ooooo0<Soo`00b?oo
0P00EOoo00<00?ooool0E?oo00<00?ooool0aooo0038ool00`00ooooo`1Dool00`00ooooo`1Dool0
0`00ooooo`37ool00<Ooo`03003ooooo05Goo`03003ooooo05Goo`03003ooooo0<Koo`00aooo00<0
0?ooool0EOoo00<00?ooool0EOoo00<00?ooool0a_oo0036ool00`00ooooo`1Fool00`00ooooo`1F
ool00`00ooooo`35ool00<Koo`03003ooooo05Koo`03003ooooo05Koo`03003ooooo0<Goo`00aOoo
00<00?ooool0Eooo00<00?ooool0Eooo00<00?ooool0a?oo0035ool00`00ooooo`1Gool00`00oooo
o`1Gool00`00ooooo`34ool00<Coo`03003ooooo05Soo`<005Soo`03003ooooo0<?oo`00a?oo00<0
0?ooool0F?oo00<00?ooool0F?oo00<00?ooool0`ooo0033ool00`00ooooo`1Iool00`00ooooo`1H
ool20034ool00<?oo`03003ooooo05Woo`03003ooooo05Woo`03003ooooo0<;oo`00`_oo00<00?oo
ool0F_oo00<00?ooool0FOoo0P00`ooo0032ool00`00ooooo`1Jool00`00ooooo`1Jool00`00oooo
o`31ool00<;oo`03003ooooo05[oo`03003ooooo05[oo`03003ooooo0<7oo`00`_oo00<00?ooool0
F_oo00<00?ooool0F_oo0P00`_oo0031ool00`00ooooo`1Kool00`00ooooo`1Kool00`00ooooo`30
ool00<7oo`03003ooooo05_oo`03003ooooo05_oo`03003ooooo0<3oo`00`Ooo00<00?ooool0Fooo
00<00?ooool0Fooo00<00?ooool0`?oo0031ool00`00ooooo`1Kool3001Kool20031ool00<3oo`80
05goo`03003ooooo05coo`03003ooooo0;ooo`00`?oo00<00?ooool0G?oo00<00?ooool0G?oo00<0
0?ooool0_ooo0030ool00`00ooooo`1Lool00`00ooooo`1Lool00`00ooooo`2oool00;ooo`8005ko
o`03003ooooo05goo`03003ooooo0;koo`00_ooo00<00?ooool0GOoo00<00?ooool0GOoo00<00?oo
ool0__oo002oool00`00ooooo`1Mool00`00ooooo`1Mool00`00ooooo`2nool00;ooo`03003ooooo
05goo`03003ooooo05goo`03003ooooo0;koo`00_ooo00<00?ooool0GOoo00<00?ooool0GOoo00<0
0?ooool0__oo002oool00`00ooooo`1Mool00`00ooooo`1Mool00`00ooooo`2nool00;ooo`03003o
oooo05goo`03003ooooo05goo`03003ooooo0;koo`00_ooo00<00?ooool0GOoo0`00GOoo00<00?oo
ool0__oo002oool00`00ooooo`1Mool00`00ooooo`1Mool00`00ooooo`2nool00;ooo`03003ooooo
05goo`03003ooooo05goo`03003ooooo0;koo`00_ooo00<00?ooool0GOoo00<00?ooool0GOoo00<0
0?ooool0__oo002oool00`00ooooo`1Mool00`00ooooo`1Mool00`00ooooo`2nool00;ooo`03003o
oooo05goo`03003ooooo05goo`03003ooooo0;koo`00_ooo00<00?ooool0GOoo00<00?ooool0GOoo
00<00?ooool0__oo002oool00`00ooooo`1Mool00`00ooooo`1Mool00`00ooooo`2nool00;ooo`03
003ooooo04coo`P000Woo`03003ooooo05goo`03003ooooo0;koo`00_ooo00<00?ooool0C?oo0P00
1Ooo00<00?ooool01ooo00<00?ooool0GOoo00<00?ooool0__oo002oool00`00ooooo`1>ool00`00
ooooo`02ool00`00ooooo`07ool00`00ooooo`1Mool00`00ooooo`2nool00;ooo`03003ooooo04oo
o`03003ooooo00_oo`D005_oo`03003ooooo0;koo`00_ooo0P00DOoo00<00?ooool02_oo00<00?oo
ool0G?oo00<00?ooool0_ooo0030ool00`00ooooo`1@ool00`00ooooo`09ool00`00ooooo`1Lool0
0`00ooooo`2oool00<3oo`03003ooooo057oo`03003ooooo00Soo`03003ooooo05coo`03003ooooo
0;ooo`00`?oo00<00?ooool0DOoo0P002Ooo00<00?ooool0Fooo0P00`Ooo0030ool2001Cool00`00
ooooo`07ool00`00ooooo`1Kool00`00ooooo`30ool00<7oo`03003ooooo057oo`03003ooooo00Oo
o`03003ooooo05_oo`03003ooooo0<3oo`00`Ooo00<00?ooool0B_oo00<00?ooool01?oo00<00?oo
ool01ooo00<00?ooool0Fooo00<00?ooool0`?oo0031ool00`00ooooo`1:ool20003ool2000:ool0
0`00ooooo`1Jool20032ool00<;oo`03003ooooo04_oo`@000_oo`03003ooooo05[oo`03003ooooo
0<7oo`00`_oo00<00?ooool0F_oo00<00?ooool0F_oo00<00?ooool0`Ooo0032ool2001Kool00`00
ooooo`1Iool00`00ooooo`32ool00<?oo`03003ooooo05Woo`<005Woo`03003ooooo0<;oo`00`ooo
0P00F_oo00<00?ooool0F?oo00<00?ooool0`ooo0034ool00`00ooooo`1Hool00`00ooooo`1Gool2
0035ool00<Goo`03003ooooo05Ooo`03003ooooo05Ooo`03003ooooo0<Coo`00aOoo00<00?ooool0
Eooo00<00?ooool0E_oo00<00?ooool0aOoo0036ool00`00ooooo`1Fool00`00ooooo`1Fool00`00
ooooo`35ool00<Ooo`03003ooooo05Goo`03003ooooo05Goo`03003ooooo0<Koo`00aooo0P00E_oo
00<00?ooool0E?oo0P00b?oo0038ool00`00ooooo`1Dool00`00ooooo`1Dool00`00ooooo`37ool0
0<Woo`03003ooooo05?oo`03003ooooo05?oo`03003ooooo0<Soo`00bOoo0P00E?oo00<00?ooool0
D_oo00<00?ooool0bOoo003:ool00`00ooooo`1Bool3001Aool2003;ool00<_oo`03003ooooo057o
o`03003ooooo057oo`03003ooooo0<[oo`00c?oo00<00?ooool0D?oo00<00?ooool0D?oo00<00?oo
ool0booo003=ool00`00ooooo`1?ool00`00ooooo`1?ool00`00ooooo`3<ool00<goo`80053oo`03
003ooooo04koo`03003ooooo0<goo`00c_oo00<00?ooool0C_oo00<00?ooool0COoo00<00?ooool0
c_oo003?ool00`00ooooo`1=ool00`00ooooo`1<ool00`00ooooo`3?ool00=3oo`03003ooooo04co
o`03003ooooo04_oo`03003ooooo0=3oo`00dOoo00<00?ooool0Booo00<00?ooool0B_oo00<00?oo
ool0dOoo003Bool2001;ool00`00ooooo`19ool00`00ooooo`3Bool00=?oo`8004[oo`03003ooooo
04Ooo`800=Goo`00eOoo00<00?ooool0Aooo0`00A_oo0P00e_oo003Fool20017ool00`00ooooo`15
ool00`00ooooo`3Fool00=Ooo`8004Koo`03003ooooo04Coo`03003ooooo0=Ooo`00fOoo0P00A?oo
00<00?ooool0@_oo0P00f_oo003Kool20012ool00`00ooooo`11ool2003Kool00=coo`<0043oo`03
003ooooo03ooo`800=goo`00g_oo0P00?ooo00<00?ooool0?_oo0P00g_oo003Pool2000mool00`00
ooooo`0lool2003Pool00>;oo`8003_oo`03003ooooo03[oo`800>;oo`00i?oo0P00>Ooo00<00?oo
ool0>?oo0P00i?oo003Vool2000gool00`00ooooo`0eool3003Vool00>Soo`8003Goo`<003?oo`<0
0>Soo`00jOoo0`00<ooo00<00?ooool0<Ooo0`00j_oo003/ool3000`ool00`00ooooo`0_ool3003/
ool00>koo`<002koo`03003ooooo02goo`<00>koo`00lOoo0`00:ooo00<00?ooool0:_oo0`00lOoo
003dool4000Wool00`00ooooo`0Xool3003cool00?Soo`<002Coo`03003ooooo02Coo`@00?Koo`00
nooo0`008Ooo00<00?ooool08?oo1@00nOoo003nool3000=ool6000;ool00`00ooooo`0Jool7003m
ool00?ooo`;oo`H000Ooo`03003ooooo00?oo`03003ooooo00Soo`03003ooooo01?oo`P00?ooo`Co
o`00oooo2?oo1`001ooo00<00?ooool01ooo00<00?ooool03_oo1P00oooo2ooo003oool>oolT003o
ool@ool00?oooaKoo`03003ooooo00Ooo`03003ooooo0?oooaooo`00oooo5Ooo00<00?ooool02?oo
00<00?ooool0oooo7ooo003ooolBool4000:ool00`00ooooo`3ooolOool00?oooaCoo`03003ooooo
00Woo`03003ooooo0?oooaooo`00oooo5Ooo00<00?ooool02?oo00<00?ooool0oooo7ooo003ooolE
ool00`00ooooo`08ool00`00ooooo`3ooolOool00?oooaGoo`03003ooooo00Soo`03003ooooo0?oo
oaooo`00oooo3ooo0P000ooo00<00?ooool02Ooo00<00?ooool0oooo7ooo003ooolAool3000<ool0
0`00ooooo`3ooolOool00001\
\>"],
  ImageRangeCache->{{{0, 575}, {354.875, 0}} -> {-3.16469, -3.16037, 
  0.0220155, 0.0356221}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(ParametricPlot[
      \ {\ \((Exp[Cos[t]] - 2  Cos[4  t] + Sin[t/12]^5)\) Cos[t], \n
        \t\t\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ \ \ \ \ \ \ \((Exp[Cos[t]] - 2  Cos[4  t] + Sin[t/12]^5)\) Sin[t]}, 
      \ {t, 0, 24  Pi}, PlotPoints -> 300]; \)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.39298 0.148414 0.30902 0.0805678 [
[.09615 .29652 -6 -9 ]
[.09615 .29652 6 0 ]
[.24457 .29652 -6 -9 ]
[.24457 .29652 6 0 ]
[.54139 .29652 -3 -9 ]
[.54139 .29652 3 0 ]
[.68981 .29652 -3 -9 ]
[.68981 .29652 3 0 ]
[.83822 .29652 -3 -9 ]
[.83822 .29652 3 0 ]
[.98664 .29652 -3 -9 ]
[.98664 .29652 3 0 ]
[.38048 .06732 -12 -4.5 ]
[.38048 .06732 0 4.5 ]
[.38048 .14788 -12 -4.5 ]
[.38048 .14788 0 4.5 ]
[.38048 .22845 -12 -4.5 ]
[.38048 .22845 0 4.5 ]
[.38048 .38959 -6 -4.5 ]
[.38048 .38959 0 4.5 ]
[.38048 .47016 -6 -4.5 ]
[.38048 .47016 0 4.5 ]
[.38048 .55072 -6 -4.5 ]
[.38048 .55072 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.09615 .30902 m
.09615 .31527 L
s
[(-2)] .09615 .29652 0 1 Mshowa
.24457 .30902 m
.24457 .31527 L
s
[(-1)] .24457 .29652 0 1 Mshowa
.54139 .30902 m
.54139 .31527 L
s
[(1)] .54139 .29652 0 1 Mshowa
.68981 .30902 m
.68981 .31527 L
s
[(2)] .68981 .29652 0 1 Mshowa
.83822 .30902 m
.83822 .31527 L
s
[(3)] .83822 .29652 0 1 Mshowa
.98664 .30902 m
.98664 .31527 L
s
[(4)] .98664 .29652 0 1 Mshowa
.125 Mabswid
.12583 .30902 m
.12583 .31277 L
s
.15552 .30902 m
.15552 .31277 L
s
.1852 .30902 m
.1852 .31277 L
s
.21488 .30902 m
.21488 .31277 L
s
.27425 .30902 m
.27425 .31277 L
s
.30393 .30902 m
.30393 .31277 L
s
.33361 .30902 m
.33361 .31277 L
s
.3633 .30902 m
.3633 .31277 L
s
.42266 .30902 m
.42266 .31277 L
s
.45235 .30902 m
.45235 .31277 L
s
.48203 .30902 m
.48203 .31277 L
s
.51171 .30902 m
.51171 .31277 L
s
.57108 .30902 m
.57108 .31277 L
s
.60076 .30902 m
.60076 .31277 L
s
.63044 .30902 m
.63044 .31277 L
s
.66013 .30902 m
.66013 .31277 L
s
.71949 .30902 m
.71949 .31277 L
s
.74917 .30902 m
.74917 .31277 L
s
.77886 .30902 m
.77886 .31277 L
s
.80854 .30902 m
.80854 .31277 L
s
.86791 .30902 m
.86791 .31277 L
s
.89759 .30902 m
.89759 .31277 L
s
.92727 .30902 m
.92727 .31277 L
s
.95695 .30902 m
.95695 .31277 L
s
.06647 .30902 m
.06647 .31277 L
s
.03679 .30902 m
.03679 .31277 L
s
.0071 .30902 m
.0071 .31277 L
s
.25 Mabswid
0 .30902 m
1 .30902 L
s
.39298 .06732 m
.39923 .06732 L
s
[(-3)] .38048 .06732 1 0 Mshowa
.39298 .14788 m
.39923 .14788 L
s
[(-2)] .38048 .14788 1 0 Mshowa
.39298 .22845 m
.39923 .22845 L
s
[(-1)] .38048 .22845 1 0 Mshowa
.39298 .38959 m
.39923 .38959 L
s
[(1)] .38048 .38959 1 0 Mshowa
.39298 .47016 m
.39923 .47016 L
s
[(2)] .38048 .47016 1 0 Mshowa
.39298 .55072 m
.39923 .55072 L
s
[(3)] .38048 .55072 1 0 Mshowa
.125 Mabswid
.39298 .08343 m
.39673 .08343 L
s
.39298 .09954 m
.39673 .09954 L
s
.39298 .11566 m
.39673 .11566 L
s
.39298 .13177 m
.39673 .13177 L
s
.39298 .164 m
.39673 .164 L
s
.39298 .18011 m
.39673 .18011 L
s
.39298 .19622 m
.39673 .19622 L
s
.39298 .21234 m
.39673 .21234 L
s
.39298 .24457 m
.39673 .24457 L
s
.39298 .26068 m
.39673 .26068 L
s
.39298 .27679 m
.39673 .27679 L
s
.39298 .29291 m
.39673 .29291 L
s
.39298 .32513 m
.39673 .32513 L
s
.39298 .34125 m
.39673 .34125 L
s
.39298 .35736 m
.39673 .35736 L
s
.39298 .37347 m
.39673 .37347 L
s
.39298 .4057 m
.39673 .4057 L
s
.39298 .42181 m
.39673 .42181 L
s
.39298 .43793 m
.39673 .43793 L
s
.39298 .45404 m
.39673 .45404 L
s
.39298 .48627 m
.39673 .48627 L
s
.39298 .50238 m
.39673 .50238 L
s
.39298 .5185 m
.39673 .5185 L
s
.39298 .53461 m
.39673 .53461 L
s
.39298 .0512 m
.39673 .0512 L
s
.39298 .03509 m
.39673 .03509 L
s
.39298 .01898 m
.39673 .01898 L
s
.39298 .00286 m
.39673 .00286 L
s
.39298 .56684 m
.39673 .56684 L
s
.39298 .58295 m
.39673 .58295 L
s
.39298 .59906 m
.39673 .59906 L
s
.39298 .61518 m
.39673 .61518 L
s
.25 Mabswid
.39298 0 m
.39298 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.49958 .30902 m
.52902 .31789 L
.61286 .33893 L
.66894 .35728 L
.7222 .37902 L
.77601 .40714 L
.80175 .42413 L
.82187 .44025 L
.83659 .45494 L
.84812 .47026 L
.85234 .47798 L
.85516 .48502 L
.85578 .48705 L
.85628 .48896 L
.85665 .49067 L
.85698 .49248 L
.85723 .49442 L
.85738 .4962 L
.85745 .49828 L
.85741 .50015 L
.85713 .50323 L
.85688 .50475 L
.85652 .5064 L
.85568 .50924 L
.85467 .51182 L
.85317 .51476 L
.85152 .51734 L
.84688 .52277 L
.84183 .527 L
.83526 .5311 L
.82807 .53447 L
.8206 .53712 L
.81185 .53943 L
.80312 .54107 L
.79828 .54175 L
.79279 .54234 L
.78994 .54258 L
.78684 .54279 L
.78112 .54306 L
.77554 .54317 L
.76933 .54313 L
.76331 .54295 L
.75763 .54266 L
.7524 .54229 L
.74655 .54176 L
.73441 .54032 L
.7192 .5379 L
.70489 .53505 L
.67162 .52641 L
.64001 .51575 L
Mistroke
.60989 .50341 L
.55188 .47328 L
.49598 .43473 L
.45189 .39471 L
.42089 .35773 L
.40755 .33755 L
.39661 .31714 L
.38974 .30075 L
.38683 .29202 L
.38469 .28416 L
.38375 .27995 L
.38292 .27553 L
.38237 .27198 L
.38193 .2682 L
.38174 .26615 L
.38161 .26428 L
.38152 .26234 L
.38147 .2603 L
.38147 .25856 L
.3815 .25677 L
.38167 .25369 L
.38193 .25093 L
.38233 .24815 L
.3828 .24567 L
.38331 .24355 L
.384 .24121 L
.38485 .23888 L
.38663 .23518 L
.38851 .23237 L
.38963 .23108 L
.39073 .23003 L
.39177 .22921 L
.39294 .22848 L
.39402 .22796 L
.39503 .22761 L
.39622 .22736 L
.39733 .22727 L
.39855 .22735 L
.39923 .22747 L
.39984 .22763 L
.40099 .22806 L
.40163 .22838 L
.40222 .22873 L
.40336 .22957 L
.40453 .23068 L
.40563 .232 L
.40658 .23341 L
.40739 .23488 L
.4082 .23668 L
.40938 .24021 L
Mistroke
.40989 .24237 L
.41027 .24452 L
.41045 .24578 L
.4106 .24719 L
.41071 .24857 L
.41078 .24989 L
.41083 .25247 L
.41075 .25534 L
.41066 .25703 L
.4105 .2589 L
.41009 .26241 L
.40951 .26597 L
.40884 .26935 L
.40507 .28262 L
.40203 .29058 L
.39867 .29809 L
.38078 .32814 L
.36729 .34544 L
.34999 .36409 L
.31267 .39598 L
.27311 .42148 L
.22807 .44258 L
.20631 .44987 L
.19541 .45275 L
.18445 .45506 L
.17534 .45647 L
.17294 .45676 L
.17042 .45702 L
.16829 .4572 L
.16602 .45735 L
.16187 .45753 L
.15811 .45756 L
.15462 .45746 L
.15154 .45725 L
.14823 .45689 L
.14527 .45642 L
.14276 .45589 L
.1402 .45521 L
.13762 .45435 L
.13511 .45329 L
.13125 .45102 L
.12967 .44975 L
.1282 .44826 L
.12704 .44674 L
.12618 .44526 L
.12556 .44385 L
.12506 .44222 L
.12475 .44044 L
.12466 .4387 L
.12479 .43652 L
Mistroke
.12499 .43525 L
.12525 .43404 L
.12592 .43176 L
.12692 .42926 L
.12933 .42473 L
.133 .41947 L
.14488 .40702 L
.16064 .39461 L
.20494 .36888 L
.2604 .34536 L
.31819 .32673 L
.38585 .31043 L
.42333 .30363 L
.4579 .29872 L
.48774 .29556 L
.50385 .2943 L
.51815 .29347 L
.52537 .29315 L
.53293 .2929 L
.53988 .29275 L
.54605 .29268 L
.55308 .29269 L
.55695 .29272 L
.56047 .29278 L
.56674 .29295 L
.56982 .29307 L
.57315 .29322 L
.57954 .29357 L
.58514 .29398 L
.59676 .29513 L
.60583 .2964 L
.61414 .29797 L
.62085 .29967 L
.62603 .30142 L
.6297 .30309 L
.63135 .30406 L
.63261 .30497 L
.63367 .30596 L
.63438 .3069 L
.63487 .30794 L
.635 .30853 L
.63504 .30906 L
.63485 .31014 L
.6346 .31074 L
.63427 .3113 L
.63342 .31232 L
.63218 .31339 L
.63068 .31438 L
.62904 .31528 L
.62437 .31722 L
Mistroke
.61919 .31882 L
.61265 .32037 L
.60587 .32162 L
.59879 .32264 L
.59023 .3236 L
.58016 .32441 L
.5746 .32474 L
.5682 .32502 L
.56488 .32513 L
.56123 .32523 L
.55444 .32533 L
.54781 .32535 L
.54062 .32529 L
.53432 .32516 L
.52725 .32495 L
.51861 .32458 L
.51058 .32415 L
.49193 .32283 L
.47399 .32115 L
.45657 .31915 L
.38903 .30824 L
.35053 .29977 L
.31578 .29063 L
.25294 .26991 L
.20269 .2481 L
.16041 .22336 L
.14353 .20994 L
.13783 .20436 L
.1327 .19843 L
.12926 .19355 L
.12657 .18855 L
.12554 .18593 L
.12488 .18361 L
.12449 .18147 L
.12434 .17931 L
.12442 .17753 L
.12473 .1757 L
.12522 .17406 L
.12584 .17263 L
.12677 .17105 L
.12802 .16944 L
.12943 .16804 L
.13093 .16683 L
.13273 .16565 L
.1349 .16451 L
.13939 .16278 L
.14249 .16194 L
.14566 .16129 L
.14871 .16084 L
.15223 .1605 L
Mistroke
.15425 .16037 L
.15621 .1603 L
.16 .16026 L
.16221 .16031 L
.16428 .16039 L
.16661 .16052 L
.16912 .16071 L
.17342 .16114 L
.17756 .16168 L
.18739 .16336 L
.19741 .16561 L
.20704 .16822 L
.22985 .176 L
.27285 .19628 L
.31076 .22055 L
.34667 .25063 L
.37515 .28225 L
.38688 .29888 L
.39666 .3159 L
.40307 .33014 L
.40564 .33728 L
.40777 .34457 L
.4092 .35094 L
.4097 .35382 L
.41007 .3564 L
.41034 .35892 L
.41054 .36155 L
.41064 .36379 L
.41065 .36608 L
.41056 .3686 L
.41035 .37121 L
.41004 .37353 L
.40965 .37556 L
.4092 .37745 L
.40871 .37906 L
.40742 .38229 L
.40657 .38387 L
.40573 .38517 L
.40475 .38641 L
.40361 .38757 L
.40264 .38835 L
.40156 .38904 L
.40039 .38958 L
.39926 .38992 L
.39811 .3901 L
.39703 .39012 L
.39585 .38998 L
.39459 .38965 L
.3935 .3892 L
.3925 .38865 L
Mistroke
.39135 .38784 L
.39028 .38692 L
.38841 .3848 L
.38682 .38241 L
.3853 .37935 L
.38388 .37543 L
.38322 .37298 L
.3827 .37057 L
.38224 .36774 L
.38206 .36625 L
.38189 .36457 L
.3817 .36161 L
.38165 .35989 L
.38163 .35828 L
.3817 .35504 L
.38188 .35184 L
.38217 .34867 L
.38261 .34517 L
.38373 .33859 L
.38545 .33112 L
.388 .32241 L
.39542 .30342 L
.40696 .28137 L
.4375 .23901 L
.47725 .19871 L
.53124 .15739 L
.59578 .12071 L
.65898 .09505 L
.68994 .0859 L
.70587 .0821 L
.72233 .07886 L
.73629 .07669 L
.74351 .07579 L
.75111 .07502 L
.75793 .07449 L
.76402 .07415 L
.77002 .07395 L
.77557 .0739 L
.78123 .07397 L
.78622 .07416 L
.79181 .07451 L
.79691 .07497 L
.8015 .07552 L
.80558 .07612 L
.81433 .07781 L
.82248 .07998 L
.83056 .08287 L
.83802 .08644 L
.84402 .09026 L
.84947 .09489 L
Mistroke
.85349 .0996 L
.8552 .10221 L
.85677 .10521 L
.85743 .10676 L
.85805 .10846 L
.85854 .11009 L
.85892 .11162 L
.85943 .11451 L
.85969 .11775 L
.85966 .12098 L
.85951 .12282 L
.85931 .12451 L
.85875 .1276 L
.85788 .131 L
.8556 .13731 L
.85253 .14361 L
.84819 .15067 L
.83651 .16524 L
.80662 .19162 L
.76106 .22048 L
.71252 .24411 L
.60061 .28319 L
.55624 .29457 L
.5223 .3024 L
.51186 .30507 L
.50834 .3062 L
.50713 .30667 L
.50604 .30717 L
.50532 .30758 L
.50475 .30801 L
.50437 .30846 L
.50423 .30888 L
.50431 .30936 L
.50464 .30983 L
.50515 .31025 L
.50592 .31071 L
.50821 .31169 L
.5112 .31267 L
.52103 .31522 L
.55269 .32248 L
.63922 .34613 L
.69633 .36667 L
.74954 .39073 L
.79229 .41527 L
.82963 .44385 L
.8448 .45971 L
.85067 .46739 L
.85511 .47436 L
.85828 .48047 L
.86086 .48702 L
Mistroke
.86183 .49035 L
.8625 .49341 L
.86297 .49659 L
.86319 .49993 L
.86319 .50165 L
.8631 .50346 L
.86271 .50664 L
.86236 .50836 L
.86196 .50996 L
.86074 .5135 L
.85934 .51647 L
.85779 .51909 L
.85335 .52464 L
.84861 .52888 L
.84242 .53306 L
.83485 .53687 L
.82683 .53988 L
.82233 .54123 L
.81732 .54249 L
.80771 .54434 L
.80203 .54512 L
.7965 .5457 L
.79324 .54596 L
.79021 .54616 L
.78665 .54633 L
.78321 .54644 L
.77739 .5465 L
.77103 .54642 L
.76488 .54618 L
.75919 .54585 L
.75233 .54529 L
.74475 .54451 L
.73063 .54258 L
.703 .53722 L
.67268 .52913 L
.6172 .50876 L
.55937 .47963 L
.50298 .44193 L
.4581 .40258 L
.42601 .36584 L
.41221 .34601 L
.40062 .32578 L
.39316 .30946 L
.38741 .2928 L
.38526 .28418 L
.38392 .27679 L
.38344 .27311 L
.38324 .27109 L
.38309 .26926 L
.38298 .26735 L
Mistroke
.38291 .26567 L
.38288 .26378 L
.38289 .26204 L
.383 .25918 L
.38323 .25631 L
.38351 .25398 L
.38392 .25157 L
.38446 .24915 L
.38514 .24673 L
.38662 .2429 L
.38743 .2413 L
.38839 .23971 L
.38938 .23836 L
.3905 .2371 L
.39159 .23613 L
.39262 .2354 L
.39361 .23486 L
.39468 .23445 L
.39584 .23418 L
.39649 .23412 L
.39708 .23411 L
.39822 .23424 L
.39928 .23453 L
.39987 .23477 L
.40048 .23508 L
.40156 .23579 L
.40266 .23676 L
.4038 .23807 L
.4047 .23939 L
.40549 .24082 L
.40676 .24393 L
.40734 .24591 L
.40779 .2479 L
.40817 .25024 L
.40834 .25163 L
.40845 .25292 L
.40858 .25539 L
.40859 .25778 L
.40849 .26052 L
.4084 .26196 L
.40825 .26356 L
.40793 .26636 L
.40744 .26946 L
.40623 .27534 L
.4043 .28237 L
.40158 .29026 L
.3949 .30533 L
.38505 .32253 L
.371 .34218 L
.33815 .37724 L
Mistroke
.29995 .40762 L
.25701 .43332 L
.23301 .44451 L
.21106 .45286 L
.19295 .45832 L
.18404 .46049 L
.17473 .46235 L
.1696 .46319 L
.16501 .46382 L
.16074 .46428 L
.15637 .46463 L
.15258 .46483 L
.14916 .4649 L
.14554 .46487 L
.14181 .4647 L
.13983 .46455 L
.13801 .46437 L
.13476 .46394 L
.13145 .46333 L
.12813 .46251 L
.12542 .46166 L
.12279 .46062 L
.11868 .45843 L
.11671 .457 L
.11489 .45533 L
.11345 .45362 L
.11238 .45195 L
.11188 .45095 L
.11142 .44986 L
.11102 .44862 L
.11074 .44744 L
.11057 .44631 L
.11047 .44523 L
.11045 .44401 L
.11052 .44266 L
.11065 .4415 L
.11087 .44023 L
.11146 .43788 L
.11196 .4364 L
.11251 .43498 L
.11378 .43226 L
.11691 .42704 L
.12146 .42111 L
.13328 .40932 L
.14784 .39795 L
.18938 .37338 L
.23952 .35129 L
.30359 .32989 L
.3417 .31985 L
.37752 .31197 L
Mistroke
.41097 .30592 L
.44689 .3008 L
.46364 .29893 L
.48111 .29733 L
.49043 .29664 L
.49877 .29612 L
.50648 .29573 L
.51063 .29555 L
.5145 .29541 L
.52142 .29522 L
.52754 .29512 L
.53311 .29509 L
.53898 .29511 L
.54521 .29522 L
.54826 .2953 L
.55155 .29541 L
.55716 .29567 L
.56218 .29597 L
.56754 .29637 L
.57236 .29682 L
.58065 .29781 L
.58846 .29909 L
.5956 .30069 L
.60084 .30232 L
.60323 .30329 L
.60507 .30421 L
.60649 .30511 L
.60753 .30596 L
.60832 .30686 L
.60862 .30734 L
.60884 .30786 L
.60899 .30876 L
.60881 .30974 L
.60833 .31065 L
.60761 .3115 L
.60673 .31225 L
.60552 .31306 L
.60228 .31466 L
.59993 .31555 L
.59709 .31644 L
.59109 .31794 L
.58332 .31936 L
.57827 .32008 L
.57333 .32067 L
.56344 .32155 L
.55755 .32193 L
.55171 .32221 L
.54605 .3224 L
.54064 .32251 L
.53448 .32257 L
Mistroke
.52773 .32255 L
.52126 .32246 L
.51399 .32227 L
.50693 .32201 L
.50021 .32169 L
.48712 .32089 L
.47266 .31974 L
.44119 .31637 L
.40467 .31104 L
.33797 .29752 L
.27654 .28049 L
.21468 .25786 L
.16089 .23144 L
.12713 .20858 L
.11362 .19615 L
.10489 .18526 L
.10316 .18243 L
.10163 .17952 L
.10056 .17707 L
.09967 .17451 L
.09929 .17312 L
.09902 .17186 L
.09868 .16947 L
.09861 .16817 L
.09862 .16679 L
.09873 .16552 L
.0989 .16437 L
.09945 .16223 L
.10021 .16031 L
.1011 .15868 L
.10228 .15701 L
.10381 .1553 L
.10571 .15363 L
.10775 .15219 L
.10981 .15099 L
.11424 .14903 L
.11696 .14811 L
.11972 .14737 L
.12223 .14681 L
.12504 .14631 L
.12827 .14588 L
.1314 .14558 L
.1349 .14537 L
.13883 .14527 L
.14269 .14531 L
.14634 .14545 L
.15052 .14572 L
.15524 .14617 L
.16032 .1468 L
.16517 .14753 L
Mistroke
.18572 .1519 L
.19793 .15535 L
.20947 .15916 L
.25424 .17855 L
.29384 .20205 L
.33149 .23125 L
.36196 .26222 L
.37531 .27931 L
.38556 .29506 L
.39294 .30894 L
.39603 .31588 L
.39871 .32292 L
.40067 .32908 L
.40201 .33433 L
.40253 .33675 L
.40298 .33928 L
.40332 .34154 L
.40356 .3436 L
.40376 .34607 L
.40385 .34821 L
.40385 .35039 L
.40381 .35156 L
.40375 .35261 L
.40358 .35427 L
.40333 .35597 L
.40299 .35761 L
.4026 .35902 L
.40209 .36044 L
.40149 .36176 L
.40092 .36274 L
.40025 .36365 L
.39947 .36445 L
.39902 .36481 L
.39859 .36509 L
.39818 .36531 L
.39772 .36549 L
.39691 .36568 L
.39604 .3657 L
.39522 .36554 L
.39475 .36538 L
.39432 .36519 L
.39336 .36458 L
.39247 .36378 L
.39153 .36268 L
.39069 .3614 L
.38996 .36003 L
.38882 .35714 L
.38827 .35524 L
.38782 .35329 L
.38743 .35106 L
Mistroke
.38716 .34887 L
.38696 .34629 L
.3869 .34493 L
.38687 .34339 L
.3869 .34045 L
.38704 .3376 L
.38716 .33606 L
.38732 .33431 L
.38778 .33065 L
.38832 .32728 L
.38905 .32351 L
.39079 .31633 L
.39606 .30043 L
.40312 .28449 L
.42969 .242 L
.46782 .19903 L
.51444 .1593 L
.57342 .12079 L
.63483 .09056 L
.69217 .06992 L
.72372 .06159 L
.74055 .05805 L
.75591 .05541 L
.76869 .05367 L
.78201 .05232 L
.78941 .05179 L
.79627 .05145 L
.8023 .05128 L
.80872 .05124 L
.81544 .05135 L
.82158 .05162 L
.82502 .05183 L
.82812 .05207 L
.83493 .05276 L
.84089 .05355 L
.84716 .05461 L
.85895 .05731 L
.86834 .0603 L
.8773 .0641 L
.88473 .06823 L
.89058 .07241 L
.89558 .07703 L
.90004 .08254 L
.90186 .08547 L
.90349 .08873 L
.90473 .09191 L
.90561 .09489 L
.90623 .09792 L
.9066 .10079 L
.90676 .104 L
Mistroke
.90665 .10749 L
.90629 .11088 L
.90572 .11412 L
.90502 .11707 L
.90406 .1203 L
.9011 .12778 L
.89665 .13616 L
.88401 .15341 L
.86826 .16952 L
.85049 .18438 L
.80342 .21522 L
.75244 .24099 L
.65769 .27728 L
.59107 .29809 L
.58064 .30193 L
.5765 .30387 L
.57499 .30476 L
.57385 .30556 L
.57302 .30629 L
.57237 .30706 L
.57212 .3075 L
.57195 .30791 L
.57185 .30868 L
.57199 .30941 L
.57232 .31009 L
.57292 .31084 L
.57382 .31164 L
.5762 .31316 L
.57978 .31488 L
.58882 .31826 L
.62084 .32805 L
.72113 .36146 L
.77671 .38527 L
.83388 .41625 L
.85709 .43178 L
.8788 .44888 L
.89581 .46519 L
.90821 .48014 L
.91714 .49465 L
.92033 .50179 L
.92174 .50574 L
.9228 .50943 L
.92325 .51133 L
.92365 .51337 L
.92417 .51691 L
.92435 .51888 L
.92444 .52096 L
.92439 .52462 L
.92407 .52793 L
.92355 .53096 L
Mistroke
.92271 .53421 L
.92152 .53761 L
.91863 .5434 L
.91658 .54652 L
.91439 .54931 L
.90929 .55454 L
.9038 .55889 L
.89105 .56615 L
.88287 .56949 L
.87442 .5722 L
.86428 .57469 L
.8541 .57651 L
.84795 .57733 L
.84218 .57794 L
.83891 .57821 L
.8353 .57846 L
.8286 .57879 L
.82198 .57895 L
.81815 .57897 L
.8145 .57894 L
.81062 .57886 L
.80703 .57874 L
.80304 .57857 L
.7988 .57833 L
.7916 .57781 L
.7848 .57718 L
.76901 .57526 L
.75391 .57285 L
.73938 .57002 L
.71164 .56335 L
.64843 .54212 L
.58576 .51263 L
.52565 .47505 L
.48193 .43993 L
.44373 .40069 L
.42766 .38015 L
.41538 .36162 L
.40665 .34588 L
.39972 .33057 L
.39704 .32335 L
.39472 .31595 L
.39313 .30971 L
.3921 .30448 L
.39168 .30173 L
.39136 .299 L
.39124 .29766 L
.39116 .29645 L
.39109 .29519 L
.39106 .29389 L
.39105 .29282 L
Mistroke
.39107 .29171 L
.39111 .29072 L
.39117 .28985 L
.39132 .28832 L
.39154 .28687 L
.39179 .28568 L
.39211 .28456 L
.39245 .28367 L
.39278 .283 L
.39313 .28247 L
.39346 .28211 L
.39385 .28185 L
.39421 .28174 L
.3946 .28178 L
.395 .282 L
.39533 .28233 L
.39565 .28284 L
.39597 .28357 L
.39613 .28405 L
.39626 .28455 L
.39648 .28564 L
.39662 .28683 L
.3967 .28796 L
.39672 .28934 L
.39668 .29091 L
.39658 .29252 L
.39641 .29413 L
.39621 .29569 L
.39553 .29952 L
.39451 .30383 L
.39299 .309 L
.38848 .32077 L
.38123 .33523 L
.37194 .35021 L
.34796 .38041 L
.31283 .41376 L
.26568 .44747 L
.21974 .47208 L
.19252 .48347 L
.16784 .49183 L
.14261 .49834 L
.12928 .50088 L
.12334 .50179 L
.11714 .50258 L
.11148 .50316 L
.10647 .50354 L
.10157 .50379 L
.09708 .5039 L
.09458 .50391 L
.09199 .50388 L
Mistroke
.08747 .50371 L
.08278 .50339 L
.08021 .50314 L
.07787 .50285 L
.07375 .50223 L
.06959 .50141 L
.06271 .49955 L
.05923 .49831 L
.05619 .497 L
.05293 .49532 L
.05012 .49355 L
.04796 .49193 L
.04584 .49003 L
.04277 .4864 L
.04141 .48419 L
.04077 .48292 L
.04025 .4817 L
.03945 .47925 L
.03897 .47693 L
.03873 .47473 L
.0387 .47225 L
.03893 .46957 L
.03937 .46699 L
.04 .46452 L
.04075 .46222 L
.04304 .45689 L
.04646 .45094 L
.05128 .44425 L
.06296 .43161 L
.097 .40542 L
.14902 .37705 L
.21514 .35049 L
.28287 .33024 L
.348 .31601 L
.37897 .31094 L
.4105 .30696 L
.4234 .30571 L
.43496 .30479 L
.44106 .30439 L
.44744 .30404 L
.45255 .3038 L
.45796 .30361 L
.46284 .3035 L
.46722 .30343 L
.47164 .30342 L
.47615 .30346 L
.4801 .30354 L
.48364 .30367 L
.48665 .30381 L
.48973 .304 L
Mistroke
.4933 .30428 L
.4963 .30457 L
.49921 .30493 L
.50202 .30537 L
.50586 .3062 L
.50747 .30668 L
.50866 .30715 L
.50954 .30763 L
.51009 .30809 L
.51037 .3085 L
.51043 .30896 L
.51021 .30945 L
.50965 .30997 L
.50891 .31041 L
.50782 .31088 L
.5063 .31137 L
.50433 .31187 L
.49987 .31268 L
.49687 .31307 L
.49376 .3134 L
.48999 .31372 L
.48773 .31387 L
.48556 .31399 L
.48138 .31417 L
.47905 .31424 L
.47651 .3143 L
.47202 .31436 L
.46936 .31437 L
.4668 .31436 L
.46184 .31429 L
.45711 .31418 L
.45141 .31399 L
.44577 .31374 L
.43301 .31297 L
.42017 .31194 L
.39429 .30918 L
.36405 .30492 L
.32935 .29873 L
.26387 .28341 L
.20411 .2649 L
.14282 .2403 L
.09431 .21482 L
.05421 .18592 L
.0456 .17774 L
.03874 .17015 L
.03333 .163 L
.02936 .15651 L
.02669 .15086 L
.02557 .14778 L
.02479 .14502 L
Mistroke
.02419 .14209 L
.02398 .14046 L
.02386 .13898 L
.02383 .13632 L
.02407 .13358 L
.02432 .13213 L
.02462 .13083 L
.02555 .12797 L
.02666 .12557 L
.02812 .12315 L
.03136 .11925 L
.03358 .11721 L
.03589 .11543 L
.04102 .11233 L
.04665 .10982 L
.05231 .10793 L
.05908 .10628 L
.06281 .1056 L
.06712 .10498 L
.07181 .10448 L
.07639 .10416 L
.0808 .10398 L
.08495 .10393 L
.08964 .10399 L
.09472 .10418 L
.09998 .10452 L
.10582 .10505 L
.11677 .10642 L
.1278 .10827 L
.13824 .11042 L
.16269 .11686 L
.18918 .1259 L
.23313 .1455 L
.27839 .17221 L
.31962 .20392 L
.34949 .23355 L
.3737 .26531 L
.38175 .27912 L
.38695 .29 L
.39029 .29872 L
.39238 .30607 L
.39272 .30764 L
.393 .30911 L
.39318 .3103 L
.39329 .31125 L
.39336 .31201 L
.39339 .31267 L
.39339 .31298 L
.39338 .31322 L
.39335 .31356 L
Mistroke
.39331 .31372 L
.39324 .31376 L
.39317 .31364 L
.3931 .31339 L
.39304 .31303 L
.39299 .31259 L
.39295 .31199 L
.39293 .31123 L
.39293 .31031 L
.39297 .30918 L
.39305 .30796 L
.39315 .30674 L
.39333 .30515 L
.39359 .30324 L
.39428 .29932 L
.3967 .28961 L
.4005 .27848 L
.40671 .2642 L
.41613 .24676 L
.44533 .20598 L
.48451 .16535 L
.53444 .12527 L
.58927 .09071 L
.65624 .05825 L
.69507 .04358 L
.73097 .03257 L
.7626 .0249 L
.7951 .01909 L
.8115 .01702 L
.81919 .01627 L
.82637 .01569 L
.83039 .01542 L
.83472 .01517 L
.84219 .01487 L
.84636 .01477 L
.85073 .01472 L
.85843 .01476 L
.86495 .01494 L
.87079 .01522 L
.87739 .01568 L
.8835 .01625 L
.89395 .01758 L
.90476 .01949 L
.91585 .02212 L
.92675 .02553 L
.93613 .02928 L
.94383 .03312 L
.95173 .03804 L
.95815 .04308 L
.96382 .04877 L
Mistroke
.96883 .05549 L
.97065 .05862 L
.97213 .06167 L
.97328 .0645 L
.97429 .06757 L
.97514 .07097 L
.97571 .07419 L
.97607 .0777 L
.97619 .08166 L
.976 .08572 L
.97579 .08778 L
.97548 .09006 L
.97469 .09413 L
.9737 .09797 L
.97058 .1068 L
.96591 .11639 L
.9539 .13429 L
.93945 .15061 L
.90025 .18374 L
.85623 .21193 L
.74959 .26241 L
.70602 .27918 L
.67077 .29285 L
.65917 .29826 L
.65491 .30071 L
.65186 .3029 L
.64985 .30481 L
.64905 .30587 L
.64851 .30681 L
.64814 .30785 L
.648 .30897 L
.6481 .31002 L
.64841 .31099 L
.64895 .31202 L
.64962 .31295 L
.65179 .31509 L
.6546 .31713 L
.65796 .31913 L
.68208 .32977 L
.76416 .36157 L
.81408 .38393 L
.86686 .41236 L
.90762 .43976 L
.94388 .47206 L
.95837 .48973 L
.96404 .49839 L
.96837 .50637 L
.97171 .51407 L
.97395 .52094 L
.97489 .52481 L
Mistroke
.97554 .52842 L
.97599 .53218 L
.97619 .53619 L
.97609 .54014 L
.97572 .54377 L
.97539 .54582 L
.97501 .54766 L
.9739 .55174 L
.97248 .55555 L
.97056 .55958 L
.96605 .56655 L
.96071 .57258 L
.95383 .57848 L
.94699 .58309 L
.93845 .58768 L
.9296 .59146 L
.91894 .59504 L
.9068 .59812 L
.90063 .59935 L
.89461 .60036 L
.88885 .60117 L
.88242 .6019 L
.87643 .60244 L
.87077 .60282 L
.86453 .60312 L
.8575 .6033 L
.85 .60332 L
.84284 .60319 L
.83493 .60287 L
.83038 .60262 L
.82613 .60234 L
.80973 .60082 L
.79442 .59885 L
.77778 .59612 L
.73871 .58753 L
.70273 .57701 L
.63318 .54969 L
.5733 .5181 L
.51547 .47871 L
.46619 .43503 L
.43374 .39747 L
.42043 .37828 L
.41064 .36155 L
.40379 .34753 L
.39855 .33421 L
.3955 .32406 L
.39457 .32013 L
.39386 .31645 L
.39357 .31466 L
.39332 .31287 L
Mistroke
.39316 .31137 L
.39305 .31013 L
.39297 .30881 L
.39294 .30816 L
.39293 .30759 L
.39293 .30668 L
.39296 .30587 L
.39301 .3053 L
.39307 .30481 L
.39315 .30447 L
.39322 .30431 L
.39328 .30429 L
.39333 .30438 L
.39337 .30461 L
.39339 .30496 L
.39339 .30548 L
.39334 .30623 L
.3933 .30667 L
.39325 .30719 L
.3931 .30826 L
.39264 .3108 L
.39197 .31365 L
.38935 .322 L
.38458 .33328 L
.37046 .35765 L
.34599 .38838 L
.31383 .41911 L
.27775 .44626 L
.23075 .47375 L
.18447 .4939 L
.16025 .50191 L
.13427 .50848 L
.12167 .51085 L
.11491 .51189 L
.10861 .51269 L
.1029 .51327 L
.09994 .51352 L
.09682 .51374 L
.09144 .514 L
.08658 .5141 L
.08165 .51407 L
.07891 .514 L
.07641 .51388 L
.07381 .51372 L
.07149 .51353 L
.06644 .51298 L
.06232 .51236 L
.05805 .51154 L
.05084 .50967 L
.04716 .50841 L
Mistroke
.04338 .50685 L
.04 .50516 L
.03669 .50315 L
.03392 .50111 L
.03167 .4991 L
.02979 .49708 L
.02805 .49478 L
.02667 .49249 L
.02564 .4903 L
.02484 .48802 L
.02429 .48578 L
.02391 .48308 L
.02381 .4805 L
.02398 .47759 L
.02417 .47608 L
.02448 .4744 L
.02528 .47118 L
.0263 .46816 L
.02957 .46114 L
.0338 .45436 L
.03887 .44773 L
.06871 .42036 L
.09172 .40481 L
.11603 .39095 L
.16796 .36683 L
.22979 .34461 L
.29872 .32587 L
.3602 .31374 L
.39201 .30914 L
.4193 .30618 L
.43373 .30502 L
.44599 .30429 L
.45238 .30401 L
.45563 .3039 L
.459 .30381 L
.46185 .30375 L
.46492 .3037 L
.4701 .30367 L
.47466 .30371 L
.47867 .30379 L
.48282 .30392 L
.48502 .30402 L
.48694 .30412 L
.49062 .30437 L
.49426 .30468 L
.49711 .30499 L
.49994 .30537 L
.50415 .30613 L
.50601 .30659 L
.50745 .30703 L
Mistroke
.50854 .30746 L
.50932 .30786 L
.50997 .30833 L
.51033 .30878 L
.51043 .30926 L
.51022 .30979 L
.50998 .31006 L
.50963 .31034 L
.50873 .31085 L
.50759 .31132 L
.50606 .31179 L
.50254 .31257 L
.5001 .31298 L
.49714 .31337 L
.49429 .31367 L
.49089 .31396 L
.48867 .31411 L
.48652 .31424 L
.48441 .31434 L
.482 .31444 L
.47758 .31456 L
.47504 .3146 L
.47258 .31462 L
.46782 .31461 L
.46506 .31458 L
.46248 .31454 L
.45729 .3144 L
.45219 .31422 L
.44597 .31393 L
.44002 .31359 L
.42582 .31254 L
.3994 .30982 L
.36897 .30559 L
.31172 .29471 L
.24661 .27771 L
.18075 .25474 L
.12778 .23047 L
.10275 .21624 L
.07971 .20056 L
.06249 .18599 L
.05048 .17277 L
.04643 .16706 L
.04309 .16124 L
.04171 .15828 L
.0405 .15511 L
.03967 .15231 L
.03912 .14976 L
.03891 .14832 L
.03876 .14679 L
.0387 .14407 L
Mistroke
.03891 .14151 L
.03934 .13924 L
.04005 .13687 L
.04057 .13557 L
.04113 .13438 L
.04246 .13209 L
.04424 .12974 L
.0463 .12757 L
.04848 .12569 L
.05356 .12237 L
.05902 .11982 L
.06566 .1176 L
.0698 .11658 L
.07456 .11567 L
.07684 .11532 L
.07931 .11501 L
.08149 .11477 L
.08388 .11456 L
.08848 .11428 L
.09292 .11415 L
.0957 .11413 L
.09838 .11416 L
.10352 .11434 L
.10823 .11462 L
.11342 .11506 L
.12311 .11622 L
.1351 .11818 L
.14644 .12055 L
.17196 .12748 L
.19689 .13625 L
.24071 .15632 L
.28567 .18366 L
.32723 .21685 L
.35692 .24792 L
.36971 .2646 L
.38054 .2816 L
.38797 .29612 L
.39267 .30809 L
.39424 .3132 L
.39534 .31762 L
.3958 .31988 L
.39618 .32219 L
.39644 .32415 L
.3966 .32584 L
.3967 .32757 L
.39672 .32905 L
.39667 .33052 L
.39662 .33128 L
.39654 .33193 L
.39636 .33304 L
Mistroke
.39624 .3336 L
.3961 .33408 L
.3958 .3349 L
.39561 .33527 L
.39543 .33557 L
.39506 .336 L
.39486 .33614 L
.39463 .33625 L
.39422 .3363 L
.39383 .33618 L
.3936 .33604 L
.39338 .33584 L
.39297 .33534 L
.39275 .33498 L
.39255 .3346 L
.39213 .33355 L
.3918 .33242 L
.39154 .33118 L
.39134 .32992 L
.39118 .32841 L
.39112 .32756 L
.39108 .32658 L
.39105 .3255 L
.39105 .32445 L
.39111 .32244 L
.39126 .32012 L
.3915 .31779 L
.39186 .31506 L
.39299 .30899 L
.39453 .30277 L
.39645 .29642 L
.40268 .28049 L
.41262 .2611 L
.44047 .22126 L
.47738 .18227 L
.52569 .14296 L
.57857 .10937 L
.64257 .07831 L
.67969 .06439 L
.71337 .05423 L
.74497 .04687 L
.7605 .04407 L
.77716 .04171 L
.79096 .04028 L
.79853 .03972 L
.8053 .03936 L
.81149 .03916 L
.81809 .03907 L
.8242 .03913 L
.82973 .03929 L
Mistroke
.83589 .03961 L
.84236 .04012 L
.84829 .04075 L
.85357 .04145 L
.8652 .04355 L
.87071 .04484 L
.87647 .04644 L
.88655 .04995 L
.89611 .05441 L
.90392 .05923 L
.90997 .06412 L
.9147 .06909 L
.91884 .07498 L
.92049 .0781 L
.92195 .08156 L
.92303 .08493 L
.92375 .08808 L
.92421 .09127 L
.92443 .09429 L
.92443 .09767 L
.92415 .10133 L
.92361 .10488 L
.92288 .10828 L
.9209 .11475 L
.91754 .12259 L
.91283 .13104 L
.90153 .14642 L
.88554 .1631 L
.86394 .18119 L
.8164 .21218 L
.76704 .23728 L
.65704 .27896 L
.61516 .29167 L
.59745 .297 L
.5848 .30119 L
.57733 .30429 L
.57583 .30509 L
.57451 .30591 L
.57351 .30666 L
.5728 .30734 L
.57224 .30809 L
.57191 .30888 L
.57185 .30961 L
.57202 .31031 L
.57248 .31112 L
.57315 .31188 L
.57418 .31273 L
.57558 .31364 L
.58232 .3168 L
.59317 .32065 L
Mistroke
.62136 .32937 L
.71487 .36122 L
.76838 .38449 L
.82321 .41469 L
.84531 .42976 L
.86584 .44633 L
.88082 .46104 L
.89319 .47649 L
.89809 .48437 L
.90224 .49285 L
.90364 .49651 L
.90486 .50038 L
.90574 .50398 L
.9063 .50721 L
.90654 .50915 L
.90669 .5112 L
.90674 .5148 L
.90664 .51677 L
.90645 .51859 L
.90616 .52056 L
.90573 .52266 L
.90467 .52631 L
.90333 .52968 L
.90184 .53261 L
.8999 .5357 L
.89519 .54142 L
.88988 .54619 L
.88255 .55114 L
.8745 .55525 L
.86607 .55854 L
.85754 .56111 L
.84735 .5634 L
.8419 .56433 L
.83569 .56519 L
.82951 .56585 L
.82362 .5663 L
.81695 .56664 L
.8135 .56674 L
.80964 .56679 L
.80308 .56677 L
.79931 .56669 L
.79582 .56657 L
.78928 .56624 L
.78225 .56574 L
.7688 .56438 L
.75592 .56263 L
.7256 .55688 L
.69141 .54789 L
.65983 .53734 L
.58995 .50627 L
Mistroke
.53039 .47024 L
.48281 .43294 L
.44108 .39032 L
.4232 .36711 L
.41018 .34672 L
.40126 .3297 L
.39417 .3125 L
.39137 .30379 L
.38942 .29621 L
.38809 .28944 L
.38757 .28588 L
.38723 .28279 L
.38701 .27999 L
.38689 .27716 L
.38686 .27486 L
.38692 .27246 L
.38708 .27001 L
.38735 .26756 L
.38769 .2654 L
.38807 .26358 L
.38898 .26043 L
.38958 .25887 L
.39018 .25758 L
.39138 .25557 L
.39203 .25474 L
.39276 .25397 L
.39356 .25332 L
.39431 .25286 L
.39514 .25252 L
.3956 .2524 L
.39603 .25234 L
.39688 .25235 L
.39735 .25244 L
.39778 .25257 L
.39855 .25292 L
.39934 .25348 L
.39998 .25409 L
.40063 .25489 L
.40169 .25669 L
.40226 .25802 L
.40272 .25943 L
.40308 .26083 L
.4034 .26248 L
.40365 .2644 L
.4038 .26634 L
.40385 .26751 L
.40386 .26862 L
.40385 .26988 L
.4038 .27125 L
.40373 .27253 L
Mistroke
.40361 .27395 L
.4033 .27661 L
.40278 .27994 L
.40214 .28313 L
.40061 .28914 L
.39836 .29612 L
.39258 .30987 L
.38453 .32471 L
.37488 .33932 L
.34552 .3736 L
.30822 .40575 L
.2615 .43565 L
.21592 .45654 L
.19082 .46477 L
.17931 .46771 L
.16887 .46987 L
.15937 .47137 L
.15423 .47198 L
.14964 .47238 L
.14589 .47261 L
.14189 .47275 L
.13786 .47276 L
.13425 .47264 L
.13228 .47253 L
.1302 .47236 L
.12655 .47195 L
.12319 .47141 L
.12024 .4708 L
.11726 .47001 L
.11419 .469 L
.11125 .46777 L
.10878 .46647 L
.10503 .46386 L
.10338 .4623 L
.10189 .46052 L
.10061 .45851 L
.09968 .45648 L
.09909 .45457 L
.09871 .45239 L
.0986 .45042 L
.09872 .44816 L
.09911 .44571 L
.09973 .44333 L
.10053 .44105 L
.10145 .4389 L
.10418 .4339 L
.10847 .42784 L
.11353 .42199 L
.12882 .40811 L
.16954 .38174 L
Mistroke
.22731 .35502 L
.292 .33281 L
.35465 .31668 L
.39006 .30955 L
.42254 .30421 L
.45353 .30021 L
.46884 .29864 L
.48491 .29731 L
.49377 .29671 L
.50175 .29627 L
.50919 .29594 L
.51291 .2958 L
.51685 .29568 L
.5235 .29554 L
.52955 .29547 L
.53298 .29546 L
.53651 .29548 L
.54265 .29556 L
.54591 .29564 L
.54892 .29573 L
.55437 .29595 L
.55998 .29626 L
.56576 .29667 L
.57532 .2976 L
.58314 .29865 L
.59059 .3 L
.59735 .30167 L
.60019 .30258 L
.6028 .3036 L
.60467 .3045 L
.60636 .30552 L
.60754 .30648 L
.60833 .30739 L
.60883 .30836 L
.60896 .30891 L
.60898 .30941 L
.60881 .31025 L
.60832 .31117 L
.60748 .31213 L
.60639 .313 L
.60471 .31402 L
.60275 .31496 L
.59809 .31664 L
.59169 .31829 L
.58314 .31986 L
.57502 .32093 L
.5649 .32188 L
.55937 .32225 L
.5562 .32242 L
.5531 .32256 L
Mistroke
.55016 .32268 L
.54689 .32278 L
.54096 .3229 L
.53467 .32295 L
.52878 .32293 L
.52543 .32289 L
.52175 .32282 L
.51493 .32264 L
.50834 .32239 L
.5012 .32205 L
.48801 .32123 L
.47229 .31995 L
.45688 .3184 L
.4269 .31457 L
.39351 .30912 L
.35662 .30165 L
.29129 .28451 L
.23547 .26517 L
.18338 .24157 L
.14594 .21873 L
.13028 .20603 L
.11986 .19499 L
.11593 .18952 L
.11285 .18384 L
.11177 .18111 L
.11131 .17965 L
.11097 .1783 L
.11073 .17706 L
.11055 .17575 L
.11045 .17354 L
.1106 .17146 L
.11096 .16964 L
.11163 .16765 L
.11252 .16586 L
.11354 .1643 L
.11468 .16294 L
.11787 .16017 L
.12007 .15878 L
.12239 .1576 L
.12733 .15576 L
.13044 .15493 L
.1335 .15431 L
.13708 .15378 L
.13896 .15357 L
.14109 .15338 L
.14308 .15326 L
.14529 .15317 L
.14744 .15314 L
.14947 .15314 L
.15343 .15325 L
Mistroke
.15778 .15351 L
.16009 .1537 L
.16263 .15395 L
.16732 .15452 L
.17852 .15639 L
.18938 .15881 L
.20011 .16172 L
.22106 .16876 L
.26378 .18827 L
.30782 .21601 L
.34447 .24674 L
.37141 .27639 L
.38335 .29289 L
.39341 .30983 L
.39992 .32359 L
.40489 .33764 L
.40674 .34495 L
.40739 .34825 L
.40786 .35119 L
.40825 .35445 L
.4084 .35611 L
.40851 .35783 L
.40859 .36061 L
.40859 .36213 L
.40854 .36352 L
.40839 .36589 L
.40811 .36825 L
.40779 .37014 L
.40735 .37208 L
.40679 .37402 L
.40608 .37592 L
.40458 .37884 L
.40375 .38004 L
.40277 .38117 L
.40168 .38215 L
.40062 .38288 L
.39959 .38339 L
.39863 .38371 L
.3975 .38391 L
.39642 .38392 L
.3958 .38385 L
.39524 .38375 L
.3946 .38357 L
.39399 .38334 L
.39292 .38282 L
.39179 .38206 L
.39057 .381 L
.38933 .37962 L
.38824 .3781 L
.3873 .37651 L
Mistroke
.38578 .37314 L
.38505 .37102 L
.38445 .36886 L
.384 .36686 L
.3836 .36461 L
.38325 .36199 L
.38303 .35943 L
.3829 .35654 L
.38288 .35485 L
.38289 .35326 L
.383 .35024 L
.38324 .34692 L
.38343 .3451 L
.38366 .34311 L
.38421 .33943 L
.38601 .33059 L
.38834 .3221 L
.39159 .3126 L
.39951 .29446 L
.41121 .27362 L
.42794 .24967 L
.4679 .20592 L
.51568 .16666 L
.57531 .12952 L
.60671 .11394 L
.63633 .10144 L
.66265 .09206 L
.69134 .08367 L
.71931 .07741 L
.73411 .07493 L
.74757 .07322 L
.75393 .0726 L
.7606 .0721 L
.76676 .07177 L
.77225 .0716 L
.77854 .07154 L
.78201 .07158 L
.78517 .07166 L
.79084 .07192 L
.79665 .07235 L
.80202 .07292 L
.80758 .07368 L
.81705 .07549 L
.82244 .07684 L
.82728 .0783 L
.8356 .0815 L
.84192 .08469 L
.84778 .08852 L
.85248 .09253 L
.85601 .09647 L
Mistroke
.85929 .10147 L
.8607 .10445 L
.86172 .10728 L
.8624 .10983 L
.8629 .11271 L
.86317 .11579 L
.86317 .11874 L
.8629 .12201 L
.86267 .12369 L
.86232 .12556 L
.8615 .12891 L
.86049 .1321 L
.85738 .13945 L
.85273 .14758 L
.84092 .16282 L
.82654 .17699 L
.79092 .20366 L
.74451 .22984 L
.69272 .25281 L
.63668 .27272 L
.55093 .29597 L
.51993 .30308 L
.51419 .30453 L
.5095 .3059 L
.50665 .30698 L
.50552 .30756 L
.50509 .30783 L
.50477 .30809 L
.50436 .30857 L
.50425 .30882 L
.50422 .30909 L
.50438 .30959 L
.50477 .31004 L
.50538 .3105 L
.50629 .31099 L
.5086 .31193 L
.5124 .31312 L
.51764 .31451 L
.53007 .31744 L
.61155 .33795 L
.70937 .37257 L
.76194 .39804 L
.80467 .42498 L
.82266 .43936 L
.83823 .45469 L
.84478 .46262 L
.85067 .47123 L
.85478 .47889 L
.85753 .48589 L
.85847 .48924 L
Mistroke
.85888 .49106 L
.85919 .49276 L
.85959 .49601 L
.85971 .4989 L
.85968 .50054 L
.85957 .50226 L
.85915 .50528 L
.85881 .50692 L
.85841 .50843 L
.85722 .51178 L
.85589 .51459 L
.85438 .51715 L
.85085 .52169 L
.84609 .52619 L
.83979 .53057 L
.83368 .5338 L
.82604 .53689 L
.81712 .53956 L
.81272 .54059 L
.80789 .54153 L
.80353 .54223 L
.7986 .54288 L
.79396 .54335 L
.78952 .54369 L
.78412 .54398 L
.77906 .54411 L
.77307 .54413 L
.76727 .54401 L
.76137 .54376 L
.75489 .54333 L
.74864 .54279 L
.74283 .54217 L
.72823 .54016 L
.71391 .53761 L
.68447 .53069 L
.65137 .5204 L
.59194 .49547 L
.53925 .46587 L
.48342 .42469 L
.44079 .38285 L
.41227 .34527 L
.40047 .32499 L
.39228 .30732 L
.38646 .29062 L
.38425 .28191 L
.38345 .27797 L
.38284 .27444 L
.3824 .27128 L
.38203 .26791 L
.38178 .26463 L
Mistroke
.38165 .26129 L
.38164 .25848 L
.38174 .25558 L
.38193 .25296 L
.38219 .25067 L
.38258 .2481 L
.38311 .24552 L
.3843 .2413 L
.38517 .23899 L
.38608 .23701 L
.38798 .23381 L
.38905 .23244 L
.39022 .23118 L
.39128 .23026 L
.39244 .22943 L
.3931 .22905 L
.39371 .22875 L
.39491 .22829 L
.39558 .22811 L
.39632 .22798 L
.39702 .22792 L
.39766 .22791 L
.39888 .22804 L
.39949 .22817 L
.40015 .22837 L
.40129 .22886 L
.40233 .22947 L
.40351 .23038 L
.40454 .23139 L
.40566 .23278 L
.40662 .23426 L
.40813 .23739 L
.40881 .23927 L
.40942 .24145 L
.40986 .24348 L
.41018 .24549 L
.41045 .24783 L
.41061 .25049 L
.41065 .25311 L
.41059 .25566 L
.41039 .25858 L
.41023 .26026 L
.41004 .26182 L
.40902 .26803 L
.40757 .27425 L
.40356 .28662 L
.39724 .301 L
.37761 .33255 L
.36261 .35088 L
.34632 .36776 L
Mistroke
.30788 .39957 L
.28418 .41518 L
.2615 .42782 L
.24044 .43772 L
.21765 .44647 L
.19588 .45281 L
.18467 .4552 L
.17985 .45602 L
.17475 .45674 L
.17038 .45722 L
.16646 .45753 L
.16246 .45773 L
.16029 .45777 L
.15836 .45778 L
.15502 .4577 L
.15155 .45749 L
.14845 .45716 L
.14573 .45676 L
.14277 .45617 L
.14018 .4555 L
.13754 .45463 L
.13496 .45356 L
.13254 .45227 L
.13051 .45089 L
.12893 .44954 L
.12747 .44794 L
.12628 .44621 L
.12543 .44451 L
.12508 .44359 L
.12478 .44253 L
.12454 .4414 L
.1244 .44032 L
.12435 .43823 L
.12453 .43625 L
.12473 .43512 L
.12502 .43386 L
.12575 .43152 L
.12663 .42936 L
.12785 .4269 L
.13112 .42171 L
.13969 .41176 L
.15391 .39945 L
.1742 .38563 L
.2228 .3605 L
.28027 .33838 L
.35136 .31806 L
.38878 .30984 L
.42862 .3028 L
.46523 .29785 L
.48184 .29611 L
Mistroke
.49693 .29481 L
.51141 .29384 L
.51887 .29344 L
.52669 .29311 L
.53054 .29298 L
.53467 .29287 L
.54202 .29273 L
.54898 .29268 L
.55522 .29271 L
.56085 .2928 L
.56598 .29294 L
.57142 .29315 L
.57709 .29344 L
.58247 .29379 L
.5879 .29422 L
.59693 .29516 L
.6058 .29641 L
.61405 .29797 L
.62064 .29962 L
.62558 .30126 L
.63008 .30331 L
.63199 .30451 L
.63335 .30565 L
.63421 .30665 L
.63456 .30723 L
.63481 .30777 L
.63503 .30886 L
.63501 .30947 L
.63489 .31004 L
.6344 .31111 L
.63364 .31211 L
.63269 .313 L
.6314 .31395 L
.62749 .31601 L
.62267 .31781 L
.61754 .31926 L
.61094 .32073 L
.60298 .32208 L
.59461 .32316 L
.58947 .32369 L
.58356 .32418 L
.57809 .32456 L
.57202 .32488 L
.56634 .3251 L
.55985 .32527 L
.55373 .32535 L
.54782 .32536 L
.54062 .3253 L
.53692 .32523 L
.53281 .32513 L
Mistroke
.52538 .32489 L
.5183 .32458 L
.50175 .32359 L
.48333 .32208 L
.44752 .31799 L
.41326 .31273 L
.33496 .29586 L
.26974 .27603 L
.21001 .25162 L
.16764 .22817 L
.14985 .21525 L
.13767 .204 L
.13348 .19917 L
.12992 .19424 L
.12829 .19151 L
.12707 .18911 L
.12609 .18674 L
.12541 .18463 L
.12497 .18269 L
.12471 .18072 L
.12466 .17881 L
.12486 .17682 L
.12523 .17517 L
.12584 .17349 L
.12661 .17199 L
.12747 .17069 L
.13004 .16797 L
.13185 .1666 L
.13378 .16543 L
.1383 .16344 L
.14121 .16254 L
.14408 .16185 L
.14691 .16134 L
.14969 .16097 L
.1529 .16068 L
.1565 .16051 L
.16009 .16048 L
.16362 .16056 L
.1669 .16074 L
.17057 .16104 L
.17501 .16152 L
.17928 .16212 L
.18944 .16395 L
.19985 .1664 L
.21149 .16972 L
.25408 .18667 L
.27704 .19878 L
.29784 .21166 L
.34098 .24537 L
.37184 .27811 L
Mistroke
.38528 .29645 L
.3951 .31289 L
.40198 .32734 L
.40702 .34157 L
.40879 .34847 L
.40992 .35453 L
.41017 .35625 L
.41037 .35784 L
.41064 .36074 L
.4108 .36374 L
.41083 .36537 L
.41082 .36684 L
.41073 .36903 L
.41056 .37128 L
.41031 .37331 L
.41001 .37507 L
.40959 .37702 L
.40904 .37902 L
.40782 .38227 L
.40704 .38383 L
.40627 .38512 L
.40538 .38636 L
.40436 .38753 L
.40336 .38847 L
.4024 .38918 L
.40146 .38975 L
.40043 .39021 L
.39929 .39056 L
.39864 .39068 L
.39804 .39075 L
.39691 .39075 L
.39572 .3906 L
.39465 .39031 L
.39366 .38992 L
.39258 .38935 L
.39143 .38858 L
.38913 .38641 L
.38804 .38505 L
.38691 .38334 L
.38511 .37979 L
.3837 .37588 L
.38312 .37376 L
.38258 .3713 L
.38216 .36884 L
.38186 .36646 L
.38166 .3642 L
.38151 .36162 L
.38146 .35881 L
.38151 .35608 L
.38168 .35276 L
Mistroke
.38196 .34949 L
.38232 .34646 L
.38282 .34306 L
.38441 .33506 L
.38647 .32722 L
.39225 .31078 L
.40123 .29169 L
.42506 .25468 L
.466 .20929 L
.51435 .16942 L
.57003 .13437 L
.62585 .10782 L
.65778 .09601 L
.68753 .08716 L
.70361 .08328 L
.72062 .07989 L
.7356 .07756 L
.7425 .07671 L
.74894 .07605 L
.75511 .07555 L
.7617 .07516 L
.76755 .07494 L
.77286 .07487 L
.779 .07492 L
.78441 .07512 L
.78734 .07528 L
.79046 .0755 L
.79597 .07602 L
.8006 .0766 L
.80551 .07736 L
.81483 .07932 L
.82272 .0816 L
.82942 .08413 L
.83698 .0879 L
.84309 .09199 L
.84769 .09608 L
.85169 .10094 L
.85336 .10361 L
.85487 .10667 L
.85549 .10826 L
.85607 .11 L
.85649 .11153 L
.85687 .11323 L
.85731 .11638 L
.85742 .11813 L
.85745 .11978 L
.85731 .12279 L
.85689 .12607 L
.85622 .12933 L
.85517 .13298 L
Mistroke
.85211 .14055 L
.84814 .14775 L
.84348 .15462 L
.82973 .17038 L
.81035 .18741 L
.7646 .21755 L
.71475 .24236 L
.61134 .27955 L
.56083 .29289 L
.52545 .30094 L
.5128 .30384 L
.50779 .30512 L
.50376 .30634 L
.50246 .30683 L
.50133 .30733 L
.50081 .30761 L
.50042 .30786 L
.49986 .30835 L
.49962 .30879 L
.49962 .30926 L
.49988 .3097 L
.50034 .31012 L
.50097 .31052 L
.50188 .31097 L
.50408 .31181 L
.51177 .31395 L
.53801 .31989 L
.62875 .34372 L
.68395 .36293 L
.74349 .38923 L
.79253 .41768 L
.8272 .44519 L
.84123 .46048 L
.84695 .46841 L
.85168 .47662 L
.85468 .48362 L
.85591 .4875 L
.85637 .48934 L
.85673 .49106 L
.85721 .49427 L
.85743 .49714 L
.85741 .50017 L
.8571 .50338 L
.85655 .50626 L
.85582 .50884 L
.85477 .51159 L
.85338 .51438 L
.8504 .51886 L
.84622 .52339 L
.84058 .52787 L
Mistroke
.83335 .53209 L
.82541 .5355 L
.81731 .53808 L
.8125 .53928 L
.80715 .54038 L
.80232 .54119 L
.79691 .54191 L
.79379 .54225 L
.79088 .54251 L
.78502 .54289 L
.78166 .54304 L
.77792 .54314 L
.77434 .54317 L
.77095 .54316 L
.76776 .5431 L
.76427 .54299 L
.75781 .54267 L
.75138 .5422 L
.74535 .54164 L
.73122 .53987 L
.71578 .53727 L
.6863 .53055 L
.65857 .52229 L
.59555 .49677 L
.53959 .46571 L
.49187 .43143 L
.44856 .39119 L
.42923 .36875 L
.41412 .34795 L
.40286 .32938 L
.39475 .3131 L
.38812 .2961 L
.3856 .28772 L
.38363 .27937 L
.38291 .27553 L
.38231 .2715 L
.38189 .26784 L
.38163 .26459 L
.3815 .26175 L
.38146 .25875 L
.38154 .25575 L
.38171 .25307 L
.38204 .25009 L
.38245 .24742 L
.38291 .24516 L
.3835 .24284 L
.38424 .2405 L
.38512 .23822 L
.38694 .23464 L
.38888 .23191 L
Mistroke
.39005 .23065 L
.39116 .22966 L
.39225 .22888 L
.39328 .22829 L
.39437 .22782 L
.39557 .22747 L
.39667 .2273 L
.39769 .22727 L
.39861 .22735 L
.3996 .22755 L
.40065 .22791 L
.40174 .22844 L
.40265 .22902 L
.40361 .22978 L
.40558 .23193 L
.40659 .23342 L
.40745 .23499 L
.40881 .2383 L
.40943 .24038 L
.40991 .24242 L
.41028 .24455 L
.41055 .24663 L
.41074 .24903 L
.41083 .2517 L
.4108 .25413 L
.41069 .25649 L
.41048 .25917 L
.41012 .26215 L
.40957 .26569 L
.4089 .26909 L
.40682 .27716 L
.40433 .28468 L
.40099 .29303 L
.3926 .30969 L
.38256 .32561 L
.35653 .3574 L
.32041 .39008 L
.28371 .41533 L
.243 .43646 L
.22157 .44495 L
.20285 .45083 L
.19296 .4533 L
.18271 .45535 L
.1782 .45606 L
.17356 .45666 L
.16973 .45705 L
.16565 .45735 L
.16178 .45751 L
.15825 .45753 L
.15521 .45745 L
Mistroke
.15203 .45726 L
.14875 .45692 L
.14546 .45641 L
.14256 .4558 L
.1401 .45514 L
.13577 .45353 L
.13363 .45246 L
.13186 .45137 L
.12909 .4491 L
.12794 .44784 L
.12688 .44636 L
.12593 .44457 L
.12529 .44282 L
.12506 .44186 L
.12487 .44078 L
.12475 .43961 L
.12473 .43849 L
.12488 .43637 L
.12524 .43434 L
.1259 .43203 L
.12688 .4295 L
.12929 .42489 L
.13236 .42039 L
.14222 .40952 L
.15753 .39689 L
.17539 .38501 L
.22785 .35834 L
.2888 .3356 L
.35164 .31801 L
.42308 .30367 L
.45831 .29866 L
.47629 .29664 L
.49527 .29492 L
.50359 .29431 L
.51226 .29376 L
.52011 .29336 L
.52732 .29306 L
.53388 .29286 L
.54079 .29272 L
.54444 .29267 L
.54824 .29265 L
.55486 .29267 L
.56058 .29276 L
.56651 .29291 L
.57192 .29312 L
.57668 .29336 L
.58206 .2937 L
.58764 .29414 L
.59707 .29511 L
.60604 .29637 L
Mistroke
.61462 .298 L
.62205 .29993 L
.62505 .30093 L
.62756 .30191 L
.62955 .30284 L
.6314 .30387 L
.63279 .30485 L
.63379 .30574 L
.63467 .30682 L
.635 .30742 L
.63522 .30798 L
.63538 .30898 L
.63522 .31007 L
.63475 .3111 L
.63405 .31204 L
.63291 .31311 L
.63152 .3141 L
.62829 .31582 L
.62369 .3176 L
.61735 .31941 L
.6092 .32114 L
.60111 .32242 L
.59104 .32359 L
.5855 .32409 L
.57937 .32453 L
.57389 .32484 L
.56765 .3251 L
.564 .32521 L
.56062 .32529 L
.55663 .32536 L
.5528 .32539 L
.54579 .32539 L
.54175 .32535 L
.53796 .32528 L
.53099 .32511 L
.52432 .32487 L
.51684 .32453 L
.50862 .32407 L
.49131 .3228 L
.47495 .32127 L
.44252 .31731 L
.40689 .31162 L
.34228 .29772 L
.26951 .27592 L
.21253 .25276 L
.18868 .24065 L
.16727 .22782 L
.15214 .21694 L
.13958 .20575 L
.1342 .19975 L
Mistroke
.13039 .19453 L
.12891 .19211 L
.12759 .18955 L
.12659 .18723 L
.12589 .18512 L
.12534 .18276 L
.12516 .18154 L
.12506 .18027 L
.12506 .17898 L
.12514 .17778 L
.1253 .17673 L
.12555 .17563 L
.12622 .17372 L
.12671 .1727 L
.12723 .17181 L
.12844 .17016 L
.12982 .16872 L
.13134 .16746 L
.13318 .16621 L
.13707 .16428 L
.13979 .1633 L
.14259 .16251 L
.1453 .16192 L
.14844 .16141 L
.15168 .16105 L
.1536 .1609 L
.15546 .1608 L
.15746 .16074 L
.15934 .16072 L
.16146 .16074 L
.16374 .1608 L
.16767 .16102 L
.17146 .16134 L
.17576 .16183 L
.1805 .16251 L
.18931 .16412 L
.19933 .16644 L
.21849 .17217 L
.25631 .1879 L
.29701 .21123 L
.33794 .24271 L
.35587 .26003 L
.37262 .27914 L
.38566 .29706 L
.39533 .3133 L
.40263 .32883 L
.40545 .33638 L
.40783 .34417 L
.40888 .34844 L
.40965 .35224 L
Mistroke
.41022 .35574 L
.41045 .35747 L
.41065 .35929 L
.41089 .36234 L
.41099 .36508 L
.411 .3667 L
.41097 .36818 L
.41081 .37086 L
.41057 .3731 L
.4102 .37544 L
.4097 .37772 L
.40914 .37972 L
.40791 .38291 L
.40712 .38449 L
.40632 .3858 L
.40445 .38814 L
.4033 .3892 L
.40218 .39 L
.40156 .39036 L
.40095 .39065 L
.39981 .39107 L
.39915 .39123 L
.39854 .39134 L
.39787 .3914 L
.39716 .39141 L
.39598 .39129 L
.3947 .39098 L
.3935 .39051 L
.3924 .38992 L
.39038 .3884 L
.3893 .38732 L
.38835 .3862 L
.38635 .38317 L
.38533 .38116 L
.38447 .37912 L
.38313 .37492 L
.38257 .37258 L
.38207 .36985 L
.38171 .36715 L
.38147 .36445 L
.38134 .36192 L
.38129 .35906 L
.38136 .35581 L
.38158 .35221 L
.38188 .34903 L
.38235 .34539 L
.38355 .33861 L
.38538 .33091 L
.3902 .31599 L
.39891 .29623 L
Mistroke
.40991 .27677 L
.44541 .23049 L
.48821 .18993 L
.54358 .1502 L
.60507 .11728 L
.64094 .10247 L
.67379 .09158 L
.70191 .08432 L
.71756 .08115 L
.73143 .07891 L
.74558 .0772 L
.75313 .07655 L
.75654 .07632 L
.76011 .07613 L
.76639 .0759 L
.77206 .07583 L
.778 .07591 L
.7813 .07602 L
.78435 .07617 L
.78963 .07654 L
.79509 .07708 L
.80006 .07773 L
.80441 .07844 L
.81442 .08063 L
.82295 .08328 L
.83081 .08659 L
.83714 .09013 L
.84303 .09452 L
.8458 .09717 L
.84802 .09972 L
.85106 .10421 L
.85238 .10682 L
.85341 .10937 L
.85414 .11179 L
.85465 .11409 L
.85502 .11668 L
.85519 .11949 L
.85511 .12266 L
.85494 .12447 L
.85471 .12616 L
.8541 .12931 L
.85318 .1327 L
.85094 .13871 L
.84754 .14546 L
.83683 .16066 L
.82275 .17534 L
.78735 .20265 L
.73903 .23018 L
.67983 .25601 L
.57557 .2887 L
Mistroke
.53424 .29838 L
.5178 .30194 L
.50507 .30484 L
.5012 .30586 L
.49808 .30687 L
.49676 .30741 L
.49588 .30789 L
.49528 .30836 L
.49499 .3088 L
.49496 .3092 L
.49516 .30962 L
.49553 .30999 L
.49614 .31039 L
.49703 .31084 L
.49827 .31133 L
.50122 .31227 L
.55328 .3241 L
.6 .33606 L
.65887 .35468 L
.71614 .37762 L
.76536 .40276 L
.80618 .43019 L
.82114 .4431 L
.83394 .45666 L
.83941 .46379 L
.84428 .47146 L
.84767 .47828 L
.84886 .48127 L
.84991 .48447 L
.85044 .48639 L
.85084 .48814 L
.85141 .49154 L
.85167 .49456 L
.85167 .4977 L
.85157 .49929 L
.85137 .50097 L
.85079 .50395 L
.8503 .50573 L
.84974 .50738 L
.84843 .5104 L
.84697 .51302 L
.8451 .51575 L
.84091 .52037 L
.83589 .52445 L
.83045 .52783 L
.8237 .53106 L
.81531 .53406 L
.8107 .53535 L
.80549 .53655 L
.80037 .53752 L
Mistroke
.79541 .53826 L
.79057 .53884 L
.78524 .53931 L
.77972 .53964 L
.77649 .53976 L
.77341 .53983 L
.76776 .53985 L
.76245 .53974 L
.75648 .53949 L
.75005 .53907 L
.74452 .5386 L
.7385 .53797 L
.7274 .5365 L
.70114 .53163 L
.66915 .52327 L
.6389 .51309 L
.5708 .48212 L
.51487 .44724 L
.46388 .4052 L
.4272 .36497 L
.41149 .343 L
.39963 .32281 L
.39125 .30496 L
.38782 .29598 L
.38489 .28681 L
.38282 .27873 L
.38145 .27177 L
.38096 .26854 L
.38054 .26514 L
.38026 .26204 L
.38009 .25927 L
.37999 .25579 L
.38003 .25264 L
.38016 .24992 L
.38041 .24709 L
.38079 .24416 L
.38132 .24123 L
.38187 .23887 L
.38257 .23642 L
.38405 .23249 L
.38592 .22886 L
.38791 .22601 L
.38988 .22392 L
.39112 .22289 L
.39248 .22199 L
.39379 .22133 L
.395 .22088 L
.39574 .22068 L
.39642 .22055 L
.39717 .22046 L
Mistroke
.39796 .22042 L
.39928 .22051 L
.40003 .22064 L
.40072 .22081 L
.40202 .22128 L
.40322 .22189 L
.40427 .22259 L
.40537 .22349 L
.40651 .22464 L
.40765 .22606 L
.40856 .22744 L
.40948 .22911 L
.41093 .23256 L
.41158 .23468 L
.4121 .23678 L
.41249 .23888 L
.41278 .24088 L
.41301 .2433 L
.41314 .2457 L
.41317 .24842 L
.41307 .25144 L
.41287 .25411 L
.41254 .25715 L
.41204 .26053 L
.41133 .26429 L
.4096 .27139 L
.40453 .28605 L
.39754 .3009 L
.37869 .33017 L
.3499 .36246 L
.31183 .39415 L
.27176 .41909 L
.23492 .43596 L
.21521 .44265 L
.20495 .44543 L
.19579 .44745 L
.18834 .44874 L
.18467 .44924 L
.18079 .44967 L
.1767 .44999 L
.17298 .45016 L
.16951 .4502 L
.16644 .45012 L
.16328 .44992 L
.16006 .44956 L
.15721 .44909 L
.15476 .44855 L
.15222 .44784 L
.14968 .44691 L
.1473 .44579 L
Mistroke
.14534 .44461 L
.14352 .4432 L
.14206 .44174 L
.14098 .44032 L
.14005 .43867 L
.13967 .43776 L
.13934 .43673 L
.13908 .43562 L
.13892 .43455 L
.13885 .43255 L
.13893 .43138 L
.13907 .43029 L
.13951 .42827 L
.14013 .4263 L
.14105 .42407 L
.14232 .42157 L
.1458 .41625 L
.15006 .41109 L
.16047 .40112 L
.17506 .39004 L
.21721 .3659 L
.27863 .34044 L
.34708 .31966 L
.41363 .305 L
.45056 .29896 L
.4697 .2964 L
.48959 .29418 L
.50651 .29264 L
.5153 .29197 L
.52457 .29137 L
.5329 .29093 L
.54037 .29061 L
.54773 .29037 L
.55456 .29022 L
.56178 .29013 L
.56576 .29012 L
.56937 .29014 L
.57586 .29022 L
.58252 .29038 L
.5883 .29059 L
.59353 .29085 L
.60481 .29161 L
.61068 .29215 L
.61598 .29272 L
.6252 .29396 L
.63404 .29552 L
.64232 .29745 L
.6479 .29914 L
.65298 .30113 L
.65509 .30217 L
Mistroke
.65703 .30332 L
.65842 .30434 L
.65965 .30546 L
.66051 .30652 L
.66106 .30752 L
.66139 .30858 L
.66144 .30971 L
.66121 .31076 L
.66076 .31175 L
.66014 .31264 L
.65927 .31359 L
.65795 .31469 L
.65648 .31569 L
.65224 .31785 L
.64719 .31975 L
.64142 .32143 L
.63355 .3232 L
.62518 .32466 L
.61485 .32601 L
.60862 .32664 L
.6026 .32714 L
.59648 .32755 L
.58947 .32791 L
.5857 .32806 L
.58212 .32818 L
.57827 .32827 L
.57407 .32834 L
.57031 .32838 L
.56615 .32839 L
.56216 .32838 L
.55842 .32834 L
.5512 .32821 L
.54336 .32797 L
.53614 .32768 L
.52822 .32727 L
.51352 .32631 L
.49548 .32476 L
.47853 .32296 L
.44552 .31853 L
.40967 .31237 L
.34579 .29782 L
.27575 .27579 L
.22252 .25307 L
.20103 .24153 L
.18223 .22949 L
.16942 .21947 L
.15936 .20937 L
.1554 .20407 L
.15285 .19953 L
.15198 .19746 L
Mistroke
.15129 .19528 L
.1509 .19331 L
.15074 .19156 L
.15082 .18965 L
.15114 .18794 L
.15143 .18701 L
.15176 .18618 L
.15223 .18525 L
.15274 .18442 L
.15391 .18295 L
.15547 .18148 L
.15729 .1802 L
.15954 .17899 L
.16163 .17812 L
.16417 .17731 L
.16708 .17663 L
.16857 .17635 L
.17004 .17613 L
.17299 .17581 L
.17585 .17562 L
.1791 .17555 L
.181 .17557 L
.18282 .17562 L
.18485 .17572 L
.1871 .17587 L
.19133 .17628 L
.19561 .17684 L
.19969 .17749 L
.20942 .17948 L
.2203 .18233 L
.23981 .18888 L
.25886 .1969 L
.30285 .22134 L
.34367 .25252 L
.37606 .28599 L
.39792 .31704 L
.40686 .33417 L
.41026 .34219 L
.41286 .34934 L
.41496 .35625 L
.41671 .36353 L
.41736 .36695 L
.4179 .37051 L
.41814 .37243 L
.41832 .37416 L
.41857 .37744 L
.41868 .38043 L
.41868 .38311 L
.41856 .38594 L
.41832 .38882 L
Mistroke
.41802 .39122 L
.41765 .39337 L
.41716 .39564 L
.41654 .39795 L
.41483 .40262 L
.41367 .40498 L
.41249 .40696 L
.41008 .4101 L
.40861 .41157 L
.40721 .41271 L
.40588 .41362 L
.40442 .41441 L
.40365 .41475 L
.40279 .41508 L
.40126 .41551 L
.39978 .41576 L
.39819 .41586 L
.39668 .41578 L
.39531 .41557 L
.39383 .4152 L
.39245 .4147 L
.39095 .414 L
.38937 .41306 L
.38628 .41055 L
.38365 .40756 L
.38144 .40424 L
.37932 .4 L
.37764 .39543 L
.3764 .3907 L
.37581 .38761 L
.37555 .38593 L
.37532 .3841 L
.37515 .38245 L
.375 .38061 L
.37484 .37726 L
.37482 .37387 L
.37494 .3701 L
.37519 .36642 L
.37555 .36296 L
.37616 .35853 L
.3769 .35431 L
.3792 .34434 L
.38199 .33512 L
.38575 .32493 L
.40557 .28703 L
.42134 .26477 L
.43865 .24424 L
.47677 .20763 L
.52513 .17179 L
.58074 .1405 L
Mistroke
.63412 .11847 L
.66602 .10884 L
.68118 .10525 L
.69474 .1026 L
.70667 .10076 L
.7126 .10002 L
.71882 .09939 L
.72491 .09891 L
.73046 .09861 L
.73378 .09849 L
.73688 .09843 L
.74255 .09844 L
.7479 .0986 L
.75083 .09875 L
.75347 .09894 L
.75819 .09939 L
.76298 .10001 L
.77079 .10142 L
.77493 .10242 L
.7786 .10347 L
.78611 .10624 L
.79207 .10925 L
.79786 .11327 L
.80008 .11526 L
.80223 .11757 L
.80512 .12167 L
.80635 .12404 L
.80727 .12635 L
.80793 .12858 L
.80836 .13067 L
.80864 .13303 L
.80873 .13558 L
.80859 .13824 L
.80818 .14115 L
.80757 .14396 L
.80681 .14655 L
.80415 .15309 L
.80061 .15946 L
.79113 .17205 L
.7768 .18626 L
.7368 .21493 L
.68941 .23979 L
.63966 .2602 L
.57972 .27951 L
.52627 .2928 L
.48513 .30074 L
.45129 .30576 L
.43943 .30721 L
.43475 .30777 L
.43103 .30824 L
Mistroke
.4288 .30858 L
.42836 .30866 L
.42797 .30875 L
.42748 .3089 L
.42726 .30905 L
.4273 .30919 L
.42754 .30931 L
.42801 .30945 L
.42876 .30961 L
.42986 .3098 L
.433 .31023 L
.4416 .3113 L
.47482 .31602 L
.51903 .32438 L
.56718 .33618 L
.62664 .355 L
.68143 .37753 L
.72671 .40182 L
.74745 .41586 L
.76369 .4292 L
.77565 .44153 L
.7806 .44787 L
.78478 .45442 L
.78747 .4598 L
.78857 .46258 L
.7895 .4655 L
.79013 .46814 L
.79051 .47049 L
.79071 .47281 L
.79073 .47495 L
.79055 .47738 L
.79011 .47991 L
.78945 .48223 L
.78865 .48429 L
.78754 .48648 L
.78606 .48879 L
.78419 .4911 L
.78223 .49309 L
.77736 .49687 L
.771 .50034 L
.76408 .50302 L
.76065 .50404 L
.75667 .50504 L
.75308 .50578 L
.74905 .50646 L
.74459 .50705 L
.74025 .50747 L
.73577 .50776 L
.73137 .50793 L
.7273 .50798 L
Mistroke
.72275 .50793 L
.71713 .50773 L
.7119 .50742 L
.7057 .50689 L
.69971 .50623 L
.68869 .50467 L
.67634 .50242 L
.64965 .49595 L
.6237 .48772 L
.5633 .46157 L
.50653 .42737 L
.45297 .38376 L
.41314 .33937 L
.39594 .31404 L
.38366 .29113 L
.3758 .27188 L
.37249 .26137 L
.37015 .25187 L
.36918 .2469 L
.36845 .24229 L
.36794 .23824 L
.36755 .23392 L
.3674 .23153 L
.36731 .22939 L
.36726 .22695 L
.36726 .2247 L
.36738 .22079 L
.36752 .21864 L
.36768 .2167 L
.36812 .21301 L
.36866 .20964 L
.37001 .20369 L
.37094 .20057 L
.3719 .19782 L
.37444 .19208 L
.37678 .18802 L
.37964 .18407 L
.38291 .18056 L
.38618 .17785 L
.39001 .17551 L
.39199 .17461 L
.39418 .17382 L
.39607 .17332 L
.39811 .17297 L
.40003 .1728 L
.40177 .17278 L
.40284 .17284 L
.40396 .17296 L
.40595 .1733 L
.40705 .17357 L
Mistroke
.40806 .17387 L
.41034 .17474 L
.41227 .17569 L
.41399 .17672 L
.41766 .17959 L
.42077 .18292 L
.4233 .18647 L
.42582 .19117 L
.42777 .19615 L
.42851 .19857 L
.42918 .20124 L
.42968 .20364 L
.43011 .20629 L
.43047 .20924 L
.43069 .21209 L
.43083 .21557 L
.43081 .21885 L
.43065 .2225 L
.43051 .22439 L
.43031 .22649 L
.42984 .23028 L
.42926 .2339 L
.42744 .2423 L
.42469 .25167 L
.41755 .26945 L
.40863 .28614 L
.38405 .31994 L
.35489 .34911 L
.31873 .3763 L
.29809 .38848 L
.27953 .39757 L
.26247 .40429 L
.25432 .4069 L
.24609 .40907 L
.24202 .40995 L
.23846 .41059 L
.23501 .41109 L
.23197 .41142 L
.23033 .41155 L
.22864 .41164 L
.227 .41168 L
.22527 .41167 L
.22383 .41163 L
.22235 .41153 L
.22102 .41139 L
.21985 .41122 L
.2179 .41084 L
.21601 .41031 L
.21441 .4097 L
.21312 .40905 L
Mistroke
.21182 .40817 L
.21122 .40765 L
.21066 .40708 L
.20982 .40592 L
.20927 .40474 L
.20892 .40344 L
.20882 .40192 L
.20896 .40039 L
.20931 .3989 L
.20962 .39796 L
.20998 .39706 L
.21105 .39494 L
.21387 .39078 L
.21786 .38626 L
.22257 .38184 L
.23686 .37107 L
.2753 .34985 L
.32297 .33034 L
.38388 .31141 L
.4514 .29597 L
.49077 .28925 L
.52673 .2845 L
.55967 .28132 L
.57785 .28007 L
.58639 .27961 L
.59431 .27926 L
.60109 .27902 L
.6083 .27882 L
.6162 .27869 L
.62332 .27864 L
.63021 .27865 L
.63762 .27874 L
.64518 .27892 L
.65206 .27916 L
.65961 .27952 L
.66737 .27999 L
.68065 .28107 L
.69399 .28256 L
.70742 .28456 L
.71792 .28657 L
.72799 .28899 L
.74286 .29395 L
.74858 .29664 L
.75353 .29971 L
.75533 .30116 L
.75693 .30271 L
.75814 .3042 L
.75897 .30555 L
.7596 .307 L
.75992 .30833 L
Mistroke
.76002 .30979 L
.75982 .31133 L
.75939 .31267 L
.75878 .31392 L
.75787 .31527 L
.75663 .31671 L
.7529 .31984 L
.75051 .32137 L
.74748 .32302 L
.73409 .32831 L
.72457 .33096 L
.71281 .33351 L
.70034 .33559 L
.68784 .33719 L
.67507 .33841 L
.66247 .33928 L
.65493 .33966 L
.6479 .33993 L
.64394 .34004 L
.63959 .34014 L
.63157 .34024 L
.62364 .34025 L
.61906 .34022 L
.61474 .34016 L
.61015 .34008 L
.60592 .33997 L
.59629 .33965 L
.58798 .33928 L
.57882 .33878 L
.56189 .3376 L
.52711 .33419 L
.49399 .32977 L
.4578 .32363 L
.41969 .31563 L
.34829 .29585 L
.29416 .27531 L
.2735 .26548 L
.25523 .25526 L
.24277 .24689 L
.23283 .23854 L
.22859 .23391 L
.22717 .23201 L
.22591 .23001 L
.22501 .22823 L
.22442 .22666 L
.22407 .2251 L
.22399 .22427 L
.22399 .22354 L
.22417 .22226 L
.22455 .22117 L
Mistroke
.22521 .22008 L
.22568 .21952 L
.22616 .21904 L
.22722 .21825 L
.22858 .21751 L
.23008 .21694 L
.23162 .21651 L
.23357 .21614 L
.2356 .21591 L
.23758 .21581 L
.23987 .21581 L
.24255 .21594 L
.24397 .21605 L
.24559 .21622 L
.24857 .21663 L
.25151 .21713 L
.26361 .22007 L
.2783 .22512 L
.29617 .23302 L
.31601 .2438 L
.35183 .26881 L
.38379 .29859 L
.39908 .31658 L
.41156 .33417 L
.42126 .35081 L
.42947 .36874 L
.4323 .37652 L
.43475 .38462 L
.43641 .39143 L
.43775 .39867 L
.43832 .40292 L
.4387 .40679 L
.43893 .41041 L
.43902 .41418 L
.43897 .4178 L
.43879 .42112 L
.43853 .42403 L
.43813 .42709 L
.43757 .43037 L
.4368 .43384 L
.43479 .44039 L
.43241 .44592 L
.42978 .45057 L
.42674 .45477 L
.42356 .45823 L
.42043 .46094 L
.41691 .46333 L
.41502 .46437 L
.41288 .46537 L
.41088 .46613 L
Mistroke
.40901 .46671 L
.40679 .46723 L
.40437 .4676 L
.40211 .46778 L
.39995 .46779 L
.39763 .46763 L
.39633 .46746 L
.39513 .46725 L
.39294 .46676 L
.39063 .46606 L
.38671 .46442 L
.38253 .46201 L
.37828 .45873 L
.37403 .45441 L
.37038 .44961 L
.36742 .44462 L
.36484 .43908 L
.36284 .43348 L
.3611 .42683 L
.36041 .42327 L
.35981 .4192 L
.35943 .41554 L
.3592 .41209 L
.35908 .40819 L
.3591 .40398 L
.35926 .40022 L
.35951 .39664 L
.35992 .39264 L
.36051 .38828 L
.36237 .37835 L
.3652 .36744 L
.37254 .34705 L
.38374 .32429 L
.39994 .2988 L
.43839 .2539 L
.48342 .21527 L
.53771 .18045 L
.56546 .16645 L
.59108 .15559 L
.61556 .14703 L
.63684 .14112 L
.64773 .1387 L
.65905 .13664 L
.66506 .13576 L
.67044 .13511 L
.67544 .13462 L
.68056 .13426 L
.68545 .13404 L
.68814 .13399 L
.69057 .13398 L
Mistroke
.69492 .13406 L
.69934 .13428 L
.70313 .1346 L
.70654 .13501 L
.71011 .13557 L
.71375 .1363 L
.72072 .13826 L
.72385 .13946 L
.72698 .14092 L
.72942 .14231 L
.73177 .14391 L
.73532 .14711 L
.73683 .14895 L
.73801 .15075 L
.73905 .15281 L
.73987 .1551 L
.74035 .15717 L
.74059 .15918 L
.74063 .16145 L
.74041 .16397 L
.73999 .16627 L
.73929 .16884 L
.7384 .17133 L
.73737 .17368 L
.73154 .18325 L
.72687 .18902 L
.72176 .19443 L
.70747 .2069 L
.67274 .22962 L
.62345 .25345 L
.56394 .27505 L
.50848 .29029 L
.47896 .29675 L
.45255 .3016 L
.42979 .30504 L
.40763 .3077 L
.39881 .30854 L
.39018 .30923 L
.3834 .30966 L
.37667 .30999 L
.373 .31012 L
.36984 .31019 L
.36703 .31023 L
.36429 .31023 L
.36183 .31021 L
.35975 .31015 L
.35806 .31009 L
.35645 .30999 L
.35492 .30987 L
.35353 .30972 L
Mistroke
.35296 .30964 L
.35243 .30955 L
.3517 .30937 L
.35129 .30919 L
.35117 .30901 L
.35129 .30885 L
.35168 .30868 L
.35227 .30852 L
.35303 .30839 L
.35409 .30825 L
.3555 .30811 L
.35717 .308 L
.35922 .3079 L
.36119 .30785 L
.3636 .30781 L
.36609 .30781 L
.36854 .30783 L
.3716 .30789 L
.3747 .30798 L
.37774 .3081 L
.38071 .30823 L
.38792 .30866 L
.39673 .30932 L
.40549 .31012 L
.42745 .31268 L
.47355 .32022 L
.53381 .33419 L
.59212 .35245 L
.64396 .37367 L
.66916 .38643 L
.69005 .39883 L
.70673 .41057 L
.72126 .42312 L
.72645 .42856 L
.73108 .43417 L
.73433 .43887 L
.73711 .44382 L
.73841 .44676 L
.73935 .4494 L
.74001 .45187 L
.74045 .45442 L
.74063 .45663 L
.7406 .45865 L
.74036 .46079 L
.73985 .46301 L
.73904 .46526 L
.73845 .46649 L
.73783 .4676 L
.73636 .4697 L
.73477 .47151 L
Mistroke
.73105 .47465 L
.72864 .47621 L
.72612 .47755 L
.72094 .47971 L
.71804 .48064 L
.71466 .48153 L
.7116 .48219 L
.70815 .4828 L
.70473 .48326 L
.70148 .48359 L
.69725 .48388 L
.69316 .48403 L
.68851 .48406 L
.68336 .48392 L
.67876 .48367 L
.67431 .48332 L
.6693 .48281 L
.66374 .4821 L
.65281 .48033 L
.64061 .47781 L
.61751 .47161 L
.58867 .46151 L
.56177 .44986 L
.50376 .41707 L
.45367 .37851 L
.41404 .33756 L
.39651 .31431 L
.38306 .29253 L
.3733 .27276 L
.36663 .25523 L
.36379 .24556 L
.36172 .23664 L
.3609 .23219 L
.36019 .22754 L
.35987 .2249 L
.35962 .22255 L
.35927 .21802 L
.3591 .21379 L
.35908 .20993 L
.35921 .20582 L
.35952 .20154 L
.35974 .19944 L
.36003 .1972 L
.36069 .19324 L
.36148 .18954 L
.36234 .18624 L
.36419 .18062 L
.36665 .17493 L
.36964 .16958 L
.37279 .16512 L
Mistroke
.37664 .16084 L
.38101 .1571 L
.38495 .15454 L
.38943 .15242 L
.39203 .15154 L
.39441 .15093 L
.39573 .15068 L
.39717 .15047 L
.39853 .15033 L
.39979 .15026 L
.40203 .15026 L
.4033 .15033 L
.40448 .15045 L
.40684 .15082 L
.40816 .15111 L
.40935 .15143 L
.41166 .15219 L
.41379 .15307 L
.41764 .15515 L
.42155 .158 L
.42545 .16178 L
.42856 .16566 L
.43147 .17031 L
.43362 .17471 L
.43559 .17997 L
.43659 .18338 L
.43738 .18674 L
.43796 .18987 L
.43846 .19339 L
.43865 .19525 L
.43882 .19734 L
.43894 .19956 L
.439 .20167 L
.439 .20552 L
.43892 .20773 L
.43881 .20977 L
.43847 .21378 L
.43801 .21757 L
.43735 .2218 L
.43645 .22639 L
.43428 .23509 L
.43174 .24315 L
.42463 .26047 L
.4146 .27901 L
.39082 .31157 L
.35872 .34351 L
.31947 .37213 L
.30056 .38282 L
.28337 .39086 L
.26901 .39628 L
Mistroke
.26154 .39856 L
.25499 .4002 L
.24855 .40142 L
.24538 .40184 L
.24368 .40201 L
.24218 .40213 L
.23946 .40224 L
.23801 .40224 L
.23671 .4022 L
.2354 .40211 L
.23427 .40199 L
.23303 .40181 L
.23193 .4016 L
.23021 .40115 L
.22861 .40054 L
.22742 .39992 L
.22632 .39913 L
.22536 .39816 L
.22493 .39756 L
.2246 .39698 L
.22417 .39577 L
.22399 .39451 L
.22404 .39313 L
.22418 .39231 L
.22438 .39153 L
.22492 .39002 L
.22573 .38835 L
.22774 .38523 L
.23085 .38152 L
.24111 .3724 L
.25486 .36301 L
.28942 .34486 L
.33909 .32527 L
.40382 .30623 L
.44398 .29713 L
.48237 .29009 L
.51624 .28517 L
.55325 .28116 L
.57152 .27973 L
.58096 .27914 L
.59077 .27863 L
.59928 .27828 L
.60373 .27813 L
.60845 .278 L
.61664 .27785 L
.62413 .27778 L
.63202 .2778 L
.63643 .27785 L
.6405 .27792 L
.64475 .27802 L
Mistroke
.64857 .27813 L
.657 .27847 L
.66398 .27884 L
.67136 .27934 L
.68418 .28046 L
.69808 .28213 L
.71152 .28429 L
.72182 .28642 L
.73187 .28906 L
.73942 .29155 L
.74615 .29436 L
.75203 .29762 L
.75414 .29911 L
.75603 .30073 L
.75749 .30229 L
.75854 .30372 L
.75931 .30517 L
.75978 .30655 L
.76002 .30816 L
.75993 .30965 L
.75951 .31128 L
.75917 .3121 L
.75869 .313 L
.75755 .31461 L
.75619 .31609 L
.75201 .31938 L
.74708 .32217 L
.74058 .325 L
.73296 .32762 L
.7247 .3299 L
.70661 .33361 L
.69469 .33539 L
.68099 .33693 L
.66847 .33797 L
.66104 .33844 L
.6539 .3388 L
.64986 .33896 L
.6454 .33911 L
.64113 .33922 L
.63714 .3393 L
.62945 .33939 L
.62113 .33939 L
.61677 .33936 L
.61203 .33929 L
.60334 .33909 L
.59824 .33893 L
.59282 .33872 L
.58302 .33826 L
.56475 .3371 L
.54717 .33565 L
Mistroke
.5137 .33197 L
.47731 .32667 L
.43822 .31945 L
.37118 .30312 L
.3164 .2853 L
.26726 .26429 L
.23416 .24513 L
.22128 .23505 L
.21677 .23063 L
.2135 .22679 L
.21082 .22269 L
.20986 .22068 L
.20949 .2197 L
.20918 .21867 L
.20897 .21771 L
.20886 .21687 L
.20882 .21609 L
.20884 .21529 L
.20905 .21398 L
.20953 .21266 L
.21028 .21144 L
.21119 .21042 L
.21244 .20942 L
.21403 .20852 L
.21563 .20785 L
.21731 .20734 L
.21935 .2069 L
.22058 .20671 L
.22177 .20657 L
.22407 .2064 L
.22635 .20635 L
.22901 .20642 L
.23203 .20663 L
.23506 .20696 L
.23806 .20738 L
.24399 .2085 L
.2515 .21034 L
.25997 .2129 L
.27624 .21905 L
.31595 .23997 L
.35039 .26508 L
.38327 .29721 L
.39671 .31396 L
.40758 .33015 L
.4162 .34579 L
.42251 .36023 L
.42528 .36819 L
.42733 .37532 L
.42905 .383 L
.42972 .38693 L
Mistroke
.43025 .39098 L
.43059 .39458 L
.43079 .39832 L
.43083 .40176 L
.43076 .4048 L
.43052 .40827 L
.43032 .41017 L
.43009 .41189 L
.42957 .41495 L
.42888 .41806 L
.42746 .42282 L
.42554 .42748 L
.42338 .43143 L
.42115 .43464 L
.41826 .43788 L
.41481 .44076 L
.41314 .44185 L
.41131 .44285 L
.40956 .44363 L
.4079 .44422 L
.40597 .44473 L
.40494 .44493 L
.40383 .4451 L
.40265 .44521 L
.40154 .44526 L
.39944 .44521 L
.39747 .44498 L
.39565 .44462 L
.39367 .44406 L
.39159 .44327 L
.38954 .44229 L
.38739 .44101 L
.38363 .43814 L
.37948 .43377 L
.37608 .42889 L
.37347 .42397 L
.3714 .41884 L
.36957 .41264 L
.36876 .40891 L
.36817 .40538 L
.36792 .40351 L
.3677 .40149 L
.36741 .39778 L
.36726 .39364 L
.36726 .39122 L
.3673 .38893 L
.36751 .38467 L
.36785 .38069 L
.3681 .37844 L
.36842 .37597 L
Mistroke
.36914 .37138 L
.37094 .36267 L
.37359 .35292 L
.38031 .33445 L
.3916 .31146 L
.40513 .28977 L
.44217 .24498 L
.49276 .20064 L
.54451 .16667 L
.57453 .15086 L
.60321 .13809 L
.6297 .12825 L
.65767 .11993 L
.6696 .11705 L
.68189 .11455 L
.69211 .11284 L
.70288 .11145 L
.70909 .11084 L
.71471 .11044 L
.71993 .11019 L
.72534 .11007 L
.73048 .11009 L
.73517 .11025 L
.73925 .1105 L
.74351 .11088 L
.74801 .11143 L
.75272 .11219 L
.75738 .11316 L
.76147 .11423 L
.76819 .1165 L
.77447 .11944 L
.77946 .12265 L
.78174 .12451 L
.78388 .12661 L
.78552 .12854 L
.78707 .13077 L
.78826 .13291 L
.78914 .13495 L
.78983 .13703 L
.79034 .13928 L
.79065 .14162 L
.79074 .14424 L
.79062 .14658 L
.79027 .14914 L
.78975 .1516 L
.7891 .15388 L
.78692 .15945 L
.7835 .16579 L
.77338 .17911 L
.76036 .19181 L
Mistroke
.74527 .20379 L
.70243 .23007 L
.64671 .25546 L
.59039 .27511 L
.53116 .29096 L
.48325 .30061 L
.45023 .30563 L
.43833 .30714 L
.43375 .30771 L
.43022 .30819 L
.42913 .30836 L
.42824 .30853 L
.42785 .30863 L
.42759 .30871 L
.42729 .30887 L
.42727 .30901 L
.42753 .30916 L
.42804 .30931 L
.42873 .30945 L
.43074 .30976 L
.43339 .31011 L
.44214 .31115 L
.47063 .31498 L
.51278 .32241 L
.56706 .33507 L
.61757 .35013 L
.67261 .37083 L
.72603 .39684 L
.76557 .42257 L
.7826 .4371 L
.78997 .44468 L
.79648 .45258 L
.80108 .45935 L
.80309 .46287 L
.80491 .46658 L
.80627 .46993 L
.80725 .47293 L
.80799 .47589 L
.80846 .47863 L
.80869 .48129 L
.8087 .4841 L
.80846 .48667 L
.80805 .48897 L
.80735 .49144 L
.80633 .49405 L
.80495 .49666 L
.8034 .499 L
.79933 .50349 L
.79468 .50715 L
.78821 .51084 L
Mistroke
.78104 .51377 L
.77403 .51586 L
.76989 .51681 L
.76583 .51758 L
.76193 .51818 L
.75824 .51864 L
.754 .51905 L
.74929 .51937 L
.74412 .51957 L
.73917 .51963 L
.73357 .51954 L
.72743 .51928 L
.72141 .51887 L
.7156 .51834 L
.7044 .51697 L
.69178 .51491 L
.67963 .51246 L
.65097 .50499 L
.6221 .49526 L
.5908 .48226 L
.53532 .45268 L
.48881 .42026 L
.44413 .37968 L
.4121 .34075 L
.39931 .32072 L
.38841 .29939 L
.38419 .2891 L
.38055 .27842 L
.37797 .26879 L
.3763 .2604 L
.37569 .25623 L
.37526 .25241 L
.375 .24908 L
.37485 .24558 L
.37482 .24189 L
.37487 .24008 L
.37496 .23814 L
.37522 .23482 L
.37559 .23184 L
.37606 .22898 L
.37661 .22639 L
.37788 .22186 L
.37956 .21748 L
.38173 .21331 L
.38447 .20945 L
.3872 .20665 L
.38879 .20538 L
.39057 .20425 L
.39228 .20341 L
.39387 .20283 L
Mistroke
.39537 .20245 L
.39677 .20225 L
.3983 .20218 L
.39994 .20229 L
.40075 .20242 L
.40163 .20262 L
.40321 .20311 L
.40471 .20377 L
.40606 .20453 L
.40873 .20659 L
.41099 .209 L
.41331 .21242 L
.41519 .21627 L
.41591 .21816 L
.4166 .2203 L
.41712 .22224 L
.41761 .22445 L
.41807 .22717 L
.41839 .22986 L
.41859 .23259 L
.41868 .2352 L
.41867 .23819 L
.41851 .24151 L
.41824 .24475 L
.41787 .24779 L
.4173 .25145 L
.41649 .25554 L
.41455 .26326 L
.41183 .27168 L
.40816 .28094 L
.39954 .2982 L
.37702 .33088 L
.34419 .36505 L
.30726 .39377 L
.27086 .4153 L
.25112 .42458 L
.23067 .43245 L
.22115 .43547 L
.21248 .43783 L
.20506 .43952 L
.19729 .44095 L
.19305 .44155 L
.18923 .44198 L
.18535 .44229 L
.18324 .4424 L
.18137 .44246 L
.17814 .44248 L
.1748 .44236 L
.17181 .44212 L
.1692 .44178 L
Mistroke
.16769 .44153 L
.16613 .44121 L
.16347 .44052 L
.1611 .43971 L
.15913 .43885 L
.15721 .43779 L
.15538 .43648 L
.15378 .43495 L
.15259 .43339 L
.15175 .43183 L
.15142 .431 L
.15113 .43005 L
.15081 .4283 L
.15074 .42657 L
.1508 .42554 L
.15094 .42443 L
.1514 .42237 L
.15176 .42118 L
.15218 .42006 L
.15338 .41742 L
.15627 .41268 L
.15983 .40813 L
.171 .39721 L
.18473 .3868 L
.20341 .37514 L
.24655 .35388 L
.3027 .33291 L
.37289 .31347 L
.4099 .30563 L
.44966 .29889 L
.46866 .29628 L
.48636 .2942 L
.50311 .29257 L
.51843 .29138 L
.53236 .29054 L
.53999 .2902 L
.54686 .28995 L
.55381 .28978 L
.56124 .28967 L
.56492 .28965 L
.56879 .28965 L
.57561 .28972 L
.57927 .28979 L
.5826 .28988 L
.58991 .29015 L
.59611 .29047 L
.60242 .29088 L
.61268 .2918 L
.62296 .29306 L
.63157 .29446 L
Mistroke
.63854 .29591 L
.64549 .29775 L
.65097 .29966 L
.65501 .30151 L
.6579 .30331 L
.65917 .30436 L
.66009 .30534 L
.66086 .30647 L
.66129 .30754 L
.66146 .30861 L
.66132 .30977 L
.6609 .31085 L
.66028 .31184 L
.65924 .31298 L
.65775 .31421 L
.65408 .31638 L
.64893 .31854 L
.64201 .32067 L
.63497 .32233 L
.62601 .32395 L
.61672 .32523 L
.60735 .32621 L
.59618 .32704 L
.59022 .32736 L
.58678 .32751 L
.58347 .32763 L
.57727 .32779 L
.57147 .32788 L
.56507 .32792 L
.55794 .32787 L
.55154 .32776 L
.54462 .32758 L
.5386 .32736 L
.53186 .32706 L
.51589 .32611 L
.49787 .32466 L
.46379 .32089 L
.42955 .31582 L
.39744 .30993 L
.32597 .29265 L
.25691 .2695 L
.2027 .24471 L
.17881 .23054 L
.16162 .21789 L
.15043 .20736 L
.14571 .20167 L
.14248 .19676 L
.14124 .19438 L
.14018 .19188 L
.13973 .19055 L
Mistroke
.1394 .18934 L
.13915 .18822 L
.13897 .18705 L
.13884 .18506 L
.13895 .18328 L
.13931 .18142 L
.13962 .18042 L
.13998 .17953 L
.14088 .17787 L
.14197 .17641 L
.14313 .17519 L
.14459 .17396 L
.14641 .17275 L
.1486 .1716 L
.15069 .17073 L
.15315 .16992 L
.15563 .16928 L
.15805 .16879 L
.16063 .16841 L
.1632 .16813 L
.16634 .16792 L
.1694 .16784 L
.1729 .16788 L
.17678 .16805 L
.1808 .16837 L
.18462 .16879 L
.19367 .17019 L
.20209 .17193 L
.21137 .17429 L
.23211 .18103 L
.25588 .191 L
.29911 .21516 L
.33566 .2426 L
.37094 .27814 L
.38361 .29459 L
.39498 .31247 L
.40313 .3287 L
.40852 .34301 L
.41059 .35043 L
.41193 .35687 L
.41246 .36027 L
.41268 .36202 L
.41287 .36385 L
.413 .36556 L
.41309 .36709 L
.41317 .36998 L
.41313 .37254 L
.41298 .37513 L
.41277 .37725 L
.41244 .37946 L
Mistroke
.412 .38171 L
.41141 .38398 L
.41008 .38765 L
.40933 .38923 L
.40844 .3908 L
.40664 .39325 L
.40571 .39423 L
.40469 .39513 L
.4037 .39585 L
.40276 .3964 L
.40164 .39692 L
.40039 .39732 L
.39915 .39755 L
.3978 .39761 L
.39654 .39751 L
.39535 .39726 L
.39429 .39692 L
.39315 .39641 L
.39191 .3957 L
.39058 .39473 L
.38932 .39359 L
.38802 .39216 L
.38585 .38907 L
.38406 .38557 L
.38253 .38148 L
.38181 .37891 L
.38123 .37637 L
.38082 .37404 L
.38045 .37134 L
.38018 .36836 L
.38003 .36544 L
.37999 .36265 L
.38005 .35959 L
.38019 .3569 L
.38044 .35386 L
.38083 .35047 L
.38137 .34673 L
.38273 .3397 L
.38496 .33096 L
.38812 .3212 L
.39593 .30259 L
.40753 .28134 L
.42421 .25695 L
.46406 .21267 L
.51175 .17305 L
.57084 .1359 L
.60192 .12034 L
.63126 .10786 L
.65993 .09764 L
.68552 .09017 L
Mistroke
.71306 .08396 L
.72761 .08151 L
.73407 .08061 L
.74087 .07981 L
.74758 .07917 L
.75356 .07872 L
.75945 .07841 L
.76491 .07823 L
.77109 .07819 L
.77666 .07828 L
.78258 .07855 L
.7855 .07875 L
.78866 .07901 L
.79435 .07964 L
.79937 .08036 L
.80455 .08129 L
.80994 .0825 L
.81836 .08496 L
.82628 .08811 L
.83284 .09159 L
.83799 .09515 L
.84293 .09972 L
.84484 .10196 L
.84661 .10444 L
.84792 .10664 L
.84913 .10914 L
.85004 .11149 L
.85071 .11374 L
.85128 .11647 L
.85159 .11902 L
.85171 .12203 L
.85157 .12496 L
.85117 .12816 L
.85082 .12999 L
.85043 .13169 L
.84829 .13825 L
.84548 .14438 L
.84161 .151 L
.83073 .1651 L
.81468 .18081 L
.77687 .20835 L
.7335 .23225 L
.67679 .25676 L
.62272 .27531 L
.53782 .29746 L
.5096 .30366 L
.50452 .30488 L
.50023 .30606 L
.49867 .30656 L
.49733 .30707 L
Mistroke
.4964 .3075 L
.49567 .30795 L
.49521 .30835 L
.49499 .30872 L
.49495 .30908 L
.49509 .30943 L
.49545 .30983 L
.49598 .31021 L
.49678 .31064 L
.49788 .3111 L
.50425 .313 L
.51521 .31554 L
.55133 .32349 L
.59833 .33537 L
.6515 .35177 L
.70286 .3713 L
.74985 .39339 L
.7952 .42071 L
.81347 .43457 L
.82986 .44966 L
.83728 .45792 L
.84301 .46542 L
.84778 .47301 L
.85112 .47975 L
.85238 .48296 L
.85349 .48638 L
.85429 .48957 L
.8548 .49245 L
.85511 .49545 L
.85519 .49868 L
.85511 .50028 L
.85495 .50198 L
.85445 .50497 L
.85373 .50768 L
.85268 .51054 L
.85143 .51316 L
.85005 .5155 L
.84686 .51971 L
.84264 .52385 L
.83649 .52832 L
.82854 .53251 L
.81984 .53582 L
.81087 .53829 L
.80198 .54001 L
.79662 .54078 L
.79143 .54134 L
.78575 .54179 L
.78041 .54206 L
.77739 .54215 L
.77405 .5422 L
Mistroke
.76784 .54217 L
.76173 .54198 L
.75599 .54168 L
.74956 .5412 L
.74264 .54054 L
.73067 .53902 L
.71718 .53682 L
.68542 .52969 L
.65484 .52048 L
.59205 .49462 L
.52842 .45805 L
.47591 .41756 L
.45236 .39496 L
.431 .37076 L
.41547 .34981 L
.40188 .32749 L
.39266 .30825 L
.38663 .29151 L
.38431 .28286 L
.38277 .27528 L
.38214 .27112 L
.38172 .26749 L
.38156 .26553 L
.38142 .26347 L
.38134 .26156 L
.3813 .25985 L
.38132 .25683 L
.38143 .25412 L
.38167 .25129 L
.38204 .24842 L
.38255 .24558 L
.38314 .24307 L
.3845 .23884 L
.38603 .23545 L
.38789 .23245 L
.38962 .23038 L
.39165 .22862 L
.39283 .22787 L
.39392 .22734 L
.39453 .22711 L
.3952 .22691 L
.39642 .22668 L
.39756 .22663 L
.39875 .22673 L
.39987 .22699 L
.40086 .22735 L
.40195 .2279 L
.40294 .22856 L
.40407 .22952 L
.40505 .23055 L
Mistroke
.40688 .23313 L
.40777 .23482 L
.40853 .23659 L
.40911 .23824 L
.40965 .24012 L
.41005 .24185 L
.41041 .24382 L
.4107 .24604 L
.41089 .24824 L
.41099 .25099 L
.41098 .25364 L
.41085 .25641 L
.41057 .2595 L
.41019 .26253 L
.40973 .26537 L
.40813 .27269 L
.406 .28001 L
.39986 .2956 L
.39028 .31365 L
.36701 .3457 L
.33229 .38026 L
.28857 .41223 L
.24449 .43566 L
.22313 .44424 L
.21216 .44794 L
.20082 .45121 L
.19036 .4537 L
.18132 .4554 L
.17712 .45603 L
.17271 .45657 L
.16868 .45694 L
.1651 .45718 L
.16173 .4573 L
.15825 .45731 L
.15511 .45722 L
.15235 .45705 L
.14926 .45673 L
.14609 .45626 L
.14328 .45569 L
.14084 .45506 L
.13646 .4535 L
.13427 .45244 L
.13241 .45134 L
.13078 .45015 L
.12928 .44879 L
.12789 .44718 L
.12685 .4456 L
.12603 .44387 L
.12568 .44285 L
.12542 .44189 L
Mistroke
.12512 .44004 L
.12505 .438 L
.12521 .43608 L
.12555 .43423 L
.12613 .43212 L
.12701 .42978 L
.12987 .42431 L
.13378 .41882 L
.1442 .40783 L
.15761 .39693 L
.17304 .38652 L
.21789 .3628 L
.27436 .34043 L
.33468 .32227 L
.40446 .30686 L
.44345 .3006 L
.46176 .29824 L
.47803 .29646 L
.49278 .29511 L
.50829 .29399 L
.51657 .29352 L
.52403 .29318 L
.53101 .29293 L
.53822 .29275 L
.54422 .29266 L
.55051 .29264 L
.55628 .29268 L
.56142 .29276 L
.56724 .29293 L
.57336 .29318 L
.57892 .29348 L
.58387 .29382 L
.59499 .29486 L
.60432 .29609 L
.61173 .29738 L
.61865 .29896 L
.62489 .30085 L
.6277 .30195 L
.62993 .30302 L
.63166 .30403 L
.63295 .30496 L
.63406 .30602 L
.63453 .3066 L
.63488 .30716 L
.63526 .30811 L
.63538 .30914 L
.63521 .31011 L
.63481 .31099 L
.6341 .31197 L
.633 .31302 L
Mistroke
.63149 .31411 L
.62976 .3151 L
.62518 .31707 L
.61988 .31874 L
.61244 .3205 L
.60416 .32196 L
.59601 .32305 L
.58645 .324 L
.57757 .32462 L
.57224 .3249 L
.56708 .32511 L
.56091 .32528 L
.55485 .32537 L
.54925 .32539 L
.54298 .32535 L
.53599 .32523 L
.532 .32513 L
.52835 .32501 L
.52105 .32472 L
.5141 .32438 L
.4996 .32345 L
.48314 .32207 L
.44848 .31812 L
.41742 .31344 L
.38366 .30716 L
.30767 .28826 L
.24456 .26661 L
.19187 .24243 L
.15558 .21971 L
.14201 .20832 L
.13156 .19657 L
.12811 .19107 L
.1267 .18813 L
.12575 .18554 L
.12514 .18323 L
.12492 .18196 L
.12479 .1808 L
.12474 .17876 L
.12496 .17668 L
.12542 .17481 L
.12579 .17379 L
.12621 .17286 L
.12727 .17109 L
.1287 .16933 L
.13031 .16783 L
.13207 .16653 L
.13599 .16441 L
.13857 .1634 L
.14157 .16249 L
.14435 .16184 L
Mistroke
.14764 .16127 L
.14956 .16102 L
.15139 .16084 L
.15346 .16068 L
.15572 .16057 L
.15774 .16051 L
.15967 .1605 L
.16184 .16053 L
.16421 .16062 L
.16632 .16073 L
.1686 .16089 L
.17281 .16129 L
.17749 .16188 L
.18282 .16271 L
.19278 .1647 L
.20253 .16712 L
.22159 .1731 L
.24291 .18155 L
.2868 .2046 L
.33135 .23688 L
.36627 .27142 L
.39014 .30414 L
.39902 .32067 L
.40266 .329 L
.40575 .33743 L
.40783 .34447 L
.4087 .34806 L
.40946 .35178 L
.41001 .35508 L
.41038 .35799 L
.41064 .36081 L
.41079 .36339 L
.41083 .36575 L
.41078 .36825 L
.41061 .37074 L
.41036 .37296 L
.41004 .37492 L
.40969 .37662 L
.40868 .38013 L
.40803 .38178 L
.40737 .38321 L
.40651 .38474 L
.40567 .38599 L
.40378 .38811 L
.40266 .38902 L
.40156 .3897 L
.40051 .39019 L
.39936 .39055 L
.39825 .39073 L
.39723 .39077 L
Mistroke
.39603 .39066 L
.39534 .39052 L
.39471 .39034 L
.39357 .38989 L
.39236 .38923 L
.39112 .38835 L
.38983 .38717 L
.38873 .38594 L
.38762 .38446 L
.3857 .3811 L
.38419 .37741 L
.38304 .37341 L
.38251 .37095 L
.38212 .36859 L
.38184 .36627 L
.38161 .36363 L
.38149 .36102 L
.38146 .35852 L
.38153 .35551 L
.38169 .35258 L
.38199 .34924 L
.38245 .34552 L
.38309 .3415 L
.38386 .33754 L
.38575 .32977 L
.39173 .31206 L
.39964 .29473 L
.4264 .25292 L
.46229 .21286 L
.50493 .17637 L
.55934 .14038 L
.62214 .10935 L
.67666 .09015 L
.70671 .0826 L
.7199 .08001 L
.73354 .07784 L
.74039 .07695 L
.74779 .07616 L
.75439 .0756 L
.76045 .07522 L
.76386 .07506 L
.7674 .07495 L
.7736 .07486 L
.77698 .07489 L
.78008 .07495 L
.78343 .07507 L
.78694 .07525 L
.79268 .07569 L
.79582 .076 L
.79867 .07634 L
Mistroke
.80365 .07705 L
.8089 .07799 L
.81745 .08 L
.82569 .08265 L
.83301 .08578 L
.83891 .08907 L
.84474 .09333 L
.84928 .09782 L
.85259 .10231 L
.8549 .10676 L
.8559 .10944 L
.85659 .11194 L
.85714 .1149 L
.85741 .11775 L
.85744 .12067 L
.8572 .12386 L
.85674 .12694 L
.8561 .12979 L
.85511 .13319 L
.85372 .13694 L
.85038 .14391 L
.84579 .15137 L
.83972 .15943 L
.8259 .17409 L
.79313 .19995 L
.74735 .22684 L
.69311 .25149 L
.64208 .27005 L
.54401 .2968 L
.49958 .30902 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000900001Ha000`40n007h00Oh_oo00<00?ooool0
ooooG?oo003Rool3003ooomLool00>;oo`03003ooooo0?oooecoo`00h_oo00<00?ooool0ooooG?oo
003Rool00`00ooooo`3ooomLool00>;oo`03003ooooo0?oooecoo`00h_oo00<00?ooool0ooooG?oo
003Rool00`00ooooo`3ooomLool00>;oo`03003ooooo0?Oooa/004Woo`00h_oo00<00?ooool0jooo
30006_oo2@00@Ooo003Rool00`00ooooo`3Vool5000^ool7000kool00>;oo`<00>3oo`H003Woo`L0
03Goo`00h_oo00<00?ooool0f_oo1`00AOoo1@00<?oo003Rool00`00ooooo`3Dool7001@ool3000]
ool00>;oo`03003ooooo0<ooo`H005Woo`<002[oo`00h_oo00<00?ooool0booo1000H_oo0P00:?oo
003Rool00`00ooooo`36ool5001Xool2000Vool00>;oo`03003ooooo0<;oo`@006ooo`8002Coo`00
h_oo00<00?ooool0__oo1000MOoo0P008_oo003Rool00`00ooooo`2kool3001kool2000Pool00>;o
o`<00;Soo`<007ooo`<001koo`00h_oo00<00?ooool0]Ooo0`00Q?oo0P007Ooo003Rool00`00oooo
o`2bool3000^oolK0010ool2000Kool00>;oo`03003ooooo0:ooo`<002_oo`L001Woo`X003Soo`80
01[oo`00h_oo00<00?ooool0[?oo0`009_oo2@00:Ooo1000=_oo00<00?ooool05ooo003Rool00`00
ooooo`2Yool3000Rool7000fool6000aool00`00ooooo`0Fool00>;oo`03003ooooo0:Koo`<0027o
o`@004?oo`<002koo`8001Ooo`00h_oo00<00?ooool0Y?oo0P007ooo1@00B_oo0`00;?oo00<00?oo
ool05Ooo003Rool00`00ooooo`2Qool3000Mool4001Bool2000[ool00`00ooooo`0Dool00>;oo`<0
09koo`<001_oo`D001gooaP002?oo`8002[oo`03003ooooo01?oo`00h_oo00<00?ooool0Vooo0`00
6_oo10005Ooo3P005ooo2P006ooo0P00:Ooo00<00?ooool04_oo003Rool00`00ooooo`2Iool2000I
ool4000Cool6000_ool3000Jool00`00ooooo`0Wool00`00ooooo`0Aool00>;oo`03003ooooo09Ko
o`<001Ooo`@001?oo`@003Soo`@001Ooo`8002Ooo`8001;oo`00h_oo00<00?ooool0Tooo0`005ooo
10004Ooo1@00@?oo1@005?oo0P009_oo00<00?ooool04?oo003Rool00`00ooooo`2Aool3000Fool3
000@ool50019ool5000Bool00`00ooooo`0Sool2000Aool00=3oo`H000coo`03003ooooo08ooo`<0
01Coo`@000ooo`@005?oo`80017oo`8002Coo`03003ooooo00ooo`00d?oo00<00?ooool00ooo00<0
0?ooool02Ooo00<00?ooool0SOoo0P005?oo10003_oo1000FOoo0P004Ooo00<00?ooool08Ooo0P00
4?oo003Gool00`00ooooo`08ool00`00ooooo`2;ool2000Cool3000>ool4001Oool2000@ool00`00
ooooo`0Qool00`00ooooo`0>ool00=Ooo`03003ooooo00Soo`@008Soo`8001;oo`<000koo`@006?o
o`80013oo`03003ooooo023oo`03003ooooo00koo`00eooo00<00?ooool02?oo00<00?ooool0Qooo
0P004_oo0`003?oo1000JOoo00<00?ooool03_oo00<00?ooool07ooo0P003ooo003Fool00`00oooo
o`09ool00`00ooooo`25ool2000Aool3000<ool3001^ool2000?ool00`00ooooo`0Oool00`00oooo
o`0=ool00<Koo`@000Woo`@000_oo`03003ooooo08?oo`80017oo`8000coo`<002?oob00033oo`03
003ooooo00coo`80023oo`03003ooooo00goo`00eOoo00<00?ooool02_oo00<00?ooool0POoo0P00
4?oo0`003?oo0P008?oo1`0000?oo`0000005P001Ooo1@00;Ooo00<00?ooool03?oo00<00?ooool0
7_oo00<00?ooool03Ooo003Fool00`00ooooo`09ool00`00ooooo`1oool2000?ool3000<ool3000J
ool`0002ool4000Zool00`00ooooo`0<ool00`00ooooo`0Mool00`00ooooo`0=ool00=Koo`03003o
oooo00Woo`03003ooooo07goo`8000ooo`<000_oo`<001OooaL001;ooa4000;oo`<002Soo`03003o
oooo00_oo`03003ooooo01goo`03003ooooo00goo`00e_oo00<00?ooool02Ooo00<00?ooool0Nooo
0P003_oo0`002ooo0`005_oo<`000ooo2P000ooo10009Ooo00<00?ooool02_oo0P007_oo00<00?oo
ool03Ooo003@ool20003ool00`00ooooo`0:ool00`00ooooo`1iool2000>ool3000;ool2000EoolE
000Rool600000ooo000000080003ool3000Sool00`00ooooo`0:ool00`00ooooo`0Lool00`00oooo
o`0=ool00=;oo`<000goo`03003ooooo07Ooo`8000koo`8000_oo`<001?oo`/000;oo`@0033oo`@0
00;oo`T000;oo`8002;oo`03003ooooo00Woo`8001goo`03003ooooo00goo`00h_oo0`00MOoo0P00
3_oo0P002_oo0`004_oo2`0000?oo`0000000`00>?oo10000_oo1`000_oo0P008?oo0P002ooo00<0
0?ooool06ooo00<00?ooool03Ooo003Rool00`00ooooo`1cool2000>ool20009ool3000Aool@0010
ool30002ool700001?oo000000007ooo00<00?ooool02Ooo00<00?ooool06ooo00<00?ooool03Ooo
003Rool00`00ooooo`1`ool3000=ool30009ool2000@ool?0017ool30002ool700000ooo0000000N
ool2000:ool00`00ooooo`0Kool00`00ooooo`0=ool00>;oo`03003ooooo06koo`<000goo`<000So
o`<000koo`h004koo`<000;oo`H000;oo`03003ooooo01coo`03003ooooo00Soo`8001coo`03003o
oooo00goo`00h_oo00<00?ooool0KOoo0P003Ooo0P002?oo0`003Ooo100000?oo`0000001`00E?oo
0P000ooo0`0000Coo`00ool001koo`03003ooooo00Woo`03003ooooo01[oo`03003ooooo00goo`00
h_oo00<00?ooool0Jooo0P003Ooo0P002?oo0`003Ooo0P0000?oo`0000002000FOoo0P000_oo00L0
0?oo003oo`00ool0000Mool2000:ool00`00ooooo`0Jool00`00ooooo`0=ool00>;oo`03003ooooo
06Woo`8000goo`8000Soo`<000coo`d005koo`03003ooooo00<00004ool00?oo000Mool00`00oooo
o`08ool00`00ooooo`0Jool00`00ooooo`0=ool00>;oo`03003ooooo06Soo`8000coo`8000Soo`80
00goo`800003ool0000000<00004ool00000001Rool00`00ooooo`0300001?oo003oo`007?oo00<0
0?ooool02?oo00<00?ooool06Ooo0P003ooo003Rool00`00ooooo`1Vool2000;ool30008ool2000<
ool800001?oo000000008_oo5000<?oo00<00?ooool010000_oo00<00?ooool06Ooo00<00?ooool0
2?oo00<00?ooool06Ooo00<00?ooool03_oo003Rool3001Uool2000:ool30008ool2000<ool20000
0ooo00000006000Kool:000Cool7000[ool00`00ooooo`0400000ooo003oo`0Jool00`00ooooo`08
ool00`00ooooo`0Iool00`00ooooo`0>ool00>;oo`03003ooooo06?oo`8000[oo`8000Woo`8000_o
o`/001[oo`@002?oo`L002Koo`03003ooooo00800004ool00?oo000Jool20009ool00`00ooooo`0H
ool00`00ooooo`0?ool002_oo`d00:[oo`03003ooooo06;oo`8000Woo`8000Woo`8000_oo`/001Ko
o`H002goo`<002Coo`8000;oo`H001[oo`03003ooooo00Koo`8001[oo`03003ooooo00ooo`008ooo
20003Ooo2@00XOoo00<00?ooool0H?oo0P002Ooo0P002Ooo0P002_oo1`0000Coo`00000001?oo`L0
03Coo`<002?oo`03003ooooo00@00003ool00?oo01Woo`03003ooooo00Koo`03003ooooo01Soo`03
003ooooo013oo`008?oo10007?oo1`00Vooo00<00?ooool0Gooo00<00?ooool01_oo0`002Ooo0P00
2_oo2P004_oo1000?Ooo10008Ooo00@00?oo003oo`8000;oo`03003ooooo01Ooo`03003ooooo00Ko
o`03003ooooo01Soo`03003ooooo013oo`007Ooo10009Ooo1`00UOoo00<00?ooool0GOoo0P002?oo
0P002Ooo0P002Ooo2P004Ooo1000A?oo0`007ooo00<00?ooool00P0000Coo`00ool001Soo`8000So
o`03003ooooo01Soo`03003ooooo013oo`006Ooo1000;ooo1@00TOoo00<00?ooool0G?oo00<00?oo
ool01_oo0P002Ooo0P002Ooo2@004Ooo0`006?oo60006ooo00<00?ooool07?oo0P0000?oo`000000
0P0000?oo`00ool05ooo00<00?ooool01ooo00<00?ooool05ooo00<00?ooool04Ooo000Gool3000g
ool4002=ool00`00ooooo`1Jool20008ool00`00ooooo`07ool20009ool600000ooo0000000@ool3
000@ool<000Fool6000Gool00`00ooooo`0Lool01000ool00?oo0P0000?oo`00ool05ooo00<00?oo
ool01_oo0P006Ooo00<00?ooool04Ooo000Fool00`00ooooo`0Gool@000Eool3002:ool00`00oooo
o`1Hool20008ool20008ool20008ool:000?ool3000?ool5000Wool5000Cool00`00ooooo`0Kool0
0`00ooooo`0300000ooo0000000Gool00`00ooooo`06ool00`00ooooo`0Gool00`00ooooo`0Bool0
01Coo`8001Coo`H0013oo`/000goo`@008Koo`<005Ooo`8000Soo`03003ooooo00Koo`8000Soo`X0
00koo`<000koo`@0033oo`<001;oo`8001_oo`800003ool0000000800003ool00?oo01Koo`03003o
oooo00Koo`03003ooooo01Ooo`03003ooooo01;oo`004ooo0P003ooo1P008?oo1@003Ooo0`00Pooo
00<00?ooool0EOoo0P002?oo0P001_oo0`002?oo2@003_oo0`003?oo1@00=_oo10004?oo0P006ooo
00P00?oo00000?oo003oo`005ooo00<00?ooool01Ooo0P006?oo00<00?ooool04ooo000Bool00`00
ooooo`0=ool3000Zool4000<ool30020ool00`00ooooo`1Dool20008ool00`00ooooo`04ool30008
ool9000=ool3000;ool5000mool3000?ool2000Jool02000ool00000ool00?oo000Fool20007ool0
0`00ooooo`0Gool00`00ooooo`0Cool0017oo`03003ooooo00coo`80037oo`<000coo`@007coo`03
003ooooo05;oo`8000Soo`8000Koo`8000Soo`T000goo`8000[oo`@004Goo`03003ooooo00goo`03
003ooooo01Soo`05003oo`00003oo`03000Fool00`00ooooo`05ool2000Hool00`00ooooo`0Dool0
013oo`03003ooooo00coo`03003ooooo03Coo`@000_oo`@007Woo`03003ooooo057oo`8000Soo`03
003ooooo00Coo`8000Soo`T000coo`<000Woo`<004[oo`8000goo`8001Woo`03003oo`0000800003
ool00?oo01Goo`8000Ooo`03003ooooo01Koo`8001Koo`003ooo0P003?oo0P00>ooo10002ooo0`00
M_oo00<00?ooool0Cooo0P002?oo0P001Ooo0P002?oo2@002ooo0`002Ooo0`00C_oo0P003Ooo00<0
0?ooool05ooo00<00?oo00000P0000?oo`00ool05Ooo00<00?ooool01Ooo00<00?ooool05ooo00<0
0?ooool05Ooo000?ool00`00ooooo`09ool20011ool4000:ool3001cool00`00ooooo`1>ool00`00
ooooo`07ool00`00ooooo`04ool20007ool9000;ool30007ool4001Cool00`00ooooo`0:ool00`00
ooooo`0Gool00`00ool0000200000ooo003oo`0Dool20007ool00`00ooooo`0Fool00`00ooooo`0F
ool000ooo`03003ooooo00Soo`8004Koo`<000[oo`80077oo`03003ooooo04coo`8000Soo`8000Go
o`8000Ooo`T000[oo`<000Ooo`<005Soo`03003ooooo00[oo`03003ooooo01Koo`D00003ool00?oo
01Coo`03003ooooo00Goo`03003ooooo01Koo`8001Soo`003_oo0P002Ooo00<00?ooool0BOoo0`00
2Ooo0P00Kooo00<00?ooool0Booo0P002?oo00<00?ooool01?oo0P001ooo20002_oo0P002?oo0P00
Fooo0P002ooo00<00?ooool05Ooo00<00?oo00000`0000?oo`00ool05?oo00<00?ooool01Ooo00<0
0?ooool05_oo00<00?ooool05ooo000>ool00`00ooooo`07ool00`00ooooo`1=ool30008ool3001/
ool3001:ool20007ool20005ool20007ool80009ool30007ool3001Nool00`00ooooo`09ool00`00
ooooo`0Eool00`00ool0000200000ooo003oo`0Dool00`00ooooo`05ool00`00ooooo`0Fool00`00
ooooo`0Hool000koo`03003ooooo00Ooo`03003ooooo04ooo`<000Soo`<006[oo`03003ooooo04Wo
o`03003ooooo00Koo`03003ooooo00Coo`8000Koo`P000Soo`<000Soo`8006;oo`03003ooooo00So
o`03003ooooo01Goo`03003oo`0000800003ool00?oo01Coo`03003ooooo00Coo`03003ooooo01Oo
o`03003ooooo01Soo`003_oo00<00?ooool01_oo0P00E?oo0`002?oo0P00J?oo00<00?ooool0Aooo
0P001ooo0P001Ooo0P001ooo1`002?oo0`001ooo0`007ooo6P00:ooo00<00?ooool02?oo00<00?oo
ool05?oo0P0000Goo`00003oo`0001Goo`03003ooooo00Goo`03003ooooo01Koo`03003ooooo01Wo
o`003_oo00<00?ooool01_oo00<00?ooool0E_oo0`001ooo0P00I_oo00<00?ooool0A_oo0P001ooo
00<00?ooool01?oo0P001_oo1`001ooo0`002?oo0P006Ooo2@006Ooo1000:?oo00<00?ooool02?oo
00<00?ooool05?oo00<00?oo00000P0000?oo`00ool05?oo00<00?ooool01?oo00<00?ooool05_oo
00<00?ooool06_oo000>ool00`00ooooo`05ool2001Kool20007ool3001Sool00`00ooooo`15ool0
0`00ooooo`05ool20005ool20006ool70007ool20008ool3000Gool5000Tool4000Uool20009ool0
0`00ooooo`0Dool00`00ool00003000Eool00`00ooooo`04ool00`00ooooo`0Fool00`00ooooo`0K
ool000koo`03003ooooo00Goo`03003ooooo05coo`8000Ooo`<0067oo`03003ooooo04Coo`03003o
oooo00Goo`03003ooooo00Coo`03003ooooo00Goo`H000Koo`<000Soo`8001Ooo`<002coo`8002Go
o`03003ooooo00Ooo`03003ooooo01?oo`D00003ool00?oo01?oo`8000Koo`03003ooooo01Goo`03
003ooooo01coo`003_oo00<00?ooool01Ooo00<00?ooool0G_oo0`001ooo0P00COoo20002_oo00<0
0?ooool0@_oo0P001_oo0P001Ooo0P001_oo1`001_oo0P002?oo0P005Ooo1000<Ooo0`008_oo00<0
0?ooool01ooo00<00?ooool04ooo00<00?oo000010005?oo00<00?ooool01?oo00<00?ooool05Ooo
00<00?ooool07Ooo000>ool00`00ooooo`05ool00`00ooooo`1Pool30007ool2001;ool20005ool0
0`00ooooo`08ool00`00ooooo`11ool20006ool00`00ooooo`03ool20007ool60006ool20007ool3
000Cool4000hool00`00ooooo`0Oool00`00ooooo`07ool00`00ooooo`0Bool500000ooo003oo`0C
ool00`00ooooo`04ool00`00ooooo`0Eool00`00ooooo`0Nool000koo`03003ooooo00Goo`03003o
oooo033oo`l002Coo`8000Ooo`8004_oo`03003ooooo00;oo`03003ooooo00Soo`03003ooooo043o
o`03003ooooo00Coo`8000Goo`8000Koo`H000Koo`8000Ooo`<0017oo`@003goo`03003ooooo01ko
o`03003ooooo00Koo`8001Coo`03003oo`0000@001?oo`8000Koo`03003ooooo01Coo`03003ooooo
01ooo`003ooo00<00?ooool01?oo00<00?ooool0:ooo1P003_oo2P007?oo0P001ooo0P00B_oo00<0
0?ooool03?oo00<00?ooool0?ooo00<00?ooool01?oo0P001?oo0P001_oo100000?oo`0000001Ooo
0P001ooo0P004?oo1000@_oo00<00?ooool07Ooo00<00?ooool01_oo00<00?ooool04_oo00<00?oo
00000P0000?oo`00ool04ooo00<00?ooool01?oo00<00?ooool05?oo00<00?ooool08?oo000?ool0
0`00ooooo`04ool00`00ooooo`0Wool5000Lool5000Jool30006ool20019ool00`00ooooo`0;ool4
000lool20006ool00`00ooooo`03ool20006ool60006ool20006ool2000?ool30017ool00`00oooo
o`0Lool00`00ooooo`06ool00`00ooooo`0Bool6000Dool00`00ooooo`04ool00`00ooooo`0Dool0
0`00ooooo`0Qool000ooo`03003ooooo00Coo`03003ooooo02Koo`8002Coo`D001Soo`<000Goo`80
04Woo`03003ooooo00[oo`T003Koo`8000Koo`03003ooooo00;oo`8000Koo`@00003ool00?oo00Go
o`8000Goo`<000koo`<004_oo`03003ooooo01[oo`8000Ooo`8001?oo`03003oo`0000@001?oo`80
00Goo`03003ooooo01Coo`03003ooooo02;oo`004?oo00<00?ooool01?oo00<00?ooool09?oo00<0
0?ooool0:?oo10006?oo0P001Ooo0P00>?oo10003?oo00<00?ooool01_oo10002?oo0P00<ooo00<0
0?ooool01?oo0P001?oo0P001_oo0`0000?oo`0000001Ooo0P001_oo0P003_oo0`00COoo00<00?oo
ool06_oo00<00?ooool01_oo00<00?ooool04Ooo00<00?oo00000P0000?oo`00ool04ooo00<00?oo
ool00_oo0P005_oo00<00?ooool08ooo000@ool00`00ooooo`04ool00`00ooooo`0Sool00`00oooo
o`0<oolH0009ool4000Fool20005ool20016ool20005ool20003ool00`00ooooo`08ool2000`ool0
0`00ooooo`04ool20003ool20006ool60005ool20006ool2000=ool3001@ool2000Kool00`00oooo
o`06ool00`00ooooo`0@ool7000Dool00`00ooooo`02ool2000Eool2000Vool0017oo`03003ooooo
00?oo`03003ooooo02;oo`03003ooooo00Woo`D001Koo`D000Woo`<001Goo`8000Coo`8004Koo`03
003ooooo00;oo`03003ooooo00?oo`03003ooooo00[oo`<002_oo`8000Koo`03003ooooo00;oo`80
00Goo`@00003ool0000000Coo`<000Goo`8000coo`<005Coo`03003ooooo01Woo`03003ooooo00Go
o`03003ooooo017oo`H001Coo`03003ooooo00;oo`8001Goo`8002Ooo`004Ooo0P001?oo0P008_oo
00<00?ooool02?oo0P008?oo10002?oo0`005?oo0P001?oo0P00A?oo00D00?ooooooo`0000Koo`03
003ooooo00coo`8002Woo`8000Koo`04003oooooool20006ool60005ool20005ool2000<ool2001G
ool00`00ooooo`0Hool00`00ooooo`06ool00`00ooooo`0@ool6000Dool00`00ooooo`02ool2000E
ool2000Xool001;oo`03003ooooo00?oo`03003ooooo01ooo`03003ooooo00Soo`03003ooooo02Co
o`D000Koo`<001?oo`8000Coo`03003ooooo03[oo`03003ooooo00Coo`04003oo`000007ool00`00
ooooo`0>ool00`00ooooo`0Uool00`00ooooo`04ool20003ool00`00ooooo`04ool400000ooo003o
o`04ool20005ool2000<ool2001Iool00`00ooooo`0Hool00`00ooooo`05ool00`00ooooo`0@ool0
0`00ool00004000Bool20004ool00`00ooooo`0Dool00`00ooooo`0Xool001;oo`8000Goo`03003o
oooo01goo`03003ooooo00Ooo`8000kooaL000Koo`D000Goo`8001;oo`8000Coo`8003[oo`8000?o
o`800003ool00?oo00Soo`03003ooooo00koo`03003ooooo02?oo`8000Koo`8000?oo`03003ooooo
00?oo`L000Coo`8000Goo`8000_oo`<005_oo`03003ooooo01Ooo`8000Koo`03003ooooo013oo`D0
0003ool00?oo017oo`8000Coo`03003ooooo01Coo`03003ooooo02Woo`004ooo00<00?ooool00ooo
0P007_oo00<00?ooool01_oo0P002ooo1P003ooo2P001ooo0P001Ooo0`004Ooo0P001?oo0P00>_oo
100000?oo`00ool02Ooo00<00?ooool03ooo00<00?ooool08Ooo0P001_oo00@00?ooooooo`8000Go
o`H000Coo`8000Goo`8000_oo`8005koo`03003ooooo01Ooo`03003ooooo00Coo`03003ooooo017o
o`H001;oo`8000Coo`03003ooooo01Coo`03003ooooo02[oo`005?oo00<00?ooool00ooo00<00?oo
ool07?oo00<00?ooool01Ooo00<00?ooool02Ooo0`006_oo1`001_oo0`001?oo0`004Ooo0P000ooo
0P00?Ooo00<00?ooool02Ooo0`004?oo00<00?ooool07ooo0P001Ooo0P000ooo0P001?oo1`001?oo
0P001?oo0P002ooo0P00H?oo00<00?ooool05_oo0P001Ooo0P004_oo1P004_oo0P001?oo00<00?oo
ool04ooo0P00;Ooo000Dool20004ool2000Mool00`00ooooo`05ool00`00ooooo`07ool3000Rool5
0004ool30005ool2000@ool20004ool2000jool00`00ooooo`0:ool00`00ooooo`0Aool00`00oooo
o`0Mool00`00ooooo`04ool20003ool20004ool00`00ool000030004ool20005ool20009ool3001R
ool00`00ooooo`0Fool00`00ooooo`03ool2000Bool6000Bool00`00ooooo`03ool00`00ooooo`0C
ool2000^ool001Goo`03003ooooo00?oo`03003ooooo01_oo`03003ooooo00Coo`03003ooooo00Oo
o`80013oo`h000Woo`H000?oo`8000Goo`<000ooo`8000Coo`8003Soo`03003ooooo00[oo`03003o
oooo01;oo`03003ooooo01_oo`03003ooooo00Coo`03003ooooo00;oo`8000Coo`D000Coo`8000Go
o`8000Woo`<006?oo`8001Ooo`03003ooooo00Coo`03003ooooo013oo`H001;oo`03003ooooo00;o
o`8001Goo`8002ooo`005_oo00<00?ooool00ooo00<00?ooool06_oo00<00?ooool01?oo00<00?oo
ool01_oo0P003?oo1@003Ooo2@001?oo1P000_oo0`001?oo0`003ooo00<00?ooool00_oo0P00=_oo
00<00?ooool02ooo00<00?ooool04ooo00<00?ooool06Ooo00<00?ooool01?oo00<00?ooool00_oo
00<00?ooool00_oo1P000ooo0P001_oo00<00?ooool01ooo0`00IOoo00<00?ooool05Ooo00<00?oo
ool01?oo00<00?ooool04?oo1P004_oo00<00?ooool00_oo0P005Ooo0P00<?oo000Gool00`00oooo
o`02ool00`00ooooo`0Jool00`00ooooo`03ool00`00ooooo`07ool00`00ooooo`09ool3000Jool4
0004ool500001?oo000000001Ooo0P003_oo0P001?oo0P00<ooo00<00?ooool03?oo00<00?ooool0
4ooo00<00?ooool06?oo00<00?ooool00ooo0P001?oo00<00?ooool00_oo1@001?oo0P001Ooo0P00
2?oo0`00Iooo00<00?ooool05?oo0P001Ooo00<00?ooool04?oo1P004Ooo0P001?oo0P005Ooo00<0
0?ooool0<?oo000Gool20004ool00`00ooooo`0Iool00`00ooooo`03ool00`00ooooo`06ool2000:
ool00`00ooooo`0Oool20005ool40002ool20005ool3000=ool20004ool00`00ooooo`0`ool00`00
ooooo`0<ool:000=ool00`00ooooo`0Fool00`00ooooo`03ool20004ool00`00ooooo`02ool40004
ool20006ool00`00ooooo`06ool3001Xool00`00ooooo`0Dool20005ool00`00ooooo`0@ool6000A
ool20004ool2000Eool00`00ooooo`0aool001Soo`8000Coo`03003ooooo01Soo`03003ooooo00?o
o`03003ooooo00Koo`03003ooooo00Ooo`80013oo`H000koo`<000Goo`<000;oo`8000Goo`<000co
o`8000Coo`8002ooo`03003ooooo00_oo`<000Soo`8000coo`03003ooooo01Goo`03003ooooo00?o
o`03003ooooo00?oo`03003ooooo00;oo`@000Coo`8000Goo`8000Ooo`<006Woo`8001Koo`03003o
oooo00?oo`03003ooooo013oo`H0017oo`8000Coo`8001Goo`03003ooooo03;oo`006Ooo00<00?oo
ool00ooo00<00?ooool06?oo00<00?ooool00_oo00<00?ooool01_oo00<00?ooool01_oo00<00?oo
ool02_oo1`001Ooo20002Ooo0`001?oo100000?oo`0000001_oo0P003?oo0P000ooo0P00;_oo00<0
0?ooool02_oo00@00?ooool000[oo`8000[oo`03003ooooo01Coo`03003ooooo00?oo`03003ooooo
00;oo`8000Coo`@000Coo`03003ooooo00Coo`03003ooooo00Goo`<006_oo`03003ooooo01Coo`03
003ooooo00?oo`80017oo`@00003ool00?oo013oo`03003ooooo00?oo`8001Coo`8003Goo`006_oo
00<00?ooool00ooo00<00?ooool05ooo00<00?ooool00ooo00<00?ooool01?oo0P002?oo00<00?oo
ool01ooo0`005?oo10002?oo0`001?oo0`0000Coo`00000000Goo`8000coo`8000?oo`03003ooooo
02[oo`03003ooooo00Woo`8000?oo`03003ooooo00[oo`03003ooooo00Soo`03003ooooo01;oo`03
003ooooo00;oo`8000Coo`8000Coo`@000Coo`03003ooooo00?oo`8000Koo`<006coo`8001Goo`03
003ooooo00?oo`80017oo`H0013oo`8000Goo`03003ooooo01?oo`8003Koo`006ooo0P001?oo00<0
0?ooool05_oo00<00?ooool00ooo00<00?ooool01?oo0P001ooo00<00?ooool01ooo0P006_oo1P00
1Ooo0`000ooo0`0000Coo`00000000Goo`8000_oo`8000?oo`03003ooooo02Woo`03003ooooo00So
o`8000Coo`<000_oo`03003ooooo00Ooo`03003ooooo017oo`8000?oo`8000Coo`8000?oo`@000Co
o`8000Goo`03003ooooo00Goo`8006koo`03003ooooo01?oo`03003ooooo00?oo`80017oo`H0013o
o`8000Goo`03003ooooo01?oo`8003Ooo`007?oo0P001?oo00<00?ooool05_oo00<00?ooool00_oo
00<00?ooool01?oo0P001ooo00<00?ooool01_oo00<00?ooool07ooo1@001?oo0`000_oo100000?o
o`0000001Ooo0P002ooo0P000_oo0P00:Ooo00<00?ooool01ooo00<00?ooool01?oo00<00?ooool0
3?oo00<00?ooool01_oo0P004Ooo0P000ooo00<00?ooool00ooo0P000ooo10001?oo0P001?oo0P00
1_oo0P00Kooo0P005?oo00<00?ooool00ooo0P004?oo1P004Ooo0P001Ooo00<00?ooool04ooo00<0
0?ooool0=ooo000Mool20004ool00`00ooooo`0Eool20004ool00`00ooooo`04ool00`00ooooo`05
ool00`00ooooo`05ool00`00ooooo`0Uool30004ool30002ool300000ooo00000004ool2000<ool0
0`00ooooo`02000Wool20008ool00`00ooooo`05ool00`00ooooo`0=ool00`00ooooo`06ool00`00
ooooo`0>ool20003ool00`00ooooo`03ool00`00ooooo`02ool40004ool00`00ooooo`03ool00`00
ooooo`04ool2001aool00`00ooooo`0Bool20005ool00`00ooooo`0>ool6000Aool00`00ooooo`03
ool2000Eool00`00ooooo`0hool001ooo`03003ooooo00;oo`03003ooooo01Goo`03003ooooo00;o
o`03003ooooo00Coo`03003ooooo00Goo`03003ooooo00Coo`8002[oo`<000Coo`<00005ool00000
003oo`020004ool2000;ool20002ool00`00ooooo`0Tool00`00ooooo`06ool00`00ooooo`06ool0
0`00ooooo`0=ool20007ool00`00ooooo`0=ool20003ool00`00ooooo`03ool00`00ooooo`02ool4
0003ool20004ool20006ool2001aool00`00ooooo`0Bool20005ool00`00ooooo`0>ool6000@ool2
0004ool2000Eool2000kool0023oo`8000?oo`03003ooooo01Goo`03003ooooo00;oo`03003ooooo
00?oo`8000Koo`03003ooooo00Coo`03003ooooo02coo`<000?oo`<00003ool0000000D000?oo`80
00[oo`8000;oo`8002Coo`03003ooooo00Koo`03003ooooo00Koo`03003ooooo00koo`03003ooooo
00Goo`03003ooooo00coo`8000?oo`03003ooooo00?oo`03003ooooo00;oo`@000?oo`8000Coo`03
003ooooo00Coo`8007;oo`03003ooooo01;oo`8000Goo`03003ooooo00goo`H0017oo`03003ooooo
00?oo`8001Coo`8003goo`008Ooo0P000ooo00<00?ooool05Ooo00D00?ooooooo`0000Koo`03003o
oooo00Coo`03003ooooo00Coo`03003ooooo02ooo`<000?oo`T000?oo`8000[oo`8000;oo`8002;o
o`03003ooooo00Koo`03003ooooo00Ooo`03003ooooo00koo`8000Koo`03003ooooo00_oo`8000?o
o`8000Coo`04003oooooool40004ool00`00ooooo`02ool20006ool00`00ooooo`1aool00`00oooo
o`0Cool00`00ooooo`02ool2000?ool6000@ool20004ool2000Eool2000nool002?oo`04003ooooo
ool2000Eool20003ool00`00ooooo`03ool20005ool00`00ooooo`04ool00`00ooooo`0aool30004
ool80003ool2000:ool00`00ooooo`02000Qool00`00ooooo`05ool20009ool00`00ooooo`0?ool0
0`00ooooo`04ool00`00ooooo`0:ool20003ool20003ool20003ool40004ool00`00ooooo`02ool0
0`00ooooo`04ool2001cool00`00ooooo`0Cool00`00ooooo`02ool2000>ool400000ooo0000000@
ool00`00ooooo`03ool00`00ooooo`0Cool20010ool002Coo`8000;oo`8001Goo`04003oooooool2
0005ool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`0eool20004ool80003ool20009ool2
0002ool00`00ooooo`0Nool00`00ooooo`05ool00`00ooooo`08ool00`00ooooo`0@ool00`00oooo
o`03ool2000:ool20003ool20003ool20003ool40003ool20003ool20005ool2001dool00`00oooo
o`0Cool01000oooooooo0P003ooo100000?oo`0000003ooo0P001?oo0P005Ooo0P00@Ooo000Uool2
0002ool2000Eool01@00oooooooo00001Ooo0P001Ooo00<00?ooool00ooo00<00?ooool0=_oo0P00
1?oo1`000ooo0P002Ooo0P000_oo0P007_oo00<00?ooool01?oo00<00?ooool02Ooo00<00?ooool0
4?oo00<00?ooool01?oo00<00?ooool02?oo00@00?ooooooo`8000?oo`8000?oo`@000?oo`8000?o
o`03003ooooo00Coo`8007Coo`03003ooooo01;oo`8000?oo`8000ooo`H0013oo`03003ooooo00;o
o`8001Goo`8004?oo`009ooo00<00?ooool00P005Ooo00D00?ooooooo`0000Goo`8000Coo`8000Co
o`03003ooooo03Soo`<000?oo`L000?oo`8000Woo`03003ooooo008001goo`03003ooooo00Coo`03
003ooooo00Woo`<0017oo`03003ooooo00?oo`03003ooooo00Ooo`03003ooooo00;oo`04003ooooo
ool20003ool30004ool01000oooooooo0P001Ooo0P00MOoo00<00?ooool04_oo0P000_oo0P003ooo
1`003ooo0P001?oo0P005Ooo00<00?ooool0@ooo000Xool20002ool00`00ooooo`0Cool01@00oooo
oooo00001?oo0P001Ooo00<00?ooool00_oo00<00?ooool0>_oo0`000ooo1`000ooo0P002?oo00D0
0?ooooooo`0001coo`03003ooooo00?oo`03003ooooo00[oo`03003ooooo017oo`03003ooooo00?o
o`03003ooooo00Koo`03003ooooo00;oo`05003oooooool00004ool30003ool20003ool00`00oooo
o`04ool00`00ooooo`1cool2000Dool01000oooooooo0P003ooo1`003ooo00<00?ooool00_oo0P00
5Ooo0P00A_oo000Yool20002ool00`00ooooo`0Cool20002ool00`00ooooo`02ool20005ool00`00
ooooo`02ool00`00ooooo`0kool20003ool70003ool20008ool20002ool00`00ooooo`0Hool00`00
ooooo`04ool00`00ooooo`0:ool00`00ooooo`0Aool00`00ooooo`03ool00`00ooooo`05ool00`00
ooooo`02ool01@00oooooooo00000ooo10000ooo0P000_oo0P001Ooo0P00MOoo0P005?oo00D00?oo
ooooo`00013oo`H000ooo`8000Coo`8001Goo`03003ooooo04Koo`00:ooo0P0000?oo`00ool05?oo
0P000_oo00<00?ooool00_oo0P001Ooo00D00?ooooooo`0003ooo`8000?oo`L000?oo`8000Ooo`80
00;oo`8001Soo`03003ooooo00Coo`03003ooooo00[oo`03003ooooo017oo`03003ooooo00?oo`03
003ooooo00Coo`03003ooooo00;oo`05003oooooool00003ool40003ool01@00oooooooo00001Ooo
0P00M_oo0P004ooo0P000_oo0P003ooo1`003ooo00<00?ooool00_oo0P005Ooo0P00BOoo000/ool2
00000ooo0000000Dool20002ool00`00ooooo`02ool20004ool20003ool00`00ooooo`0nool20003
ool60004ool00`00ooooo`06ool00`00ooooo`02000Gool00`00ooooo`03ool2000;ool7000>ool2
0004ool00`00ooooo`03ool00`00ooooo`02ool01@00oooooooo00000ooo10000ooo00D00?oooooo
o`0000Goo`8007Koo`8001?oo`8000;oo`03003ooooo00koo`L000koo`8000Coo`03003ooooo01?o
o`8004_oo`00;_oo00@00?ooool001Coo`8000;oo`03003ooooo00;oo`03003ooooo00?oo`05003o
ooooool00012ool20003ool60003ool20007ool01@00oooooooo00005_oo00<00?ooool00ooo00<0
0?ooool02Ooo00<00?oo00001Ooo0`003?oo00<00?ooool00_oo00<00?ooool00_oo00<00?ooool0
0_oo00@00?ooooooo`8000;oo`<000?oo`8000;oo`8000Coo`8007Ooo`03003ooooo01;oo`03003o
oooo008000ooo`L000ooo`03003ooooo00;oo`8001Goo`8004coo`00;ooo0P0000?oo`0000005?oo
00@00?ooool000Coo`03003ooooo00;oo`8000?oo`03003ooooo027oo`/001Coo`8000Coo`H000;o
o`8000Ooo`8000;oo`03003ooooo01?oo`03003ooooo00?oo`03003ooooo00Ooo`8000;oo`03003o
oooo00Goo`8000_oo`03003ooooo00;oo`05003oooooool00004ool01000oooooooo0P000_oo0`00
0ooo0P000_oo0P001?oo00<00?ooool0M_oo00<00?ooool04Ooo0P000_oo0P003ooo100000?oo`00
00003_oo0P000ooo0P005Ooo0P00C_oo000`ool200000ooo0000000Dool00`00ooooo`020003ool2
0003ool01@00oooooooo00008?oo0`002_oo1`004?oo0P000ooo1P000ooo00<00?ooool01Ooo0P00
0_oo00<00?ooool04_oo00<00?ooool00ooo00<00?ooool01_oo0P000ooo00<00?ooool01_oo0P00
2_oo00<00?ooool00_oo00@00?ooool000Coo`04003oooooool20002ool30003ool01000oooooooo
0P000ooo0P00Mooo0P004_oo0P000_oo0P003ooo1`003ooo00<00?ooool00_oo0P005Ooo0P00Cooo
000bool00`00ooooo`02000Cool200000ooo00000003ool20003ool01@00oooooooo00007Ooo0P00
4ooo10003ooo0P000ooo1P000_oo0P001ooo00@00?ooool001?oo`03003ooooo00?oo`03003ooooo
00Koo`03003ooooo00;oo`03003ooooo00Ooo`03003ooooo00Soo`03003ooooo00;oo`04003oo`00
0003ool20003ool00`00ooooo`030003ool01@00oooooooo00000ooo0P00N?oo00<00?ooool04Ooo
00@00?ooooooo`8000ooo`H000ooo`8000?oo`8001Goo`80057oo`00<ooo0P0000?oo`0000004ooo
0P000_oo00@00?ooooooo`8000?oo`8000;oo`03003ooooo01[oo`03003ooooo01Koo`8000ooo`80
00?oo`H00003ool0000000Ooo`800003ool00?oo017oo`03003ooooo00;oo`8000Ooo`03003ooooo
00?oo`03003ooooo00Ooo`8000Woo`03003ooooo00;oo`03003oo`0000?oo`8000?oo`03003ooooo
00<000?oo`05003oooooool00003ool2001gool2000Bool20002ool2000?ool6000@ool01000oooo
oooo0P005Ooo0P00Dooo000dool20002ool00`00ooooo`0Bool01000ooooo`000ooo0P000ooo0P00
0_oo00<00?ooool06?oo00<00?ooool06Ooo0`003_oo0P000ooo1@000_oo00<00?ooool01Ooo0P00
00?oo`0000004?oo00<00?ooool00_oo00<00?ooool01Ooo00<00?ooool01?oo0`002?oo00<00?oo
ool01ooo00<00?ooool00_oo0P000ooo0P000ooo00<00?ooool00`000ooo00D00?ooooooo`0000;o
o`8007Ooo`8001;oo`8000?oo`8000koo`L000ooo`8000;oo`<001Coo`<005Coo`00=_oo0P0000?o
o`0000004ooo0P0000?oo`0000000_oo0P000ooo0P000_oo00<00?ooool05ooo00<00?ooool07?oo
10002ooo0P000ooo1P0000?oo`0000001_oo0P0000?oo`0000003ooo00<00?ooool00_oo00<00?oo
ool01Ooo00<00?ooool01?oo00<00?ooool02?oo0P002?oo00<00?ooool00_oo00@00?ooooooo`80
00?oo`03003ooooo00<000?oo`03003ooooo008000;oo`03003ooooo07Koo`8001;oo`04003ooooo
ool2000>ool7000?ool20003ool2000Dool2001Gool003Ooo`8000;oo`8001;oo`800003ool00000
00;oo`<000?oo`04003ooooo000Hool00`00ooooo`09ool>0008ool4000:ool20003ool300000ooo
003oo`020007ool01000ool000003_oo00<00?ooool00_oo00<00?ooool01?oo00<00?ooool01Ooo
00<00?ooool02Ooo00<00?ooool01_oo00@00?ooooooo`8000?oo`05003oooooool00002ool30003
ool00`00ooooo`020002ool00`00ooooo`1eool2000Bool20002ool3000>ool6000?ool30002ool2
000Dool2001Iool003Woo`800003ool0000001?oo`04003ooooo0003ool20003ool01000ooooo`00
5ooo00<00?ooool01ooo0P003_oo10002?oo0`002Ooo0P000_oo20001ooo00@00?oo000000goo`03
003ooooo00;oo`03003ooooo00Coo`03003ooooo00Goo`03003ooooo00[oo`03003ooooo00Goo`05
003oooooool00003ool01@00oooooooo00000_oo0`000_oo0P000_oo0P0000?oo`000000Mooo0P00
4Ooo0P000ooo0P003_oo1P004?oo0P000_oo0P005?oo0P00Fooo000kool200000ooo0000000Bool2
00000ooo00000002ool20003ool200000ooo003oo`0Eool00`00ooooo`06ool00`00ooooo`0Bool3
0007ool2000:ool20002ool500000ooo003oo`06ool01000ool000003?oo00<00?ooool00_oo00<0
0?ooool00ooo0P001ooo1@002?oo00<00?ooool01Ooo00<00?ooool00P000_oo00@00?ooooooo`80
0003ool0000000?oo`8000;oo`800003ool0000007Koo`8001;oo`04003oooooool2000>ool6000@
ool20002ool2000Dool2001Mool003goo`800003ool0000001;oo`03003ooooo00800004ool00000
0002ool200000ooo0000000Eool00`00ooooo`05ool00`00ooooo`0Eool30006ool20009ool20002
ool500000ooo00000006ool01000ool000002ooo00<00?oo00001`0000?oo`00ool01_oo0P001?oo
0P001_oo00<00?ooool01Ooo00L00?oo003oo`00ool00003ool200001?oo000000000_oo0P000_oo
00<00?ooool00P00M_oo0P004Ooo0P000_oo0P003_oo1`003ooo0P000_oo0P004ooo0`00Gooo000o
ool5000Aool200000ooo00000002ool20003ool200000ooo0000000Cool00`00ooooo`05ool00`00
ooooo`0Hool30005ool20009ool200000ooo0000000300000ooo00000006ool01000ool000002_oo
0P000ooo0P001?oo00<00?ooool01?oo00<00?oo00001_oo00<00?ooool00ooo0P001_oo0`0000?o
o`0000001?oo00<00?ooool00P000_oo0P000_oo00<00?ooool00P00MOoo0P004Ooo0P000_oo0P00
3_oo1`003ooo0P000_oo0P004ooo0`00HOoo0011ool4000Aool20002ool200001?oo000000000_oo
0P0000?oo`0000004ooo00<00?ooool01?oo00<00?ooool06ooo0`001?oo0P002?oo0P000_oo1000
0_oo00<00?ooool01?oo00@00?oo000000[oo`04003oooooool20003ool00`00ooooo`04ool01000
ooooo`001_oo0P001Ooo00<00?ooool01?oo0P000_oo0P000ooo00<00?ooool00P000_oo0P0000?o
o`0000000_oo00<00?ooool0M?oo00<00?ooool04?oo00<00?ooool00P003ooo1P003ooo0P000_oo
0P004ooo0`00Hooo0013ool4000Aool01000oooooooo1@000ooo0P0000?oo`0000004Ooo00<00?oo
ool01?oo00<00?ooool07_oo0P001?oo0P002?oo00<00?ooool01@0000?oo`0000001?oo0P000_oo
00<00?ooool01ooo00@00?ooooooo`8000?oo`03003ooooo00?oo`03003ooooo00L000;oo`03003o
oooo00?oo`03003ooooo00Coo`05003oooooool00003ool00`00ooooo`020002ool200000ooo0000
0002ool00`00ooooo`1cool2000Aool200000ooo0000000?ool6000?ool20002ool2000Cool2001V
ool004Coo`800003ool00000013oo`8000;oo`800004ool000000002ool20002ool00`00ooooo`0?
ool00`00ooooo`03ool00`00ooooo`0Pool30002ool30007ool00`00ooooo`0500000ooo00000004
ool20002ool00`00ooooo`06ool01000oooooooo0P000ooo00<00?ooool00_oo00@00?ooooooo`P0
00;oo`03003ooooo00;oo`03003ooooo00?oo`8000;oo`8000;oo`03003ooooo008000;oo`800003
ool0000000;oo`03003ooooo07;oo`80017oo`800003ool0000000ooo`H000ooo`8000;oo`8001?o
o`8006Soo`00A_oo1@003ooo0P000ooo1@000ooo00<00?ooool00P004?oo00<00?ooool00ooo00<0
0?ooool08_oo0P000_oo0P001ooo0P0000Koo`0000000?oo0002ool00`00ooooo`02ool20002ool0
0`00ooooo`05ool01000oooooooo0P000ooo00@00?ooooooo`8000;oo`<000Goo`800003ool00000
00?oo`03003ooooo00?oo`800003ool0000000;oo`03003ooooo008000;oo`800003ool0000000;o
o`03003ooooo077oo`<0013oo`800003ool0000000ooo`L000koo`8000;oo`8001?oo`8006[oo`00
B?oo1@003ooo0P000_oo0P0000Coo`00000000;oo`800003ool00000013oo`03003ooooo00;oo`03
003ooooo02Coo`8000;oo`8000Koo`8000;oo`800005ool00?ooool00004ool60005ool01000oooo
oooo0P000ooo00D00?ooooooo`0000;oo`04003ooooo0006ool200000ooo003oo`02ool00`00oooo
o`02ool300001Ooo00000?oo00000_oo0P000_oo0P0000Coo`00ooooo`8007;oo`<0013oo`800003
ool0000000ooo`H000ooo`8000;oo`8001?oo`8006coo`00B_oo0P0000?oo`0000003_oo0`000_oo
0P0000Coo`00000000;oo`800003ool0000000ooo`03003ooooo00;oo`03003ooooo02Goo`8000;o
o`8000Koo`03003ooooo00D00003ool00?oo00?oo`8000;oo`03003ooooo00?oo`04003oooooool2
0002ool00`00ooooo`02ool01000ool000000_oo1@000_oo0P0000?oo`00ool00_oo00P00?oooooo
o`00ool00?oo0P0000Coo`00003oo`8000;oo`800004ool00?ooool2001aool3000@ool200000ooo
0000000?ool6000?ool20002ool2000Cool2001^ool004coo`800003ool0000000koo`<000;oo`80
0003ool0000000;oo`800003ool0000000ooo`03003ooooo00;oo`03003ooooo02Koo`8000;oo`80
00Goo`800003ool0000000<00003ool00?oo00?oo`8000;oo`03003ooooo00?oo`03003ooooo0080
00;oo`03003ooooo00;oo`@00003ool0000000?oo`03003ooooo00800003ool0000000;oo`03003o
oooo00800003ool0000000@00003ool0000000;oo`04003ooooo0002ool2001`ool3000?ool30000
0ooo0000000?ool6000?ool20002ool3000Aool3001`ool004koo`800004ool00000000>ool20000
0ooo00000002ool20002ool200000ooo0000000>ool20003ool00`00ooooo`0Vool20003ool20004
ool20002ool200001?oo003oo`001?oo0P0000?oo`0000001?oo00<00?ooool00P000_oo00@00?oo
ooooo`H00003ool00?oo00?oo`800005ool00000ool00002ool01000ooooo`000_oo0P0000Coo`00
003oo`8000;oo`04003oo`000002ool00`00ooooo`1^ool3000?ool300001?oo000000003Ooo1`00
3ooo0P000_oo0`004Ooo0`00L_oo001@ool200001?oo000000003_oo0P0000Coo`00003oo`<000;o
o`@000koo`8000?oo`03003ooooo02Ooo`8000;oo`8000Coo`8000;oo`@00003ool00?oo00?oo`04
003ooooo0004ool00`00ooooo`020002ool02@00oooooooo003oo`00ool00002ool00`00ooooo`03
ool01P00ool00000ool000;oo`03003oo`0000;oo`800004ool00000ool20002ool01000ool00000
0_oo00<00?ooool0KOoo0`003ooo0P000_oo0`003Ooo1`003ooo1P004_oo0P00MOoo001Aool30002
ool2000>ool200001?oo00000?oo0`0000Coo`00003oo`8000koo`8000;oo`8002Soo`8000?oo`80
00Coo`03003ooooo00H000Coo`04003ooooo0003ool50002ool01000oooooooo10000ooo00<00?oo
ool01?oo00D00?oo003oo`0000;oo`8000?oo`05003ooooo003oo`020002ool01000ool000000_oo
00<00?ooool0K?oo0`003ooo0P000_oo0P003_oo1P004?oo1P004_oo0P00Mooo001Dool20002ool2
000>ool80002ool4000>ool20002ool2000Yool20002ool20004ool20002ool50004ool01000ool0
00000ooo00@00?oo000000;oo`04003oooooool40003ool00`00ooooo`04ool00`00ool000020002
ool20003ool00`00ool0000400001?oo003oo`000ooo00<00?ooool0Jooo0`003_oo0`0000Coo`00
000000koo`H0013oo`D001?oo`8007Woo`00E_oo0`0000?oo`0000003_oo0P0000?oo`0000000`00
0_oo10003_oo00<00?ooool00P00:_oo00D00?ooooooo`0000Coo`8000;oo`D000Coo`03003oo`00
00?oo`04003oo`000002ool01000oooooooo10000ooo0`001?oo00<00?oo00000P000_oo00@00?oo
ooooo`<00008ool00000003oo`00ool000;oo`8006coo`<000koo`8000;oo`<000goo`L000ooo`D0
01Coo`8007_oo`00FOoo0P0000Coo`00000000goo`800003ool0000000<00003ool0000000<000go
o`8000;oo`03003ooooo02Soo`8000;oo`8000Coo`03003ooooo00800003ool0000000Coo`03003o
o`0000;oo`04003ooooo0002ool00`00ooooo`040004ool00`00ooooo`05ool400000ooo00000002
ool00`00ool0000400001?oo003oo`000_oo0P00Jooo0`003_oo0P000_oo0P003_oo1`003_oo1P00
5?oo0P00OOoo001Kool6000=ool200000ooo000000030002ool4000=ool200000ooo0000000Zool0
0`00ooooo`020004ool00`00ooooo`0200000ooo00000004ool01@00ool00?oo00000_oo00@00?oo
ool000;oo`@000Coo`03003ooooo00Goo`03003oo`0000800003ool00?oo00@00006ool00000ool0
0?oo0P0000?oo`000000J_oo0`003Ooo0`0000Coo`00000000koo`H000ooo`D001Coo`<007ooo`00
G_oo0P0000?oo`0000003Ooo0P0000?oo`0000000`000_oo10003Ooo1000:_oo0P000_oo00<00?oo
ool00_oo0P0000Coo`00003oo`8000Coo`@000;oo`04003ooooo0002ool40004ool00`00ooooo`05
ool00`00ool0000200001ooo003oo`00ool00?oo00L00003ool0000006Woo`<000goo`<00003ool0
000000koo`L000koo`H001Coo`<0087oo`00H?oo1@003Ooo0P0000?oo`0000000`000_oo10003?oo
0P0000?oo`000000:_oo00<00?ooool00P000ooo0P0000?oo`0000000`000ooo0`0000Coo`00ool0
00;oo`03003ooooo00<000Goo`03003ooooo00Goo`04003oo`000002ool20002ool400001_oo003o
o`00ool006Woo`<000goo`800004ool00000000>ool7000>ool5000Eool30023ool006?oo`D000co
o`800003ool0000000@00003ool00000008000coo`@002[oo`800003ool0000000Coo`03003oo`00
00@000?oo`06003oo`00003oo`000_oo00<00?ooool00`001?oo1@001?oo00D00?oo00000?oo00<0
0003ool0000000800006ool00?oo003oo`00J?oo0`003Ooo0P0000?oo`0000003_oo20003Ooo1@00
5_oo0P00Q_oo001Uool5000<ool90002ool3000<ool4000Zool01000ooooo`001?oo00<00?oo0000
10000ooo00<00?oo00000_oo00D00?oo00000?oo00<000Coo`8000?oo`03003ooooo00;oo`<00004
ool00000ool400001_oo003oo`00ool006Koo`<000goo`H000goo`P000koo`D001Koo`8008Soo`00
J?oo1@002ooo0`0000?oo`0000000`000_oo0`003?oo0`00:_oo0P0000?oo`0000000ooo00<00?oo
00000P0000Coo`00ooooo`@00006ool00?ooool00?oo0`000ooo0`001?oo00@00?ooooooo`<00004
ool00?ooool500001?oo003oo`00IOoo0`003?oo0`0000Coo`00000000goo`L000koo`D001Ooo`80
08[oo`00J_oo1P002_oo0`0000Coo`00003oo`<00003ool00000008000[oo`@002[oo`04003oo`00
0003ool00`00ool0000200002Ooo003ooooo003oo`00ool00002ool00`00ool000020003ool00`00
ool00004ool01000oooooooo1@0000?oo`0000000`0000?oo`0000000P00H_oo0`003Ooo0`0000?o
o`0000003Ooo1`003_oo1@006?oo0P00S?oo001]ool200001?oo000000002_oo1@0000Goo`000000
0?oo00@000[oo`@002Woo`800003ool00?oo00;oo`03003oo`0000800004ool00?ooool300001Ooo
003oo`00ool00`000_oo00<00?ooool00`000_oo00<00?ooool00`0000Goo`00ool00?oo00@00004
ool00000001Qool2000=ool300001?oo000000003?oo1`003ooo1@005ooo0`00S_oo001_ool30000
1?oo000000002_oo100000?oo`0000001P002_oo1000:Ooo00@00?oo000000;oo`03003oo`000080
0003ool00?oo00D00003ool00?oo00<000;oo`04003ooooo0005ool00`00ool0000400000ooo0000
000300001?oo003oo`00Gooo0`003?oo0`0000Coo`00000000coo`L000ooo`D001Soo`<0093oo`00
L_oo0P000_oo0`002Ooo2@0000?oo`0000000P002Ooo1000:?oo10000_oo00<00?oo00000P0000?o
o`00ool0100000?oo`00ool00`000_oo00@00?ooool000Goo`X00006ool00?oo003oo`00GOoo0`00
3Ooo1P003?oo1`004?oo1@006?oo0P00Tooo001dool300000ooo000000020009ool=0009ool4000X
ool00`00ool00002ool00`00ool0000400000ooo003oo`0200000ooo000000020002ool01000oooo
o`001Ooo1@0000?oo`0000000`0000Coo`00ool005coo`<000coo`H000coo`L0013oo`D001Soo`<0
09Goo`00Mooo20002Ooo30002Ooo10009ooo0`000_oo00<00?oo00000`000_oo00@00?oo003oo`@0
0003ool00?oo00;oo`03003ooooo00?oo`03003oo`0000/005[oo`<000coo`H000coo`L0017oo`@0
01Woo`8009Soo`00Nooo1P002_oo30002?oo10009ooo0P000_oo00<00?oo00000`0000Ooo`00ool0
0?oo003oo`0200000ooo003oo`02ool00`00ooooo`03ool01@00ool00000ool01@0000Coo`000000
05Soo`8000goo`D000_oo`T0013oo`D001Soo`<009[oo`00O_oo1P002Ooo30002Ooo0`009_oo0P00
0_oo00<00?oo00000`0000?oo`00ool00P0000Goo`00003oo`0000?oo`03003ooooo00?oo`03003o
o`0000X005Koo`<000coo`D000_oo`T0013oo`D001Woo`8009goo`00POoo1P002Ooo2`002Ooo0`00
9Ooo0P000_oo1@0000?oo`0000000P0000Goo`00003oo`0000?oo`03003ooooo00;oo`/00003ool0
0?oo05?oo`<000coo`@000coo`T0017oo`@001Woo`<009ooo`00QOoo1@002Ooo1`0000Coo`000000
00Soo`<002Coo`<00003ool0000000X00003ool00?oo00;oo`03003ooooo00;oo`X00003ool00?oo
05;oo`<000coo`<000_oo`T001;oo`D001Woo`800:;oo`00>Ooo2000Aooo1@0000?oo`0000004000
2?oo10008_oo0`0000?oo`0000002@0000?oo`00ool00_oo00<00?ooool00_oo00<00?oo00002000
@Ooo20001ooo10003?oo0`002ooo20005?oo10002?oo20002Ooo0`00@Ooo1P00DOoo1P001_oo000i
ool20005ool00`00ooooo`19ool40002ool00`00ooooo`03ool;0008ool3000Qool300000ooo0000
000600001?oo003oo`000ooo0`0000?oo`0000002@00A_oo00<00?ooool01?oo1@002ooo10001?oo
8@000_oo1@002_oo0P001Ooo00<00?ooool01Ooo0P00A?oo00<00?ooool00ooo00<00?ooool0DOoo
00<00?ooool01_oo000kool00`00ooooo`02ool00`00ooooo`1<ool50007ool;0007ool4000Oool3
00000ooo000000090003ool01000oooooooo2P00Aooo00<00?ooool01@001?oo@`001?oo00<00?oo
ool00_oo00<00?ooool00_oo0`00COoo00<00?ooool0D?oo00<00?ooool01_oo000lool00`00oooo
o`1Cool60006ool;0007ool3000Nool300000ooo000000080003ool01000oooooooo2P00A_oo5P00
2_oo20005?oo1P002ooo2`001?oo0P00D?oo00<00?ooool0Booo20001_oo000mool00`00ooooo`1B
ool01000oooooooo1P001Ooo2`001_oo0`007Ooo0`0000?oo`0000001`000_oo0`0000?oo`00ool0
2000?ooo3`001Ooo1P002ooo20005?oo1@005ooo2P00Cooo00<00?ooool0Booo00<00?ooool00_oo
00<00?ooool01_oo000nool00`00ooooo`1Aool00`00ooooo`05ool50006ool;0005ool3000Kool3
00000ooo000000060002ool300000ooo00000007000gool>0004ool00`00ooooo`05ool5000;ool9
000Dool5000Lool20003ool:0017ool00`00ooooo`1=ool01@00oooooooo00002?oo000_ool4000<
ool00`00ooooo`12ool4000:ool00`00ooooo`09ool50006ool:0005ool3000Iool300000ooo0000
00050002ool200000ooo00000007000bool@0008ool01000oooooooo1@002ooo2@005Ooo1@007?oo
0`0000?oo`00ool02Ooo1`00@?oo1000Cooo00D00?ooooooo`0000Soo`00?ooo0P00DOoo00<00?oo
ool03Ooo1@001_oo2@001?oo10005ooo0`0000?oo`0000001@0000Koo`00003oo`00ool6000]ool<
00000ooo00000003000<ool5000;ool9000Eool5000Nool20004ool2000>ool5000oool00`00oooo
o`1?ool01000ooooo`002?oo0010ool00`00ooooo`1?ool00`00ooooo`0Aool50006ool80004ool3
000Fool:00001?oo00000?oo1`00:?oo2`001?oo1@001ooo:`002Ooo1@007_oo0`001ooo00<00?oo
ool03ooo1P00??oo00<00?ooool0C_oo00@00?ooool000Soo`00@?oo00<00?ooool0Cooo00<00?oo
ool05Ooo1@001Ooo20000ooo10005Ooo2@0000?oo`00ool01`008_oo2`001_oo10001?oo3`000_oo
00<00?ooool01Ooo2P002ooo40007ooo0P002_oo00<00?ooool04_oo1P00>Ooo00<00?ooool0Cooo
00<00?oo00002?oo000iool00`00ooooo`04ool00`00ooooo`1;ool01@00oooooooo00006ooo1@00
1?oo20000ooo10004ooo200000?oo`0000001P007_oo2P002?oo>P002?oo100000?oo`0000001`00
5_oo0`001Ooo00<00?ooool01?oo00<00?ooool05_oo1000=ooo00<00?ooool0Cooo00<00?oo0000
2?oo000iool20003ool2001?ool4000Oool50004ool80002ool4000Aool700000ooo00000005000I
ool:0006ool`000>ool=000<ool6000?ool20008ool20003ool2000Lool3000_ool20003ool00`00
ooooo`1Aool20008ool003_oo`@005;oo`8002?oo`H000?oo`d000ooo`d001Goo`T000;ooah000go
oaT000Woo`d000_oo`H000Woo`8000coo`@001ooo`<002ooo`<005Coo`8000Soo`00^ooo1P000_oo
30003Ooo2`004_oo6@001_oo20003ooo2`003_oo3P002?oo20002ooo10001?oo0`00<ooo0`00S_oo
0030oolB000;ool9000>oolH0006ool8000Aool;000Iool9000:ool6000=ool5000gool2002=ool0
0<Gooa4000Soo`P000Wooa400003ool0000000@000Goo`L001Coo`X001_oo`H000?oo`D000coo`@0
00goo`<003Soo`8008coo`00b_oo3`001_oo1P001_oo3@000ooo8P001ooo2@007_oo0`003?oo0P00
3?oo10002_oo00<00?ooool00P00>?oo00<00?ooool0R_oo003?ool>0002ool50003oolF0002ool8
000Dool=000Qool3000@ool2000=ool20008ool00`00ooooo`03ool00`00ooooo`0fool00`00oooo
o`29ool00<goob@000Ooo`P001goo`P002?oo`8001?oo`03003ooooo00coo`8000Koo`03003ooooo
00Coo`8003Ooo`03003ooooo08Woo`00o`00o`00@@000Ooo0004ool00`00ooooo`0>ool00`00oooo
o`0>ool00`00ooooo`0>ool00`00ooooo`0>ool00`00ooooo`0>ool00`00ooooo`0>ool00`00oooo
o`0>ool00`00ooooo`0>ool00`00ooooo`0>ool00`00ooooo`0>ool00`00ooooo`0>ool00`00oooo
o`0:oolT0003ool01000oooooooo300000?oo`00ool03ooo00<00?ooool01?oo2`004?oo00<00?oo
ool03_oo0P003ooo00D00?ooooooo`0000coo`04003oo`000006ool00`00ooooo`04ool2000?ool0
0`00ooooo`0>ool00`00ooooo`0>ool00`00ooooo`03ool00`00ooooo`08ool00`00ooooo`0>ool0
0`00ooooo`0>ool00`00ooooo`0>ool00`00ooooo`0>ool00`00ooooo`0>ool00`00ooooo`0>ool0
0`00ooooo`0>ool00`00ooooo`07ool000Coo`03003ooooo00koo`03003ooooo00koo`03003ooooo
00koo`03003ooooo00koo`03003ooooo00koo`03003ooooo00koo`03003ooooo00koo`03003ooooo
00koo`03003ooooo00koo`03003ooooo00koo`03003ooooo00koo`03003ooooo00ooo``000;oo`D0
00CooaD000Coo`X000[oo`03003ooooo00Coo``000ooo`03003ooooo00koo`D000coo`03003oo`00
008000coo`<000Soo`03003ooooo00;oo`80013oo`03003ooooo00koo`03003ooooo00koo`03003o
oooo00?oo`03003ooooo00Soo`03003ooooo00koo`03003ooooo00koo`03003ooooo00koo`03003o
oooo00koo`03003ooooo00koo`03003ooooo00koo`03003ooooo00koo`03003ooooo00Ooo`00=ooo
00<00?ooool0D_oo00<00?ooool0??oo3P001Ooo1`001ooo<`001?oo20003?oo00<00?ooool04?oo
1@002_oo0`003Ooo0`002Ooo0P000_oo0P004Ooo00<00?ooool09?oo0P00;?oo00<00?ooool0D_oo
00<00?ooool01ooo000gool00`00ooooo`1Bool00`00ooooo`0gool@0007ool9000:oolF0008ool8
000Aool80008ool00`00ooooo`0Aool300000ooo00000004ool5000=ool4000;ool4000Bool00`00
ooooo`0Sool2000]ool00`00ooooo`1Bool00`00ooooo`07ool00<7ooa8000[oo`X000gooaT000Oo
o`L0013oo`P001[oo`<00003ool0000000<000koo`D000coo`D003Ooo`03003ooooo08coo`00_Ooo
4P003Ooo2`004ooo6P001Ooo1P004?oo20005?oo30002Ooo1P003?oo10000ooo0`00=?oo00<00?oo
ool0SOoo002hool600000ooo0000000;000?ool=000GoolU000@ool70004ool>0007ool?000;ool6
0008ool2000`ool2002@ool00;?oo`D000?oo`h0017oo`L00003ool0000000D001coo`D000Gooc@0
00goo`d000goo`H000koo`8002_oo`@0097oo`00[_oo1@001Ooo3@005?oo00<00?oo00001@0000?o
o`0000001P008?oo1P002?oo?0001_oo4@005Ooo0`009Ooo1000U?oo002Yool50006ool>000Fool0
0`00ool0000600000ooo00000007000Tool70008oolF000<ool7000>ool@000Nool2000Qool4002F
ool00:Goo`D000Kooa0001Ooo`03003oo`0000T00003ool0000000D002[oo`P000Coo`@000Koobh0
00Soo`D001ooo`8001coo`@009Woo`00XOoo1@001ooo4@006?oo0P0000?oo`0000001@0000Coo`00
003oo`P002koo`X00003ool00000008000_oo`L000goo`L001Goo`D001koo`<001Coo`H009coo`00
W_oo10002?oo2P000_oo0P0000?oo`0000006_oo0P0000?oo`0000001P0000Coo`00003oo`T003?o
o`d000_oo`P000_oo`P001Coo`D001koo`<000coo`T009koo`00V_oo10002Ooo2@001?oo1@006ooo
0P0000?oo`0000001P000_oo0`0000?oo`0000001`00>?oo40001_oo20002ooo20004ooo1@007Ooo
0`001?oo2P00Xooo002Fool4000:ool90005ool4000Mool200000ooo000000070002ool300000ooo
00000007000noolL000;ool8000Bool5000Iool;002Zool009;oo`D000[oo`T000Goo`D001koo`80
0003ool0000000P000?oo`800003ool00?oo00P004Goo`@00003ool00000010000coo`P0017oo`D0
00ooo`/000?oo`800:coo`00S_oo1P002Ooo2`001Ooo10008?oo0P0000?oo`0000002@000ooo00@0
0?ooooooo`P00003ool00?oo04Ooo`<000gooa`000Sooa`000coo`<00:Woo`00R_oo1`002Ooo2`00
1_oo10008Ooo0P0000?oo`0000000P0000?oo`0000001@000ooo00@00?ooooooo`H00005ool00000
ool0001:ool3000>ool60002oolW000Lool3002Vool008Koo`L000[oo`/000Ooo`@002;oo`800003
ool0000000800004ool00000ool50003ool30002ool600001Ooo00000?oo0000C?oo10003Ooo1P00
3?oo2@003ooo1P006_oo0`00Y?oo0023ool7000:ool;0007ool4000Tool200000ooo000000030000
0ooo0000000400000ooo003oo`02ool00`00ooooo`02ool<001?ool3000=ool6000<ool:000>ool6
000Jool3002Qool0083oo`<00004ool00000000:ool<0007ool4000Tool300000ooo000000030000
0ooo0000000500000ooo003oo`02ool00`00ooooo`03ool600000ooo00000003001Aool4000=ool6
000<ool9000=ool7000Jool2002Oool007goo`L000[oo`<00003ool0000000H000Soo`@002Goo`<0
0003ool0000000<000;oo`@00005ool00000ool00003ool00`00ooooo`03ool=001Dool3000=ool6
000<ool9000=ool7000Iool3002Lool007_oo`D000[oo`@00003ool0000000H000Woo`@002Goo`80
0003ool00?oo00D000?oo`@00005ool00000ool00003ool00`00ooooo`03ool;00000ooo0000001F
ool3000>ool5000=ool7000>ool300001?oo000000006Ooo0`00VOoo001hool5000:ool40002ool7
0009ool5000Vool400000ooo000000030003ool300000ooo003oo`0200000ooo003oo`02ool00`00
ooooo`03ool600000ooo0000000300000ooo0000001Hool4000=ool5000=ool7000>ool300001?oo
000000006?oo0`00Uooo001eool5000:ool500000ooo00000006000:ool4000Vool200001?oo0000
0?oo1@000ooo1@0000Coo`00000000;oo`04003ooooo0005ool=00000ooo003oo`1Kool3000=ool4
000=ool8000>ool300001?oo000000006?oo0`00U?oo001bool60009ool500000ooo00000006000;
ool4000Wool200001?oo003ooooo1P000_oo100000?oo`00ool00`000_oo00@00?ooool000Goo`03
003oo`0000800003ool00?oo00@00004ool00?oo001Nool2000?ool3000=ool8000>ool300001?oo
000000006?oo0P00T_oo001`ool5000:ool500000ooo0000000200001?oo000000002ooo1000:?oo
00@00?oo000000?oo`D000?oo`@00003ool00?oo00<000;oo`04003ooooo0004ool00`00ooooo`03
00001?oo00000?oo100000Coo`00ool005ooo`<000ooo`<000goo`L000ooo`<00004ool00000000G
ool3002?ool006goo`H000[oo`X00004ool00000000;ool4000Xool200000ooo00000003ool50003
ool00`00ool0000200000ooo003oo`030002ool00`00ooooo`030002ool00`00ooooo`0600000ooo
0000000300001?oo003oo`00HOoo0P003ooo0`003_oo1`003ooo0`0000Coo`00000001Ooo`<008co
o`00J_oo1P002ooo0P0000Coo`00003oo`<000;oo`<000_oo`@002Woo`04003ooooo0004ool00`00
ool000020003ool00`00ooooo`020002ool00`00ool000020003ool00`00ool00004ool00`00oooo
o`0700000ooo0000000500000ooo003oo`1Qool3000>ool4000>ool7000?ool300001?oo00000000
5_oo0`00R_oo001Wool300001?oo000000002ooo1@0000Goo`0000000?oo00@000_oo`@002Woo`80
0003ool0000000Coo`03003oo`00008000?oo`800004ool000000002ool00`00ool000020003ool0
0`00ool00003ool20003ool500000ooo003oo`0700000ooo003oo`1Sool2000?ool3000>ool8000?
ool300001?oo000000005_oo0`00Qooo001Uool6000<ool900000ooo00000002000<ool3000Zool2
00000ooo00000004ool00`00ool000020004ool01P00ooooo`00ool000;oo`03003oo`00008000Co
o`8000?oo`04003oooooool400000ooo003oo`0700001Ooo00000?oo0000IOoo0`003_oo10003_oo
1`004?oo0P000_oo0P005_oo0`00QOoo001Rool300001?oo000000003?oo100000?oo`0000000P00
00?oo`0000000P003?oo0`00:_oo0P000_oo0P001?oo1@001?oo00<00?ooool00P0000?oo`00ool0
0P0000Coo`00000000Coo`D000Coo`05003oo`00003oo`0200000ooo003oo`0300001Ooo003oo`00
ool00P00Iooo0P003ooo10003_oo1`003ooo0`0000?oo`0000005ooo0P00Pooo001Oool300001?oo
000000003Ooo100000?oo`0000001`003?oo0`00:ooo0P000_oo00<00?ooool00_oo1`000ooo00<0
0?ooool00P000_oo00<00?oo00000_oo0`001Ooo0`001Ooo00<00?oo00000P0000Coo`00ooooo`D0
0005ool00?oo003oo`02001Xool3000>ool4000>ool8000>ool300001?oo000000005_oo0P00POoo
001Mool300001?oo000000003Ooo2@0000?oo`0000000P003?oo1000:_oo0P000_oo0P001?oo1`00
0ooo00P00?ooool00?oo003oo`000_oo00<00?ooool00P0000?oo`00ool00ooo00<00?ooool01Ooo
00<00?oo00000P0000?oo`0000000_oo00D00?oo00000?oo00800003ool00?oo008006[oo`8000ko
o`D000koo`L000ooo`800004ool00000000Fool2001oool005_oo`H000koo`@00003ool000000080
0003ool00000008000coo`@002_oo`8000;oo`8000Coo`03003oo`0000800003ool00?oo00;oo`80
0007ool00000ool00?oo00000_oo00<00?ooool010001?oo00<00?ooool01Ooo00<00?oo00001@00
0_oo1@0000Koo`00ooooo`00ool2001[ool3000>ool4000>ool7000?ool300000ooo0000000Fool2
001mool005Woo`800003ool0000000ooo`@00003ool0000000800003ool00000008000goo`<002_o
o`8000?oo`03003ooooo00?oo`03003oo`0000800003ool00?oo00?oo`06003ooooo003oo`000_oo
00@00?ooool000;oo`@000Coo`03003ooooo00Goo`05003oo`00003oo`0200000ooo003oo`020000
1_oo00000000ool000;oo`04003oo`00001]ool2000>ool5000>ool6000@ool200000ooo0000000F
ool3001jool005Ooo`D000ooo`@00003ool0000000800003ool00000008000goo`800003ool00?oo
02[oo`8000;oo`8000Coo`H00003ool00?oo00?oo`04003ooooo0002ool01000ooooo`000_oo00@0
0?ooooooo`<000Coo`<000Coo`03003oo`0000800004ool00000ool200001?oo00000?oo0`0000Oo
o`00ooooo`00ool0001_ool3000=ool5000>ool6000@ool200001?oo000000005Ooo0`00N?oo001E
ool4000@ool40002ool30002ool3000>ool200000ooo003oo`0Yool20003ool20004ool600000ooo
003oo`03ool01000ooooo`000ooo00<00?oo00000ooo00@00?ooooooo`@000?oo`03003ooooo00Co
o`05003oo`00ool00002ool01@00ooooo`00ool01`0000?oo`00ool00P0000?oo`00ool0Kooo0P00
3ooo10003ooo1@004?oo0`0000?oo`0000005_oo0P00M_oo001Cool4000@ool40002ool30002ool3
000?ool01000ooooo`00:Ooo0P001?oo00<00?ooool00ooo00<00?oo00000`0000?oo`00ool00ooo
0P0000?oo`0000000_oo00@00?ooool000?oo`04003oooooool40003ool00`00ooooo`03ool20000
1?oo003oo`000_oo0P000_oo0P0000Coo`00003oo`D00005ool00000ool0001aool2000?ool4000?
ool6000@ool200000ooo0000000Fool2001dool0057oo`@000ooo`D000;oo`<000;oo`<000ooo`80
00;oo`03003ooooo02Koo`8000Coo`8000Coo`800003ool0000000@000Goo`04003ooooo0003ool0
1000ooooo`000ooo00T00?ooooooo`00ool00?oo00000_oo00<00?ooool00ooo00H00?ooool00?oo
0002ool20002ool20002ool200001Ooo00000?oo00000_oo0P0000?oo`00ool0LOoo0P003ooo1@00
3_oo1P004?oo1P005Ooo0P00L_oo001?ool4000?ool300001?oo00000?oo0`000_oo10003ooo0P00
0_oo00<00?ooool09Ooo0P001?oo0P001Ooo2@001Ooo00@00?ooool000Coo`04003ooooo0003ool0
1000oooooooo1P0000?oo`00ool00ooo0P0000Goo`00003oo`0000;oo`03003oo`0000;oo`8000;o
o`03003ooooo00800005ool00?ooool00002ool2001aool3000?ool5000>ool6000@ool6000Eool2
001`ool004goo`@0013oo`800004ool00000ool30002ool4000@ool01@00oooooooo00009_oo0`00
0ooo0P001_oo00<00?oo00001P001Ooo00@00?ooool000Goo`04003ooooo0003ool00`00ooooo`02
ool30002ool20003ool20002ool00`00ool00003ool01000ool000000_oo00<00?ooool00P000_oo
0P0000Goo`00ooooo`0000;oo`8007;oo`80013oo`800003ool0000000koo`H0017oo`800003ool0
000001Goo`<006goo`00Booo10004?oo0P0000Coo`00003oo`<000?oo`@000ooo`8000?oo`8002Go
o`8000Coo`8000Goo`800003ool0000000800003ool0000000Goo`04003ooooo0005ool90004ool0
1000ool000000_oo10000ooo0P0000?oo`00ool00_oo00@00?ooool000;oo`8000;oo`03003ooooo
00<00005ool00000ool00003ool00`00ooooo`1aool2000@ool200000ooo0000000>ool6000Aool5
000Eool3001[ool004Woo`@0017oo`04003ooooo0002ool30002ool4000@ool00`00ooooo`03ool0
0`00ooooo`0Rool20004ool20006ool200000ooo0000000200000ooo00000005ool00`00ooooo`02
0005ool01000oooooooo0P000ooo00D00?ooooooo`0000;oo`04003ooooo0006ool01000ool00000
0ooo00H00?ooooooo`00ool300000ooo00000002ool300001?oo00000?oo0P000_oo0P00Looo0P00
4?oo0P0000?oo`0000003_oo1P004Ooo0P0000Coo`00000001Coo`<006Woo`00A_oo0`0000?oo`00
00004?oo0P0000Coo`00003oo`<000;oo`800003ool00?oo013oo`03003ooooo00?oo`8002;oo`80
00Coo`8000Ooo`03003ooooo00@00003ool00?oo00Goo`05003oooooool00006ool01000oooooooo
0P000ooo00@00?ooooooo`800003ool00000008000Goo`04003ooooo0004ool00`00ooooo`02ool0
1@00ool00000ool00`000_oo0`0000Coo`00003oo`8000;oo`8007?oo`80017oo`800004ool00000
000=ool6000Aool200000ooo0000000Eool2001Xool004Coo`<00003ool00000013oo`800003ool0
000000;oo`8000;oo`800003ool0000001;oo`03003ooooo00?oo`03003ooooo01ooo`8000Coo`80
00Soo`03003oo`0000@00003ool00?oo00Goo`05003oooooool00007ool01000oooooooo0P000ooo
00<00?ooool00_oo00<00?ooool02@000_oo00<00?ooool00_oo00<00?ooool00_oo00@00?oo003o
o`800003ool00?oo00;oo`<00004ool00000ool20003ool00`00ooooo`1bool2000@ool300001?oo
000000003Ooo1`004?oo0P0000?oo`0000005Ooo0P00I_oo0012ool300000ooo0000000Aool40002
ool30002ool200000ooo0000000Bool00`00ooooo`03ool00`00ooooo`0Nool30003ool30007ool2
00000ooo0000000300000ooo003oo`04ool20003ool00`00ooooo`06ool01000oooooooo0P000ooo
00<00?ooool00ooo00<00?ooool01`000_oo00<00?ooool00ooo00<00?ooool00ooo0P000_oo00@0
0?ooool000?oo`<000;oo`04003ooooo0003ool2001dool2000@ool20003ool2000=ool200000ooo
00000002000@ool200000ooo0000000Eool2001Tool0047oo`800003ool00000017oo`800004ool0
0000ool30002ool20002ool00`00ooooo`0Aool00`00ooooo`04ool00`00ooooo`0Kool30004ool2
0009ool200000ooo000000020002ool00`00ooooo`03ool20003ool00`00ooooo`07ool01000oooo
oooo0P000ooo00<00?ooool01?oo00@00?ooool000Koo`03003ooooo00Coo`03003ooooo00Coo`03
003ooooo008000;oo`04003oooooool30002ool01000ooooo`000ooo0P00MOoo0P004?oo0P000ooo
0P003Ooo1P004?oo0P000_oo0P005Ooo0P00H_oo000oool200000ooo0000000Bool40002ool30002
ool200000ooo0000000Cool00`00ooooo`05ool00`00ooooo`0Hool30005ool20009ool20002ool4
00000ooo00000005ool20002ool20009ool20003ool20004ool00`00ooooo`03ool200000ooo003o
o`05ool00`00ooooo`03ool20006ool200001?oo003oo`000_oo00@00?ooooooo`<000;oo`03003o
oooo008000?oo`03003ooooo07?oo`80017oo`8000?oo`<000coo`H0013oo`8000;oo`8001Goo`80
063oo`00?Ooo0P000_oo0P004Ooo10000_oo0`000ooo00<00?ooool00P004ooo0P001ooo00<00?oo
ool05?oo10001Ooo0`002_oo0P0000?oo`0000000`0000?oo`0000001Ooo0P000_oo0P002_oo00<0
0?ooool00_oo0P001?oo00<00?ooool01Ooo0P001?oo0P001_oo00<00?ooool01Ooo0P000_oo0`00
0_oo00<00?ooool010000_oo00<00?ooool00P000ooo0P00MOoo0P004Ooo0P000ooo0P003Ooo1P00
4?oo0P0000Coo`00000001Goo`8005koo`00>ooo0`0000?oo`0000004_oo0`000ooo0P000ooo0P00
0_oo00<00?ooool04ooo00<00?ooool01_oo00<00?ooool04?oo1@001_oo0`002_oo0P0000?oo`00
0000100000?oo`0000001Ooo0P000_oo0P002ooo00<00?ooool00_oo0P001?oo0P001ooo1P001ooo
00<00?ooool01Ooo00L00?oo003oo`00ool00003ool00`00ooooo`040002ool20002ool01000oooo
oooo0P00M_oo0P004Ooo0P000ooo0P003Ooo1P004?oo0P0000?oo`0000005_oo0P00G?oo000jool2
00000ooo0000000Bool40003ool20003ool20002ool00`00ooooo`0Dool00`00ooooo`07ool00`00
ooooo`0<ool40008ool2000;ool20002ool50002ool20005ool20002ool2000<ool00`00ooooo`02
ool20005ool00`00ooooo`05ool00`00ooooo`0:ool00`00ooooo`05ool00`00ooooo`020002ool0
1@00oooooooo00000_oo0`000ooo0P000_oo00@00?ooooooo`8007Ooo`03003ooooo013oo`8000?o
o`03003ooooo00coo`D0013oo`<00003ool0000001Koo`8005[oo`00>?oo0P0000?oo`0000004ooo
10000ooo0P000ooo00D00?ooooooo`0001Ooo`03003ooooo00Soo`@000Goo`D000[oo`8000_oo`<0
0003ool0000000@000;oo`8000Goo`8000;oo`03003ooooo00coo`03003oo`0000;oo`8000Goo`03
003ooooo00Goo`03003ooooo00Woo`03003ooooo00Koo`04003oooooool20002ool01@00oooooooo
00000_oo0`000ooo0P000_oo0P000ooo00<00?ooool0MOoo0P004Ooo0P000ooo0P003_oo1@004?oo
0P000_oo0P005_oo0P00F?oo000fool200000ooo0000000Cool200000ooo003oo`02ool30003ool0
1@00oooooooo00006?oo00<00?ooool03?oo1@003Ooo0P003?oo0P0000Coo`00003oo`@000;oo`03
003ooooo00Coo`8000;oo`03003ooooo00goo`03003ooooo00@000Koo`03003ooooo00Coo`03003o
oooo00Woo`03003ooooo00Koo`03003ooooo00;oo`05003oooooool00003ool00`00ooooo`030003
ool20002ool20003ool2001gool2000Aool20002ool2000>ool6000@ool20002ool2000Fool2001F
ool003Goo`800003ool0000001?oo`04003ooooo0003ool30003ool01@00oooooooo00006Ooo00<0
0?ooool06_oo10003?oo0P000_oo1`000_oo00<00?ooool01?oo00D00?ooooooo`00013oo`03003o
oooo00;oo`8000Koo`03003ooooo00Coo`03003ooooo00Soo`03003ooooo00Ooo`03003ooooo00;o
o`8000?oo`05003oooooool00002ool30004ool01@00oooooooo00000ooo0P00N?oo00<00?ooool0
4?oo00@00?ooooooo`8000koo`H0013oo`8000;oo`8001Koo`8005Coo`00<ooo0P0000?oo`000000
4ooo0P0000?oo`0000000ooo0`000ooo00D00?ooooooo`0001[oo`8001Ooo`@000koo`8000;oo`80
0004ool00000ool20002ool00`00ooooo`04ool01@00oooooooo00004Ooo00<00?ooool00_oo0P00
1_oo0P001Ooo0`002?oo00<00?ooool01ooo00<00?ooool00_oo0`000ooo00D00?ooooooo`0000;o
o`@000?oo`05003oooooool00004ool00`00ooooo`1fool2000Aool20002ool2000?ool6000@ool2
00001?oo000000005_oo0P00D_oo000aool20002ool2000Cool00`00ooooo`020003ool20004ool0
1@00oooooooo00007?oo0P005?oo0P004?oo0`0000Coo`00003oo`D000;oo`8000Koo`03003ooooo
008001;oo`03003ooooo00?oo`03003ooooo00Goo`8000Coo`03003ooooo00Ooo`03003ooooo00So
o`03003ooooo00;oo`04003oo`000003ool01@00oooooooo00000_oo10000ooo00@00?ooooooo`80
00?oo`8007Soo`80017oo`04003oooooool2000>ool6000@ool20002ool2000Gool2001@ool0033o
o`8000;oo`03003ooooo01;oo`04003ooooo0004ool20004ool01@00oooooooo00007_oo0`002ooo
1`004Ooo0P000_oo0P0000Coo`00003oo`800003ool0000000Ooo`03003ooooo008001?oo`03003o
oooo00?oo`03003ooooo00Koo`8000?oo`03003ooooo00Koo`03003ooooo00Woo`03003ooooo00;o
o`03003ooooo008000?oo`05003oooooool00002ool40003ool01000oooooooo0P000ooo0P00NOoo
00<00?ooool03ooo0P000_oo0P003ooo1P004?oo0P000_oo0P005_oo0`00C_oo000^ool20002ool2
000Cool20002ool00`00ooooo`02ool20004ool00`00ooooo`02ool00`00ooooo`0Oool<000Eool2
0002ool200000ooo000000030002ool20007ool00`00ooooo`02000Dool00`00ooooo`03ool00`00
ooooo`07ool20002ool00`00ooooo`06ool00`00ooooo`09ool00`00ooooo`02ool01@00oooooooo
00001?oo00D00?ooooooo`0000?oo`<000?oo`8000?oo`03003ooooo00;oo`03003ooooo07Ooo`03
003ooooo013oo`04003oooooool2000>ool7000@ool20002ool2000Fool2001=ool002goo`8000;o
o`8001?oo`8000;oo`03003ooooo00;oo`8000Coo`03003ooooo00;oo`03003ooooo03ooo`8000;o
o`8000;oo`@000;oo`8000Soo`03003ooooo008001Goo`03003ooooo00?oo`03003ooooo00Soo`80
0003ool00?oo00Goo`8000coo`03003ooooo00;oo`03003ooooo00;oo`03003ooooo00;oo`05003o
ooooool00003ool40002ool20003ool00`00ooooo`02ool2001hool00`00ooooo`0@ool20002ool2
000?ool7000@ool20002ool2000Fool2001;ool002_oo`8000?oo`03003ooooo01;oo`8000;oo`03
003ooooo00;oo`8000Goo`05003oooooool00010ool30002ool200000ooo000000020003ool00`00
ooooo`06ool20002ool00`00ooooo`0Eool00`00ooooo`03ool00`00ooooo`0:ool8000>ool00`00
ooooo`02ool00`00ooooo`03ool00`00ooooo`02ool01@00oooooooo00000ooo10000_oo0P000ooo
0P000ooo0P00N?oo00<00?ooool04Ooo00@00?ooooooo`8000koo`L0013oo`8000?oo`8001Goo`80
04[oo`00:_oo0P000_oo0P005?oo0P000_oo00<00?ooool00_oo0P001Ooo00D00?ooooooo`0003oo
o`<000;oo`800003ool0000000<000;oo`8000Soo`8000;oo`03003ooooo01Koo`8000Goo`03003o
oooo00[oo`03003ooooo017oo`8000Coo`03003ooooo00Coo`03003ooooo00;oo`05003oooooool0
0003ool40002ool20003ool20004ool2001gool00`00ooooo`0Aool01000oooooooo0P003ooo00<0
0?oo000010004?oo0P000_oo0P005_oo0P00B?oo000Xool20003ool2000Dool20002ool00`00oooo
o`02ool20005ool01000oooooooo0P00?Ooo0P000ooo0P0000?oo`0000000`000_oo0P002?oo0P00
0ooo00<00?ooool06?oo00<00?ooool00ooo00<00?ooool02_oo00<00?ooool04Ooo00<00?ooool0
0ooo00<00?ooool01Ooo00<00?ooool00_oo00D00?ooooooo`0000?oo`@000?oo`03003ooooo00;o
o`03003ooooo00;oo`8007Ooo`03003ooooo017oo`8000?oo`03003ooooo00goo`800003ool00000
0080017oo`04003oooooool2000Eool20017ool002Ooo`03003ooooo00;oo`03003ooooo01?oo`05
003oooooool00004ool20006ool01@00oooooooo0000??oo0P000ooo20000ooo0P002?oo0P000_oo
0P006ooo00<00?ooool00ooo00<00?ooool02_oo00<00?ooool04?oo0P001Ooo00<00?ooool01_oo
00<00?ooool00_oo00D00?ooooooo`0000Coo`@000;oo`03003ooooo00;oo`03003ooooo00?oo`80
07Koo`03003ooooo017oo`8000?oo`8000ooo`03003oo`0000<0017oo`8000?oo`03003ooooo01Co
o`8004Goo`009_oo00@00?ooooooo`8001Goo`05003oooooool00005ool00`00ooooo`04ool00`00
ooooo`02ool00`00ooooo`0gool30003ool200000ooo000000030003ool20009ool01000oooooooo
0P007?oo00<00?ooool01?oo00<00?ooool02Ooo0`004?oo00<00?ooool01?oo00<00?ooool01_oo
0P001?oo00D00?ooooooo`0000Coo`@000;oo`8000?oo`8000Goo`8007Goo`03003ooooo017oo`80
00Coo`03003ooooo00goo`800003ool000000080017oo`04003oooooool2000Eool20014ool002Go
o`04003oooooool2000Eool01000oooooooo0P001?oo0P001Ooo00<00?ooool00ooo00<00?ooool0
=Ooo0`000ooo0P0000?oo`0000000`001?oo0P002?oo0P000ooo00<00?ooool07?oo00<00?ooool0
1?oo00<00?ooool02Ooo00<00?ooool04?oo00<00?ooool01?oo00<00?ooool01ooo0P001?oo00D0
0?ooooooo`0000Coo`@000;oo`8000?oo`8000Goo`8007Goo`03003ooooo017oo`8000Coo`03003o
oooo00koo`03003oo`0000<0017oo`8000;oo`8001Koo`03003ooooo047oo`009?oo00D00?oooooo
o`0001Koo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00?oo`03003ooooo00?oo`03003o
oooo03Coo`8000Coo`800003ool0000000@000?oo`8000Woo`8000;oo`8001ooo`03003ooooo00Go
o`03003ooooo00Soo`03003ooooo00ooo`03003ooooo00Coo`8000[oo`8000Coo`05003oooooool0
0004ool40003ool01000oooooooo0P001_oo0P00M?oo00<00?ooool04Ooo0P001?oo00<00?ooool0
3_oo1P004_oo00@00?ooooooo`8001Goo`80047oo`008ooo00<00?ooool00P005_oo00<00?ooool0
0_oo00<00?ooool00ooo0P001Ooo00<00?ooool00ooo00<00?ooool0<Ooo0`001?oo0P0000?oo`00
000010001?oo00<00?ooool01ooo0P000ooo0P008?oo00<00?ooool01Ooo00<00?ooool02?oo00<0
0?ooool03ooo00<00?ooool01?oo00<00?ooool02_oo0P001?oo00D00?ooooooo`0000Coo`D000;o
o`8000?oo`03003ooooo00Goo`8007?oo`03003ooooo01;oo`03003ooooo00;oo`80013oo`03003o
o`0000<0017oo`8000;oo`8001Koo`03003ooooo03koo`008Ooo0P000_oo0P005_oo0P000ooo00<0
0?ooool01?oo00<00?ooool01?oo00<00?ooool00ooo00<00?ooool0;ooo0`001?oo0P0000?oo`00
000010001?oo0P002Ooo0P000ooo00<00?ooool08?oo00<00?ooool01_oo00<00?ooool01ooo00<0
0?ooool03_oo0P001_oo00<00?ooool02ooo00<00?ooool00ooo00D00?ooooooo`0000Coo`D000;o
o`8000?oo`8000Ooo`8007;oo`03003ooooo01;oo`03003ooooo00;oo`80013oo`H001;oo`05003o
ooooool0000Fool2000nool0023oo`8000;oo`03003ooooo01Koo`03003ooooo00;oo`03003ooooo
00?oo`8000Koo`03003ooooo00Coo`03003ooooo02coo`8000Goo`800003ool0000000@000Coo`80
00[oo`04003oooooool2000Sool20008ool00`00ooooo`06ool00`00ooooo`0>ool00`00ooooo`05
ool00`00ooooo`0<ool00`00ooooo`03ool01@00oooooooo00001Ooo10000ooo0P000ooo0P001_oo
0P00L_oo00<00?ooool04_oo00<00?ooool00_oo0P004Ooo1@004_oo00@00?ooooooo`8001Goo`80
03goo`007ooo0P000_oo00<00?ooool05_oo0P000ooo00<00?ooool01?oo00<00?ooool01Ooo00<0
0?ooool01?oo0P00:_oo0`001Ooo0P0000?oo`0000001@001?oo0P002Ooo0P000ooo0P009Ooo00<0
0?ooool01_oo00<00?ooool01_oo00<00?ooool03Ooo0P001ooo00<00?ooool03Ooo00<00?ooool0
0ooo00D00?ooooooo`0000Goo`@000?oo`8000?oo`8000Ooo`80077oo`03003ooooo01;oo`03003o
oooo00;oo`80017oo`D001;oo`8000?oo`03003ooooo01Coo`8003_oo`007_oo0P000_oo00<00?oo
ool05ooo00<00?ooool00_oo00<00?ooool01?oo00<00?ooool01Ooo00<00?ooool01Ooo00<00?oo
ool09_oo0P001Ooo0`0000?oo`0000000P0000?oo`0000001?oo0P002_oo0P000ooo0P009_oo00<0
0?ooool01ooo00<00?ooool01Ooo00<00?ooool03Ooo00<00?ooool01_oo00<00?ooool03_oo00<0
0?ooool00ooo00@00?ooooooo`8000Coo`D000?oo`03003ooooo00;oo`8000Ooo`80073oo`03003o
oooo01;oo`03003ooooo00?oo`03003ooooo00ooo`H0017oo`8000?oo`8001Goo`8003[oo`007Ooo
0P000_oo0P006?oo00<00?ooool00_oo00<00?ooool01?oo0P001ooo00<00?ooool01_oo00<00?oo
ool08Ooo10001Ooo0`0000?oo`0000000P0000?oo`0000001?oo0P002_oo0P001?oo00<00?ooool0
9_oo00<00?ooool02?oo00<00?ooool01?oo00<00?ooool03?oo00<00?ooool01ooo00<00?ooool0
3ooo00<00?ooool00ooo00@00?ooooooo`8000Coo`D000?oo`8000Coo`03003ooooo00Koo`8006oo
o`03003ooooo01;oo`03003ooooo00?oo`03003ooooo00ooo`H001;oo`03003ooooo00;oo`03003o
oooo01Coo`8003Soo`007?oo0P000_oo0P006Ooo00<00?ooool00_oo00<00?ooool01?oo0P001ooo
00<00?ooool01ooo00<00?ooool06ooo1@001_oo0`000_oo100000?oo`0000001?oo0`002_oo0P00
0ooo0P00:_oo00<00?ooool02?oo00<00?ooool00ooo0`002ooo00<00?ooool01ooo00<00?ooool0
4Ooo00<00?ooool00ooo00@00?ooooooo`8000Coo`D000?oo`8000Coo`8000Ooo`8006koo`03003o
oooo01?oo`03003ooooo00?oo`03003ooooo00ooo`H001;oo`03003ooooo00;oo`8001Goo`8003Oo
o`006ooo0P000_oo0P006Ooo00<00?ooool00ooo00<00?ooool01?oo0P001ooo0P002Ooo0`005_oo
1@001ooo0`000_oo10000_oo0P001?oo0P003?oo00<00?ooool00_oo0P00:ooo00<00?ooool02Ooo
00<00?ooool00_oo00<00?ooool02_oo00<00?ooool02?oo00<00?ooool04_oo00<00?ooool00ooo
00<00?ooool00_oo00<00?ooool00ooo10001?oo00<00?ooool00ooo0P001ooo0P00KOoo00<00?oo
ool04ooo00<00?ooool00ooo0P004?oo1`004Ooo00<00?ooool00_oo0P005_oo00<00?ooool0=?oo
000Jool00`00ooooo`02ool00`00ooooo`0Hool00`00ooooo`02ool00`00ooooo`05ool20008ool0
0`00ooooo`09ool70008ool80009ool30003ool40002ool20004ool2000<ool20004ool00`00oooo
o`0/ool00`00ooooo`09ool20002ool00`00ooooo`08ool2000:ool2000Eool20004ool20003ool0
0`00ooooo`03ool50003ool20004ool20008ool2001[ool2000Eool00`00ooooo`03ool2000Aool6
000Aool20004ool2000Eool00`00ooooo`0cool001Woo`03003ooooo00;oo`03003ooooo01Soo`03
003ooooo00?oo`03003ooooo00Koo`03003ooooo00Ooo`03003ooooo00ooo`P000goo`@000Coo`@0
00;oo`8000Coo`8000goo`8000?oo`8002ooo`03003ooooo00[oo`@000Soo`8000coo`03003ooooo
01Goo`8000Coo`8000?oo`8000Coo`D000?oo`8000Goo`8000Soo`8006[oo`03003ooooo01Coo`03
003ooooo00?oo`80017oo`@00003ool00?oo013oo`8000Coo`8001Goo`03003ooooo03;oo`006?oo
00<00?ooool00_oo00<00?ooool06Ooo00<00?ooool00ooo00<00?ooool01_oo0P002Ooo00<00?oo
ool07ooo10001Ooo10000ooo0`000_oo0`003Ooo0P001?oo0P00<Ooo00<00?ooool03?oo2@003Ooo
0P006?oo0P001?oo0P000ooo0P001Ooo10001?oo0P001Ooo00<00?ooool01_oo0P00JOoo0P005Ooo
0P001_oo00<00?ooool03ooo100000?oo`00ool04Ooo00<00?ooool00ooo00<00?ooool04ooo0P00
<_oo000Gool00`00ooooo`02ool2000Kool00`00ooooo`03ool00`00ooooo`06ool2000:ool3000K
ool30005ool50004ool20003ool3000>ool20004ool00`00ooooo`0bool00`00ooooo`0;ool00`00
ooooo`0Cool00`00ooooo`0Hool20005ool00`00ooooo`02ool00`00ooooo`03ool40004ool20005
ool20008ool2001Xool00`00ooooo`0Dool00`00ooooo`05ool00`00ooooo`0?ool400000ooo003o
o`0Aool00`00ooooo`03ool2000Dool2000aool001Koo`03003ooooo00?oo`03003ooooo01[oo`03
003ooooo00?oo`8000Soo`8000coo`D000ooo`L000Coo`H000Coo`<000?oo`<000koo`8000Coo`80
03Goo`03003ooooo00_oo`03003ooooo01;oo`8001_oo`8000Goo`8000?oo`03003ooooo00?oo`D0
00Coo`03003ooooo00Coo`8000Soo`8006Koo`03003ooooo01Goo`03003ooooo00Coo`80017oo`@0
0003ool00?oo017oo`03003ooooo00Coo`03003ooooo01;oo`80033oo`005Ooo00<00?ooool00ooo
0P007?oo00<00?ooool01?oo00<00?ooool01ooo0P003ooo4@001ooo1P001?oo0`001?oo0P004?oo
0P000ooo0P00>?oo00<00?ooool02_oo00<00?ooool04_oo00<00?ooool06ooo0P001Ooo0P000ooo
0P001Ooo1@000ooo0P001Ooo0P002?oo0`00I?oo00<00?ooool05_oo00<00?ooool01?oo00<00?oo
ool04?oo1P004_oo0P001Ooo00<00?ooool04_oo0P00;ooo000Dool20005ool00`00ooooo`0Kool0
0`00ooooo`04ool00`00ooooo`08ool3000Rool50006ool20005ool2000@ool20003ool2000kool0
0`00ooooo`09ool00`00ooooo`0Aool00`00ooooo`0Nool00`00ooooo`03ool20003ool20005ool5
0003ool20006ool20009ool2001Sool00`00ooooo`0Eool20006ool00`00ooooo`0@ool6000Bool2
0005ool00`00ooooo`0Bool2000^ool001Coo`03003ooooo00?oo`03003ooooo01coo`03003ooooo
00Goo`03003ooooo00Soo`@001_oo`L000Koo`<000Goo`80013oo`8000Coo`8003coo`03003ooooo
00Woo`<0017oo`03003ooooo01ooo`03003ooooo00Coo`04003oooooool20006ool50003ool20006
ool00`00ooooo`08ool2001Qool00`00ooooo`0Fool00`00ooooo`05ool00`00ooooo`0@ool6000B
ool20005ool00`00ooooo`0Cool00`00ooooo`0[ool001?oo`03003ooooo00Coo`03003ooooo01co
o`03003ooooo00Koo`03003ooooo00Woo`H0017oo`T000Koo`@000Goo`<0013oo`8000Coo`8003oo
o`03003ooooo00Soo`03003ooooo013oo`03003ooooo027oo`03003ooooo00Coo`8000?oo`03003o
oooo00Coo`D000?oo`8000Koo`8000[oo`<005koo`03003ooooo01Ooo`03003ooooo00Coo`8001;o
o`D001?oo`8000Coo`8001Goo`03003ooooo02[oo`004_oo00<00?ooool01?oo00<00?ooool07Ooo
00<00?ooool01ooo00<00?ooool02ooo5`002Ooo10001_oo0`004?oo0P001?oo0P00@_oo00<00?oo
ool01ooo00<00?ooool03ooo00<00?ooool08ooo00<00?ooool01?oo0P000ooo00<00?ooool01?oo
1P000ooo0P001_oo0P002_oo0`00G?oo00<00?ooool05ooo00<00?ooool01Ooo00<00?ooool04Ooo
1@004ooo0P001?oo0P005Ooo00<00?ooool0:Ooo000Bool00`00ooooo`03ool00`00ooooo`0Oool0
0`00ooooo`07ool2000Wool40006ool4000Aool20005ool20014ool00`00ooooo`06ool00`00oooo
o`0=ool2000Wool00`00ooooo`04ool20003ool20006ool60003ool20005ool2000<ool2001Jool0
0`00ooooo`0Hool00`00ooooo`05ool00`00ooooo`0Aool5000Dool00`00ooooo`02ool2000Eool0
0`00ooooo`0Xool0017oo`03003ooooo00Coo`03003ooooo01ooo`03003ooooo00Soo`<001ooo`H0
00Koo`@001?oo`<000Coo`8004Ooo`8000Koo`03003ooooo00coo`8002Woo`03003ooooo00Goo`04
003oooooool20006ool60004ool20005ool2000<ool2001Hool00`00ooooo`0Hool00`00ooooo`05
ool2000Bool6000Dool00`00ooooo`02ool00`00ooooo`0Dool2000Xool0013oo`8000Goo`03003o
oooo027oo`03003ooooo00Woo`@001Soo`D000Ooo`@001Koo`8000Coo`8004_oo`8000Coo`03003o
oooo00_oo`03003ooooo02[oo`03003ooooo00Goo`8000?oo`03003ooooo00Goo`H000Coo`8000Go
o`8000coo`<005Goo`03003ooooo01Woo`03003ooooo00Goo`03003ooooo017oo`H001Coo`03003o
oooo00;oo`03003ooooo01Coo`8002Ooo`004?oo00<00?ooool01?oo00<00?ooool08_oo0P003?oo
2@001_oo2P002Ooo0`006?oo0P001Ooo0P00@?oo20001Ooo0`000_oo00<00?ooool02Ooo0P00;_oo
0P001_oo0P000ooo00<00?ooool01_oo0`0000?oo`00ool01?oo0P001Ooo0P003Ooo0`00DOoo0P00
6ooo00<00?ooool01Ooo00<00?ooool04_oo0`0000?oo`0000004ooo0P001?oo00<00?ooool05?oo
0P009_oo000?ool20006ool00`00ooooo`0Sool3000Bool8000?ool3000Iool20005ool20012ool2
0005ool00`00ooooo`05ool40009ool2000aool20006ool20003ool20007ool60005ool20005ool2
000>ool4001=ool00`00ooooo`0Jool00`00ooooo`06ool00`00ooooo`0Bool5000Dool00`00oooo
o`03ool00`00ooooo`0Dool2000Uool000ooo`03003ooooo00Goo`03003ooooo02Goo`8002?oo`D0
01[oo`8000Goo`8004Koo`03003ooooo00;oo`03003ooooo00Ooo`/003Coo`8000Ooo`04003ooooo
ool20007ool400000ooo00000004ool30005ool3000>ool4001:ool00`00ooooo`0Kool00`00oooo
o`05ool00`00ooooo`0Bool6000Dool00`00ooooo`03ool00`00ooooo`0Dool2000Tool000koo`80
00Koo`03003ooooo02Soo`8001_oo`L001coo`8000Koo`8004Soo`03003ooooo00coo`03003ooooo
03coo`8000Ooo`8000;oo`8000Soo`<00003ool0000000Goo`<000Koo`80013oo`<004Koo`03003o
oooo01coo`03003ooooo00Koo`03003ooooo01;oo`@00003ool00?oo01?oo`03003ooooo00?oo`03
003ooooo01Goo`03003ooooo027oo`003_oo00<00?ooool01Ooo00<00?ooool0:Ooo1`004Ooo1@00
8?oo0P001_oo0P00Booo00<00?ooool02ooo1000??oo0P001ooo0P000ooo0P001ooo100000?oo`00
00001Ooo0P001ooo0P004Ooo0`00@_oo00<00?ooool07Ooo00<00?ooool01_oo00<00?ooool04ooo
1P005?oo00<00?ooool00_oo0P005ooo00<00?ooool08?oo000>ool00`00ooooo`05ool00`00oooo
o`0_oolB000Sool30005ool2001>ool00`00ooooo`0:ool00`00ooooo`0nool20007ool20003ool2
0008ool400000ooo003oo`05ool20007ool3000Aool4000mool00`00ooooo`0Nool00`00ooooo`06
ool00`00ooooo`0Cool6000Dool20004ool2000Gool00`00ooooo`0Oool000koo`03003ooooo00Go
o`03003ooooo067oo`<000Koo`80057oo`03003ooooo00Woo`03003ooooo043oo`03003ooooo00Ko
o`03003ooooo00;oo`8000Ooo`@00003ool0000000Koo`8000Soo`8001?oo`<003Soo`80027oo`03
003ooooo00Koo`8001Goo`@00003ool00?oo01?oo`03003ooooo00?oo`8001Ooo`03003ooooo01ko
o`003_oo00<00?ooool01Ooo00<00?ooool0Gooo0`001_oo0P00Dooo0P002_oo00<00?ooool0@Ooo
00<00?ooool01_oo0P001?oo0P001ooo00D00?oo00000?oo008000Koo`8000Soo`8001Coo`@003?o
o`8002;oo`03003ooooo00Ooo`03003ooooo01?oo`L001Coo`03003ooooo00?oo`03003ooooo01Go
o`8001ooo`003_oo00<00?ooool01Ooo0P00GOoo0`001_oo0`00E_oo00<00?ooool02?oo00<00?oo
ool0@_oo00<00?ooool01ooo0P000ooo0`001_oo0P0000?oo`0000000P001ooo0P002?oo0`005Ooo
1@00;?oo0P009?oo00<00?ooool01ooo00<00?ooool05?oo100000?oo`00ool05?oo00<00?ooool0
0ooo00<00?ooool05Ooo0P007_oo000>ool00`00ooooo`06ool00`00ooooo`1Hool30007ool3001H
ool00`00ooooo`08ool00`00ooooo`13ool00`00ooooo`07ool20004ool20007ool200000ooo0000
00020007ool20009ool2000Hool7000Rool3000Vool00`00ooooo`07ool00`00ooooo`0Dool00`00
ool00004000Dool00`00ooooo`04ool00`00ooooo`0Eool00`00ooooo`0Lool000koo`03003ooooo
00Koo`03003ooooo05Koo`<000Ooo`8005Coo`03003ooooo00Coo`03003ooooo00Soo`03003ooooo
04Coo`8000Woo`8000Coo`8000Koo`P000Ooo`8000Woo`8001coo`D001Woo`H002Ooo`8000Woo`03
003ooooo01Coo`03003oo`0000800003ool00?oo01Coo`03003ooooo00Coo`03003ooooo01Goo`03
003ooooo01_oo`003_oo00<00?ooool01_oo00<00?ooool0Dooo0`001ooo0`00E_oo0P000ooo0P00
2ooo00<00?ooool0A_oo00<00?ooool01ooo0P001Ooo0P001_oo0P0000?oo`0000000`001_oo0`00
2Ooo0`007_oo2`001Ooo2P00;?oo00<00?ooool02?oo00<00?ooool05?oo1`005Ooo00<00?ooool0
1?oo00<00?ooool05_oo00<00?ooool06_oo000>ool00`00ooooo`07ool00`00ooooo`1?ool30008
ool3001Jool4000<ool00`00ooooo`17ool20009ool20004ool30006ool200001?oo00000?oo0P00
1ooo0P002_oo0P009ooo1P00=Ooo00<00?ooool02?oo00<00?ooool05Ooo1@0000?oo`00ool05?oo
00<00?ooool01?oo00<00?ooool05Ooo0P006ooo000>ool00`00ooooo`07ool00`00ooooo`1<ool3
0009ool2001]ool30019ool00`00ooooo`07ool20005ool20007ool200001?oo00000?oo0P001ooo
0`002Ooo0P00Gooo00<00?ooool02Ooo00<00?ooool05Ooo00<00?oo00000P0000?oo`00ool05?oo
00<00?ooool01Ooo00<00?ooool05Ooo0P006_oo000>ool00`00ooooo`08ool00`00ooooo`19ool3
0008ool3001_ool00`00ooooo`1:ool20009ool20005ool20007ool500000ooo00000008ool30008
ool3001Kool00`00ooooo`0:ool00`00ooooo`0Eool00`00ool00005000Eool00`00ooooo`04ool0
0`00ooooo`0Fool00`00ooooo`0Hool000ooo`03003ooooo00Soo`03003ooooo04Goo`<000Woo`<0
077oo`03003ooooo04coo`03003ooooo00Ooo`8000Koo`8000Ooo`D00004ool000000007ool30009
ool4001Fool2000;ool2000Gool300001Ooo00000?oo00005Ooo00<00?ooool01Ooo00<00?ooool0
5_oo00<00?ooool05ooo000?ool00`00ooooo`09ool20012ool3000:ool2001dool00`00ooooo`1=
ool20009ool20005ool30007ool500001?oo000000002?oo0`002_oo1000D_oo00<00?ooool02_oo
00<00?ooool05ooo00<00?oo00000P0000?oo`00ool05Ooo00<00?ooool01Ooo00<00?ooool05_oo
00<00?ooool05_oo000?ool2000;ool2000mool4000:ool3001fool00`00ooooo`1?ool00`00oooo
o`08ool00`00ooooo`04ool20008ool500001?oo000000002Ooo0P003?oo1000COoo00<00?ooool0
2ooo00<00?ooool05ooo00<00?oo00000P0000?oo`00ool05Ooo00<00?ooool01Ooo00<00?ooool0
5_oo00<00?ooool05_oo000@ool00`00ooooo`0;ool2000hool3000;ool3001iool00`00ooooo`1@
ool20009ool20006ool20008ool40003ool20009ool3000=ool30018ool2000=ool2000Iool00`00
ool0000200000ooo003oo`0Eool20007ool00`00ooooo`0Fool00`00ooooo`0Eool0017oo`03003o
oooo00_oo`<003;oo`@000_oo`<007coo`03003ooooo05;oo`03003ooooo00Soo`8000Koo`8000So
o`@000?oo`8000[oo`<000goo`@004?oo`03003ooooo00goo`03003ooooo01Soo`03003oo`0000@0
01Ooo`03003ooooo00Goo`03003ooooo01Koo`03003ooooo01Goo`004_oo00<00?ooool03?oo1@00
:?oo1P003Ooo0`00O_oo00<00?ooool0Dooo0P002Ooo0P001_oo0`002?oo1@000_oo0P002ooo0`00
3_oo1000?Ooo0P003ooo00<00?ooool06Ooo00D00?oo00000?oo00<001Koo`03003ooooo00Goo`80
01Soo`03003ooooo01Coo`004ooo00<00?ooool03ooo0`008Ooo1P003ooo0`00POoo00<00?ooool0
EOoo00<00?ooool02?oo0P001_oo0P002Ooo1P0000Coo`00000000[oo`@000ooo`@003Koo`<0013o
o`03003ooooo01[oo`08003oo`00003oo`00ool001Koo`03003ooooo00Koo`03003ooooo01Ooo`03
003ooooo01?oo`005?oo00<00?ooool04?oo1`005?oo1`004_oo0`00Q?oo0`00E_oo0P002Ooo0P00
1ooo0P002Ooo1P0000Coo`00000000_oo`<0017oo`D002koo`@001;oo`03003ooooo01Woo`800004
ool000000002ool00`00ooooo`0Dool20007ool00`00ooooo`0Gool2000Dool001Goo`8001Oooa@0
01Goo`@008Ooo`03003ooooo05Soo`03003ooooo00Soo`8000Ooo`8000Woo`X000coo`<001?oo`L0
02Goo`<001Coo`03003ooooo01[oo`03003ooooo00<00003ool00?oo01Ooo`03003ooooo00Goo`80
01Woo`03003ooooo01;oo`005_oo0`00>_oo1000Rooo00<00?ooool0FOoo0P002Ooo0P001ooo0`00
2Ooo1`0000?oo`0000003Ooo10005_oo1@006Ooo1`005Ooo0P007Ooo00<00?ooool00`0000?oo`00
ool05ooo00<00?ooool01_oo00<00?ooool06?oo00<00?ooool04Ooo000Hool3000dool4002?ool0
0`00ooooo`1Kool00`00ooooo`08ool20008ool20008ool;000>ool5000GoolI000Jool2000Oool0
0`00ool0000300000ooo003oo`0Gool00`00ooooo`06ool2000Iool00`00ooooo`0Aool001[oo`H0
02[oo`D009?oo`03003ooooo05coo`8000Woo`8000Woo`8000Soo`/0013oo`D004Coo`<001ooo`80
0007ool00000ool00?oo00006?oo00<00?ooool01ooo00<00?ooool06?oo00<00?ooool04?oo000O
ool4000Qool6002Hool00`00ooooo`1Nool00`00ooooo`08ool20009ool20009ool;000Aool5000n
ool3000Qool00`00ooooo`0300000ooo0000000Iool00`00ooooo`06ool00`00ooooo`0Hool00`00
ooooo`0@ool002?oo`L000koo`d009goo`03003ooooo05ooo`8000[oo`8000Woo`<000Woo`X001?o
o`H003Ooo`<002;oo`03003ooooo00@00003ool00?oo01Woo`03003ooooo00Koo`03003ooooo01Wo
o`03003ooooo00ooo`00:_oo3`00ZOoo00<00?ooool0HOoo00<00?ooool02?oo0`002Ooo0`002_oo
2P005_oo1`00;Ooo10008ooo0P0000?oo`0000000P0000?oo`0000006_oo00<00?ooool01_oo0P00
6_oo00<00?ooool03ooo003Rool00`00ooooo`1Rool2000;ool2000:ool2000;ool:000Jool7000Q
ool6000Vool00`00ooooo`0400000ooo003oo`0Iool00`00ooooo`08ool00`00ooooo`0Hool00`00
ooooo`0?ool00>;oo`<006Coo`8000_oo`8000[oo`8000coo`X001koo`D001Goo`P002[oo`05003o
oooo003oo`0200000ooo0000000Jool00`00ooooo`08ool00`00ooooo`0Hool2000@ool00>;oo`03
003ooooo06Goo`8000coo`8000[oo`8000coo`X0027ooaH0033oo`05003ooooo003oo`020002ool0
0`00ooooo`0Iool00`00ooooo`08ool00`00ooooo`0Iool00`00ooooo`0>ool00>;oo`03003ooooo
06Ooo`8000coo`8000[oo`<000coo`X006?oo`05003ooooo003oo`020002ool00`00ooooo`0Jool0
0`00ooooo`08ool00`00ooooo`0Iool00`00ooooo`0>ool00>;oo`03003ooooo06Woo`8000coo`80
00_oo`8000goo`X005ooo`05003ooooo003oo`020003ool00`00ooooo`0Jool00`00ooooo`08ool0
0`00ooooo`0Iool2000?ool00>;oo`03003ooooo06_oo`8000coo`8000_oo`8000koo`/005[oo`03
003oo`0000<00005ool00?ooool0000Lool2000:ool00`00ooooo`0Jool00`00ooooo`0=ool00>;o
o`03003ooooo06goo`8000coo`<000[oo`8000ooo`L00003ool00000008005Coo`800003ool00000
00@00003ool0000001goo`03003ooooo00Woo`03003ooooo01[oo`03003ooooo00goo`00h_oo00<0
0?ooool0Kooo0P003?oo0`002_oo0`003ooo3000Cooo0P0000Coo`00003oo`@00003ool00?oo01ko
o`03003ooooo00Woo`03003ooooo01[oo`03003ooooo00goo`00h_oo00<00?ooool0LOoo0P003Ooo
0P002_oo0`004?oo3@00BOoo2P000_oo00<00?ooool07_oo00<00?ooool02?oo0P007?oo00<00?oo
ool03Ooo003Rool00`00ooooo`1cool2000=ool2000;ool2000Bool=0012ool;0003ool00`00oooo
o`0Nool00`00ooooo`09ool00`00ooooo`0Kool00`00ooooo`0=ool00>;oo`03003ooooo07Coo`<0
00goo`8000_oo`8001?oo`@00003ool0000000T003Soo`@000;oo`L000?oo`80023oo`8000_oo`03
003ooooo01_oo`03003ooooo00goo`00h_oo0`00M_oo0P003_oo0P002ooo0P005Ooo100000?oo`00
00002P00<?oo0`000ooo20000ooo0P008_oo00<00?ooool02Ooo0P007Ooo00<00?ooool03Ooo003R
ool00`00ooooo`1hool2000>ool2000;ool3000Fool400000ooo0000000<000Tool60004ool80002
ool3000Sool00`00ooooo`0:ool00`00ooooo`0Lool00`00ooooo`0=ool00>;oo`03003ooooo07[o
o`8000koo`8000coo`<001Oooah000[oo``000Coo`T000Coo`<002Coo`8000_oo`8001koo`03003o
oooo00goo`00h_oo00<00?ooool0O?oo0P003_oo0`003?oo0`006Ooo5@000ooo30001Ooo300000Co
o`00000000;oo`H002Koo`03003ooooo00[oo`03003ooooo01goo`03003ooooo00goo`00h_oo00<0
0?ooool0O_oo0P003_oo0`003Ooo0`006ooo<@0000?oo`0000000P00:ooo00<00?ooool02_oo0P00
7ooo00<00?ooool03Ooo003@ool6000<ool00`00ooooo`20ool2000?ool3000=ool3000Oool70000
0ooo0000000H0004ool5000]ool2000=ool00`00ooooo`0Nool00`00ooooo`0=ool00=3oo`03003o
oooo00?oo`03003ooooo00Woo`03003ooooo08;oo`80013oo`<000goo`<002;oob40033oo`03003o
oooo00coo`03003ooooo01ooo`03003ooooo00goo`00eooo00<00?ooool02?oo00<00?ooool0Q?oo
0P004Ooo0`003Ooo1000KOoo0P003_oo0P008Ooo00<00?ooool03Ooo003Gool00`00ooooo`08ool0
0`00ooooo`25ool3000Bool3000=ool5001Xool2000?ool00`00ooooo`0Oool2000?ool00=Ooo`03
003ooooo00Soo`@008Ooo`8001?oo`@000goo`D006;oo`80013oo`03003ooooo023oo`03003ooooo
00koo`00e_oo00<00?ooool02Ooo00<00?ooool0R_oo0`004ooo10003_oo1@00G?oo0P004Ooo00<0
0?ooool08Ooo00<00?ooool03_oo003Cool4000;ool00`00ooooo`2=ool2000Dool4000?ool5001E
ool3000Bool00`00ooooo`0Qool00`00ooooo`0?ool00=Goo`03003ooooo00[oo`03003ooooo08oo
o`<001Goo`<0013oo`D004ooo`8001Coo`03003ooooo02;oo`03003ooooo00ooo`00e_oo00<00?oo
ool02Ooo00<00?ooool0T_oo0P005_oo0`004_oo1000B?oo0`005Ooo00<00?ooool08_oo0P004Ooo
003Fool00`00ooooo`09ool00`00ooooo`2Dool3000Fool3000Cool40012ool2000Fool2000Uool0
0`00ooooo`0@ool00=Koo`03003ooooo00Woo`03003ooooo09Ooo`8001Ooo`<001Coo`@003Woo`D0
01Ooo`8002Goo`8001;oo`00d?oo0P000ooo00<00?ooool02_oo00<00?ooool0VOoo0`005ooo0`00
5Ooo1P00;ooo1@006Ooo0P009ooo00<00?ooool04Ooo003Bool3000=ool00`00ooooo`2Lool2000H
ool4000Gool>000Jool7000Lool2000Xool2000Cool00>;oo`<009koo`<001Woo`@0023ooa`0023o
o`<002Woo`03003ooooo01;oo`00h_oo00<00?ooool0XOoo0P006ooo1000E_oo0P00:ooo00<00?oo
ool04ooo003Rool00`00ooooo`2Sool3000Lool4001>ool4000/ool00`00ooooo`0Dool00>;oo`03
003ooooo0:Koo`8001koo`@004Koo`@002ooo`03003ooooo01Goo`00h_oo00<00?ooool0Z?oo0`00
7ooo1`00??oo0`00<_oo00<00?ooool05_oo003Rool00`00ooooo`2[ool2000Sool:000^ool5000d
ool00`00ooooo`0Gool00>;oo`03003ooooo0:goo`<002Woo`/001[oo`/003Ooo`03003ooooo01So
o`00h_oo00<00?ooool0/?oo1000<?oo6P00@?oo0P006ooo003Rool00`00ooooo`2dool30025ool3
000Lool00>;oo`<00;Ooo`@0083oo`8001koo`00h_oo00<00?ooool0^ooo0`00Nooo0P008?oo003R
ool00`00ooooo`2nool4001eool2000Rool00>;oo`03003ooooo0<;oo`@006ooo`8002Coo`00h_oo
00<00?ooool0a_oo1000JOoo0P009_oo003Rool00`00ooooo`3:ool5001Qool3000Xool00>;oo`03
003ooooo0<ooo`D005Woo`<002_oo`00h_oo00<00?ooool0e?oo1000D_oo0`00;_oo003Rool00`00
ooooo`3Hool70017ool4000aool00>;oo`03003ooooo0=ooo`L003coo`@003Goo`00h_oo0`00i_oo
1000<Ooo2000>?oo003Rool00`00ooooo`3Zool=000Mool8000oool00>;oo`03003ooooo0?Oooah0
04Koo`00h_oo00<00?ooool0ooooG?oo003Rool00`00ooooo`3ooomLool00>;oo`03003ooooo0?oo
oecoo`00h_oo00<00?ooool0ooooG?oo003Rool00`00ooooo`3ooomLool00>;oo`03003ooooo0?oo
oecoo`00h_oo0`00ooooG?oo003Rool00`00ooooo`3ooomLool00001\
\>"],
  ImageRangeCache->{{{0, 575}, {354.875, 0}} -> {-2.65254, -3.83553, 
  0.0234687, 0.0432317}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Plot[\ 3  x^2 + Log[\((Pi - x)\)^2]/Pi^4 + 1, \ {x, 0, 2  Pi}]; \)\)],
   "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.151576 0.0147151 0.00492726 [
[.17539 .00222 -3 -9 ]
[.17539 .00222 3 0 ]
[.32696 .00222 -3 -9 ]
[.32696 .00222 3 0 ]
[.47854 .00222 -3 -9 ]
[.47854 .00222 3 0 ]
[.63011 .00222 -3 -9 ]
[.63011 .00222 3 0 ]
[.78169 .00222 -3 -9 ]
[.78169 .00222 3 0 ]
[.93327 .00222 -3 -9 ]
[.93327 .00222 3 0 ]
[.01131 .11326 -12 -4.5 ]
[.01131 .11326 0 4.5 ]
[.01131 .21181 -12 -4.5 ]
[.01131 .21181 0 4.5 ]
[.01131 .31035 -12 -4.5 ]
[.01131 .31035 0 4.5 ]
[.01131 .4089 -12 -4.5 ]
[.01131 .4089 0 4.5 ]
[.01131 .50744 -18 -4.5 ]
[.01131 .50744 0 4.5 ]
[.01131 .60599 -18 -4.5 ]
[.01131 .60599 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.17539 .01472 m
.17539 .02097 L
s
[(1)] .17539 .00222 0 1 Mshowa
.32696 .01472 m
.32696 .02097 L
s
[(2)] .32696 .00222 0 1 Mshowa
.47854 .01472 m
.47854 .02097 L
s
[(3)] .47854 .00222 0 1 Mshowa
.63011 .01472 m
.63011 .02097 L
s
[(4)] .63011 .00222 0 1 Mshowa
.78169 .01472 m
.78169 .02097 L
s
[(5)] .78169 .00222 0 1 Mshowa
.93327 .01472 m
.93327 .02097 L
s
[(6)] .93327 .00222 0 1 Mshowa
.125 Mabswid
.05412 .01472 m
.05412 .01847 L
s
.08444 .01472 m
.08444 .01847 L
s
.11476 .01472 m
.11476 .01847 L
s
.14507 .01472 m
.14507 .01847 L
s
.2057 .01472 m
.2057 .01847 L
s
.23602 .01472 m
.23602 .01847 L
s
.26633 .01472 m
.26633 .01847 L
s
.29665 .01472 m
.29665 .01847 L
s
.35728 .01472 m
.35728 .01847 L
s
.38759 .01472 m
.38759 .01847 L
s
.41791 .01472 m
.41791 .01847 L
s
.44822 .01472 m
.44822 .01847 L
s
.50885 .01472 m
.50885 .01847 L
s
.53917 .01472 m
.53917 .01847 L
s
.56948 .01472 m
.56948 .01847 L
s
.5998 .01472 m
.5998 .01847 L
s
.66043 .01472 m
.66043 .01847 L
s
.69074 .01472 m
.69074 .01847 L
s
.72106 .01472 m
.72106 .01847 L
s
.75138 .01472 m
.75138 .01847 L
s
.81201 .01472 m
.81201 .01847 L
s
.84232 .01472 m
.84232 .01847 L
s
.87264 .01472 m
.87264 .01847 L
s
.90295 .01472 m
.90295 .01847 L
s
.96358 .01472 m
.96358 .01847 L
s
.9939 .01472 m
.9939 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .11326 m
.03006 .11326 L
s
[(20)] .01131 .11326 1 0 Mshowa
.02381 .21181 m
.03006 .21181 L
s
[(40)] .01131 .21181 1 0 Mshowa
.02381 .31035 m
.03006 .31035 L
s
[(60)] .01131 .31035 1 0 Mshowa
.02381 .4089 m
.03006 .4089 L
s
[(80)] .01131 .4089 1 0 Mshowa
.02381 .50744 m
.03006 .50744 L
s
[(100)] .01131 .50744 1 0 Mshowa
.02381 .60599 m
.03006 .60599 L
s
[(120)] .01131 .60599 1 0 Mshowa
.125 Mabswid
.02381 .03935 m
.02756 .03935 L
s
.02381 .06399 m
.02756 .06399 L
s
.02381 .08862 m
.02756 .08862 L
s
.02381 .1379 m
.02756 .1379 L
s
.02381 .16253 m
.02756 .16253 L
s
.02381 .18717 m
.02756 .18717 L
s
.02381 .23644 m
.02756 .23644 L
s
.02381 .26108 m
.02756 .26108 L
s
.02381 .28571 m
.02756 .28571 L
s
.02381 .33499 m
.02756 .33499 L
s
.02381 .35962 m
.02756 .35962 L
s
.02381 .38426 m
.02756 .38426 L
s
.02381 .43353 m
.02756 .43353 L
s
.02381 .45817 m
.02756 .45817 L
s
.02381 .4828 m
.02756 .4828 L
s
.02381 .53208 m
.02756 .53208 L
s
.02381 .55671 m
.02756 .55671 L
s
.02381 .58135 m
.02756 .58135 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .01976 m
.02499 .01976 L
.02605 .01976 L
.02729 .01977 L
.02846 .01977 L
.03053 .01979 L
.03279 .01981 L
.03527 .01984 L
.0379 .01988 L
.04262 .01998 L
.04749 .02011 L
.05205 .02027 L
.06244 .02071 L
.07305 .02131 L
.08274 .02198 L
.10458 .02394 L
.12357 .02614 L
.14429 .02907 L
.18493 .03642 L
.22406 .0455 L
.26565 .05731 L
.30571 .0708 L
.34426 .08571 L
.38527 .10367 L
.42475 .123 L
.46273 .14344 L
.50315 .16708 L
.54206 .19231 L
.58342 .22106 L
.62326 .25082 L
.66159 .28135 L
.70238 .31592 L
.74164 .35121 L
.77939 .38701 L
.8196 .42715 L
.85828 .46774 L
.89942 .51302 L
.93905 .55868 L
.97619 .60332 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000900001Ha000`40n007h00Ooooooooo@_oo003o
oooooom2ool00?oooooood;oo`00oooooooo@_oo003ooooooom2ool00?oooooood;oo`00N_oo2000
B_oo2000B_oo1P00Cooo1P00Booo1@00C_oo10009Ooo001nool00`00ooooo`1;ool20005ool00`00
ooooo`18ool00`00ooooo`03ool00`00ooooo`1?ool00`00ooooo`1:ool00`00ooooo`03ool00`00
ooooo`1:ool20003ool00`00ooooo`0Rool007koo`03003ooooo04goo`03003ooooo00;oo`03003o
oooo04ooo`03003ooooo04koo`03003ooooo057oo`03003ooooo04Woo`03003ooooo00?oo`03003o
oooo027oo`00O_oo00<00?ooool0C_oo00<00?ooool0Dooo00<00?ooool0BOoo2000DOoo00<00?oo
ool0B?oo00<00?ooool01?oo00<00?ooool08Ooo001nool00`00ooooo`1?ool00`00ooooo`1Bool0
0`00ooooo`19ool00`00ooooo`02ool00`00ooooo`1Aool00`00ooooo`18ool00`00ooooo`04ool0
0`00ooooo`0Qool007koo`03003ooooo053oo`03003ooooo053oo`03003ooooo04_oo`05003ooooo
ool0001Cool00`00ooooo`18ool20004ool2000Sool007koo`03003ooooo057oo`03003ooooo04co
o`@004goo`05003oooooool0001=ool00`00ooooo`02ool00`00ooooo`19ool00`00ool00003ool0
0`00ooooo`0Rool007koo`03003ooooo057oo`8004ooo`03003ooooo04goo`04003ooooo001=ool5
001<ool00`00ooooo`03000Uool007koo`03003ooooo05;oo`03003ooooo04koo`03003ooooo04co
o`04003ooooo001=ool00`00ooooo`1>ool00`00ooooo`0Xool007koo`03003ooooo05;oo`03003o
oooo04koo`03003ooooo04goo`03003oo`0004goo`03003ooooo04ooo`03003ooooo02Ooo`00:ooo
00<00?ooool0C?oo00D00?ooooooo`0004goo`03003ooooo00Coo`03003ooooo04koo`03003ooooo
04goo`03003oo`0004goo`03003ooooo04ooo`8002Soo`00:ooo00<00?ooool0COoo1000COoo0P00
0ooo0P00Booo0P000ooo00<00?ooool0Cooo0P00COoo00<00?ooool0D?oo0P009ooo000[ool00`00
ooooo`1?ool2001?ool4001>ool3001Bool2001=ool6001?ool4000Sool002_oo`03003ooooo0?oo
oooooaCoo`00:ooo00<00?ooool0oooooooo5?oo000[ool00`00ooooo`3ooooooolDool002_oo`03
003ooooo0?oooooooaCoo`00:ooo00<00?ooool0oooooooo5?oo000Noooo003o000R0002ool002_o
o`03003ooooo00koo`03003ooooo00goo`03003ooooo00koo`03003ooooo00goo`03003ooooo00ko
o`03003ooooo00goo`03003ooooo00koo`03003ooooo00goo`03003ooooo00koo`03003ooooo00go
o`03003ooooo00goo`03003ooooo00koo`03003ooooo00goo`03003ooooo00koo`03003ooooo00go
o`03003ooooo00koo`03003ooooo00goo`03003ooooo00koo`03003ooooo00goo`03003ooooo00ko
o`03003ooooo00goo`03003ooooo00koo`03003ooooo00goo`03003ooooo00goo`03003ooooo00ko
o`03003ooooo00goo`03003ooooo00koo`03003ooooo00goo`03003ooooo00koo`03003ooooo00go
o`03003ooooo00koo`03003ooooo00goo`03003ooooo00?oo`00:ooo00<00?ooool03_oo00<00?oo
ool03Ooo00<00?ooool03_oo00<00?ooool03Ooo00<00?ooool03_oo00<00?ooool03Ooo00<00?oo
ool03_oo00<00?ooool03Ooo00<00?ooool03_oo00<00?ooool03Ooo00<00?ooool03Ooo00<00?oo
ool03_oo00<00?ooool03Ooo00<00?ooool03_oo00<00?ooool03Ooo00<00?ooool03_oo00<00?oo
ool03Ooo00<00?ooool03_oo00<00?ooool03Ooo00<00?ooool03_oo00<00?ooool03Ooo00<00?oo
ool03_oo00<00?ooool03Ooo00<00?ooool03Ooo00<00?ooool03_oo00<00?ooool03Ooo00<00?oo
ool03_oo00<00?ooool03Ooo00<00?ooool03_oo00<00?ooool03Ooo00<00?ooool03_oo00<00?oo
ool03Ooo00<00?ooool00ooo000[oolC0010ool00`00ooooo`1?ool00`00ooooo`1?ool00`00oooo
o`1@ool00`00ooooo`1?ool00`00ooooo`1?ool00`00ooooo`0Tool002_oo`03003ooooo013ooa@0
02coo`03003ooooo04ooo`03003ooooo04ooo`03003ooooo053oo`03003ooooo04ooo`03003ooooo
04ooo`03003ooooo02Coo`00:ooo00<00?ooool08ooo2@00ooooiooo000[ool00`00ooooo`0/ool6
003ooooQool002_oo`03003ooooo03;oo`P00?ooomWoo`00:ooo00<00?ooool0>_oo2000oooodOoo
000[ool00`00ooooo`12ool6003oooo;ool002_oo`03003ooooo04Soo`D00?ooolKoo`00:ooo00<0
0?ooool0COoo1P00oooo`?oo000[ool00`00ooooo`1Cool5003ooonkool002_oo`03003ooooo05So
o`@00?oookOoo`00:ooo0`00G?oo1000oooo/ooo000[ool00`00ooooo`1Pool4003ooon_ool002_o
o`03003ooooo06Coo`@00?oooj_oo`00:ooo00<00?ooool0J?oo1000ooooYooo000[ool00`00oooo
o`1/ool4003ooonSool002_oo`03003ooooo06ooo`@00?oooj3oo`00:ooo00<00?ooool0Looo0`00
ooooWOoo000[ool00`00ooooo`1fool3003ooonJool002_oo`03003ooooo07Woo`@00?oooiKoo`00
:ooo00<00?ooool0O?oo1000ooooTooo000[ool00`00ooooo`20ool3003ooon@ool002_oo`03003o
oooo08?oo`<00?ooohgoo`00:ooo00<00?ooool0Q_oo0`00ooooR_oo000[ool30029ool3003ooon7
ool002_oo`03003ooooo08coo`<00?ooohCoo`00:ooo00<00?ooool0Sooo0`00ooooPOoo000[ool0
0`00ooooo`2Bool3003ooomnool002_oo`03003ooooo09Goo`<00?ooog_oo`00:ooo00<00?ooool0
V?oo0`00ooooN?oo000[ool00`00ooooo`2Jool3003ooomfool002_oo`03003ooooo09goo`<00?oo
og?oo`00:ooo00<00?ooool0X?oo0P00ooooLOoo000[ool00`00ooooo`2Rool3003ooom^ool002_o
o`03003ooooo0:Goo`<00?ooof_oo`00:ooo00<00?ooool0Yooo0`00ooooJOoo000[ool00`00oooo
o`2Zool3003ooomVool002_oo`03003ooooo0:goo`800?ooofCoo`00:ooo0`00[ooo0P00ooooH_oo
000[ool00`00ooooo`2aool3003ooomOool002_oo`03003ooooo0;?oo`<00?oooegoo`00:ooo00<0
0?ooool0]_oo0P00ooooFooo000[ool00`00ooooo`2hool3003ooomHool002_oo`03003ooooo0;[o
o`<00?oooeKoo`00:ooo00<00?ooool0_Ooo0P00ooooE?oo000[ool00`00ooooo`2oool2003ooomB
ool002_oo`03003ooooo0<7oo`<00?ooodooo`003ooo20001_oo10002_oo00<00?ooool0`ooo0`00
ooooCOoo000?ool20005ool00`00ooooo`03ool20003ool00`00ooooo`07ool00`00ooooo`36ool2
003ooom;ool0017oo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo00;oo`8000Soo`03003o
oooo0<Soo`800?ooodWoo`004_oo00<00?ooool01_oo00<00?ooool01?oo00<00?ooool01_oo00<0
0?ooool0b_oo0P00ooooAooo000Cool00`00ooooo`05ool00`00ooooo`04ool00`00ooooo`06ool5
003:ool2003ooom5ool001Coo`03003ooooo00Coo`03003ooooo00Coo`03003ooooo00Koo`03003o
oooo0<koo`800?oood?oo`005Ooo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool01_oo00<0
0?ooool0d?oo0P00oooo@Ooo000Eool20004ool00`00ooooo`04ool00`00ooooo`06ool00`00oooo
o`3Bool2003oooloool001Koo`03003ooooo00;oo`03003ooooo00Coo`03003ooooo00Koo`03003o
oooo0=Coo`<00?oooccoo`005_oo00<00?ooool00_oo0P001Ooo00<00?ooool01_oo00<00?ooool0
e_oo0`00oooo>_oo000?ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`02ool00`00oooo
o`07ool00`00ooooo`3Hool2003oooliool000ooo`8000?oo`8000Koo`8000?oo`03003ooooo00Oo
o`03003ooooo0=[oo`800?ooocOoo`004Ooo10002?oo10002_oo00<00?ooool0g?oo0P00oooo=Ooo
000[ool00`00ooooo`3Nool2003ooolcool002_oo`03003ooooo0>3oo`800?oooc7oo`00:ooo00<0
0?ooool0h_oo0P00oooo;ooo000[ool00`00ooooo`3Tool2003oool]ool002_oo`<00>Koo`800?oo
ob_oo`00:ooo00<00?ooool0j?oo0P00oooo:Ooo000[ool00`00ooooo`3Zool2003ooolWool002_o
o`03003ooooo0>_oo`800?ooobKoo`00:ooo00<00?ooool0kOoo0P00oooo9?oo000[ool00`00oooo
o`3_ool2003ooolRool002_oo`03003ooooo0?7oo`800?ooob3oo`00:ooo00<00?ooool0l_oo0P00
oooo7ooo000[ool00`00ooooo`3dool2003ooolMool002_oo`03003ooooo0?Koo`800?oooa_oo`00
:ooo00<00?ooool0mooo0P00oooo6_oo000[ool00`00ooooo`3iool2003ooolHool002_oo`03003o
oooo0?_oo`800?oooaKoo`00:ooo00<00?ooool0o?oo0P00oooo5Ooo000[ool3003nool2003ooolC
ool002_oo`03003ooooo0?ooo`7oo`800?oooa7oo`00:ooo00<00?ooool0oooo0ooo00<00?ooool0
oooo3_oo000[ool00`00ooooo`3oool4ool2003oool>ool002_oo`03003ooooo0?ooo`Koo`03003o
oooo0?ooo`_oo`00:ooo00<00?ooool0oooo1ooo0P00oooo2ooo000[ool00`00ooooo`3oool9ool0
0`00ooooo`3oool8ool002_oo`03003ooooo0?ooo`[oo`800?ooo`Soo`00:ooo00<00?ooool0oooo
3?oo00<00?ooool0oooo1Ooo000[ool00`00ooooo`3oool=ool2003oool5ool002_oo`03003ooooo
0?ooo`ooo`03003ooooo0?ooo`;oo`00:ooo00<00?ooool0oooo4?oo0P00oooo0_oo000[ool00`00
ooooo`3ooolBool00`00ooooo`3nool002_oo`<00?oooa?oo`800?koo`00:ooo00<00?ooool0oooo
5Ooo00<00?ooool0nooo000[ool00`00ooooo`3ooolFool2003kool002_oo`03003ooooo0?oooaSo
o`03003ooooo0?Soo`00:ooo00<00?ooool0oooo6Ooo0P00n?oo000[ool00`00ooooo`3ooolKool0
0`00ooooo`3eool002_oo`03003ooooo0?oooacoo`800?Goo`00:ooo00<00?ooool0oooo7Ooo0P00
m?oo000[ool00`00ooooo`3ooolOool2003bool002_oo`03003ooooo0?ooob3oo`800?7oo`004Ooo
1P001_oo10002_oo00<00?ooool0oooo8_oo0P00kooo000Dool00`00ooooo`05ool20003ool00`00
ooooo`07ool00`00ooooo`3ooolSool2003^ool001Coo`03003ooooo00Goo`03003ooooo00;oo`80
00Soo`03003ooooo0?ooobGoo`800>coo`003ooo20001?oo00<00?ooool01?oo00<00?ooool01_oo
1@00oooo9?oo0P00jooo000?ool00`00ooooo`02ool00`00ooooo`04ool00`00ooooo`04ool00`00
ooooo`06ool00`00ooooo`3ooolXool2003Yool0013oo`05003oooooool00006ool00`00ooooo`04
ool00`00ooooo`06ool00`00ooooo`3ooolYool2003Xool0013oo`05003oooooool00006ool00`00
ooooo`04ool00`00ooooo`06ool00`00ooooo`3oool[ool00`00ooooo`3Uool0017oo`04003ooooo
0006ool00`00ooooo`04ool00`00ooooo`06ool00`00ooooo`3oool/ool2003Uool0017oo`04003o
oooo0006ool00`00ooooo`04ool00`00ooooo`06ool00`00ooooo`3oool^ool00`00ooooo`3Rool0
01;oo`03003oo`0000Koo`8000Goo`03003ooooo00Koo`03003ooooo0?ooobooo`800>;oo`004_oo
00<00?oo00001ooo00<00?ooool00_oo00<00?ooool01ooo00<00?ooool0oooo<?oo0P00hOoo000C
ool20007ool20003ool00`00ooooo`07ool00`00ooooo`3ooolbool00`00ooooo`3Nool001?oo`80
00Soo`@000[oo`03003ooooo0?oooc?oo`03003ooooo0=goo`00:ooo00<00?ooool0oooo=?oo0P00
gOoo000[ool00`00ooooo`3oooleool2003Lool002_oo`03003ooooo0?ooocOoo`03003ooooo0=Wo
o`00:ooo00<00?ooool0oooo>?oo0P00fOoo000[ool3003oooliool2003Hool002_oo`03003ooooo
0?oooc_oo`03003ooooo0=Goo`00:ooo00<00?ooool0oooo??oo0P00eOoo000[ool00`00ooooo`3o
oolmool2003Dool002_oo`03003ooooo0?ooocooo`03003ooooo0=7oo`00:ooo00<00?ooool0oooo
@?oo00<00?ooool0d?oo000[ool00`00ooooo`3ooom1ool2003@ool002_oo`03003ooooo0?oood;o
o`800<ooo`00:ooo00<00?ooool0ooooA?oo00<00?ooool0c?oo000[ool00`00ooooo`3ooom5ool2
003<ool002_oo`03003ooooo0?ooodKoo`800<_oo`00:ooo00<00?ooool0ooooB?oo00<00?ooool0
b?oo000[ool00`00ooooo`3ooom9ool20038ool002_oo`<00?oood[oo`800<Ooo`00:ooo00<00?oo
ool0ooooC?oo00<00?ooool0a?oo000[ool00`00ooooo`3ooom=ool20034ool002_oo`03003ooooo
0?ooodkoo`800<?oo`00:ooo00<00?ooool0ooooCooo0P00`_oo000[ool00`00ooooo`3ooomAool0
0`00ooooo`2oool002_oo`03003ooooo0?oooe;oo`800;ooo`00:ooo00<00?ooool0ooooDooo0P00
__oo000[ool00`00ooooo`3ooomEool00`00ooooo`2kool002_oo`03003ooooo0?oooeKoo`800;_o
o`00:ooo00<00?ooool0ooooEooo0P00^_oo000[ool00`00ooooo`3ooomIool00`00ooooo`2gool0
02_oo`03003ooooo0?oooe[oo`03003ooooo0;Koo`00:ooo00<00?ooool0ooooFooo0P00]_oo000[
ool3003ooomLool2002eool002_oo`03003ooooo0?oooegoo`800;Coo`00:ooo00<00?ooool0oooo
Gooo00<00?ooool0/Ooo000[ool00`00ooooo`3ooomPool00`00ooooo`2`ool002_oo`03003ooooo
0?ooof7oo`03003ooooo0:ooo`00:ooo00<00?ooool0ooooH_oo0P00[ooo000[ool00`00ooooo`3o
oomSool2002^ool002_oo`03003ooooo0?ooofCoo`800:goo`00:ooo00<00?ooool0ooooIOoo0P00
[?oo000Aool40008ool4000:ool00`00ooooo`3ooomWool00`00ooooo`2Yool0013oo`8000?oo`03
003ooooo00Coo`8000?oo`03003ooooo00Ooo`03003ooooo0?ooofSoo`03003ooooo0:Soo`004?oo
00<00?ooool00ooo00<00?ooool00ooo00<00?ooool00_oo0P002?oo00<00?ooool0ooooJOoo00<0
0?ooool0Yooo000?ool00`00ooooo`04ool00`00ooooo`02ool00`00ooooo`04ool00`00ooooo`06
ool00`00ooooo`3ooomZool2002Wool000ooo`03003ooooo00Coo`03003ooooo00;oo`03003ooooo
00Coo`03003ooooo00Koo`D00?ooofWoo`800:Koo`003ooo0P001?oo0P001?oo00<00?ooool01?oo
00<00?ooool01_oo00<00?ooool0ooooK?oo0P00YOoo000?ool00`00ool00003ool00`00ooooo`03
ool00`00ooooo`04ool00`00ooooo`06ool00`00ooooo`3ooom^ool00`00ooooo`2Rool000ooo`03
003ooooo00<000Koo`03003ooooo00Coo`03003ooooo00Koo`03003ooooo0?ooofooo`03003ooooo
0:7oo`003ooo00<00?ooool02Ooo00<00?ooool01?oo00<00?ooool01_oo00<00?ooool0ooooL?oo
00<00?ooool0X?oo000@ool00`00ooooo`08ool20005ool00`00ooooo`06ool00`00ooooo`3oooma
ool00`00ooooo`2Oool0013oo`8000[oo`03003ooooo00;oo`03003ooooo00Ooo`03003ooooo0?oo
og;oo`8009ooo`004Ooo0P002Ooo0P000ooo00<00?ooool01ooo00<00?ooool0ooooLooo0P00W_oo
000Cool40006ool4000:ool00`00ooooo`3ooomdool2002Mool002_oo`03003ooooo0?ooogGoo`80
09coo`00:ooo00<00?ooool0ooooM_oo0P00Vooo000[ool00`00ooooo`3ooomhool00`00ooooo`2H
ool002_oo`03003ooooo0?ooogWoo`03003ooooo09Ooo`00:ooo0`00ooooN_oo00<00?ooool0U_oo
000[ool00`00ooooo`3ooomkool00`00ooooo`2Eool002_oo`03003ooooo0?ooogcoo`8009Goo`00
:ooo00<00?ooool0ooooOOoo0P00U?oo000[ool00`00ooooo`3ooomnool2002Cool002_oo`03003o
oooo0?ooogooo`8009;oo`00:ooo00<00?ooool0ooooP?oo0P00TOoo000[ool00`00ooooo`3ooon2
ool00`00ooooo`2>ool002_oo`03003ooooo0?oooh?oo`03003ooooo08goo`00:ooo00<00?ooool0
ooooQ?oo00<00?ooool0S?oo000[ool00`00ooooo`3ooon5ool00`00ooooo`2;ool002_oo`03003o
oooo0?ooohKoo`03003ooooo08[oo`00:ooo00<00?ooool0ooooQooo00<00?ooool0ROoo000[ool0
0`00ooooo`3ooon8ool00`00ooooo`28ool002_oo`<00?ooohWoo`03003ooooo08Ooo`00:ooo00<0
0?ooool0ooooR_oo0P00Qooo000[ool00`00ooooo`3ooon;ool20026ool002_oo`03003ooooo0?oo
ohcoo`8008Goo`00:ooo00<00?ooool0ooooSOoo0P00Q?oo000[ool00`00ooooo`3ooon>ool20023
ool002_oo`03003ooooo0?ooohooo`8008;oo`00:ooo00<00?ooool0ooooT?oo0P00POoo000[ool0
0`00ooooo`3ooonAool20020ool002_oo`03003ooooo0?oooi;oo`8007ooo`00:ooo00<00?ooool0
ooooU?oo00<00?ooool0O?oo000[ool00`00ooooo`3ooonEool00`00ooooo`1kool002_oo`03003o
oooo0?oooiKoo`03003ooooo07[oo`00:ooo0`00ooooUooo00<00?ooool0NOoo000[ool00`00oooo
o`3ooonHool00`00ooooo`1hool002_oo`03003ooooo0?oooiWoo`03003ooooo07Ooo`00:ooo00<0
0?ooool0ooooV_oo00<00?ooool0M_oo000[ool00`00ooooo`3ooonKool00`00ooooo`1eool002_o
o`03003ooooo0?oooicoo`03003ooooo07Coo`00:ooo00<00?ooool0ooooWOoo00<00?ooool0Looo
000[ool00`00ooooo`3ooonNool00`00ooooo`1bool002_oo`03003ooooo0?oooiooo`03003ooooo
077oo`00:ooo00<00?ooool0ooooX?oo00<00?ooool0L?oo000Aool40008ool4000:ool00`00oooo
o`3ooonQool00`00ooooo`1_ool0013oo`03003ooooo00;oo`03003ooooo00Coo`8000?oo`03003o
oooo00Ooo`03003ooooo0?oooj;oo`03003ooooo06koo`003ooo00<00?ooool01?oo00<00?ooool0
0ooo00<00?ooool00_oo0P002?oo00<00?ooool0ooooXooo00<00?ooool0KOoo000?ool00`00oooo
o`04ool00`00ooooo`02ool00`00ooooo`04ool00`00ooooo`06ool5003ooonRool00`00ooooo`1/
ool000ooo`03003ooooo00Coo`03003ooooo00;oo`03003ooooo00Coo`03003ooooo00Koo`03003o
oooo0?ooojGoo`03003ooooo06_oo`004?oo0P000ooo00<00?ooool00ooo00<00?ooool01?oo00<0
0?ooool01_oo00<00?ooool0ooooY_oo00<00?ooool0J_oo000Aool40006ool00`00ooooo`04ool0
0`00ooooo`06ool00`00ooooo`3ooonWool00`00ooooo`1Yool0013oo`8000?oo`03003ooooo00?o
o`03003ooooo00Coo`03003ooooo00Koo`03003ooooo0?ooojSoo`03003ooooo06Soo`004?oo00<0
0?ooool00ooo00<00?ooool00_oo00<00?ooool01?oo00<00?ooool01_oo00<00?ooool0ooooZOoo
00<00?ooool0Iooo000@ool00`00ooooo`03ool00`00ooooo`02ool20005ool00`00ooooo`06ool0
0`00ooooo`3ooonZool00`00ooooo`1Vool0013oo`03003ooooo00?oo`03003ooooo00?oo`03003o
oooo00;oo`03003ooooo00Ooo`03003ooooo0?oooj_oo`03003ooooo06Goo`004Ooo00D00?oooooo
o`0000Koo`8000?oo`03003ooooo00Ooo`03003ooooo0?ooojcoo`03003ooooo06Coo`004_oo0`00
2?oo10002_oo00<00?ooool0oooo[Ooo00<00?ooool0Hooo000[ool00`00ooooo`3ooon^ool00`00
ooooo`1Rool002_oo`03003ooooo0?ooojooo`03003ooooo067oo`00:ooo00<00?ooool0oooo/?oo
00<00?ooool0H?oo000[ool00`00ooooo`3ooonaool00`00ooooo`1Oool002_oo`<00?oook;oo`03
003ooooo05koo`00:ooo00<00?ooool0oooo/ooo00<00?ooool0GOoo000[ool00`00ooooo`3ooond
ool00`00ooooo`1Lool002_oo`03003ooooo0?oookCoo`8005goo`00:ooo00<00?ooool0oooo]Ooo
0P00G?oo000[ool00`00ooooo`3ooonfool2001Kool002_oo`03003ooooo0?oookOoo`8005[oo`00
:ooo00<00?ooool0oooo^?oo0P00FOoo000[ool00`00ooooo`3oooniool2001Hool002_oo`03003o
oooo0?oook[oo`8005Ooo`00:ooo00<00?ooool0oooo^ooo0P00E_oo000[ool00`00ooooo`3ooonl
ool2001Eool002_oo`03003ooooo0?oookgoo`03003ooooo05?oo`00:ooo0`00oooo__oo00<00?oo
ool0D_oo000[ool00`00ooooo`3ooonoool00`00ooooo`1Aool002_oo`03003ooooo0?oool3oo`03
003ooooo053oo`00:ooo00<00?ooool0oooo`Ooo00<00?ooool0Cooo000[ool00`00ooooo`3oooo2
ool00`00ooooo`1>ool002_oo`03003ooooo0?oool?oo`03003ooooo04goo`00:ooo00<00?ooool0
ooooa?oo00<00?ooool0C?oo000[ool00`00ooooo`3oooo5ool00`00ooooo`1;ool002_oo`03003o
oooo0?ooolKoo`03003ooooo04[oo`00:ooo00<00?ooool0ooooaooo00<00?ooool0BOoo000[ool0
0`00ooooo`3oooo7ool2001:ool002_oo`03003ooooo0?ooolSoo`8004Woo`00:ooo00<00?ooool0
oooobOoo0P00B?oo000[ool00`00ooooo`3oooo:ool20017ool002_oo`<00?oool_oo`03003ooooo
04Goo`00:ooo00<00?ooool0ooooc?oo00<00?ooool0A?oo000[ool00`00ooooo`3oooo=ool00`00
ooooo`13ool002_oo`03003ooooo0?ooolkoo`03003ooooo04;oo`00:ooo00<00?ooool0oooocooo
00<00?ooool0@Ooo000[ool00`00ooooo`3oooo@ool00`00ooooo`10ool002_oo`03003ooooo0?oo
om7oo`03003ooooo03ooo`00:ooo00<00?ooool0ooood_oo00<00?ooool0?_oo000[ool00`00oooo
o`3ooooBool2000oool000?oo`P000Koo`@000Soo`@000[oo`03003ooooo0?ooom?oo`8003koo`00
1ooo00<00?ooool01_oo0P000ooo00<00?ooool01?oo0P000ooo00<00?ooool01ooo00<00?ooool0
ooooe?oo0P00?Ooo0007ool00`00ooooo`06ool00`00ooooo`02ool20005ool00`00ooooo`02ool2
0008ool00`00ooooo`3ooooEool2000lool000Ooo`03003ooooo00Goo`03003ooooo00Coo`03003o
oooo00;oo`03003ooooo00Coo`03003ooooo00Koo`03003ooooo0?ooomKoo`03003ooooo03[oo`00
1ooo00<00?ooool01Ooo00<00?ooool01?oo00<00?ooool00_oo00<00?ooool01?oo00<00?ooool0
1_oo1@00ooooeOoo00<00?ooool0>Ooo0007ool00`00ooooo`05ool00`00ooooo`04ool00`00oooo
o`02ool00`00ooooo`04ool00`00ooooo`06ool00`00ooooo`3ooooHool00`00ooooo`0hool000Oo
o`03003ooooo00Goo`03003ooooo00Coo`03003ooooo00;oo`03003ooooo00Coo`03003ooooo00Ko
o`03003ooooo0?ooomWoo`03003ooooo03Ooo`001ooo00<00?ooool01Ooo00<00?ooool01?oo00<0
0?ooool00_oo00<00?ooool01?oo00<00?ooool01_oo00<00?ooool0oooof_oo00<00?ooool0=_oo
0007ool00`00ooooo`05ool00`00ooooo`04ool00`00ooooo`02ool00`00ooooo`04ool00`00oooo
o`06ool00`00ooooo`3ooooKool00`00ooooo`0eool000Ooo`03003ooooo00Goo`8000Goo`03003o
oooo00;oo`8000Goo`03003ooooo00Koo`03003ooooo0?ooomcoo`03003ooooo03Coo`000ooo00D0
0?ooooooo`0000Soo`03003ooooo00;oo`03003ooooo00Coo`03003ooooo00;oo`03003ooooo00Oo
o`03003ooooo0?ooomcoo`8003Goo`001?oo10002?oo0P000ooo00<00?ooool01?oo0P000ooo00<0
0?ooool01ooo00<00?ooool0oooogOoo0P00=?oo0006ool20009ool40008ool4000:ool00`00oooo
o`3ooooNool00`00ooooo`0bool002_oo`03003ooooo0?ooomooo`03003ooooo037oo`00:ooo00<0
0?ooool0ooooh?oo00<00?ooool0<?oo000[ool00`00ooooo`3ooooQool00`00ooooo`0_ool002_o
o`03003ooooo0?ooon7oo`80033oo`00:ooo0`00ooooh_oo0P00;ooo000[ool00`00ooooo`3ooooS
ool00`00ooooo`0]ool002_oo`03003ooooo0?ooonCoo`03003ooooo02coo`00:ooo00<00?ooool0
ooooiOoo00<00?ooool0:ooo000[ool00`00ooooo`3ooooVool00`00ooooo`0Zool002_oo`03003o
oooo0?ooonKoo`8002_oo`00:ooo00<00?ooool0ooooiooo0P00:_oo000[ool00`00ooooo`3ooooX
ool00`00ooooo`0Xool002_oo`03003ooooo0?ooonWoo`03003ooooo02Ooo`00:ooo00<00?ooool0
ooooj_oo00<00?ooool09_oo000[ool00`00ooooo`3oooo[ool00`00ooooo`0Uool002_oo`03003o
oooo0?ooon_oo`8002Koo`00:ooo00<00?ooool0ooook?oo0P009Ooo000[ool00`00ooooo`3oooo]
ool00`00ooooo`0Sool002_oo`<00?ooonkoo`03003ooooo02;oo`00:ooo00<00?ooool0ooookooo
00<00?ooool08Ooo000[ool00`00ooooo`3oooo`ool00`00ooooo`0Pool002_oo`03003ooooo0?oo
oo7oo`03003ooooo01ooo`00:ooo00<00?ooool0oooolOoo0P008?oo000[ool00`00ooooo`3oooob
ool2000Oool002_oo`03003ooooo0?oooo?oo`8001koo`00:ooo00<00?ooool0oooom?oo00<00?oo
ool07?oo000[ool00`00ooooo`3ooooeool00`00ooooo`0Kool002_oo`03003ooooo0?ooooKoo`03
003ooooo01[oo`00:ooo00<00?ooool0oooomooo00<00?ooool06Ooo000[ool00`00ooooo`3ooooh
ool00`00ooooo`0Hool002_oo`03003ooooo0?ooooSoo`8001Woo`00:ooo0`00oooonOoo0P006?oo
000[ool00`00ooooo`3oooojool2000Gool002_oo`03003ooooo0?oooo_oo`03003ooooo01Goo`00
:ooo00<00?ooool0ooooo?oo00<00?ooool05?oo000[ool00`00ooooo`3oooomool00`00ooooo`0C
ool002_oo`03003ooooo0?ooookoo`03003ooooo01;oo`00:ooo00<00?ooool0oooooooo00<00?oo
ool04Ooo000[ool00`00ooooo`3oooooool2000Bool002_oo`03003ooooo0?ooooooo`7oo`80017o
o`00:ooo00<00?ooool0oooooooo0_oo0P004?oo0003ool80004ool80006ool4000:ool00`00oooo
o`3oooooool3ool00`00ooooo`0>ool000Ooo`03003ooooo00Goo`8000Goo`03003ooooo00?oo`80
00?oo`03003ooooo00Ooo`03003ooooo0?ooooooo`Coo`03003ooooo00goo`001ooo00<00?ooool0
1ooo00<00?ooool00_oo00<00?ooool00ooo00<00?ooool00_oo0P002?oo00<00?ooool0oooooooo
1Ooo00<00?ooool03?oo0007ool00`00ooooo`08ool00`00ooooo`06ool00`00ooooo`04ool00`00
ooooo`06ool5003ooooooolBool000Ooo`03003ooooo00Woo`03003ooooo00Goo`03003ooooo00Co
o`03003ooooo00Koo`03003ooooo0?oooooooaCoo`001ooo00<00?ooool02_oo00<00?ooool01?oo
00<00?ooool01?oo00<00?ooool01_oo00<00?ooool0oooooooo5?oo0007ool00`00ooooo`0;ool0
0`00ooooo`03ool00`00ooooo`04ool00`00ooooo`06ool00`00ooooo`3ooooooolDool000Ooo`03
003ooooo00_oo`8000Coo`03003ooooo00Coo`03003ooooo00Koo`03003ooooo0?oooooooaCoo`00
1ooo00<00?ooool03?oo00<00?ooool00_oo00<00?ooool01?oo00<00?ooool01_oo00<00?ooool0
oooooooo5?oo0007ool00`00ooooo`0<ool00`00ooooo`02ool20005ool00`00ooooo`06ool00`00
ooooo`3ooooooolDool000?oo`05003oooooool00007ool00`00ooooo`04ool00`00ooooo`03ool0
0`00ooooo`02ool00`00ooooo`07ool00`00ooooo`3ooooooolDool000Coo`@000Ooo`8000?oo`80
00Koo`8000?oo`03003ooooo0?oooooooakoo`001_oo0P002Ooo10002?oo1000oooooooo8Ooo0000
\
\>"],
  ImageRangeCache->{{{0, 575}, {354.875, 0}} -> {-0.532587, -9.26373, 
  0.0242978, 0.747467}}]
}, Open  ]]
},
FrontEndVersion->"X 3.0",
ScreenRectangle->{{0, 1600}, {0, 1200}},
WindowSize->{1570, 1046},
WindowMargins->{{4, Automatic}, {Automatic, 20}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1731, 51, 148, 2, 52, "Input"],
Cell[1882, 55, 30732, 900, 372, 9241, 630, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[32651, 960, 144, 3, 52, "Input"],
Cell[32798, 965, 23725, 535, 372, 4192, 289, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[56560, 1505, 158, 3, 52, "Input"],
Cell[56721, 1510, 33594, 929, 372, 9270, 624, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[90352, 2444, 321, 5, 82, "Input"],
Cell[90676, 2451, 153709, 5960, 372, 77918, 5020, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[244422, 8416, 104, 2, 52, "Input"],
Cell[244529, 8420, 23819, 540, 372, 4136, 292, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

